


(******************************************************************************)
(*                       Probabilistic Analysis of                            *)
(*                        Q1 of Spare gates with shared events                *)
(*                                  by                                        *)
(*                          Yassmeen Elderhalli                               *)
(*                      y_elderh@encs.concordia.ca                            *)
(******************************************************************************)

(*loadPath := "/home/yassmeen/Downloads/ProbTheories_HOL-k12" :: !loadPath;
(*set_trace "Unicode" 0;*)

app load ["HolKernel", "Parse", "boolLib", "bossLib", "numLib", "unwindLib", 
"tautLib", "Arith", "prim_recTheory", "combinTheory", "quotientTheory", 
"arithmeticTheory", "realTheory", "hrealTheory", "realaxTheory", "realLib",  
"jrhUtils", "pairTheory", "seqTheory", "limTheory", "transcTheory", "listTheory", 
"mesonLib", "boolTheory", "topologyTheory", "pred_setTheory", "util_probTheory", 
"optionTheory", "numTheory", "sumTheory", "InductiveDefinition", "ind_typeTheory",
"pred_setLib", "iterate_hvgTheory", "card_hvgTheory", "product_hvgTheory", 
"topology_hvgTheory", "derivative_hvgTheory", "integration_hvgTheory",
"real_sigmaTheory", "extreal_hvgTheory", "measure_hvgTheory", "lebesgue_hvgTheory",
"probability_hvgTheory", "lebesgue_measure_hvgTheory", "normal_rv_hvgTheory", "netsTheory", "PIE_EXTREALTheory","dep_rewrite", "integration_before_afterTheory", "DFT_Gates_def_PROBTheory", "CASTheory","WCSPTheory", "WCSP_sharedTheory", "CPDFTTheory", "AND_FDEPTheory"];
*)
open HolKernel Parse boolLib bossLib numLib unwindLib tautLib Arith prim_recTheory 
combinTheory quotientTheory arithmeticTheory hrealTheory realaxTheory realTheory 
realLib jrhUtils pairTheory seqTheory limTheory transcTheory listTheory mesonLib 
boolTheory topologyTheory pred_setTheory util_probTheory optionTheory numTheory 
sumTheory InductiveDefinition ind_typeTheory pred_setLib iterate_hvgTheory 
card_hvgTheory product_hvgTheory topology_hvgTheory derivative_hvgTheory
integration_hvgTheory real_sigmaTheory extreal_hvgTheory measure_hvgTheory
lebesgue_hvgTheory probability_hvgTheory lebesgue_measure_hvgTheory normal_rv_hvgTheory netsTheory PIE_EXTREALTheory dep_rewrite integration_before_afterTheory DFT_Gates_def_PROBTheory CASTheory WCSPTheory WCSP_sharedTheory CPDFTTheory AND_FDEPTheory;






val _ = new_theory "Q1_shared_spare";


infixr 0 ++ << || ORELSEC ## --> THENC;
infix 1 >> |->;
fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
 
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Suff = PARSE_TAC SUFF_TAC;
val POP_ORW = POP_ASSUM (fn thm => ONCE_REWRITE_TAC [thm]);
val !! = REPEAT;
val op++ = op THEN;
val op<< = op THENL;
val op|| = op ORELSE;
val op>> = op THEN1;
val std_ss' = simpLib.++ (std_ss, boolSimps.ETA_ss);

(*---------------------------*)
fun SET_TAC L =
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION,
    IN_INTER, IN_DIFF, IN_INSERT, IN_DELETE, IN_BIGINTER, IN_BIGUNION,
    IN_IMAGE, GSPECIFICATION, IN_DEF] THEN METIS_TAC [];

fun SET_RULE tm = prove(tm,SET_TAC []);


val set_rewrs
= [INTER_EMPTY, INTER_UNIV, UNION_EMPTY, UNION_UNIV, DISJOINT_UNION,
DISJOINT_INSERT, DISJOINT_EMPTY, GSYM DISJOINT_EMPTY_REFL,
DISJOINT_BIGUNION, INTER_SUBSET, INTER_IDEMPOT, UNION_IDEMPOT,
SUBSET_UNION];

val UNIONL_def = Define `(UNIONL [] = {})
/\ (UNIONL (s::ss) = (s:'a ->bool) UNION UNIONL ss)`;


val IN_UNIONL = store_thm
("IN_UNIONL",
``!l (v:'a ). v IN UNIONL l = (?s. MEM s l /\ v IN s)``,
Induct >> RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY]
++ RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY, IN_UNION]
++ PROVE_TAC []);


val elt_rewrs
= [SUBSET_DEF, IN_COMPL, IN_DIFF, IN_UNIV, NOT_IN_EMPTY, IN_UNION,
IN_INTER, IN_IMAGE, IN_FUNSET, IN_DFUNSET, GSPECIFICATION,
DISJOINT_DEF, IN_BIGUNION, IN_BIGINTER, IN_COUNT, IN_o,
IN_UNIONL, IN_DELETE, IN_PREIMAGE, IN_SING, IN_INSERT];


fun rewr_ss ths =
simpLib.++
(std_ss,
simpLib.SSFRAG
{ac = [],
name = NONE,
convs = [],
dprocs = [],
filter = NONE,
rewrs = set_rewrs @ elt_rewrs,
congs = []});
val pset_set_ss = rewr_ss set_rewrs;
val pset_elt_ss = rewr_ss elt_rewrs;
val pset_ss = rewr_ss (set_rewrs @ elt_rewrs);


fun PSET_TAC ths =
REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_set_ss ths
++ REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_elt_ss ths;

fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Simplify = RW_TAC arith_ss;
val Suff = PARSE_TAC SUFF_TAC;
val Know = PARSE_TAC KNOW_TAC;
fun wrap a = [a];
val Rewr = DISCH_THEN (REWRITE_TAC o wrap);
val Rewr' = DISCH_THEN (ONCE_REWRITE_TAC o wrap);
val Cond =
  DISCH_THEN
  (fn mp_th =>
   let
     val cond = fst (dest_imp (concl mp_th))
   in
     KNOW_TAC cond << [ALL_TAC, DISCH_THEN (MP_TAC o MP mp_th)]
   end);
val FUN_EQ_TAC = CONV_TAC (CHANGED_CONV (ONCE_DEPTH_CONV FUN_EQ_CONV));
fun K_TAC _ = ALL_TAC;
fun MESON ths tm = prove(tm,MESON_TAC ths);
fun METIS ths tm = prove(tm,METIS_TAC ths);
val DISC_RW_KILL = DISCH_TAC THEN ONCE_ASM_REWRITE_TAC [] THEN 
                   POP_ASSUM K_TAC;
			   
val IN_REST = store_thm ("IN_REST",
 ``!x:'a. !s. x IN (REST s) <=> x IN s /\ ~(x = CHOICE s)``,
  REWRITE_TAC[REST_DEF, IN_DELETE]);
fun SET_TAC L = 
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN
    SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION, IN_INTER, IN_DIFF, 
      IN_INSERT, IN_DELETE, IN_REST, IN_BIGINTER, IN_BIGUNION, IN_IMAGE, 
      GSPECIFICATION, IN_DEF, EXISTS_PROD] THEN METIS_TAC [];
fun ASSERT_TAC tm = SUBGOAL_THEN tm STRIP_ASSUME_TAC;
fun SET_RULE tm = prove(tm,SET_TAC []);
fun ASM_SET_TAC L = REPEAT (POP_ASSUM MP_TAC) THEN SET_TAC L;
val ASM_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN ARITH_TAC;
val ASM_REAL_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN REAL_ARITH_TAC;

fun DFT_rewrs L =  REPEAT( METIS_TAC L);


val rewrs = [REAL_LE_REFL, REAL_LE_LT, REAL_LE_ANTISYM, REAL_LET_ANTISYM, REAL_LET_TOTAL, REAL_LET_TRANS, real_of_num,REAL_LT_NEG1_1,REAL_LT_NEG1_0,REAL_LE_NEG1_0,REAL_LE_NEG1_1, REAL_LT_TOTAL, max_def, min_def, REAL_LT_TRANS, REAL_LE_TRANS, REAL_MIN_COMM, REAL_MAX_COMM];

val DFT_rewrs_ss  =DFT_rewrs rewrs;


val shared_spare_Q1_event_union = store_thm("shared_spare_Q1_event_distinct",
``! Xa Xd Y Z p t. (rv_gt0_ninfinity [Xa; Xd; Y; Z] )/\

 (!s. ALL_DISTINCT [Y s; Xa s; Xd s; Z s]) /\
     DISJOINT_WSP Y Xa Xd t /\ DISJOINT_WSP Z Xa Xd t /\
     (!s. (D_AND (D_BEFORE Z Xd)(D_BEFORE Xd Y) s = NEVER s )) /\
     (!s. D_AND (D_BEFORE  Y Xd)(D_BEFORE Xd Z) s = NEVER s ) /\
      (!s. (D_AND (D_BEFORE Xa Y)(D_BEFORE Xa Z) s = NEVER s )) 
     ==>
(DFT_event p (D_OR (D_OR (D_AND (Xa)(D_BEFORE Y Xa))(D_AND Y (D_BEFORE Xd Y)))(D_AND (Y )(D_BEFORE Z Y ))) t = DFT_event p (D_AND (D_AND (Xa)(D_BEFORE Y Z))(D_BEFORE Z Xa)) t UNION
           DFT_event p (D_AND (D_AND (Z)(D_BEFORE Y Xa))(D_BEFORE Xa Z)) t UNION
	   (DFT_event p (D_AND (Xa)(D_BEFORE Y Xa)) t INTER (p_space p DIFF DFT_event p Z t)) UNION
	   DFT_event p (D_AND (D_AND (Z)(D_BEFORE Xd Y))(D_BEFORE Y Z)) t UNION
	   (DFT_event p (D_AND (Y) (D_BEFORE Xd Y)) t INTER (p_space p DIFF DFT_event p Z t)) UNION
	   DFT_event p (D_AND (Y)(D_BEFORE Z Y)) t)``,

REPEAT GEN_TAC THEN REWRITE_TAC[AND_INTER, rv_gt0_ninfinity_def,  DISJOINT_WSP_def, NEVER_def, ALL_DISTINCT, MEM, DFT_event_def]
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION, DISJOINT_DEF]
THEN NTAC 6 (POP_ASSUM (MP_TAC o Q.SPEC `x:'a`))
THEN RW_TAC std_ss[D_OR_def, D_BEFORE_def, D_AND_def]
THEN REPEAT (POP_ASSUM MP_TAC)
THEN RW_TAC std_ss[]
THEN METIS_TAC[extreal_max_def, extreal_min_def, lt_le, le_lt, lt_trans, le_trans, lt_infty, le_infty, le_refl, lt_total, le_total]);


val shared_spare_disjoint_1 = store_thm("shared_spare_disjoint_1",
  ``
! Xa Xd Y Z p t. (rv_gt0_ninfinity [Xa; Xd; Y; Z] ) /\
(!s. ALL_DISTINCT [Y s; Xa s; Xd s; Z s]) /\

     DISJOINT_WSP Y Xa Xd t /\ DISJOINT_WSP Z Xa Xd t /\
     (!s. (D_AND (D_BEFORE Z Xd)(D_BEFORE Xd Y) s = NEVER s )) /\
     (!s. D_AND (D_BEFORE  Y Xd)(D_BEFORE Xd Z) s = NEVER s ) /\
      (!s. (D_AND (D_BEFORE Xa Y)(D_BEFORE Xa Z) s = NEVER s )) ==>
DISJOINT  (DFT_event p (D_AND (D_AND (Xa)(D_BEFORE Y Z))(D_BEFORE Z Xa)) t) 
           (DFT_event p (D_AND (D_AND (Z)(D_BEFORE Y Xa))(D_BEFORE Xa Z)) t UNION
	   (DFT_event p (D_AND (Xa)(D_BEFORE Y Xa)) t INTER (p_space p DIFF DFT_event p Z t)) UNION
	   DFT_event p (D_AND (D_AND (Z)(D_BEFORE Xd Y))(D_BEFORE Y Z)) t UNION
	   (DFT_event p (D_AND (Y) (D_BEFORE Xd Y)) t INTER (p_space p DIFF DFT_event p Z t)) UNION
	   DFT_event p (D_AND (Y)(D_BEFORE Z Y)) t)``,

REPEAT GEN_TAC THEN REWRITE_TAC[AND_INTER, rv_gt0_ninfinity_def,  DISJOINT_WSP_def, NEVER_def, ALL_DISTINCT, MEM, DFT_event_def]
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION, DISJOINT_DEF]
THEN NTAC 9(POP_ASSUM (MP_TAC o Q.SPEC `x:'a`))
THEN RW_TAC std_ss[D_OR_def, D_BEFORE_def, D_AND_def]
THEN REPEAT (POP_ASSUM MP_TAC)
THEN RW_TAC std_ss[]
THEN METIS_TAC[extreal_max_def, extreal_min_def, lt_le, le_lt, lt_trans, le_trans, lt_infty, le_infty, le_refl, lt_total, le_total]);

val shared_spare_disjoint_2 = store_thm("shared_spare_disjoint_2",
  ``
! Xa Xd Y Z p t. (rv_gt0_ninfinity [Xa; Xd; Y; Z] ) /\
(!s. ALL_DISTINCT [Y s; Xa s; Xd s; Z s]) /\

     DISJOINT_WSP Y Xa Xd t /\ DISJOINT_WSP Z Xa Xd t /\
     (!s. (D_AND (D_BEFORE Z Xd)(D_BEFORE Xd Y) s = NEVER s )) /\
     (!s. D_AND (D_BEFORE  Y Xd)(D_BEFORE Xd Z) s = NEVER s ) /\
       (!s. (D_AND (D_BEFORE Xa Y)(D_BEFORE Xa Z) s = NEVER s )) ==>

DISJOINT   (DFT_event p (D_AND (D_AND (Z)(D_BEFORE Y Xa))(D_BEFORE Xa Z)) t) 
	   ((DFT_event p (D_AND (Xa)(D_BEFORE Y Xa)) t INTER (p_space p DIFF DFT_event p Z t)) UNION
	   DFT_event p (D_AND (D_AND (Z)(D_BEFORE Xd Y))(D_BEFORE Y Z)) t UNION
	   (DFT_event p (D_AND (Y) (D_BEFORE Xd Y)) t INTER (p_space p DIFF DFT_event p Z t)) UNION
	   DFT_event p (D_AND (Y)(D_BEFORE Z Y)) t)``,

REPEAT GEN_TAC THEN REWRITE_TAC[AND_INTER, rv_gt0_ninfinity_def,  DISJOINT_WSP_def, NEVER_def, ALL_DISTINCT, MEM, DFT_event_def]
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION, DISJOINT_DEF]
THEN NTAC 9(POP_ASSUM (MP_TAC o Q.SPEC `x:'a`))
THEN RW_TAC std_ss[D_OR_def, D_BEFORE_def, D_AND_def]
THEN REPEAT (POP_ASSUM MP_TAC)
THEN RW_TAC std_ss[]
THEN METIS_TAC[extreal_max_def, extreal_min_def, lt_le, le_lt, lt_trans, le_trans, lt_infty, le_infty, le_refl, lt_total, le_total]);


val shared_spare_disjoint_3 = store_thm("shared_spare_disjoint_3",
  ``
! Xa Xd Y Z p t. (rv_gt0_ninfinity [Xa; Xd; Y; Z] ) /\
(!s. ALL_DISTINCT [Y s; Xa s; Xd s; Z s]) /\

     DISJOINT_WSP Y Xa Xd t /\ DISJOINT_WSP Z Xa Xd t /\
     (!s. (D_AND (D_BEFORE Z Xd)(D_BEFORE Xd Y) s = NEVER s )) /\
     (!s. D_AND (D_BEFORE  Y Xd)(D_BEFORE Xd Z) s = NEVER s ) /\
     (!s. (D_AND (D_BEFORE Xa Y)(D_BEFORE Xa Z) s = NEVER s )) ==>
DISJOINT   ((DFT_event p (D_AND (Xa)(D_BEFORE Y Xa)) t INTER (p_space p DIFF DFT_event p Z t)))
	   (DFT_event p (D_AND (D_AND (Z)(D_BEFORE Xd Y))(D_BEFORE Y Z)) t UNION
	   (DFT_event p (D_AND (Y) (D_BEFORE Xd Y)) t INTER (p_space p DIFF DFT_event p Z t)) UNION
	   DFT_event p (D_AND (Y)(D_BEFORE Z Y)) t)``,

REPEAT GEN_TAC THEN REWRITE_TAC[AND_INTER, rv_gt0_ninfinity_def,  DISJOINT_WSP_def, NEVER_def, ALL_DISTINCT, MEM, DFT_event_def]
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION, DISJOINT_DEF]
THEN NTAC 9(POP_ASSUM (MP_TAC o Q.SPEC `x:'a`))
THEN RW_TAC std_ss[D_OR_def, D_BEFORE_def, D_AND_def]
THEN REPEAT (POP_ASSUM MP_TAC)
THEN RW_TAC std_ss[]
THEN METIS_TAC[extreal_max_def, extreal_min_def, lt_le, le_lt, lt_trans, le_trans, lt_infty, le_infty, le_refl, lt_total, le_total]);



val shared_spare_disjoint_4 = store_thm("shared_spare_disjoint_4",
  ``
! Xa Xd Y Z p t. 
DISJOINT   (DFT_event p (D_AND (D_AND (Z)(D_BEFORE Xd Y))(D_BEFORE Y Z)) t)
	   ((DFT_event p (D_AND (Y) (D_BEFORE Xd Y)) t INTER (p_space p DIFF DFT_event p Z t)) UNION
	   DFT_event p (D_AND (Y)(D_BEFORE Z Y)) t)``,

RW_TAC std_ss[AND_INTER, rv_gt0_ninfinity_def]
THEN RW_TAC std_ss[DFT_event_def]
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION, DISJOINT_DEF]
THEN RW_TAC std_ss[D_OR_def, D_BEFORE_def, D_AND_def]
THEN REPEAT (POP_ASSUM MP_TAC)
THEN RW_TAC std_ss[]
THEN METIS_TAC[extreal_max_def, extreal_min_def, lt_le, le_lt, lt_trans, le_trans, lt_infty, le_infty, le_refl, lt_total, le_total]);




val shared_spare_disjoint_5 = store_thm("shared_spare_disjoint_5",
  ``
! Xa Xd Y Z p t.
DISJOINT   ((DFT_event p (D_AND (Y) (D_BEFORE Xd Y)) t INTER (p_space p DIFF DFT_event p Z t)))
	   (DFT_event p (D_AND (Y)(D_BEFORE Z Y)) t)``,

RW_TAC std_ss[AND_INTER, rv_gt0_ninfinity_def]
THEN RW_TAC std_ss[DFT_event_def]
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION, DISJOINT_DEF]

THEN RW_TAC std_ss[D_OR_def, D_BEFORE_def, D_AND_def]
THEN REPEAT (POP_ASSUM MP_TAC)
THEN RW_TAC std_ss[]
THEN METIS_TAC[extreal_max_def, extreal_min_def, lt_le, le_lt, lt_trans, le_trans, lt_infty, le_infty, le_refl, lt_total, le_total]);



val add_assoc_6_var = store_thm("add_assoc_6_var",
  `` !A1 A2 A3 A4 A5 A6.
       A1 <> PosInf /\ A2 <> PosInf /\ A3 <> PosInf /\ A4 <> PosInf /\
       A5 <> PosInf /\ A6 <> PosInf ==>
       (A1 + (A2 + (A3 + (A4 + (A5+ A6)))) = A1 + A2 + A3 + A4 + A5+A6)
  ``,
METIS_TAC[add_assoc,extreal_hvgTheory.add_not_infty]);


val prob_shared_spare_initial_1
 = store_thm("prob_shared_spare_initial_1",
  ``!Xa Xd Y Z p t.
          rv_gt0_ninfinity [Xa; Xd; Y; Z] /\ (!s. ALL_DISTINCT [Y s; Xa s; Xd s; Z s]) /\
          DISJOINT_WSP Y Xa Xd t /\ DISJOINT_WSP Z Xa Xd t /\
          (!s. D_AND (D_BEFORE Z Xd) (D_BEFORE Xd Y) s = NEVER s) /\
          (!s. D_AND (D_BEFORE Y Xd) (D_BEFORE Xd Z) s = NEVER s) /\
          (!s. D_AND (D_BEFORE Xa Y) (D_BEFORE Xa Z) s = NEVER s) /\
          random_variable (\x. real (Xa x)) p
            (m_space lborel,measurable_sets lborel) /\
          random_variable (\x. real (Xd x)) p
            (m_space lborel,measurable_sets lborel) /\
          random_variable (\x. real (Y x)) p
            (m_space lborel,measurable_sets lborel) /\
          random_variable (\x. real (Z x)) p
            (m_space lborel,measurable_sets lborel) /\ 0 <= t ==>
          (prob p
             (DFT_event p
                (D_OR
                   (D_OR (D_AND Xa (D_BEFORE Y Xa)) (D_AND Y (D_BEFORE Xd Y)))
                   (D_AND Y (D_BEFORE Z Y))) t) =
           prob p
             (DFT_event p (D_AND (D_AND Xa (D_BEFORE Y Z)) (D_BEFORE Z Xa)) t) +
           prob p
             (DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t) +
           prob p
             (DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
              (p_space p DIFF DFT_event p Z t)) +
           prob p
             (DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t) +
           prob p
             (DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
              (p_space p DIFF DFT_event p Z t)) +
           prob p (DFT_event p (D_AND Y (D_BEFORE Z Y)) t))``,


RW_TAC std_ss[shared_spare_Q1_event_union, rv_gt0_ninfinity_def]
THEN KNOW_TAC(``DFT_event p Xa t IN events p ``)
     THEN1(RW_TAC std_ss [DFT_event_def]
      THEN KNOW_TAC(``{s:'a | Xa s <= Normal t}=PREIMAGE Xa {s |  s <= Normal t}``) THEN1(
      	             SRW_TAC [] [GSPECIFICATION, EXTENSION, PREIMAGE_def])
      THEN DISCH_TAC
      THEN ASM_REWRITE_TAC[]
      THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
      THEN REWRITE_TAC [events_def]
      THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	       	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
      THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
      THEN REWRITE_TAC [p_space_def, m_space_def]
      THEN KNOW_TAC(``prob_space p``) THEN1(FULL_SIMP_TAC std_ss [random_variable_def])
      THEN DISCH_TAC
      THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def, EVENTS_INTER, EVENTS_SPACE, m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def, indep_var, indep_vars, indep_sets])
THEN DISCH_TAC
THEN KNOW_TAC(``DFT_event p Xd t IN events p ``)
     THEN1(RW_TAC std_ss [DFT_event_def]
      THEN KNOW_TAC(``{s:'a | Xd s <= Normal t}=PREIMAGE Xd {s |  s <= Normal t}``) THEN1(
      	             SRW_TAC [] [GSPECIFICATION, EXTENSION, PREIMAGE_def])
      THEN DISCH_TAC
      THEN ASM_REWRITE_TAC[]
      THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
      THEN REWRITE_TAC [events_def]
      THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	       	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
      THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
      THEN REWRITE_TAC [p_space_def, m_space_def]
      THEN KNOW_TAC(``prob_space p``) THEN1(FULL_SIMP_TAC std_ss [random_variable_def])
      THEN DISCH_TAC
      THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def, EVENTS_INTER, EVENTS_SPACE, m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def, indep_var, indep_vars, indep_sets])
THEN DISCH_TAC

THEN KNOW_TAC(``DFT_event p Y t IN events p ``)
     THEN1(RW_TAC std_ss [DFT_event_def]
      THEN KNOW_TAC(``{s:'a | Y s <= Normal t}=PREIMAGE Y {s |  s <= Normal t}``) THEN1(
      	             SRW_TAC [] [GSPECIFICATION, EXTENSION, PREIMAGE_def])
      THEN DISCH_TAC
      THEN ASM_REWRITE_TAC[]
      THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
      THEN REWRITE_TAC [events_def]
      THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	       	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
      THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
      THEN REWRITE_TAC [p_space_def, m_space_def]
      THEN KNOW_TAC(``prob_space p``) THEN1(FULL_SIMP_TAC std_ss [random_variable_def])
      THEN DISCH_TAC
      THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def, EVENTS_INTER, EVENTS_SPACE, m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def, indep_var, indep_vars, indep_sets])
THEN DISCH_TAC



THEN KNOW_TAC(``DFT_event p Z t IN events p ``)
     THEN1(RW_TAC std_ss [DFT_event_def]
      THEN KNOW_TAC(``{s:'a | Z s <= Normal t}=PREIMAGE Z {s |  s <= Normal t}``) THEN1(
      	             SRW_TAC [] [GSPECIFICATION, EXTENSION, PREIMAGE_def])
      THEN DISCH_TAC
      THEN ASM_REWRITE_TAC[]
      THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
      THEN REWRITE_TAC [events_def]
      THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	       	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
      THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
      THEN REWRITE_TAC [p_space_def, m_space_def]
      THEN KNOW_TAC(``prob_space p``) THEN1(FULL_SIMP_TAC std_ss [random_variable_def])
      THEN DISCH_TAC
      THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def, EVENTS_INTER, EVENTS_SPACE, m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def, indep_var, indep_vars, indep_sets])
THEN DISCH_TAC

THEN KNOW_TAC(`` !t. {(w,u) | 0 <= w /\ w < u /\ w <= t:real}  IN
          measurable_sets (pair_measure lborel lborel)``)
	        THEN1( RW_TAC std_ss[] THEN
		`!w u t:real. 0 <= w /\ w < u /\ w <= t =  w < u /\  0 <= w /\ w <= t` by METIS_TAC[CONJ_COMM, CONJ_ASSOC]
		THEN ONCE_ASM_REWRITE_TAC[]
		      THEN  MP_TAC (Q.SPECL [`t':real`] before_set_IN_MEASURABLE_SETS_PAIR_lborel)
                      THEN RW_TAC std_ss[IMP_CLAUSES])
THEN DISCH_TAC		      
THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
THEN DISCH_TAC 
THEN KNOW_TAC(``prob_space p``) THEN1(FULL_SIMP_TAC std_ss [random_variable_def])
THEN DISCH_TAC
THEN KNOW_TAC(``!X Y p t. rv_gt0_ninfinity [X; Y] /\ 0<=t /\random_variable (\x. real (X x)) p (m_space lborel, measurable_sets lborel) /\
random_variable (\x. real (Y x)) p (m_space lborel, measurable_sets lborel) ==>
 DFT_event p (D_BEFORE X Y) t IN events p``)
     THEN1(RW_TAC std_ss[DFT_BEFORE_event_GT0, rv_gt0_ninfinity_def]
           THEN `! w u t. 0 <= w /\ w <= Normal t /\ w < u = 0 <= w /\ w < u /\ w <= Normal t`
	        by METIS_TAC[CONJ_COMM, CONJ_ASSOC]
	   	
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL_2RV_BEFORE]
	   THEN WEAKEN_TAC (equal (Term `!w u t.
             0 <= w /\ w <= Normal t /\ w < u <=>
             0 <= w /\ w < u /\ w <= Normal t`))
	   THEN REWRITE_TAC [events_def]
	   THEN KNOW_TAC(``measurable_sets p' = subsets (p_space p', measurable_sets p')``) THEN1(
	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
           THEN DISCH_TAC 
           THEN KNOW_TAC(``prob_space p'``) THEN1(FULL_SIMP_TAC std_ss [random_variable_def])
	   THEN DISCH_TAC

          THEN  KNOW_TAC(`` (\s. (real (X s),real (Y' s))) IN measurable (m_space p', measurable_sets p') (m_space (pair_measure lborel lborel), measurable_sets (pair_measure lborel lborel))``)
               THEN1( FULL_SIMP_TAC std_ss [random_variable_def]
       THEN METIS_TAC [measurable_Pair, p_space_def, random_variable_def, events_def, measurable_sets_def, m_space_def, space_def, subsets_def, prob_space_def, measure_space_lborel, sigma_finite_measure_lborel])
      THEN DISCH_TAC THEN METIS_TAC[IN_MEASURABLE, random_variable_def, space_def, m_space_def, subsets_def, measurable_sets_def, events_def, p_space_def])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
THEN KNOW_TAC(``DFT_event p (D_AND (D_AND Xa (D_BEFORE Y Z)) (D_BEFORE Z Xa)) t IN events p ``)
     THEN1(RW_TAC std_ss[AND_INTER]
           THEN METIS_TAC [EVENTS_INTER])
THEN DISCH_TAC
THEN KNOW_TAC(``DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t IN events p ``)
     THEN1(RW_TAC std_ss[AND_INTER]
           THEN METIS_TAC [EVENTS_INTER])
THEN DISCH_TAC
THEN KNOW_TAC(``DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
       (p_space p DIFF DFT_event p Z t) IN events p ``)
      THEN1(RW_TAC std_ss[AND_INTER]
           THEN METIS_TAC [EVENTS_INTER, EVENTS_COMPL])
THEN DISCH_TAC

THEN KNOW_TAC(`` DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t IN events p ``)
     THEN1(RW_TAC std_ss[AND_INTER]
           THEN METIS_TAC [EVENTS_INTER, EVENTS_COMPL])
THEN DISCH_TAC
THEN KNOW_TAC (``  DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
      (p_space p DIFF DFT_event p Z t) IN events p``)
  THEN1(RW_TAC std_ss[AND_INTER]
           THEN METIS_TAC [EVENTS_INTER, EVENTS_COMPL])
THEN DISCH_TAC


THEN KNOW_TAC (`` DFT_event p (D_AND Y (D_BEFORE Z Y)) t IN events p``)
 THEN1(RW_TAC std_ss[AND_INTER]
           THEN METIS_TAC [EVENTS_INTER, EVENTS_COMPL])
THEN DISCH_TAC
THEN `(DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t UNION
             DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
             (p_space p DIFF DFT_event p Z t) UNION
             DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
             DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
             (p_space p DIFF DFT_event p Z t) UNION
             DFT_event p (D_AND Y (D_BEFORE Z Y)) t) IN events p` by METIS_TAC  [EVENTS_UNION]
THEN `(DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
             (p_space p DIFF DFT_event p Z t) UNION
             DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
             DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
             (p_space p DIFF DFT_event p Z t) UNION
             DFT_event p (D_AND Y (D_BEFORE Z Y)) t) IN events p` by METIS_TAC [EVENTS_UNION]

THEN `(DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
             DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
             (p_space p DIFF DFT_event p Z t) UNION
             DFT_event p (D_AND Y (D_BEFORE Z Y)) t) IN events p` by METIS_TAC [EVENTS_UNION]
THEN `(DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
             (p_space p DIFF DFT_event p Z t) UNION
             DFT_event p (D_AND Y (D_BEFORE Z Y)) t) IN events p` by METIS_TAC [EVENTS_UNION]
THEN RW_TAC std_ss[OR_UNION]
THEN KNOW_TAC (``prob p
     (DFT_event p (D_AND (D_AND Xa (D_BEFORE Y Z)) (D_BEFORE Z Xa)) t UNION
      DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t UNION
      DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
      DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND Y (D_BEFORE Z Y)) t) = prob p
     (DFT_event p (D_AND (D_AND Xa (D_BEFORE Y Z)) (D_BEFORE Z Xa)) t ) + 
     prob p ( DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t UNION
      DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
      DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND Y (D_BEFORE Z Y)) t)``)

    THEN1( MP_TAC (Q.SPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`,`DFT_event p (D_AND (D_AND Xa (D_BEFORE Y Z)) (D_BEFORE (Z:'a->extreal) Xa)) t`, `  ( DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t UNION
      DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
      DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND Y (D_BEFORE Z Y)) t)`,`(DFT_event p (D_AND (D_AND Xa (D_BEFORE Y Z)) (D_BEFORE Z Xa)) t UNION
      DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t UNION
      DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
      DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND Y (D_BEFORE Z Y)) t)` ] PROB_ADDITIVE) 
        THEN PSET_TAC[shared_spare_disjoint_1, rv_gt0_ninfinity_def]
	THEN KNOW_TAC(``(DFT_event p (D_AND (D_AND Xa (D_BEFORE Y Z)) (D_BEFORE Z Xa)) t UNION
          DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t UNION
          DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
          (p_space p DIFF DFT_event p Z t) UNION
          DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
          DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
          (p_space p DIFF DFT_event p Z t) UNION
          DFT_event p (D_AND Y (D_BEFORE Z Y)) t =
          DFT_event p (D_AND (D_AND Xa (D_BEFORE Y Z)) (D_BEFORE Z Xa)) t UNION
          (DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t UNION
           DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
           (p_space p DIFF DFT_event p Z t) UNION
           DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
           DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
           (p_space p DIFF DFT_event p Z t) UNION
           DFT_event p (D_AND Y (D_BEFORE Z Y)) t))``)
	   THEN1(ASM_SET_TAC[])
       THEN FULL_SIMP_TAC std_ss[])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``prob p
     (DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t UNION
      DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
      DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND Y (D_BEFORE Z Y)) t)  = prob p
     (DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t) +
      prob p (DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
      DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND Y (D_BEFORE Z Y)) t) ``)
      THEN1(MP_TAC (Q.SPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`,` DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t`, `( DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
      DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND Y (D_BEFORE Z Y)) t)`, `(DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t UNION
      DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
      DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
      (p_space p DIFF DFT_event p Z t) UNION
      DFT_event p (D_AND Y (D_BEFORE Z Y)) t) ` ] PROB_ADDITIVE)
      THEN RW_TAC std_ss[shared_spare_disjoint_2, rv_gt0_ninfinity_def]
      THEN `(DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t UNION
          DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
          (p_space p DIFF DFT_event p Z t) UNION
          DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
          DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
          (p_space p DIFF DFT_event p Z t) UNION
          DFT_event p (D_AND Y (D_BEFORE Z Y)) t =
          DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t UNION
          (DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
           (p_space p DIFF DFT_event p Z t) UNION
           DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
           DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
           (p_space p DIFF DFT_event p Z t) UNION
           DFT_event p (D_AND Y (D_BEFORE Z Y)) t))` by ASM_SET_TAC[]
     THEN FULL_SIMP_TAC std_ss[])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(`` prob p
      (DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
       (p_space p DIFF DFT_event p Z t) UNION
       DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
       DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
       (p_space p DIFF DFT_event p Z t) UNION
       DFT_event p (D_AND Y (D_BEFORE Z Y)) t) =
       prob p
      (DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
       (p_space p DIFF DFT_event p Z t)) +
      prob p ( DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
       DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
       (p_space p DIFF DFT_event p Z t) UNION
       DFT_event p (D_AND Y (D_BEFORE Z Y)) t)``)
       THEN1(MP_TAC (Q.SPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`,`(DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
       (p_space p DIFF DFT_event p Z t))` , `DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
       DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
       (p_space p DIFF DFT_event p Z t) UNION
       DFT_event p (D_AND Y (D_BEFORE Z Y)) t`, `(DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
       (p_space p DIFF DFT_event p Z t) UNION
       DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
       DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
       (p_space p DIFF DFT_event p Z t) UNION
       DFT_event p (D_AND Y (D_BEFORE Z Y)) t)` ] PROB_ADDITIVE)
       THEN RW_TAC std_ss[shared_spare_disjoint_3, rv_gt0_ninfinity_def]
       THEN `(DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
          (p_space p DIFF DFT_event p Z t) UNION
          DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
          DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
          (p_space p DIFF DFT_event p Z t) UNION
          DFT_event p (D_AND Y (D_BEFORE Z Y)) t =
          DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
          (p_space p DIFF DFT_event p Z t) UNION
          (DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
           DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
           (p_space p DIFF DFT_event p Z t) UNION
           DFT_event p (D_AND Y (D_BEFORE Z Y)) t))` by ASM_SET_TAC[]
	   THEN FULL_SIMP_TAC std_ss[])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``prob p
       (DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
        DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
        (p_space p DIFF DFT_event p Z t) UNION
        DFT_event p (D_AND Y (D_BEFORE Z Y)) t)    = prob p
       (DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t ) +
       prob p ( DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
        (p_space p DIFF DFT_event p Z t) UNION
        DFT_event p (D_AND Y (D_BEFORE Z Y)) t) ``)
	THEN1(MP_TAC (Q.SPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`,`(DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t )`, `DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
        (p_space p DIFF DFT_event p Z t) UNION
        DFT_event p (D_AND Y (D_BEFORE Z Y)) t`,  ` (DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
        DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
        (p_space p DIFF DFT_event p Z t) UNION
        DFT_event p (D_AND Y (D_BEFORE Z Y)) t)` ] PROB_ADDITIVE)
	THEN RW_TAC std_ss[shared_spare_disjoint_4, rv_gt0_ninfinity_def]
	THEN `(DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
          DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
          (p_space p DIFF DFT_event p Z t) UNION
          DFT_event p (D_AND Y (D_BEFORE Z Y)) t =
          DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t UNION
          (DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
           (p_space p DIFF DFT_event p Z t) UNION
           DFT_event p (D_AND Y (D_BEFORE Z Y)) t))` by ASM_SET_TAC[]
	   THEN FULL_SIMP_TAC std_ss[])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(`` prob p
        (DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
         (p_space p DIFF DFT_event p Z t) UNION
         DFT_event p (D_AND Y (D_BEFORE Z Y)) t) =  prob p
        (DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
         (p_space p DIFF DFT_event p Z t)) + 
        prob p ( DFT_event p (D_AND Y (D_BEFORE Z Y)) t) ``)
	THEN1(MP_TAC (Q.SPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`,`DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
         (p_space p DIFF DFT_event p Z t)`, `DFT_event p (D_AND Y (D_BEFORE Z Y)) t`, `(DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
         (p_space p DIFF DFT_event p Z t) UNION
         DFT_event p (D_AND Y (D_BEFORE Z Y)) t)`] PROB_ADDITIVE)
	 THEN RW_TAC std_ss[shared_spare_disjoint_5, rv_gt0_ninfinity_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]

THEN METIS_TAC[add_assoc_6_var, PROB_FINITE]);







val after_set1_BIGUNION_Q = store_thm("after_set1_BIGUNION_Q",
  ``!t.  BIGUNION
  ({ {w|  real q  < w:real /\ 0<= w/\ w <= t} CROSS {u| u:real <  real q   } | q IN Q_set}) =
  {(a,u) | u < a /\ 0<=a /\ a <=t}``,

SRW_TAC [] [GSPECIFICATION, EXTENSION]
THEN EQ_TAC
    THEN1( SRW_TAC [] [GSPECIFICATION, EXTENSION]
           THEN RW_TAC std_ss [LAMBDA_PAIR]
           THEN METIS_TAC[REAL_LT_LE, REAL_LE_LT, REAL_LT_TRANS, REAL_LE_TRANS, LAMBDA_PAIR])
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]	    
THEN KNOW_TAC (``SND x < FST x /\ FST x <=t:real /\ 0<= FST x ``)
     THEN1(FULL_SIMP_TAC std_ss[ LAMBDA_PAIR])
THEN DISCH_TAC
THEN KNOW_TAC (``Normal (SND x) < Normal (FST x)``)
     THEN1(METIS_TAC [extreal_lt_eq])
THEN DISCH_TAC

THEN KNOW_TAC(``?q. q IN Q_set/\ Normal (SND x) < q /\  q < Normal (FST x)``)
     THEN1(METIS_TAC [Q_DENSE_IN_R])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``FST (x:real#real) = real (Normal(FST x))``)
     THEN1(RW_TAC std_ss [GSYM real_normal])
THEN DISCH_TAC 
THEN KNOW_TAC(``SND (x:real#real) = real(Normal (SND x))``)
     THEN1(METIS_TAC[real_normal])
THEN DISCH_TAC 
THEN KNOW_TAC(``?r. q = Normal r``) 
     THEN1(METIS_TAC[Q_not_infty])
THEN RW_TAC std_ss[]

THEN Q.EXISTS_TAC(`{y| SND y < real (Normal r) /\ real(Normal r) < FST y /\ 0<= FST y/\ FST y <=t}`)
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]
     THEN1(METIS_TAC[extreal_real_lt , extreal_not_infty])
     THEN1(METIS_TAC[extreal_real_lt , extreal_not_infty])
THEN Q.EXISTS_TAC(`Normal r`)     
THEN SRW_TAC[] [GSPECIFICATION, EXTENSION]
THEN METIS_TAC[CONJ_COMM, CONJ_ASSOC]);




val after_set1_BIGUNION_IN_MESURABLE_SETS = store_thm(
  "after_set1_BIGUNION_IN_MESURABLE_SETS",
  ``    !t q.
              {w | real q < w /\ 0 <= w /\ w <= t} CROSS {u | u < real q} IN
            measurable_sets (pair_measure lborel lborel)``,


RW_TAC std_ss [pair_measure, measure_of, lborel,m_space_def, measurable_sets_def ]
   THEN1 (KNOW_TAC(``{w|  real q  < w:real /\ 0<= w/\ w <= t}  CROSS {u | u < real q}IN {a CROSS b | a IN subsets borel /\ b IN subsets borel}``)

             THEN1 (KNOW_TAC(``{u | u < real q} IN subsets borel``) 
                   THEN1(METIS_TAC[OPEN_INTERVAL_LEFT, borel_open])
                   THEN DISCH_TAC
                   THEN KNOW_TAC(``{w|  real q  < w:real /\ 0<= w/\ w <= t} IN subsets borel``)
                        THEN1 (KNOW_TAC(``{w|  real q  < w:real /\ 0<= w/\ w <= t} = {w|real q < w} INTER
	                        {w|0<=w /\ w<=t}``)
                              THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
                              THEN DISCH_TAC
		              THEN ONCE_ASM_REWRITE_TAC[]
		              THEN KNOW_TAC(``{w | real q < w} IN subsets borel /\
		         		 {w | 0 <= w /\ w <= t} IN subsets borel==>
					 ({w | real q < w} INTER
		                         {w | 0 <= w /\ w <= t} IN subsets borel)``)
			          THEN1(METIS_TAC[sigma_algebra_borel, algebra_def, sigma_algebra_def, ALGEBRA_ALT_INTER])
			          THEN DISCH_TAC
			          THEN KNOW_TAC(``{w | real q < w} IN subsets borel ``)
		                       THEN1(METIS_TAC[OPEN_INTERVAL_RIGHT, borel_open])
		    	          THEN DISCH_TAC
			          THEN KNOW_TAC(``{w | 0 <= w /\ w <= t} IN subsets borel``)
			               THEN1 (KNOW_TAC(``{w | 0 <= w:real /\ w <= t} = {w | 0 <= w} INTER
			 	                    {w| w <= t:real}``)
			   	                THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
				       THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
				        THEN METIS_TAC[borel_closed, CLOSED_INTERVAL_RIGHT, CLOSED_INTERVAL_LEFT,sigma_algebra_borel, algebra_def, sigma_algebra_def, ALGEBRA_ALT_INTER])
			        THEN DISCH_TAC
			        THEN FULL_SIMP_TAC std_ss[])
	           THEN DISCH_TAC 	  
	           THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]		  
                   THEN Q.EXISTS_TAC(`( {w | real q < w /\ 0 <= w /\ w <= t},{u | u < real q})`)
	           THEN SRW_TAC [] [GSPECIFICATION, EXTENSION])
            THEN DISCH_TAC
	    THEN METIS_TAC [sigma_sets_basic])

THEN KNOW_TAC(``univ(:real) CROSS univ(:real) = univ(:real#real)``)
    THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
THEN DISCH_TAC THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(`` {a CROSS b | a IN subsets borel /\ b IN subsets borel} SUBSET POW univ(:real#real)``)
     THEN1( RW_TAC std_ss [GSYM UNIV_FUN_TO_BOOL, SUBSET_UNIV])
THEN FULL_SIMP_TAC std_ss[] );


val after_set1_IN_MEASURABLE_SETS_PAIR_lborel = store_thm("after_set1_IN_MEASURABLE_SETS_PAIR_lborel",
  ``  !t. {(a,u) | u < a /\ 0 <= a /\ a <= t} IN
          measurable_sets (pair_measure lborel lborel) ``,
RW_TAC std_ss [GSYM after_set1_BIGUNION_Q]
THEN KNOW_TAC (``!q. q IN Q_set ==> ({w | real q < w /\ 0 <= w /\ w <= t} CROSS  {u | u < real q} )   IN measurable_sets (pair_measure lborel lborel)``)
     THEN1(METIS_TAC[after_set1_BIGUNION_IN_MESURABLE_SETS])
THEN DISCH_TAC
THEN KNOW_TAC(``BIGUNION
  { {w | real q < w /\ 0 <= w /\ w <= t} CROSS  {u | u < real q}  |
   q IN Q_set} = BIGUNION
  (IMAGE (\q. {w | real q < w /\ 0 <= w /\ w <= t} CROSS  {u | u < real q} )
   Q_set)``)
     THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION, IMAGE_DEF])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``measure_space (pair_measure lborel lborel)``)
     THEN1(METIS_TAC[ measure_space_pair_measure', measure_space_lborel, sigma_finite_measure_lborel])
THEN DISCH_TAC
THEN DEP_REWRITE_TAC[MEASURE_SPACE_BIGUNION_Q]
THEN RW_TAC std_ss[] );





val DFT_event_after1_PREIMAGE = store_thm("DFT_event_after1_PREIMAGE",
  `` ! p t X Y. DFT_event p (D_AND Y (D_BEFORE X Y)) t =
                PREIMAGE (\x. (Y x, X x)){(w,u)|u < w /\w <= Normal t} INTER p_space p``,

RW_TAC std_ss [DFT_event_AND_BEFORE, PREIMAGE_def]
THEN `(Y x,X x) IN {(w,u) | u <w /\ w<=Normal t} =
      ((Y x,X x) IN {(w,u) | (\a b. a < b /\ b <= Normal t )u w} )` by RW_TAC std_ss[]

THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]);

val DFT_event_after1_PREIMAGE_GT0 = store_thm(
  "DFT_event_after1_PREIMAGE_GT0",
  ``   !p t X Y.
       (!s. 0 <= Y s) ==>
       (DFT_event p (D_AND Y (D_BEFORE X Y)) t =
        PREIMAGE (\x. (Y x,X x))
          {(w,u) | u < w /\ 0 <= w /\ w <= Normal t} INTER p_space p)``,

RW_TAC std_ss [DFT_event_after1_PREIMAGE, PREIMAGE_def]
THEN `(Y x,X x) IN {(w,u) | u <w /\ 0<=w/\w<=Normal t} =
      ((Y x,X x) IN {(w,u) | (\a b. a < b /\0<=b/\ b <= Normal t )u w} )` by RW_TAC std_ss[]
THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]);





val PREIMAGE_EXTREAL_REAL_2RV_after1 = store_thm("PREIMAGE_EXTREAL_REAL_2RV_after1",
  ``!X Y t p.
       (!s. X s <> PosInf /\ 0 <= X s /\ Y s <> PosInf /\ 0 <= Y s) /\
       0 <= t ==>
       (PREIMAGE (\s. (Y s,X s))
          {(w,u) | u < w /\ 0 <= w /\ w <= Normal t} INTER p_space p =
        PREIMAGE (\s. (real( Y s),real (X s)))
          {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p)``, 

RW_TAC std_ss [PREIMAGE_def]
THEN KNOW_TAC(`` !s. (Y s,X s) IN {(w,u) | u < w /\ 0<=w/\w <= Normal t} =
                       X s < Y s /\ 0<= Y s/\ Y s <= Normal t``)
THEN1(RW_TAC std_ss [IN_ELIM_PAIR_THM])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(`` !s. (real (Y s),real(X s)) IN {(w,u) | u < w /\ 0<=w/\w <= t} =
                       real(X s) < real(Y s) /\ 0<= real (Y s) /\ real(Y s) <= t``)
THEN1(RW_TAC std_ss [IN_ELIM_PAIR_THM])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]
THEN EQ_TAC
THEN1 (RW_TAC std_ss[]
      THEN1 (KNOW_TAC (``X x <> NegInf ``)
      	    THEN1 (METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
      	    THEN DISCH_TAC
      	    THEN KNOW_TAC (``Y x <> NegInf ``)
      	    THEN1 (METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
      	    THEN DISCH_TAC
      	    THEN METIS_TAC [extreal_real_lt])
      THEN1(RW_TAC std_ss[real_def]
      THEN RW_TAC std_ss [REAL_LE_REFL]
      THEN SELECT_ELIM_TAC
      THEN RW_TAC std_ss []
      THEN1 (Q.EXISTS_TAC `real (Y x)`
      	    THEN METIS_TAC [normal_real])
      THEN METIS_TAC [extreal_le_eq, extreal_of_num_def])
      THEN RW_TAC std_ss[real_def]
      THEN SELECT_ELIM_TAC
      THEN RW_TAC std_ss []
      THEN1 (Q.EXISTS_TAC `real (Y x)`
      	    THEN METIS_TAC [normal_real])
      THEN METIS_TAC [extreal_le_eq, extreal_of_num_def])


THEN KNOW_TAC (``X x <> NegInf ``)
THEN1 (METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
THEN DISCH_TAC
THEN (`Y x <> NegInf ` by METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
THEN DISCH_TAC
THEN RW_TAC std_ss[]
THEN1 (METIS_TAC [extreal_real_lt])
THEN UNDISCH_TAC(``real (Y x) <= t``)
THEN REWRITE_TAC [real_def]
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
THEN1 (Q.EXISTS_TAC`real (Y x)`
      THEN METIS_TAC[normal_real])
THEN METIS_TAC [extreal_le_eq]);



val DFT_event_after1_PREIMAGE_GT0_REAL = store_thm("DFT_event_after1_PREIMAGE_GT0_REAL",
  `` !p t X Y.rv_gt0_ninfinity [X; Y] /\ 0 <= t==>
     (DFT_event p (D_AND Y (D_BEFORE X Y)) t =
     PREIMAGE (\x. (real (Y x),real (X x)))
         {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p) ``,

RW_TAC std_ss [DFT_event_after1_PREIMAGE_GT0,rv_gt0_ninfinity_def]
THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL_2RV_after1]);


val prob_after_diff_space = store_thm("prob_after_diff_space",
  `` !p Xa Y Z t. rv_gt0_ninfinity [Xa; Y; Z] /\ 0<= t /\ indep_varp p (pair_measure lborel lborel)
                (\x. (real (Xa x),real (Y x))) lborel (\x. real (Z x))
 ==> (prob p
     (DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
      (p_space p DIFF DFT_event p Z t)) =
      (1-prob p (DFT_event p Z t)) * prob p (DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t)) ``,

RW_TAC std_ss[indep_varp_def]
THEN KNOW_TAC(``(p_space p DIFF DFT_event p Z t) = {s | Normal t < Z s} INTER p_space p ``)
    THEN1 (RW_TAC std_ss[DFT_event_def]
           THEN SRW_TAC [] [GSPECIFICATION, EXTENSION, DIFF_DEF]
           THEN EQ_TAC THEN RW_TAC std_ss[] THEN METIS_TAC [extreal_lt_def, extreal_le_def])

THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]

THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num. {if i = 0 then
	  PREIMAGE (\s. (real (Xa s),real (Y s)))
                {(w,u) | u < w /\0<=w/\ w <= t} INTER p_space p else 
                 PREIMAGE (\s. real (Z s)) {u | t < u} INTER
              p_space p})`, `{0:num; 1}`,`(\i:num. if i = 0 then
	  PREIMAGE (\s. (real (Xa s),real (Y s)))
                {(w,u) | u < w /\0<=w/\ w <= t} INTER p_space p else 
                 PREIMAGE (\s. real (Z s)) {u | t < u} INTER
              p_space p):num->'a->bool`, `0:num`,`1:num`]  prob_prod_any_2_of_10_set)
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` indep_sets p
           (\i.
                {if i = 0 then
                   PREIMAGE (\x. (real (Xa x),real (Y x)))
                     {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p
                 else PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p})
           {0; 1}``)
      THEN1(FULL_SIMP_TAC std_ss[indep_sets]
            THEN RW_TAC std_ss[]
	         THEN(FULL_SIMP_TAC std_ss[Pi_iff]
		     THEN KNOW_TAC(``PREIMAGE (\x. (real (Xa x),real (Y x)))
      {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p IN events p ``)
      	       	     THEN1( KNOW_TAC(``!t. {(w,u) | u < w /\ 0 <= w /\ w <= t} IN measurable_sets (pair_measure lborel lborel)  ``)
		          THEN1(RW_TAC std_ss[after_set1_IN_MEASURABLE_SETS_PAIR_lborel])
		     THEN DISCH_TAC
		     THEN  REWRITE_TAC [events_def]
	   	     THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
                     THEN DISCH_TAC 
                    THEN KNOW_TAC(``prob_space p``) THEN1(FULL_SIMP_TAC std_ss [random_variable_def])
	   	    THEN DISCH_TAC

          THEN METIS_TAC [IN_MEASURABLE, p_space_def, random_variable_def, events_def, measurable_sets_def, m_space_def, space_def, subsets_def, prob_space_def, measure_space_lborel, sigma_finite_measure_lborel, random_variable_def])
	  THEN SRW_TAC [] [GSPECIFICATION, EXTENSION])
	  THEN1(  KNOW_TAC(`` PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p IN events p``)
                  THEN1(`{u | t<u} IN measurable_sets lborel` by METIS_TAC[borel_open, OPEN_INTERVAL_LEFT, OPEN_INTERVAL_RIGHT, lborel, borel, subsets_def, space_def, m_space_def, measurable_sets_def, PAIR, sigma_def]
		      THEN  REWRITE_TAC [events_def]
	   	     THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
                     THEN DISCH_TAC 
                    THEN KNOW_TAC(``prob_space p``) THEN1(FULL_SIMP_TAC std_ss [random_variable_def])
	   	    THEN DISCH_TAC
		     THEN METIS_TAC [IN_MEASURABLE, p_space_def, random_variable_def, events_def, measurable_sets_def, m_space_def, space_def, subsets_def, prob_space_def, measure_space_lborel, sigma_finite_measure_lborel, random_variable_def])
		  THEN SRW_TAC [] [GSPECIFICATION, EXTENSION] )
	THEN FULL_SIMP_TAC std_ss[Pi_iff]
	THEN `J SUBSET {0; 1} = (J = {0:num}) \/ (J = {1:num}) \/ (J= {0;1:num})` by ASM_SET_TAC[] 
	THEN FULL_SIMP_TAC std_ss[]	  
             THEN1(`{A j | j IN {0:num}} = {A 0}` by ASM_SET_TAC[]
	     	    THEN ONCE_ASM_REWRITE_TAC[]
		    THEN RW_TAC std_ss[BIGINTER_SING]
		    THEN RW_TAC std_ss[PRODUCT_SING]
		    THEN UNDISCH_TAC (`` !i:num.
             i IN {0} ==>
             A i IN
             {if i = 0 then
	         PREIMAGE (\x. (real (Xa x),real (Y x)))
                  {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p
              else PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p} ``)
	     	    THEN DISCH_TAC
		    THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num`)
 		    THEN PSET_TAC[]
		    THEN KNOW_TAC(``PREIMAGE (\x. (real (Xa x),real (Y x)))
      {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p IN events p ``)
      	       	     THEN1( KNOW_TAC(``!t. {(w,u) | u < w /\ 0 <= w /\ w <= t} IN measurable_sets (pair_measure lborel lborel)  ``)
		          THEN1(RW_TAC std_ss[after_set1_IN_MEASURABLE_SETS_PAIR_lborel])
		     THEN DISCH_TAC
		     THEN  REWRITE_TAC [events_def]
	   	     THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
                     THEN DISCH_TAC 
                    THEN KNOW_TAC(``prob_space p``) THEN1(FULL_SIMP_TAC std_ss [random_variable_def])
	   	    THEN DISCH_TAC

          THEN METIS_TAC [IN_MEASURABLE, p_space_def, random_variable_def, events_def, measurable_sets_def, m_space_def, space_def, subsets_def, prob_space_def, measure_space_lborel, sigma_finite_measure_lborel, random_variable_def])
	           THEN DISCH_TAC THEN METIS_TAC [PROB_FINITE, normal_real])
	   THEN1(`{A j | j IN {1:num}} = {A 1} ` by ASM_SET_TAC[]
	         THEN ONCE_ASM_REWRITE_TAC[]
		 THEN RW_TAC std_ss[BIGINTER_SING, PRODUCT_SING]    
		 THEN UNDISCH_TAC(``!i:num.
             i IN {1} ==>
             A i IN
             {if i = 0 then
                PREIMAGE (\x. (real (Xa x),real (Y x)))
		  {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p
              else PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p} ``)
	      THEN DISCH_TAC
	      THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num`)
	      THEN PSET_TAC[]
	      THEN KNOW_TAC(`` PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p IN events p``)
                  THEN1(`{u | t<u} IN measurable_sets lborel` by METIS_TAC[borel_open, OPEN_INTERVAL_LEFT, OPEN_INTERVAL_RIGHT, lborel, borel, subsets_def, space_def, m_space_def, measurable_sets_def, PAIR, sigma_def]
		      THEN  REWRITE_TAC [events_def]
	   	     THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
                     THEN DISCH_TAC 
                    THEN KNOW_TAC(``prob_space p``) THEN1(FULL_SIMP_TAC std_ss [random_variable_def])
	   	    THEN DISCH_TAC
		     THEN METIS_TAC [IN_MEASURABLE, p_space_def, random_variable_def, events_def, measurable_sets_def, m_space_def, space_def, subsets_def, prob_space_def, measure_space_lborel, sigma_finite_measure_lborel, random_variable_def])
		  THEN DISCH_TAC THEN METIS_TAC [PROB_FINITE, normal_real])

THEN WEAKEN_TAC (equal(Term` J SUBSET {0; 1} <=> (J = {0}) \/ (J = {1}) \/ (J = {0; 1:num})`))

THEN KNOW_TAC(``{(A:num->'a->bool) j | j IN {0:num; 1}}={A 0; A 1}``) THEN1( SRW_TAC [] [GSPECIFICATION, EXTENSION] THEN EQ_TAC THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[]) THEN RW_TAC std_ss[] THEN1(Q.EXISTS_TAC `0` THEN ASM_SET_TAC[]) THEN Q.EXISTS_TAC `1:num` THEN ASM_SET_TAC[])

THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN `FINITE {0:num} /\ FINITE {1:num} /\ DISJOINT {0:num} {1:num}/\ ({0;1:num} = {0} UNION {1})` by SRW_TAC  [] [GSPECIFICATION, EXTENSION, FINITE_DEF, DISJOINT_DEF]
THEN RW_TAC std_ss [BIGINTER_INTER,PRODUCT_UNION, PRODUCT_SING]

THEN KNOW_TAC(``( (A:num->'a->bool) 0 = PREIMAGE (\s. (real (Xa s),real (Y s)))
                  {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p) ``) 
     THEN1 (UNDISCH_TAC(``!i:num.
             i IN {0; 1} ==>
             A i IN
             {if i = 0 then
                PREIMAGE (\x. (real (Xa x),real (Y x)))
                  {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p
              else PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p}``)
     THEN DISCH_TAC
     THEN POP_ASSUM (MP_TAC o Q.SPEC `(0:num) `)
     THEN FULL_SIMP_TAC std_ss[prove(``0 IN {0;(1:num)}``,
     SRW_TAC[][EXTENSION,GSPECIFICATION])]
      THEN  PSET_TAC[])
      
THEN RW_TAC std_ss[]
THEN ASM_REWRITE_TAC[]

THEN `( (A:num->'a->bool) (1:num) = PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p)` by

  (UNDISCH_TAC(``!i:num.
             i IN {0; 1} ==>
             A i IN
             {if i = 0 then
	     PREIMAGE (\x. (real (Xa x),real (Y x)))
	       {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p
              else PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p}``)
     THEN DISCH_TAC
     THEN POP_ASSUM (MP_TAC o Q.SPEC `(1:num) `)
     THEN FULL_SIMP_TAC std_ss[prove(``1 IN {0;(1:num)}``,
     SRW_TAC[][EXTENSION,GSPECIFICATION])]
      THEN  PSET_TAC[])
      

THEN ASM_REWRITE_TAC[]
THEN FULL_SIMP_TAC std_ss[]
THEN `prob_space p` by FULL_SIMP_TAC std_ss[random_variable_def]
THEN UNDISCH_TAC(`` !(J' :num -> bool).
             J' SUBSET {(0 :num)} UNION {(1 :num)} /\
             J' <> ({} :num -> bool) /\ FINITE J' ==>
             !(A' :num -> 'a -> bool).
                 (!(i :num).
                      i IN J' ==>
                      A' i IN
                      {if i = (0 :num) then
                        PREIMAGE
                          (\(x :'a).
                               (real ((Xa :'a -> extreal) x),
                                real ((Y :'a -> extreal) x))) A INTER
                        p_space
                          (p :
                             ('a -> bool) #
                             (('a -> bool) -> bool) #
                             (('a -> bool) -> extreal))
                      else
                        PREIMAGE (\(x :'a). real ((Z :'a -> extreal) x)) B INTER
                        p_space p |
                      if i = (0 :num) then
                        A IN measurable_sets (pair_measure lborel lborel)
                      else B IN measurable_sets lborel}) ==>
                 (prob p (BIGINTER {A' j | j IN J'}) =
                  Normal (product J' (\(j :num). real (prob p (A' j)))))``)
THEN DISCH_TAC
THEN POP_ASSUM (MP_TAC o Q.SPEC `{0;1:num}`)
THEN `{0; 1} SUBSET {0} UNION {1:num} /\ {0; 1:num} <> {} /\ FINITE {0; 1:num}` by PSET_TAC[]
THEN RW_TAC std_ss[]
THEN POP_ASSUM (MP_TAC o Q.SPEC `(\i. if i = 0 then
				    PREIMAGE (\x. (real ((Xa:'a->extreal) x),real (Y x))) {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p else
				     PREIMAGE (\s. real (Z s)) {u | t < u:real} INTER p_space p)`)
THEN DISCH_TAC
THEN `{0:num} UNION {1} = {0;1}` by ASM_SET_TAC[]
THEN FULL_SIMP_TAC std_ss[]
THEN `{u | t<u} IN measurable_sets lborel` by METIS_TAC[borel_open, OPEN_INTERVAL_LEFT, OPEN_INTERVAL_RIGHT, lborel, borel, subsets_def, space_def, m_space_def, measurable_sets_def, PAIR, sigma_def]
THEN  KNOW_TAC(``!t. {(w,u) | u < w /\ 0 <= w /\ w <= t} IN measurable_sets (pair_measure lborel lborel)  ``)
      THEN1(RW_TAC std_ss[after_set1_IN_MEASURABLE_SETS_PAIR_lborel])
THEN DISCH_TAC
THEN KNOW_TAC (`` (! (i :num).
              i IN {0;1:num} ==>
              (\ (i :num).
                   if i = (0 :num) then
                     PREIMAGE
                       (\(x :'a).
                            (real ((Xa :'a -> extreal) x),
                             real ((Y :'a -> extreal) x)))
                       {(w,u) | u < w /\ (0 :real) <= w /\ w <= (t :real)} INTER
                     p_space
                       (p :
                          ('a -> bool) #
                          (('a -> bool) -> bool) # (('a -> bool) -> extreal))
                   else
                     PREIMAGE (\(s :'a). real ((Z :'a -> extreal) s))
                       {u | t < u} INTER p_space p) i IN
              {if i = (0 :num) then
                PREIMAGE (\(x :'a). (real (Xa x),real (Y x))) A INTER
                p_space p
              else PREIMAGE (\(x :'a). real (Z x)) B INTER p_space p |
              if i = (0 :num) then
                A IN measurable_sets (pair_measure lborel lborel)
              else B IN measurable_sets lborel}) ``)
	   THEN1(ASM_SET_TAC[])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``{if j = 0:num then
                PREIMAGE (\x. (real (Xa x),real (Y x)))
                  {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p
              else PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p |
              j IN {0; 1}} = {
                PREIMAGE (\x. (real (Xa x),real (Y x)))
                  {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p
              ; PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p } ``)
     THEN1(RW_TAC std_ss [GSPECIFICATION, EXTENSION]
           THEN PSET_TAC [PREIMAGE_def]
           THEN EQ_TAC
	      THEN1(RW_TAC std_ss[]
	            THEN1( ASM_SET_TAC[])
	            THEN ASM_SET_TAC[])
	   THEN DISCH_TAC
          THEN RW_TAC std_ss[]
	  THEN1(Q.EXISTS_TAC`0:num`
		 THEN ASM_SET_TAC[])

          THEN Q.EXISTS_TAC`1:num`
	  THEN RW_TAC std_ss[])
    THEN DISCH_TAC
    THEN FULL_SIMP_TAC std_ss[]
    THEN `FINITE {0:num} /\FINITE {1:num} /\ DISJOINT {0:num} {1:num} /\ ( {0:num;1} = {0} UNION {1}) `
    by SRW_TAC[] [GSPECIFICATION, EXTENSION]
    THEN  FULL_SIMP_TAC std_ss [PRODUCT_UNION]
    THEN FULL_SIMP_TAC std_ss [PRODUCT_SING]
    THEN FULL_SIMP_TAC std_ss [BIGINTER_INTER]
    THEN FULL_SIMP_TAC std_ss [REAL_MUL_COMM]

    THEN rw_tac std_ss [PRODUCT_UNION]
    THEN rw_tac std_ss[PRODUCT_SING]
    THEN FULL_SIMP_TAC std_ss [BIGINTER_INTER]
    THEN FULL_SIMP_TAC std_ss [REAL_MUL_COMM])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(`` (!i.
              i IN {0:num; 1} ==>
              (if i = 0 then
                 PREIMAGE (\s. (real (Xa s),real (Y s)))
                   {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p
               else PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. (real (Xa s),real (Y s)))
                   {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p
               else PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p})``)
     THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]     
 THEN `{u | t<u} IN measurable_sets lborel` by METIS_TAC[borel_open, OPEN_INTERVAL_LEFT, OPEN_INTERVAL_RIGHT, lborel, borel, subsets_def, space_def, m_space_def, measurable_sets_def, PAIR, sigma_def]
THEN  KNOW_TAC(``!t. {(w,u) | u < w /\ 0 <= w /\ w <= t} IN measurable_sets (pair_measure lborel lborel)  ``)
      THEN1(RW_TAC std_ss[after_set1_IN_MEASURABLE_SETS_PAIR_lborel])
THEN DISCH_TAC

THEN KNOW_TAC(``(!i.
              i IN {0:num; 1} ==>
              (if i = 0 then
                 PREIMAGE (\s. (real (Xa s),real (Y s)))
                   {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p
               else PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p) IN
              events p) ``)         
	THEN1(RW_TAC std_ss[] THEN METIS_TAC[random_variable_def, p_space_def, events_def, m_space_def, space_def, subsets_def, measurable_sets_def, IN_MEASURABLE, prob_space_def ])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN `prob_space p` by FULL_SIMP_TAC std_ss[random_variable_def]
THEN `{0; 1} SUBSET {0; 1:num}` by ASM_SET_TAC[]
THEN FULL_SIMP_TAC std_ss[]


THEN KNOW_TAC(`` prob p
     (DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
      ({s | Normal t < Z s} INTER p_space p)) = prob p
           (PREIMAGE (\s. (real (Xa s),real (Y s)))
              {(w,u) | u < w /\ 0 <= w /\ w <= t} INTER p_space p INTER
            (PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p))``)
     THEN1(`rv_gt0_ninfinity [ Y; Xa]` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
           THEN `!s. 0<= Xa s` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
           THEN RW_TAC std_ss[DFT_event_after1_PREIMAGE_GT0_REAL]
	   THEN `{s | Normal t < Z s} = PREIMAGE Z {s | Normal t < s}` by ASM_SET_TAC [PREIMAGE_def]
   	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN KNOW_TAC(`` (PREIMAGE Z {s|  Normal t < s} INTER p_space p =
	 PREIMAGE (\s. real (Z s)) {s|t:real <s} INTER p_space p)``) 
                THEN1(PSET_TAC[PREIMAGE_def]THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]
		THEN EQ_TAC THEN1(RW_TAC std_ss[]
     	                         THEN RW_TAC std_ss [real_def]
	    	                      THEN1( METIS_TAC [lt_le, le_lt, lt_infty, le_infty, extreal_lt_def, extreal_le_def, extreal_of_num_def, rv_gt0_ninfinity_def])
                                 THEN1(FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
				       THEN METIS_TAC[])
				 THEN SELECT_ELIM_TAC
	    			 THEN RW_TAC std_ss[]
	    	 		     THEN1(Q.EXISTS_TAC` real (Z x)`
		                          THEN METIS_TAC [normal_real])
		                 THEN `Normal t < Normal x'` by METIS_TAC[]
				 THEN METIS_TAC [extreal_lt_eq,lt_le, le_lt, lt_infty, le_infty, extreal_lt_def, extreal_le_def, extreal_of_num_def])
                    THEN RW_TAC std_ss[]
		    THEN FULL_SIMP_TAC std_ss [real_def]
		    THEN UNDISCH_TAC(``t < if (Z x = NegInf) \/ (Z x = PosInf) then 0
         else @r. Z x = Normal r``) 
                    THEN SELECT_ELIM_TAC
		    THEN RW_TAC std_ss[] THEN1 (Q.EXISTS_TAC` real (Z x)`
     	    	            THEN METIS_TAC [normal_real,lt_le, le_lt, lt_infty, le_infty, extreal_lt_def, extreal_le_def, extreal_of_num_def, rv_gt0_ninfinity_def])
                   THEN METIS_TAC [extreal_lt_eq,normal_real,lt_le, le_lt, lt_infty, le_infty, extreal_lt_def, extreal_le_def, extreal_of_num_def])
	THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
	THEN RW_TAC std_ss[])
THEN DISCH_TAC
THEN RW_TAC std_ss[]
THEN `rv_gt0_ninfinity [Y; Xa]` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
THEN RW_TAC std_ss[GSYM DFT_event_after1_PREIMAGE_GT0_REAL]

THEN KNOW_TAC(``PREIMAGE (\s. real (Z s)) {u | t < u} INTER p_space p = p_space p DIFF PREIMAGE (\s. real (Z s)) {u |u <= t:real} INTER p_space p ``)
     THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION]
          THEN PSET_TAC [PREIMAGE_def]
	  THEN EQ_TAC
	       THEN1(RW_TAC std_ss[] THEN METIS_TAC[real_lt])
	   THEN RW_TAC std_ss[] THEN METIS_TAC[real_lt])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]	   
THEN KNOW_TAC(`` PREIMAGE (\s. real (Z s)) {u | u<=t } INTER p_space p IN events p``)
                  THEN1(`{u | u<=t} IN measurable_sets lborel` by METIS_TAC[borel_closed, CLOSED_INTERVAL_LEFT, CLOSED_INTERVAL_RIGHT, lborel, borel, subsets_def, space_def, m_space_def, measurable_sets_def, PAIR, sigma_def]
		      THEN  REWRITE_TAC [events_def]
	   	     THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
                     THEN DISCH_TAC 
                    THEN KNOW_TAC(``prob_space p``) THEN1(FULL_SIMP_TAC std_ss [random_variable_def])
	   	    THEN DISCH_TAC
		     THEN METIS_TAC [IN_MEASURABLE, p_space_def, random_variable_def, events_def, measurable_sets_def, m_space_def, space_def, subsets_def, prob_space_def, measure_space_lborel, sigma_finite_measure_lborel, random_variable_def])
THEN DISCH_TAC		     
THEN KNOW_TAC(``  prob p
     (p_space p DIFF PREIMAGE (\s. real (Z s)) {u | u <= t} INTER p_space p) = 1-prob p (PREIMAGE (\s. real (Z s)) {u | u <= t} INTER p_space p) ``)		     
     THEN1 ( DEP_REWRITE_TAC[PROB_COMPL]
             THEN RW_TAC std_ss[])
THEN DISCH_TAC THEN RW_TAC std_ss[]
THEN `!s. Z s <> PosInf /\ 0<= Z s` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
THEN RW_TAC std_ss[GSYM PREIMAGE_EXTREAL_REAL]
THEN KNOW_TAC(`` prob p (PREIMAGE Z {u | u <= Normal t} INTER p_space p) = prob p (DFT_event p Z t)``)
THEN1(  RW_TAC std_ss[ DFT_event_def, PREIMAGE_def]
        THEN ASM_SET_TAC[])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN METIS_TAC[ mul_comm]);




val prob_shared_spare_initial_2 = store_thm("prob_shared_spare_initial_2",
  `` !p t Xa Xd  Y Z f_xay f_condxa_y f_y f_z.
  0 <= t /\
          indep_varp p lborel (\x. real (Z x)) (pair_measure lborel lborel)
            (\x. (real (Y x),real (Xd x))) /\
	  indep_var p lborel (\x. real (Y x)) lborel (\x. real (Xd x)) /\  
          distributed p lborel (\x. real (Z x)) f_z /\ (!z. 0 <= f_z z) /\
          distributed p lborel (\x. real (Y x)) f_y /\ (!x. 0 <= f_y x) /\
          cont_CDF p (\s. real (Xd s)) /\ measurable_CDF p (\s. real (Xd s))/\
          (!x. (\s. real (CDF p (\x. real (Xd x)) s)) contl x) /\
	  indep_var p lborel (\s. real (Z s)) lborel (\s. real (Y s)) /\
         cont_CDF p (\s. real (Z s)) /\ measurable_CDF p (\s. real (Z s)) /\
(!s. ALL_DISTINCT [Xa s; Xd s; Y s; Z s])/\ 
prob_space p /\ den_gt0_ninfinity f_xay f_y f_condxa_y /\
          rv_gt0_ninfinity [Xa; Xd; Y; Z] /\
          (!y.
               cond_density lborel lborel p (\x. real (Xa x)) (\x. real (Y x))
                 y f_xay f_y f_condxa_y) /\
          indep_varp p (pair_measure lborel lborel)
            (\x. (real (Xa x),real (Y x))) lborel (\x. real (Z x)) /\
          (!z. 0 <= f_z z) /\ (!x. f_xay x <> PosInf) /\
          distributed p lborel (\x. real (Z x)) f_z ==>
(prob p
             (DFT_event p (D_AND (D_AND Xa (D_BEFORE Y Z)) (D_BEFORE Z Xa)) t) +
           prob p
             (DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t) +
           prob p
             (DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
              (p_space p DIFF DFT_event p Z t)) +
           prob p
             (DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t) +
           prob p
             (DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
              (p_space p DIFF DFT_event p Z t)) +
           prob p (DFT_event p (D_AND Y (D_BEFORE Z Y)) t) =
	    pos_fn_integral lborel
     (\y.
          f_y y * indicator_fn {y' | 0 <= y' /\ y' <= t} y *
          pos_fn_integral lborel
            (\x.
                 f_condxa_y y x * indicator_fn {x' | y < x' /\ x' <= t} x *
                 pos_fn_integral lborel
                   (\z. f_z z * indicator_fn {z' | y < z' /\ z' < x} z))) +
   pos_fn_integral lborel
     (\z.
          f_z z * indicator_fn {z' | 0 <= z' /\ z' <= t} z *
          pos_fn_integral lborel
            (\y.
                 f_y y * indicator_fn {y' | 0 <= y' /\ y' < z} y *
                 pos_fn_integral lborel
                   (\x.
                        f_condxa_y y x *
                        indicator_fn {x' | y < x' /\ x' < z} x))) +
   (1 - CDF p (\x. real (Z x)) t) *
   pos_fn_integral lborel
     (\y.
          indicator_fn {u | 0 <= u /\ u <= t} y * f_y y *
          pos_fn_integral lborel
            (\x. indicator_fn {w | y < w /\ w <= t} x * f_condxa_y y x)) +
   pos_fn_integral lborel
     (\z.
          f_z z * indicator_fn {z' | 0 <= z' /\ z' <= t} z *
          pos_fn_integral lborel
            (\y.
                 f_y y * indicator_fn {y' | 0 <= y' /\ y' < z} y *
                 CDF p (\x. real (Xd x)) y)) +
   (1 - CDF p (\x. real (Z x)) t) *
   pos_fn_integral lborel
     (\y.
          f_y y *
          (indicator_fn {y' | 0 <= y' /\ y' <= t} y *
           CDF p (\s. real (Xd s)) y)) +
   pos_fn_integral lborel
     (\y.
          f_y y *
          (indicator_fn {y' | 0 <= y' /\ y' <= t} y *
           CDF p (\s. real (Z s)) y)))``,
RW_TAC std_ss[]
THEN `rv_gt0_ninfinity [Xa; Y ; Z]` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
THEN KNOW_TAC(``  prob p (DFT_event p (D_AND (D_AND Xa (D_BEFORE Y Z)) (D_BEFORE Z Xa)) t)=
                  pos_fn_integral lborel
             (\y.
                  f_y y * indicator_fn {y' | 0 <= y' /\ y' <= t} y *
                  pos_fn_integral lborel
                    (\x.
                         f_condxa_y y x *
                         indicator_fn {x' | y < x' /\ x' <= t} x *
                         pos_fn_integral lborel
                           (\z.
                                f_z z *
                                indicator_fn {z' | y < z' /\ z' < x} z)))``)
    THEN1(METIS_TAC[prob_event1_shared_spare])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``  prob p (DFT_event p (D_AND (D_AND Z (D_BEFORE Y Xa)) (D_BEFORE Xa Z)) t) =
                   pos_fn_integral lborel
             (\z.
                  f_z z * indicator_fn {z' | 0 <= z' /\ z' <= t} z *
                  pos_fn_integral lborel
                    (\y.
                         f_y y * indicator_fn {y' | 0 <= y' /\ y' < z} y *
                         pos_fn_integral lborel
                           (\x.
                                f_condxa_y y x *
                                indicator_fn {x' | y < x' /\ x' < z} x)))``)
     THEN1(METIS_TAC[prob_event2_shared_spare])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]     
THEN KNOW_TAC(`` prob p (DFT_event p (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) t) =
            pos_fn_integral lborel
             (\z.
                  f_z z * indicator_fn {z' | 0 <= z' /\ z' <= t} z *
                  pos_fn_integral lborel
                    (\y.
                         f_y y * indicator_fn {y' | 0 <= y' /\ y' < z} y *
                         CDF p (\x. real (Xd x)) y))``)
    THEN1(KNOW_TAC(`` (D_AND (D_AND Z (D_BEFORE Xd Y)) (D_BEFORE Y Z)) = P_AND (P_AND Xd Y)(Z)``)
          THEN1( RW_TAC std_ss[D_AND_def, D_BEFORE_def, P_AND_def]
   	      THEN KNOW_TAC(`` !s. (
        max (max (Z s) (if Xd s < Y s then Xd s else PosInf))
          (if Y s < Z s then Y s else PosInf)) =
   ( if (if Xd s <= Y s then Y s else PosInf) <= Z s then Z s else PosInf)``)
                   THEN1(RW_TAC std_ss[extreal_max_def, extreal_min_def] THEN FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def] THEN METIS_TAC [lt_le, le_lt, lt_trans, le_trans, lt_infty, le_infty, extreal_of_num_def, ALL_DISTINCT, MEM])
	      THEN RW_TAC std_ss[])
	      THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
	      THEN `(!s. ALL_DISTINCT [Z s; Y s; Xd s])` by METIS_TAC [ALL_DISTINCT, MEM]
	      THEN `rv_gt0_ninfinity [Z; Y; Xd]` by METIS_TAC [rv_gt0_ninfinity_def]
	      
	      THEN RW_TAC std_ss[prob_CPDFT, cont_CDF_def, indep_CPAND_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``prob p
     (DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t INTER
      (p_space p DIFF DFT_event p Z t)) =
      (1-prob p (DFT_event p Z t)) * prob p (DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t)  ``)
     THEN1( DEP_REWRITE_TAC[prob_after_diff_space]
     THEN `rv_gt0_ninfinity [Xa; Y; Z]` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
     THEN RW_TAC std_ss[])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]     
THEN KNOW_TAC(``  prob p
     (DFT_event p (D_AND Y (D_BEFORE Xd Y)) t INTER
      (p_space p DIFF DFT_event p Z t)) =
       (1-prob p (DFT_event p Z t)) * prob p (DFT_event p (D_AND Y (D_BEFORE Xd Y)) t)``)
     THEN1(DEP_REWRITE_TAC[prob_after_diff_space]
           THEN `rv_gt0_ninfinity [Y; Xd; Z]` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
           THEN RW_TAC std_ss[]
     	   THEN FULL_SIMP_TAC std_ss[indep_varp_def]
     	   THEN FULL_SIMP_TAC std_ss[indep_sets]
     	   THEN RW_TAC std_ss[]
     	        THEN1( KNOW_TAC(`` { PREIMAGE (\x. (real (Y x),real (Xd x))) A INTER p_space p|
	    A IN measurable_sets (pair_measure lborel lborel)} SUBSET events p``)
              	      THEN1( KNOW_TAC(`` !A. A IN measurable_sets (pair_measure lborel lborel) ==>PREIMAGE (\x. (real (Y x),real (Xd x))) A INTER p_space p IN events p ``)
	                     THEN1(RW_TAC std_ss[]
	   		            THEN METIS_TAC [random_variable_def, p_space_def, m_space_def, space_def, events_def, measurable_sets_def, subsets_def, IN_MEASURABLE])
	                     THEN ASM_SET_TAC[])
 	   	        THEN KNOW_TAC(``{PREIMAGE (\x. real (Z x)) B INTER p_space p |
           B IN measurable_sets lborel} SUBSET events p ``)
		      	      THEN1(KNOW_TAC(``!B. B IN measurable_sets lborel ==> PREIMAGE (\x. real (Z x)) B INTER p_space p IN events p ``)	    
			            THEN1(RW_TAC std_ss[]
		  	                  THEN METIS_TAC [random_variable_def, p_space_def, m_space_def, space_def, events_def, measurable_sets_def, subsets_def, IN_MEASURABLE])
	                             THEN ASM_SET_TAC[])
		              THEN ASM_SET_TAC[])
          THEN  FULL_SIMP_TAC std_ss[Pi_iff] 		  
      	  THEN `J SUBSET {0;1:num} = (J = {0}) \/ (J = {1}) \/ (J = {0;1})` by ASM_SET_TAC[]

      	  THEN FULL_SIMP_TAC std_ss[]
	       THEN1(UNDISCH_TAC(``    !(J' :num -> bool).
	             J' SUBSET {(0 :num); (1 :num)} /\ J' <> ({} :num -> bool) /\
		     FINITE J' ==>
		     !(A' :num -> 'a -> bool).
		     (!(i :num).
		     i IN J' ==>
		     A' i IN
		     {if i = (0 :num) then
		     PREIMAGE (\ (x :'a). real ((Z :'a -> extreal) x)) A INTER
		     p_space
		     (p :
		     ('a -> bool) #
		     (('a -> bool) -> bool) #
		     (('a -> bool) -> extreal))
		     else
		     PREIMAGE
		     (\ (x :'a).
		     (real ((Y :'a -> extreal) x),
		     real ((Xd :'a -> extreal) x))) B INTER
		     p_space p |
		     if i = (0 :num) then A IN measurable_sets lborel
		     else B IN measurable_sets (pair_measure lborel lborel)}) ==>
		     (prob p (BIGINTER {A' j | j IN J'}) =
		     Normal (product J' (\ (j :num). real (prob p (A' j)))))``)		
	       	     THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `{0:num}`)
	       	     THEN `{0} SUBSET {0; 1:num} /\ {0:num} <> {} /\ FINITE {0:num}` by SRW_TAC [] [GSPECIFICATION, EXTENSION]
		     THEN RW_TAC std_ss[]
		     THEN `{A j| j IN {0:num}} = {A 0}` by ASM_SET_TAC[]
		     THEN ONCE_ASM_REWRITE_TAC[]
		     THEN RW_TAC std_ss[BIGINTER_SING, PRODUCT_SING]
		     THEN UNDISCH_TAC(`` !(A' :num -> 'a -> bool).
		     (!(i :num).
		     i IN {(0 :num)} ==>
		     A' i IN
		     {if i = (0 :num) then
		     PREIMAGE (\ (x :'a). real ((Z :'a -> extreal) x)) A INTER
		     p_space
		     (p :
		     ('a -> bool) #
		     (('a -> bool) -> bool) # (('a -> bool) -> extreal))
		     else
		     PREIMAGE
		     (\ (x :'a).
		     (real ((Y :'a -> extreal) x),
		     real ((Xd :'a -> extreal) x))) B INTER p_space p |
		     if i = (0 :num) then A IN measurable_sets lborel
		     else B IN measurable_sets (pair_measure lborel lborel)}) ==>
		     (prob p (BIGINTER {A' j | j IN {(0 :num)}}) =
		     Normal (product {(0 :num)} (\ (j :num). real (prob p (A' j)))))
		     ``)
		     THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `A:num->'a->bool`)
		     THEN RW_TAC std_ss[]
		     
		     THEN KNOW_TAC(``(!i.
		     i IN {0} ==>
		     (A:num->'a->bool) i IN
		     {if i:num = 0 then PREIMAGE (\x. real (Z x)) A INTER p_space p
		     else PREIMAGE (\x. (real (Y x),real (Xd x))) B INTER p_space p |
		     if i = 0 then A IN measurable_sets lborel
		     else B IN measurable_sets (pair_measure lborel lborel)})``)
		         THEN1(KNOW_TAC(`` {if i:num = 0 then
           		        PREIMAGE (\x. (real (Y x),real (Xd x))) A INTER p_space p
				else PREIMAGE (\x. real (Z x)) B INTER p_space p |
				if i:num = 0 then A IN measurable_sets (pair_measure lborel lborel)
				else B IN measurable_sets lborel} =    {if i:num = 0 then PREIMAGE (\x. real (Z x)) A INTER p_space p
				else PREIMAGE (\x. (real (Y x),real (Xd x))) B INTER p_space p |
				if i:num = 0 then A IN measurable_sets lborel
				else B IN measurable_sets (pair_measure lborel lborel)}``)
   			        THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION]
          			      THEN EQ_TAC
             			           THEN1 (RW_TAC std_ss[]
	            		 	         THEN Q.EXISTS_TAC`((1-FST (x':num#real reln#(real->bool))), (SND (SND x')), (FST (SND x')))`
						 THEN KNOW_TAC(``(\ (i,A,B).
								(if i = 0 then
								PREIMAGE (\x. (real (Y x),real (Xd x))) A INTER p_space p
								else PREIMAGE (\x. real (Z x)) B INTER p_space p,
								if i = 0 then
								A IN measurable_sets (pair_measure lborel lborel)
								else B IN measurable_sets lborel)) (x':num#real reln#(real->bool)) = 
								(if (FST x') = 0 then
								PREIMAGE (\x. (real (Y x),real (Xd x))) (FST (SND x')) INTER p_space p
								else PREIMAGE (\x. real (Z x)) (SND (SND x')) INTER p_space p,
								if (FST x') = 0 then
								(FST (SND x')) IN measurable_sets (pair_measure lborel lborel)
								else (SND (SND x')) IN measurable_sets lborel)  ``)
						      THEN1( `(x':num#real reln#(real->bool)) = (FST x', (FST (SND x')), (SND (SND x')))` by RW_TAC std_ss[PAIR]
            	             			             THEN ONCE_ASM_REWRITE_TAC[]
            		     			             THEN RW_TAC std_ss[PAIR, LAMBDA_PROD])
                                              THEN DISCH_TAC	    
                  			      THEN ONCE_ASM_REWRITE_TAC[]
					      THEN KNOW_TAC(``(\(i,A,B).
					      (if i = 0 then PREIMAGE (\x. real (Z x)) A INTER p_space p
					      else PREIMAGE (\x. (real (Y x),real (Xd x))) B INTER p_space p,
					      if i = 0 then A IN measurable_sets lborel
					      else B IN measurable_sets (pair_measure lborel lborel)))
					      ( 1-FST x',SND (SND x'),FST (SND (x':num#real reln#(real->bool)))) =  (if (1-FST x') = 0 then PREIMAGE (\x. real (Z x)) (SND (SND x')) INTER p_space p
					      else PREIMAGE (\x. (real (Y x),real (Xd x))) (FST (SND x')) INTER p_space p,
					      if (1-FST x') = 0 then (SND (SND x')) IN measurable_sets lborel
					      else (FST (SND x')) IN measurable_sets (pair_measure lborel lborel))``)
					           THEN1(RW_TAC std_ss[PAIR, LAMBDA_PROD] )
				             THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
					     THEN Cases_on`FST x' = 0:num`
         				          THEN1( RW_TAC std_ss[])
    					     THEN  RW_TAC std_ss[]  THEN FULL_SIMP_TAC std_ss[NOT_LESS_EQUAL]
         				     THEN METIS_TAC[LESS_LESS_SUC,ONE, NOT_ZERO_LT_ZERO])
    			         THEN RW_TAC std_ss[]
   				 THEN  Q.EXISTS_TAC`((1-FST (x':num#(real->bool)#real reln)), (SND (SND x')), (FST (SND x')))`
				 THEN KNOW_TAC(``(\ (i,A,B).
				 (if i = 0 then PREIMAGE (\x. real (Z x)) A INTER p_space p
				 else PREIMAGE (\x. (real (Y x),real (Xd x))) B INTER p_space p,
				 if i = 0 then A IN measurable_sets lborel
				 else B IN measurable_sets (pair_measure lborel lborel))) (x':num#(real->bool)#real reln) = (if (FST x') = 0 then PREIMAGE (\x. real (Z x)) (FST (SND x')) INTER p_space p
				 else PREIMAGE (\x. (real (Y x),real (Xd x)))(SND (SND x')) INTER p_space p,
				 if (FST x') = 0 then (FST (SND (x')) )IN measurable_sets lborel
				 else (SND (SND x')) IN measurable_sets (pair_measure lborel lborel))
				 ``)
    				     THEN1(`x':num#(real->bool)#real reln = (FST (x'), (FST (SND x')), SND (SND x'))` by RW_TAC std_ss[]
           			           THEN ONCE_ASM_REWRITE_TAC[] THEN RW_TAC std_ss[PAIR, LAMBDA_PROD])
				THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]   
				THEN Cases_on`FST(x':num#(real->bool)#real reln) = 0`
	    			     THEN1(RW_TAC std_ss[]
	          		  	   THEN FULL_SIMP_TAC std_ss[])
				THEN RW_TAC std_ss[]
				     THEN1(FULL_SIMP_TAC std_ss[NOT_LESS_EQUAL]
				           THEN METIS_TAC[LESS_LESS_SUC,ONE, NOT_ZERO_LT_ZERO]) 
				     THEN1(FULL_SIMP_TAC std_ss[])
				THEN FULL_SIMP_TAC std_ss[NOT_LESS_EQUAL]
				THEN METIS_TAC[LESS_LESS_SUC,ONE, NOT_ZERO_LT_ZERO])
		           THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[])
	              THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
		      THEN FULL_SIMP_TAC std_ss[BIGINTER_SING, PRODUCT_SING])


	       THEN1(UNDISCH_TAC(``    !(J' :num -> bool).
	             J' SUBSET {(0 :num); (1 :num)} /\ J' <> ({} :num -> bool) /\
		     FINITE J' ==>
		     !(A' :num -> 'a -> bool).
		     (!(i :num).
		     i IN J' ==>
		     A' i IN
		     {if i = (0 :num) then
		     PREIMAGE (\ (x :'a). real ((Z :'a -> extreal) x)) A INTER
		     p_space
		     (p :
		     ('a -> bool) #
		     (('a -> bool) -> bool) #
		     (('a -> bool) -> extreal))
		     else
		     PREIMAGE
		     (\ (x :'a).
		     (real ((Y :'a -> extreal) x),
		     real ((Xd :'a -> extreal) x))) B INTER
		     p_space p |
		     if i = (0 :num) then A IN measurable_sets lborel
		     else B IN measurable_sets (pair_measure lborel lborel)}) ==>
		     (prob p (BIGINTER {A' j | j IN J'}) =
		     Normal (product J' (\ (j :num). real (prob p (A' j)))))``)		
	       	     THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `{1:num}`)
	       	     THEN `{1} SUBSET {0; 1:num} /\ {1:num} <> {} /\ FINITE {1:num}` by SRW_TAC [] [GSPECIFICATION, EXTENSION]
		     THEN RW_TAC std_ss[]
		     THEN `{A j| j IN {1:num}} = {A 1}` by ASM_SET_TAC[]
		     THEN ONCE_ASM_REWRITE_TAC[]
		     THEN RW_TAC std_ss[BIGINTER_SING, PRODUCT_SING]
		     THEN UNDISCH_TAC(`` !(A' :num -> 'a -> bool).
		     (!(i :num).
		     i IN {(1 :num)} ==>
		     A' i IN
		     {if i = (0 :num) then
		     PREIMAGE (\ (x :'a). real ((Z :'a -> extreal) x)) A INTER
		     p_space
		     (p :
		     ('a -> bool) #
		     (('a -> bool) -> bool) # (('a -> bool) -> extreal))
		     else
		     PREIMAGE
		     (\ (x :'a).
		     (real ((Y :'a -> extreal) x),
		     real ((Xd :'a -> extreal) x))) B INTER p_space p |
		     if i = (0 :num) then A IN measurable_sets lborel
		     else B IN measurable_sets (pair_measure lborel lborel)}) ==>
		     (prob p (BIGINTER {A' j | j IN {(1 :num)}}) =
		     Normal (product {(1 :num)} (\ (j :num). real (prob p (A' j)))))
		     ``)
		     THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `A:num->'a->bool`)
		     THEN RW_TAC std_ss[]
		     
		     THEN KNOW_TAC(``(!i.
		     i IN {1} ==>
		     (A:num->'a->bool) i IN
		     {if i:num = 0 then PREIMAGE (\x. real (Z x)) A INTER p_space p
		     else PREIMAGE (\x. (real (Y x),real (Xd x))) B INTER p_space p |
		     if i = 0 then A IN measurable_sets lborel
		     else B IN measurable_sets (pair_measure lborel lborel)})``)
		         THEN1(KNOW_TAC(`` {if i:num = 0 then
           		        PREIMAGE (\x. (real (Y x),real (Xd x))) A INTER p_space p
				else PREIMAGE (\x. real (Z x)) B INTER p_space p |
				if i:num = 0 then A IN measurable_sets (pair_measure lborel lborel)
				else B IN measurable_sets lborel} =    {if i:num = 0 then PREIMAGE (\x. real (Z x)) A INTER p_space p
				else PREIMAGE (\x. (real (Y x),real (Xd x))) B INTER p_space p |
				if i:num = 0 then A IN measurable_sets lborel
				else B IN measurable_sets (pair_measure lborel lborel)}``)
   			        THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION]
          			      THEN EQ_TAC
             			           THEN1 (RW_TAC std_ss[]
	            		 	         THEN Q.EXISTS_TAC`((1-FST (x':num#real reln#(real->bool))), (SND (SND x')), (FST (SND x')))`
						 THEN KNOW_TAC(``(\ (i,A,B).
								(if i = 0 then
								PREIMAGE (\x. (real (Y x),real (Xd x))) A INTER p_space p
								else PREIMAGE (\x. real (Z x)) B INTER p_space p,
								if i = 0 then
								A IN measurable_sets (pair_measure lborel lborel)
								else B IN measurable_sets lborel)) (x':num#real reln#(real->bool)) = 
								(if (FST x') = 0 then
								PREIMAGE (\x. (real (Y x),real (Xd x))) (FST (SND x')) INTER p_space p
								else PREIMAGE (\x. real (Z x)) (SND (SND x')) INTER p_space p,
								if (FST x') = 0 then
								(FST (SND x')) IN measurable_sets (pair_measure lborel lborel)
								else (SND (SND x')) IN measurable_sets lborel)  ``)
						      THEN1( `(x':num#real reln#(real->bool)) = (FST x', (FST (SND x')), (SND (SND x')))` by RW_TAC std_ss[PAIR]
            	             			             THEN ONCE_ASM_REWRITE_TAC[]
            		     			             THEN RW_TAC std_ss[PAIR, LAMBDA_PROD])
                                              THEN DISCH_TAC	    
                  			      THEN ONCE_ASM_REWRITE_TAC[]
					      THEN KNOW_TAC(``(\(i,A,B).
					      (if i = 0 then PREIMAGE (\x. real (Z x)) A INTER p_space p
					      else PREIMAGE (\x. (real (Y x),real (Xd x))) B INTER p_space p,
					      if i = 0 then A IN measurable_sets lborel
					      else B IN measurable_sets (pair_measure lborel lborel)))
					      ( 1-FST x',SND (SND x'),FST (SND (x':num#real reln#(real->bool)))) =  (if (1-FST x') = 0 then PREIMAGE (\x. real (Z x)) (SND (SND x')) INTER p_space p
					      else PREIMAGE (\x. (real (Y x),real (Xd x))) (FST (SND x')) INTER p_space p,
					      if (1-FST x') = 0 then (SND (SND x')) IN measurable_sets lborel
					      else (FST (SND x')) IN measurable_sets (pair_measure lborel lborel))``)
					           THEN1(RW_TAC std_ss[PAIR, LAMBDA_PROD] )
				             THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
					     THEN Cases_on`FST x' = 0:num`
         				          THEN1( RW_TAC std_ss[])
    					     THEN  RW_TAC std_ss[]  THEN FULL_SIMP_TAC std_ss[NOT_LESS_EQUAL]
         				     THEN METIS_TAC[LESS_LESS_SUC,ONE, NOT_ZERO_LT_ZERO])
    			         THEN RW_TAC std_ss[]
   				 THEN  Q.EXISTS_TAC`((1-FST (x':num#(real->bool)#real reln)), (SND (SND x')), (FST (SND x')))`
				 THEN KNOW_TAC(``(\ (i,A,B).
				 (if i = 0 then PREIMAGE (\x. real (Z x)) A INTER p_space p
				 else PREIMAGE (\x. (real (Y x),real (Xd x))) B INTER p_space p,
				 if i = 0 then A IN measurable_sets lborel
				 else B IN measurable_sets (pair_measure lborel lborel))) (x':num#(real->bool)#real reln) = (if (FST x') = 0 then PREIMAGE (\x. real (Z x)) (FST (SND x')) INTER p_space p
				 else PREIMAGE (\x. (real (Y x),real (Xd x)))(SND (SND x')) INTER p_space p,
				 if (FST x') = 0 then (FST (SND (x')) )IN measurable_sets lborel
				 else (SND (SND x')) IN measurable_sets (pair_measure lborel lborel))
				 ``)
    				     THEN1(`x':num#(real->bool)#real reln = (FST (x'), (FST (SND x')), SND (SND x'))` by RW_TAC std_ss[]
           			           THEN ONCE_ASM_REWRITE_TAC[] THEN RW_TAC std_ss[PAIR, LAMBDA_PROD])
				THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]   
				THEN Cases_on`FST(x':num#(real->bool)#real reln) = 0`
	    			     THEN1(RW_TAC std_ss[]
	          		  	   THEN FULL_SIMP_TAC std_ss[])
				THEN RW_TAC std_ss[]
				     THEN1(FULL_SIMP_TAC std_ss[NOT_LESS_EQUAL]
				           THEN METIS_TAC[LESS_LESS_SUC,ONE, NOT_ZERO_LT_ZERO]) 
				     THEN1(FULL_SIMP_TAC std_ss[])
				THEN FULL_SIMP_TAC std_ss[NOT_LESS_EQUAL]
				THEN METIS_TAC[LESS_LESS_SUC,ONE, NOT_ZERO_LT_ZERO])
		           THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[])
	              THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
		      THEN FULL_SIMP_TAC std_ss[BIGINTER_SING, PRODUCT_SING])

                THEN UNDISCH_TAC(``    !(J' :num -> bool).
                  J' SUBSET {(0 :num); (1 :num)} /\ J' <> ({} :num -> bool) /\
		  FINITE J' ==>
		  !(A' :num -> 'a -> bool).
                  (!(i :num).
                  i IN J' ==>
                  A' i IN
                  {if i = (0 :num) then
                  PREIMAGE (\(x :'a). real ((Z :'a -> extreal) x)) A INTER
                  p_space
                  (p :
                  ('a -> bool) #
                  (('a -> bool) -> bool) #
                  (('a -> bool) -> extreal))
                  else
                  PREIMAGE
                  (\(x :'a).
                  (real ((Y :'a -> extreal) x),
                  real ((Xd :'a -> extreal) x))) B INTER
                  p_space p |
                  if i = (0 :num) then A IN measurable_sets lborel
                  else B IN measurable_sets (pair_measure lborel lborel)}) ==>
                  (prob p (BIGINTER {A' j | j IN J'}) =
                  Normal (product J' (\(j :num). real (prob p (A' j)))))``)		
	       THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `{0;1:num}`)
	       THEN `{0;1} SUBSET {0; 1:num} /\ {0;1:num} <> {} /\ FINITE {0;1:num}` by SRW_TAC [] [GSPECIFICATION, EXTENSION]
	       THEN RW_TAC std_ss[]
	       THEN KNOW_TAC(``{(A:num->'a->bool) j | j IN {0:num; 1}}={A 0; A 1}``)
	       THEN1(ASM_SET_TAC[])
	       THEN DISCH_TAC
	       THEN ASM_REWRITE_TAC[]
	       THEN `FINITE {0:num} /\ FINITE {1:num} /\ DISJOINT {0:num} {1:num}/\ ({0;1:num} = {0} UNION {1})` by SRW_TAC  [] [GSPECIFICATION, EXTENSION, FINITE_DEF, DISJOINT_DEF]
	       THEN RW_TAC std_ss [BIGINTER_INTER,PRODUCT_UNION, PRODUCT_SING]
               THEN UNDISCH_TAC(``!(A' :num -> 'a -> bool).
               (!(i :num).
               i IN {(0 :num); (1 :num)} ==>
               A' i IN
               {if i = (0 :num) then
               PREIMAGE (\(x :'a). real ((Z :'a -> extreal) x)) A INTER
               p_space
               (p :
               ('a -> bool) #
               (('a -> bool) -> bool) # (('a -> bool) -> extreal))
               else
               PREIMAGE
               (\(x :'a).
               (real ((Y :'a -> extreal) x),
               real ((Xd :'a -> extreal) x))) B INTER p_space p |
               if i = (0 :num) then A IN measurable_sets lborel
               else B IN measurable_sets (pair_measure lborel lborel)}) ==>
               (prob p (BIGINTER {A' j | j IN {(0 :num); (1 :num)}}) =
               Normal
               (product {(0 :num); (1 :num)}
               (\(j :num). real (prob p (A' j))))) ``) 
	       THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `A:num->'a->bool `)
	       THEN RW_TAC std_ss[]

	       THEN KNOW_TAC(``(!i.
	       i IN {0} UNION {1} ==>
	       (A:num->'a->bool) i IN
	       {if i:num = 0 then PREIMAGE (\x. real (Z x)) A INTER p_space p
	       else PREIMAGE (\x. (real (Y x),real (Xd x))) B INTER p_space p |
	       if i = 0 then A IN measurable_sets lborel
	       else B IN measurable_sets (pair_measure lborel lborel)})``)
	           THEN1( KNOW_TAC(`` {if i:num = 0 then
           	         PREIMAGE (\x. (real (Y x),real (Xd x))) A INTER p_space p
			 else PREIMAGE (\x. real (Z x)) B INTER p_space p |
			 if i:num = 0 then A IN measurable_sets (pair_measure lborel lborel)
			 else B IN measurable_sets lborel} =    {if i:num = 0 then PREIMAGE (\x. real (Z x)) A INTER p_space p
			 else PREIMAGE (\x. (real (Y x),real (Xd x))) B INTER p_space p |
			 if i:num = 0 then A IN measurable_sets lborel
			 else B IN measurable_sets (pair_measure lborel lborel)}``)
   			 THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION]
			       THEN EQ_TAC
		                    THEN1( RW_TAC std_ss[]
 			                  THEN Q.EXISTS_TAC`((1-FST (x':num#real reln#(real->bool))), (SND (SND x')), (FST (SND x')))`
                               		  THEN KNOW_TAC(``(\ (i,A,B).
					  (if i = 0 then
					  PREIMAGE (\x. (real (Y x),real (Xd x))) A INTER p_space p
					  else PREIMAGE (\x. real (Z x)) B INTER p_space p,
					  if i = 0 then
					  A IN measurable_sets (pair_measure lborel lborel)
					  else B IN measurable_sets lborel)) (x':num#real reln#(real->bool)) = 
					  (if (FST x') = 0 then
					  PREIMAGE (\x. (real (Y x),real (Xd x))) (FST (SND x')) INTER p_space p
					  else PREIMAGE (\x. real (Z x)) (SND (SND x')) INTER p_space p,
					  if (FST x') = 0 then
					  (FST (SND x')) IN measurable_sets (pair_measure lborel lborel)
					  else (SND (SND x')) IN measurable_sets lborel)  ``)
     					      THEN1( `(x':num#real reln#(real->bool)) = (FST x', (FST (SND x')), (SND (SND x')))` by RW_TAC std_ss[PAIR]
					      THEN ONCE_ASM_REWRITE_TAC[]
					      THEN RW_TAC std_ss[PAIR, LAMBDA_PROD])
      					 THEN DISCH_TAC	    
					 THEN ONCE_ASM_REWRITE_TAC[]
					 THEN KNOW_TAC(``(\(i,A,B).
					 (if i = 0 then PREIMAGE (\x. real (Z x)) A INTER p_space p
					 else PREIMAGE (\x. (real (Y x),real (Xd x))) B INTER p_space p,
					 if i = 0 then A IN measurable_sets lborel
					 else B IN measurable_sets (pair_measure lborel lborel)))
					 ( 1-FST x',SND (SND x'),FST (SND (x':num#real reln#(real->bool)))) =  (if (1-FST x') = 0 then PREIMAGE (\x. real (Z x)) (SND (SND x')) INTER p_space p
					 else PREIMAGE (\x. (real (Y x),real (Xd x))) (FST (SND x')) INTER p_space p,
					 if (1-FST x') = 0 then (SND (SND x')) IN measurable_sets lborel
					 else (FST (SND x')) IN measurable_sets (pair_measure lborel lborel))``)
					      THEN1(RW_TAC std_ss[PAIR, LAMBDA_PROD] )
					 THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
    					 THEN Cases_on`FST x' = 0:num` 
         				     THEN1( RW_TAC std_ss[])
					     THEN1(RW_TAC std_ss[]
					 	   THEN1(FULL_SIMP_TAC std_ss[NOT_LESS_EQUAL]
					 	       THEN METIS_TAC[LESS_LESS_SUC,ONE, NOT_ZERO_LT_ZERO] )
						  THEN FULL_SIMP_TAC std_ss[NOT_LESS_EQUAL]
						  THEN METIS_TAC[LESS_LESS_SUC,ONE, NOT_ZERO_LT_ZERO]) 					    THEN  RW_TAC std_ss[])
				 THEN RW_TAC std_ss[]		  
    			         THEN  Q.EXISTS_TAC`((1-FST (x':num#(real->bool)#real reln)), (SND (SND x')), (FST (SND x')))`
				 THEN KNOW_TAC(``(\ (i,A,B).
					(if i = 0 then PREIMAGE (\x. real (Z x)) A INTER p_space p
					else PREIMAGE (\x. (real (Y x),real (Xd x))) B INTER p_space p,
					if i = 0 then A IN measurable_sets lborel
					else B IN measurable_sets (pair_measure lborel lborel))) (x':num#(real->bool)#real reln) = (if (FST x') = 0 then PREIMAGE (\x. real (Z x)) (FST (SND x')) INTER p_space p
					else PREIMAGE (\x. (real (Y x),real (Xd x)))(SND (SND x')) INTER p_space p,
					if (FST x') = 0 then (FST (SND (x')) )IN measurable_sets lborel
					else (SND (SND x')) IN measurable_sets (pair_measure lborel lborel))
					``)
				     THEN1(`x':num#(real->bool)#real reln = (FST (x'), (FST (SND x')), SND (SND x'))` by RW_TAC std_ss[]
           			           THEN ONCE_ASM_REWRITE_TAC[] THEN RW_TAC std_ss[PAIR, LAMBDA_PROD])
				 THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]   
				 THEN Cases_on`FST(x':num#(real->bool)#real reln) = 0`
	                               THEN1(RW_TAC std_ss[]
	          		            THEN FULL_SIMP_TAC std_ss[])
				 THEN RW_TAC std_ss[]
	     			      THEN1(FULL_SIMP_TAC std_ss[NOT_LESS_EQUAL]
         			             THEN METIS_TAC[LESS_LESS_SUC,ONE, NOT_ZERO_LT_ZERO])
	 			      THEN1(FULL_SIMP_TAC std_ss[])
	 			 THEN FULL_SIMP_TAC std_ss[NOT_LESS_EQUAL]
         			 THEN METIS_TAC[LESS_LESS_SUC,ONE, NOT_ZERO_LT_ZERO])
			     THEN DISCH_TAC	 THEN FULL_SIMP_TAC std_ss[])
		        THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
		        THEN FULL_SIMP_TAC std_ss[BIGINTER_SING, PRODUCT_SING, BIGINTER_2, PRODUCT_UNION])

THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]


THEN KNOW_TAC(`` prob p (DFT_event p Z t) = CDF p (\x. real (Z x)) t``)

    THEN1(`!s. Z s <> PosInf /\ 0<= Z s` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def] 
 	   THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]	   
THEN KNOW_TAC(``prob p (DFT_event p (D_AND Y (D_BEFORE Xd Y)) t) =
                 pos_fn_integral lborel
             (\y.
                  f_y y *
                  (indicator_fn {y' | 0 <= y' /\ y' <= t} y *
                   CDF p (\s. real (Xd s)) y))``)
    THEN1(MP_TAC (Q.ISPECL [`Xd:'a->extreal`, `Y:'a->extreal`, `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `f_y:real->extreal`, `t:real`] PROB_DFT_AFTER)
          THEN RW_TAC std_ss[]
	  THEN ` rv_gt0_ninfinity [Xd; Y] `by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
	  THEN `indep_var p lborel (\s. real (Xd s)) lborel (\s. real (Y s))` by 
	       (MP_TAC (Q.ISPECL [`(\i. if i:num = 0 then (\x. real ((Y:'a->extreal) x)) else (\x. real (Xd x)))` , `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `lborel`, `1:num`, `0:num`, `{0;1:num}` ] indep_vars_var)
	             THEN `1 IN {0; 1:num} /\ 0 IN {0; 1:num} /\ 1 <> 0:num`  by ASM_SET_TAC[]
		     THEN RW_TAC std_ss[]
		     THEN KNOW_TAC(``indep_vars p (\i. lborel)
           (\i. if i = 0 then (\x. real ((Y:'a->extreal) x)) else (\x. real (Xd x))) {0; 1} ``)
	                 THEN1(`{x|(x = 0) \/ (x=1:num)} = {0;1:num}` by ASM_SET_TAC[]
			       THEN FULL_SIMP_TAC std_ss[indep_var])
		     THEN RW_TAC std_ss[])
	 THEN FULL_SIMP_TAC std_ss[])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]	 
THEN KNOW_TAC(`` prob p (DFT_event p (D_AND Y (D_BEFORE Z Y)) t)    =
          pos_fn_integral lborel
             (\y.
                  f_y y *
                  (indicator_fn {y' | 0 <= y' /\ y' <= t} y *
                   CDF p (\s. real (Z s)) y))``)
       THEN1(MP_TAC (Q.ISPECL [`Z:'a->extreal`, `Y:'a->extreal`, `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `f_y:real->extreal`, `t:real`] PROB_DFT_AFTER)
          THEN RW_TAC std_ss[]
	  THEN ` rv_gt0_ninfinity [Z; Y] `by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
	  THEN FULL_SIMP_TAC std_ss[])
	  
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(`` prob p (DFT_event p (D_AND Xa (D_BEFORE Y Xa)) t) =
        pos_fn_integral lborel
             (\y.
                  indicator_fn {u | 0 <= u /\ u <= t} y * f_y y *
                  pos_fn_integral lborel
                    (\x. indicator_fn {w | y < w /\ w <= t} x * f_condxa_y y x))``)                 
    THEN1(KNOW_TAC(`` (D_AND Xa (D_BEFORE Y Xa)) = CSP Y Xa``)
         THEN1(RW_TAC std_ss[D_AND_def, D_BEFORE_def, CSP_def]
	       THEN KNOW_TAC(`` !s. (max (Xa s) (if Y s < Xa s then Y s else PosInf)) =
   ( if Y s < Xa s then Xa s else PosInf) ``)
                    THEN1(RW_TAC std_ss[extreal_max_def] THEN FULL_SIMP_TAC std_ss[] THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_infty, le_infty, lt_le, le_lt])
		THEN RW_TAC std_ss[])
	THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
	THEN MP_TAC (Q.ISPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `Xa:'a->extreal`, `Y:'a->extreal`, `f_xay:(real#real)->extreal`, `f_y:real->extreal`, `f_condxa_y:real->real->extreal`, `t:real`] prob_CSP)
	THEN RW_TAC std_ss[]
        THEN `rv_gt0_ninfinity [Xa; Y]` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
	THEN FULL_SIMP_TAC std_ss[])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[]);	


val _ = export_theory();

