
(******************************************************************************)
(*                           DFT Rewrite Rules                                *)
(*                          Yassmeen Elderhalli                               *)
(*                      y_elderh@encs.concordia.ca                            *)
(******************************************************************************)

(*loadPath := "/home/yassmeen/Downloads/Reqiured-Theories" :: !loadPath;
loadPath := "/home/yassmeen/Downloads/DFT-Theories" :: !loadPath;
loadPath := "/home/yassmeen/Downloads/Rules-Theories" :: !loadPath;

*)
(*set_trace "Unicode" 0;*)


(*app load ["HolKernel", "Parse", "boolLib", "bossLib", "numLib", "unwindLib", 
"tautLib", "Arith", "prim_recTheory", "combinTheory", "quotientTheory", 
"arithmeticTheory", "realTheory", "hrealTheory", "realaxTheory", "realLib",  
"jrhUtils", "pairTheory", "seqTheory", "limTheory", "transcTheory", "listTheory", 
"sortingTheory", "rich_listTheory",  "mesonLib", "boolTheory", "topologyTheory", "pred_setTheory", "util_probTheory", "optionTheory", "numTheory", "sumTheory", "InductiveDefinition", "ind_typeTheory","pred_setLib", "iterate_hvgTheory", "card_hvgTheory", "product_hvgTheory", 
"topology_hvgTheory", "derivative_hvgTheory", "integration_hvgTheory",
"real_sigmaTheory", "extreal_hvgTheory", "measure_hvgTheory", "lebesgue_hvgTheory",
"probability_hvgTheory", "lebesgue_measure_hvgTheory", "normal_rv_hvgTheory", "netsTheory",
"PIE_EXTREALTheory", "integration_before_afterTheory", "dep_rewrite", "DFT_Gates_def_PROBTheory", "rewrite_Rules_LemmasTheory"];
*)
open HolKernel Parse boolLib bossLib numLib unwindLib tautLib Arith prim_recTheory 
combinTheory quotientTheory arithmeticTheory hrealTheory realaxTheory realTheory 
realLib jrhUtils pairTheory seqTheory limTheory transcTheory listTheory sortingTheory rich_listTheory mesonLib boolTheory topologyTheory pred_setTheory util_probTheory optionTheory numTheory 
sumTheory InductiveDefinition ind_typeTheory pred_setLib iterate_hvgTheory 
card_hvgTheory product_hvgTheory topology_hvgTheory derivative_hvgTheory
integration_hvgTheory real_sigmaTheory extreal_hvgTheory measure_hvgTheory
lebesgue_hvgTheory probability_hvgTheory lebesgue_measure_hvgTheory
normal_rv_hvgTheory netsTheory PIE_EXTREALTheory integration_before_afterTheory dep_rewrite DFT_Gates_def_PROBTheory rewrite_Rules_LemmasTheory;

val _ = new_theory "Rewrite_Rules";

infixr 0 ++ << || ORELSEC ## --> THENC;
infix 1 >> |->;
fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
 
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Suff = PARSE_TAC SUFF_TAC;
val POP_ORW = POP_ASSUM (fn thm => ONCE_REWRITE_TAC [thm]);
val !! = REPEAT;
val op++ = op THEN;
val op<< = op THENL;
val op|| = op ORELSE;
val op>> = op THEN1;
val std_ss' = simpLib.++ (std_ss, boolSimps.ETA_ss);

(*---------------------------*)
fun SET_TAC L =
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION,
    IN_INTER, IN_DIFF, IN_INSERT, IN_DELETE, IN_BIGINTER, IN_BIGUNION,
    IN_IMAGE, GSPECIFICATION, IN_DEF] THEN METIS_TAC [];

fun SET_RULE tm = prove(tm,SET_TAC []);


val set_rewrs
= [INTER_EMPTY, INTER_UNIV, UNION_EMPTY, UNION_UNIV, DISJOINT_UNION,
DISJOINT_INSERT, DISJOINT_EMPTY, GSYM DISJOINT_EMPTY_REFL,
DISJOINT_BIGUNION, INTER_SUBSET, INTER_IDEMPOT, UNION_IDEMPOT,
SUBSET_UNION];

val UNIONL_def = Define `(UNIONL [] = {})
/\ (UNIONL (s::ss) = (s:'a ->bool) UNION UNIONL ss)`;


val IN_UNIONL = store_thm
("IN_UNIONL",
``!l (v:'a ). v IN UNIONL l = (?s. MEM s l /\ v IN s)``,
Induct >> RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY]
++ RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY, IN_UNION]
++ PROVE_TAC []);


val elt_rewrs
= [SUBSET_DEF, IN_COMPL, IN_DIFF, IN_UNIV, NOT_IN_EMPTY, IN_UNION,
IN_INTER, IN_IMAGE, IN_FUNSET, IN_DFUNSET, GSPECIFICATION,
DISJOINT_DEF, IN_BIGUNION, IN_BIGINTER, IN_COUNT, IN_o,
IN_UNIONL, IN_DELETE, IN_PREIMAGE, IN_SING, IN_INSERT];


fun rewr_ss ths =
simpLib.++
(std_ss,
simpLib.SSFRAG
{ac = [],
name = NONE,
convs = [],
dprocs = [],
filter = NONE,
rewrs = set_rewrs @ elt_rewrs,
congs = []});
val pset_set_ss = rewr_ss set_rewrs;
val pset_elt_ss = rewr_ss elt_rewrs;
val pset_ss = rewr_ss (set_rewrs @ elt_rewrs);


fun PSET_TAC ths =
REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_set_ss ths
++ REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_elt_ss ths;

fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Simplify = RW_TAC arith_ss;
val Suff = PARSE_TAC SUFF_TAC;
val Know = PARSE_TAC KNOW_TAC;
fun wrap a = [a];
val Rewr = DISCH_THEN (REWRITE_TAC o wrap);
val Rewr' = DISCH_THEN (ONCE_REWRITE_TAC o wrap);
val Cond =
  DISCH_THEN
  (fn mp_th =>
   let
     val cond = fst (dest_imp (concl mp_th))
   in
     KNOW_TAC cond << [ALL_TAC, DISCH_THEN (MP_TAC o MP mp_th)]
   end);
val FUN_EQ_TAC = CONV_TAC (CHANGED_CONV (ONCE_DEPTH_CONV FUN_EQ_CONV));
fun K_TAC _ = ALL_TAC;
fun MESON ths tm = prove(tm,MESON_TAC ths);
fun METIS ths tm = prove(tm,METIS_TAC ths);
val DISC_RW_KILL = DISCH_TAC THEN ONCE_ASM_REWRITE_TAC [] THEN 
                   POP_ASSUM K_TAC;
			   
val IN_REST = store_thm ("IN_REST",
 ``!x:'a. !s. x IN (REST s) <=> x IN s /\ ~(x = CHOICE s)``,
  REWRITE_TAC[REST_DEF, IN_DELETE]);
fun SET_TAC L = 
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN
    SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION, IN_INTER, IN_DIFF, 
      IN_INSERT, IN_DELETE, IN_REST, IN_BIGINTER, IN_BIGUNION, IN_IMAGE, 
      GSPECIFICATION, IN_DEF, EXISTS_PROD] THEN METIS_TAC [];
fun ASSERT_TAC tm = SUBGOAL_THEN tm STRIP_ASSUME_TAC;
fun SET_RULE tm = prove(tm,SET_TAC []);
fun ASM_SET_TAC L = REPEAT (POP_ASSUM MP_TAC) THEN SET_TAC L;
val ASM_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN ARITH_TAC;
val ASM_REAL_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN REAL_ARITH_TAC;

val LIST_INDUCT_TAC = INDUCT_THEN list_INDUCT ASSUME_TAC;

val SNOC_INDUCT_TAC = Prim_rec.INDUCT_THEN listTheory.SNOC_INDUCT ASSUME_TAC;


(******************************************************************************)
(*               Rewrite Rule 1                                               *)
(******************************************************************************)

val rule_1_AND = store_thm("rule_1_AND",
  `` !L1 L2. PERM L1 L2 ==> (n_AND L1 = n_AND L2) ``,

RW_TAC std_ss[n_AND_comm]);

val rule_1_OR = store_thm("rule_1_OR",
  `` !L1 L2. PERM L1 L2 ==> (n_OR L1 = n_OR L2) ``,
RW_TAC std_ss[n_OR_comm]);


val rule_1_k_out_n = store_thm("rule_1_k_out_n",
  `` !L1 L2 k. PERM L1 L2 ==>(k_out_n_gate k L1 = k_out_n_gate k L2)``,
RW_TAC std_ss[k_out_n_gate_def]
THEN `k_out (k:num) L1 =k_out (k:num) L2` by  RW_TAC list_ss[PERM_k_out]
THEN RW_TAC list_ss[]);


(******************************************************************************)
(*               Rewrite Rule 2                                               *)
(******************************************************************************)


val rule_2_AND = store_thm("rule_2_AND",
  ``!L1 L2 .(L1 = L2) ==>  (n_AND L1 = n_AND L2)  ``,
RW_TAC list_ss[]);

val rule_2_OR = store_thm("rule_2_OR",
  ``!L1 L2 .(L1 = L2) ==>  (n_OR L1 = n_OR L2)  ``,
RW_TAC list_ss[]);

val rule_2_k_out_n = store_thm("rule_2_k_out_n",
  ``!L1 L2 k.(L1 = L2) ==>  (k_out_n_gate k L1 = k_out_n_gate k L2)  ``,

RW_TAC list_ss[]);

val rule_2_PAND = store_thm("rule_2_PAND",
  ``!L1 L2. (L1 = L2) ==> (n_PAND L1 = n_PAND L2) ``,

RW_TAC list_ss[]);


(******************************************************************************)
(*               Rewrite Rule 15                                              *)
(******************************************************************************)

val rule_15_k_out_n = store_thm("rule_15_k_out_n",
  ``!L. ALL_DISTINCT L /\ rv_gt0 L ==> (k_out_n_gate 1 L = n_OR L)``,

RW_TAC std_ss[k_out_of_n_gate_OR]);


(******************************************************************************)
(*               Rewrite Rule 3                                               *)
(******************************************************************************)

val rule_3_AND = store_thm("rule_3_AND",
`` !x. rv_gt0 [x]  ==> (n_AND [x] = x) ``,

RW_TAC std_ss[]
THEN `HD [x] = x` by RW_TAC list_ss[]
THEN RW_TAC list_ss[n_AND_SING]);

val rule_3_OR = store_thm("rule_3_OR",
  `` !x. n_OR [x] = x  ``,

RW_TAC list_ss[n_OR_def]
THEN RW_TAC std_ss[D_OR_NEVER]);


val rule_3_k_out_n = store_thm("rule_3_k_out_n",
  `` !x k. rv_gt0[x] ==> (k_out_n_gate 1 [x] = x )``,

RW_TAC list_ss[k_out_of_n_gate_OR]
THEN RW_TAC list_ss[n_OR_def, D_OR_NEVER]);


val rule_3_PAND = store_thm("rule_3_PAND",
  ``!x. rv_gt0 [x] ==> (n_PAND [x] = x)  ``,
RW_TAC list_ss[rv_gt0_def, n_PAND_def, FOLDR, LAST_DEF]
THEN RW_TAC std_ss[P_AND_def, le_refl, ALWAYS_def]
THEN RW_TAC std_ss[ETA_THM]);


(******************************************************************************)
(*               Rewrite Rule 4                                               *)
(******************************************************************************)

val rule_4_AND = store_thm("rule_4_AND",
  ``!L1 L2 x. n_AND (L1++[x]++L2) = n_AND (L1++[n_OR[x]]++L2)  ``,

RW_TAC std_ss[rule_3_OR]);

val rule_4_OR = store_thm("rule_4_OR",
  ``!L1 L2 x. n_OR (L1++[x]++L2) = n_OR (L1++[n_OR[x]]++L2)  ``,
RW_TAC std_ss[rule_3_OR]);


val rule_4_k_out_n_gate = store_thm("rule_4_k_out_gate",
  `` !L1 L2 x k.
            k_out_n_gate k (L1 ++ [x] ++ L2) =
            k_out_n_gate k (L1 ++ [n_OR [x]] ++ L2)``,
RW_TAC std_ss[rule_3_OR]);


val rule_4_general = store_thm("rule_4_general",
  ``!L1 L2 x. (L1++[x]++L2) =  (L1++[n_OR[x]]++L2)``,

RW_TAC std_ss[rule_3_OR]);


(******************************************************************************)
(*               Rewrite Rule 5                                               *)
(******************************************************************************)


val rule_5_AND = store_thm("rule_5_AND",
  ``!L1 L2.
        rv_gt0 (L1++L2)==> (n_AND ((n_AND L2)::L1) = n_AND (L2++L1))  ``,

RW_TAC std_ss[]
THEN `(n_AND L2)::L1 = [n_AND L2] ++L1`by RW_TAC list_ss[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN `PERM (L1++L2)(L2++L1)` by RW_TAC list_ss[PERM_APPEND]
THEN `rv_gt0 ((L2:('a->extreal)list)++L1)` by METIS_TAC[rv_gt0_PERM]
THEN RW_TAC std_ss[n_AND_APPEND]
THEN `rv_gt0 (L1:('a->extreal)list) /\ rv_gt0 (L2:('a->extreal)list)` by METIS_TAC[rv_gt0_SPLIT]
THEN `!s. (0<= n_AND L2 s)` by RW_TAC std_ss[n_AND_GT0]
THEN `rv_gt0 [n_AND L2]` by RW_TAC list_ss[rv_gt0_def]
THEN `rv_gt0 ([n_AND L2]++L1)` by RW_TAC list_ss[rv_gt0_SPLIT]
THEN RW_TAC list_ss[n_AND_APPEND]
THEN RW_TAC list_ss[n_AND_def]
THEN RW_TAC list_ss[GSYM n_AND_def]
THEN RW_TAC list_ss[D_AND_ALWAYS]);

val rule_5_OR = store_thm("rule_5_OR",
   ``!L1 L2. (n_OR ((n_OR L2)::L1) = n_OR (L2++L1))  ``,
RW_TAC std_ss[]
THEN ` (n_OR L2::L1) =  ([n_OR L2]++L1)` by RW_TAC list_ss[]
THEN ONCE_ASM_REWRITE_TAC[] THEN RW_TAC std_ss[n_OR_APPEND]
THEN RW_TAC list_ss[n_OR_def] THEN RW_TAC list_ss[GSYM n_OR_def]
THEN RW_TAC list_ss[D_OR_NEVER]);


val rule_5_PAND = store_thm("rule_5_PAND",
  `` !L1 L2.
            rv_gt0 (L1 ++ L2) ==>
            (n_PAND (n_PAND L2::L1) = n_PAND (L2 ++ L1))``,
RW_TAC list_ss[rv_gt0_SPLIT]
THEN DEP_REWRITE_TAC[n_PAND_left_flattening1]
THEN RW_TAC std_ss[]);


(******************************************************************************)
(*               Rewrite Rule 7                                               *)
(******************************************************************************)

val rule_7_AND = store_thm("rule_7_AND",
  ``!x L. n_AND (x::x::L) = n_AND (x::L)  ``,

RW_TAC list_ss[n_AND_def]
THEN RW_TAC list_ss[GSYM D_AND_ASSOC]
THEN RW_TAC list_ss[D_AND_ID]);

val rule_7_OR = store_thm("rule_7_OR",
  ``!x L. n_OR (x::x::L)  = n_OR (x::L)  ``,

RW_TAC list_ss[n_OR_def, GSYM D_OR_ASSOC, D_OR_ID, rv_gt0_def]);


val rule_7_PAND = store_thm("rule_7_PAND",
 ``!x L.  rv_gt0 [x]==> (n_PAND (x::x::L) = n_PAND (x::L))  ``,

RW_TAC list_ss[n_PAND_def, rv_gt0_def]
THEN RW_TAC list_ss[P_AND_ALWAYS, P_AND_ID]);


(******************************************************************************)
(*               Rewrite Rule 8                                               *)
(******************************************************************************)

val rule_8 = store_thm("rule_8",
  ``!X Y. D_AND X (D_OR X Y) = X  ``,

RW_TAC std_ss[D_ABSORB_AND]);


(******************************************************************************)
(*               Rewrite Rule 9                                               *)
(******************************************************************************)

val rule_9 = store_thm("rule_9",
 ``!X Y. D_OR X (D_AND X Y) = X  ``,

RW_TAC std_ss[D_OR_OVER_AND]
THEN RW_TAC std_ss[D_OR_ID]
THEN RW_TAC std_ss[D_ABSORB_AND]);


(******************************************************************************)
(*               Rewrite Rule 10                                              *)
(******************************************************************************)

val rule_10 = store_thm("rule_10",
  ``!X Y Z. D_OR (D_AND X Y)(D_AND Y Z) = D_AND (D_OR X Z) Y ``,

RW_TAC std_ss[D_OR_OVER_AND]
THEN RW_TAC std_ss[D_OR_COMM, D_OR_OVER_AND]
THEN RW_TAC std_ss[D_OR_ID]
THEN KNOW_TAC(``D_AND (D_OR X Y) Y = Y``)
     THEN1(RW_TAC std_ss[D_AND_COMM]
          THEN RW_TAC std_ss[D_AND_OVER_OR]
	  THEN RW_TAC std_ss[D_AND_ID]
          THEN RW_TAC std_ss[D_OR_COMM]
	  THEN RW_TAC std_ss[D_OR_OVER_AND]
	  THEN RW_TAC std_ss[D_OR_ID]
	  THEN RW_TAC std_ss[D_ABSORB_AND])
THEN RW_TAC std_ss[]	  
THEN RW_TAC std_ss[D_AND_OVER_OR]
THEN RW_TAC std_ss[D_RIGHT_AND_OVER_OR]
THEN RW_TAC std_ss[D_AND_ID]
THEN RW_TAC std_ss[D_AND_OVER_OR]
THEN RW_TAC std_ss[GSYM D_AND_ASSOC]
THEN RW_TAC std_ss[D_AND_ID]
THEN `D_OR (D_AND (D_AND Y Z) X) (D_AND Y Z) = D_AND Y Z` by RW_TAC std_ss[D_OR_COMM, rule_9]
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[D_OR_ASSOC]
THEN RW_TAC std_ss[D_OR_ID]);


(******************************************************************************)
(*               Rewrite Rule 11                                              *)
(******************************************************************************)

val rule_11 = store_thm("rule_11",
  `` !L1 L2. n_OR (L1 ++ [NEVER] ++ L2) = n_OR (L1 ++ L2)``,

RW_TAC std_ss[n_OR_APPEND]
THEN RW_TAC list_ss[n_OR_def, D_OR_NEVER]);

(******************************************************************************)
(*               Rewrite Rule 12                                              *)
(******************************************************************************)

val rule_12 = store_thm("rule_12",
  `` !L1 L2. rv_gt0(L1 ++ L2)==>(n_OR (L1 ++ [ALWAYS] ++ L2) = ALWAYS)``,

RW_TAC std_ss[n_OR_APPEND, rv_gt0_SPLIT]
THEN RW_TAC std_ss[n_OR_def, D_OR_ALWAYS]
THEN RW_TAC list_ss[FOLDR]
THEN KNOW_TAC(``D_OR ALWAYS NEVER = ALWAYS``)
     THEN1(ONCE_REWRITE_TAC[D_OR_COMM]
           THEN RW_TAC std_ss[NEVER_def]
	   THEN `!s. 0<= (\s. PosInf) s` by METIS_TAC[extreal_of_num_def, le_infty]
	   THEN DEP_REWRITE_TAC[D_OR_ALWAYS]
	   THEN METIS_TAC[extreal_of_num_def, le_infty])
THEN RW_TAC std_ss[]	   
THEN RW_TAC list_ss[GSYM n_OR_def]
THEN `!s. 0<= n_OR L1 s`by RW_TAC list_ss[n_OR_GT0]
THEN RW_TAC std_ss[D_OR_ALWAYS]
THEN `!s. 0<= n_OR L2 s` by RW_TAC list_ss[n_OR_GT0]
THEN ONCE_REWRITE_TAC[D_OR_COMM]
THEN RW_TAC std_ss[D_OR_ALWAYS]);


(******************************************************************************)
(*               Rewrite Rule 13                                              *)
(******************************************************************************)

val rule_13_AND = store_thm("rule_13_AND",
  `` !L1 L2. rv_gt0 (L1 ++ L2) ==> (n_AND (L1 ++ [NEVER] ++ L2) = NEVER) ``,
  
RW_TAC std_ss[rv_gt0_SPLIT]
THEN KNOW_TAC(``rv_gt0 (L1++ [NEVER] ++ L2)``)
     THEN1(RW_TAC std_ss[rv_gt0_def, NEVER_def, rv_gt0_SPLIT]
           THEN METIS_TAC[extreal_of_num_def, le_infty])
THEN RW_TAC std_ss[n_AND_APPEND]	   
THEN `rv_gt0 (L1++[NEVER])`by FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT]
THEN RW_TAC list_ss[n_AND_APPEND]
THEN RW_TAC list_ss[n_AND_def]
THEN RW_TAC std_ss[D_AND_NEVER, D_AND_COMM]
THEN `!x. D_AND NEVER x = NEVER` by  METIS_TAC[D_AND_COMM, D_AND_NEVER]
THEN ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[D_AND_NEVER]);


val rule_13_PAND = store_thm("rule_13_PAND",
  ``!L. rv_gt0 L ==> (n_PAND (L ++ [NEVER]) = NEVER)  ``,

RW_TAC std_ss[]
THEN `rv_gt0 (L ++[NEVER])` by METIS_TAC[rv_gt0_SPLIT,rv_gt0_def, extreal_of_num_def, le_infty, NEVER_def]
THEN KNOW_TAC(``n_PAND (L++[NEVER]) = n_PAND (n_PAND L ::[NEVER])``)
    THEN1(DEP_REWRITE_TAC[GSYM rule_5_PAND]
         THEN FULL_SIMP_TAC list_ss[rv_gt0_SPLIT])
THEN RW_TAC std_ss[]	 
THEN RW_TAC list_ss[n_PAND_def]
THEN `!s. 0<= (FOLDL (λa b. P_AND a b) ALWAYS L) s` by RW_TAC list_ss[P_AND_FOLDL_GT0, ALWAYS_def, le_refl]
THEN RW_TAC std_ss[P_AND_ALWAYS]
THEN RW_TAC list_ss[GSYM n_PAND_def]
THEN RW_TAC std_ss[P_AND_def]
THEN RW_TAC std_ss[NEVER_def]);


val rule_13_PAND_2 = store_thm("rule_13_PAND_2",
  ``!L. rv_gt0 L ==> (n_PAND (NEVER::L) = NEVER)  ``,

RW_TAC std_ss[]
THEN `NEVER::L = [NEVER]++L` by RW_TAC list_ss[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN DEP_REWRITE_TAC[GSYM rule_5_PAND]
THEN RW_TAC std_ss[]
     THEN1 FULL_SIMP_TAC list_ss[rv_gt0_SPLIT, NEVER_def, extreal_of_num_def, le_infty, le_refl, rv_gt0_def]
THEN RW_TAC list_ss[n_PAND_def]
THEN `P_AND ALWAYS NEVER = NEVER` by RW_TAC std_ss[NEVER_def, extreal_of_num_def, le_refl, P_AND_ALWAYS, le_infty]
THEN ONCE_ASM_REWRITE_TAC[]
THEN Induct_on `L`
     THEN1(RW_TAC list_ss[])
THEN RW_TAC list_ss[]     
THEN FULL_SIMP_TAC list_ss[rv_gt0_def]
THEN KNOW_TAC(``P_AND NEVER h = NEVER ``)
     THEN1(RW_TAC std_ss[P_AND_def, NEVER_def]
           THEN RW_TAC std_ss[le_infty])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]   
THEN FULL_SIMP_TAC std_ss[]
THEN METIS_TAC[]);


val rule_13_PAND_3 = store_thm("rule_13_PAND_3",
  ``!L1 L2. rv_gt0 (L1 ++ L2)==> (n_PAND (L1 ++ [NEVER] ++ L2) = NEVER)  ``,

RW_TAC std_ss[]
THEN `rv_gt0 (L1 ++[NEVER]++L2)` by METIS_TAC[rv_gt0_SPLIT,rv_gt0_def, extreal_of_num_def, le_infty, NEVER_def]
THEN DEP_REWRITE_TAC[GSYM rule_5_PAND]
THEN RW_TAC std_ss[]
     THEN1(FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT])
     THEN1(FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT])
THEN `rv_gt0 [n_PAND L1]` by FULL_SIMP_TAC list_ss[rv_gt0_SPLIT, n_PAND_GT0, rv_gt0_def]
THEN `[n_PAND L1; NEVER] = [n_PAND L1]++[NEVER]` by RW_TAC list_ss[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC list_ss[rule_13_PAND]
THEN FULL_SIMP_TAC list_ss[rv_gt0_SPLIT]
THEN RW_TAC list_ss[rule_13_PAND_2]);


(******************************************************************************)
(*               Rewrite Rule 14                                              *)
(******************************************************************************)

val rule_14_AND = store_thm("rule_14_AND",
  ``!L. rv_gt0 L ==> (n_AND (ALWAYS::L) = n_AND L)  ``,

RW_TAC list_ss[n_AND_def]
THEN RW_TAC list_ss[GSYM n_AND_def]
THEN ONCE_REWRITE_TAC[D_AND_COMM]
THEN DEP_REWRITE_TAC[D_AND_ALWAYS]
THEN RW_TAC std_ss[]
THEN Induct_on `L`
    THEN1(RW_TAC list_ss[n_AND_def, ALWAYS_def, le_refl])
THEN RW_TAC std_ss[]
THEN RW_TAC list_ss[n_AND_def]
THEN RW_TAC list_ss[GSYM n_AND_def]
THEN FULL_SIMP_TAC list_ss[rv_gt0_def]
THEN RW_TAC std_ss[D_AND_def, extreal_max_def]);


val rule_14_PAND = store_thm("rule_14_PAND",
  ``!L. rv_gt0 L ==> (n_PAND (ALWAYS::L) = n_PAND L)  ``,
RW_TAC list_ss[n_PAND_def]
THEN RW_TAC list_ss[P_AND_ID]);


(******************************************************************************)
(*               Rewrite Rule 16                                              *)
(******************************************************************************)

val rule_16_k_out_of_n_gate_AND = store_thm("rule_16_k_out_of_n_gate_AND",
  ``!L.ALL_DISTINCT L ==> (k_out_n_gate (LENGTH L) L = n_AND L)  ``,

RW_TAC std_ss[k_out_n_gate_def]
THEN RW_TAC std_ss[k_out_def]
THEN `FINITE (set L)` by ASM_SET_TAC[FINITE_LIST_TO_SET]
THEN `LENGTH L = CARD (set L)` by RW_TAC list_ss[ALL_DISTINCT_CARD_LIST_TO_SET]
THEN KNOW_TAC(``!s:('a->extreal)->bool. FINITE s /\ s SUBSET (set L ) /\ (CARD s = CARD (set L)) ==> (s = set L)``)
    THEN1(RW_TAC std_ss[SUBSET_EQ_CARD])
THEN DISCH_TAC    
THEN KNOW_TAC(``{s:('a->extreal)->bool|s SUBSET set L /\ (CARD s = LENGTH L)} = {s|s SUBSET set L /\ (CARD s = LENGTH L) /\ FINITE s}``)
      THEN1 (KNOW_TAC(``!s:('a->extreal)->bool. s SUBSET (set L) ==> FINITE s``)
             THEN1(RW_TAC std_ss[] THEN METIS_TAC[FINITE_SUBSET])
	     THEN DISCH_TAC
	     THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
	     THEN EQ_TAC THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]	     
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``{s | s ⊆ set L ∧ (CARD s = CARD (set L)) ∧ FINITE s} =
                {s:('a->extreal)->bool | s = set L}``)
    THEN1(SRW_TAC[][GSPECIFICATION, EXTENSION]
          THEN EQ_TAC THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]	  
THEN KNOW_TAC(``{s:('a->extreal)->bool | s = set L}  = {set L}``)
     THEN1(SRW_TAC[][GSPECIFICATION, EXTENSION]
            THEN EQ_TAC THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN RW_TAC list_ss[SET_TO_LIST_SING]
THEN KNOW_TAC(``n_AND (SET_TO_LIST (set L)) = n_AND L ``)
     THEN1(KNOW_TAC(``PERM L (SET_TO_LIST (set (L:('a->extreal)list)))``)
           THEN1 METIS_TAC[ALL_DISTINCT_PERM_LIST_TO_SET_TO_LIST]
           THEN RW_TAC list_ss[n_AND_comm])
THEN RW_TAC list_ss[n_OR_def]	   
THEN RW_TAC std_ss[D_OR_NEVER]);


(******************************************************************************)
(*               Rewrite Rule 18                                              *)
(******************************************************************************)

val rule_18 = store_thm("rule_18",
  ``!X Y. D_AND X Y = D_OR (P_AND X Y)(P_AND Y X)  ``,

RW_TAC std_ss[D_AND_def, P_AND_def, D_OR_def]
THEN KNOW_TAC(``  !s.( max (X s) (Y s)) =
   (
        min (if X s <= Y s then Y s else PosInf)
          (if Y s <= X s then X s else PosInf))``)
    THEN1 (RW_TAC std_ss[extreal_max_def, extreal_min_def] THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_le, le_lt, le_trans, lt_trans, lt_infty, le_infty])
THEN RW_TAC std_ss[] ) ;  


(******************************************************************************)
(*               Rewrite Rule 19                                              *)
(******************************************************************************)

val rule_19 = store_thm("rule_19",
  ``!X Y. (!s. ALL_DISTINCT [X s; Y s])==>(D_AND (P_AND X Y)(P_AND Y X) = NEVER)  ``,

RW_TAC std_ss[D_AND_def, P_AND_def, NEVER_def]
THEN KNOW_TAC(``  !s.
        (max (if X s <= Y s then Y s else PosInf)
          (if Y s <= X s then X s else PosInf)) =
   ( PosInf) ``)
     THEN1(RW_TAC std_ss[extreal_max_def, extreal_min_def] THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_le, le_lt, le_trans, lt_trans, lt_infty, le_infty, ALL_DISTINCT, MEM])
THEN RW_TAC std_ss[])  ;  

(******************************************************************************)
(*               Rewrite Rule 20                                              *)
(******************************************************************************)

val rule_20 = store_thm("rule_20",
 `` !B C1 C2 L.
            rv_gt0 (L ++ [B; C1; C2]) ==>
            (n_PAND ([B; P_AND C1 C2] ++ L) =
             D_AND (P_AND C1 C2) (n_PAND ([B; C2] ++ L)))``,

NTAC 3(GEN_TAC) THEN SNOC_INDUCT_TAC
THEN1 (RW_TAC list_ss[n_PAND_def]
       THEN FULL_SIMP_TAC std_ss[rv_gt0_def]
       THEN RW_TAC std_ss[P_AND_ALWAYS]
       THEN RW_TAC std_ss[P_AND_def, D_AND_def, extreal_max_def]
       THEN KNOW_TAC(``  !s.(
        if B s <= if C1 s <= C2 s then C2 s else PosInf then
          if C1 s <= C2 s then C2 s else PosInf
        else PosInf) =
   (
        if
          (if C1 s <= C2 s then C2 s else PosInf) <= if B s <= C2 s then C2 s
          else PosInf
        then
          if B s <= C2 s then C2 s else PosInf
        else if C1 s <= C2 s then C2 s
        else PosInf)``)
	THEN1(RW_TAC std_ss[] THEN REPEAT (POP_ASSUM MP_TAC) THEN RW_TAC std_ss[] THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_le, le_lt, lt_trans, le_trans, le_infty, lt_infty])
        THEN RW_TAC std_ss[])
THEN RW_TAC std_ss[]
THEN RW_TAC list_ss[SNOC_APPEND]
THEN KNOW_TAC(``B::P_AND C1 C2::(L ++ [x]) = (B::P_AND C1 C2::L) ++ [x] ``)
    THEN1(RW_TAC list_ss[])
THEN DISCH_TAC
THEN KNOW_TAC(`` (B::C2::(L ++ [x])) = (B::C2::L) ++ [x:'a->extreal]``)
    THEN1(RW_TAC list_ss[])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]    
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``rv_gt0 (B::P_AND C1 C2 ::L) ``)
    THEN1(RW_TAC list_ss[rv_gt0_def]
          THEN1 FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT]
	  THEN1 (FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT]
	         THEN RW_TAC std_ss[P_AND_def]
		 THEN METIS_TAC[extreal_of_num_def, le_infty])
	  THEN FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT, SNOC_APPEND])
THEN DISCH_TAC
THEN `B::P_AND C1 C2::L ++ [x] = (B::P_AND C1 C2::L) ++ [x]` by RW_TAC std_ss[GSYM APPEND_ASSOC]
THEN ONCE_ASM_REWRITE_TAC[]
THEN `	n_PAND (B::P_AND C1 C2::L ++ [x])= P_AND (n_PAND (B::P_AND C1 C2::L)) x` by RW_TAC std_ss[lem8]  
THEN ONCE_ASM_REWRITE_TAC[]
THEN FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT]
THEN `(B::C2::(L ++ [x])) = (B::C2::L) ++ [x]` by RW_TAC list_ss[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``(n_PAND (B::C2::L ++ [x])) = P_AND (n_PAND (B::C2::L))x``)
    THEN1(DEP_REWRITE_TAC[lem8]
         THEN RW_TAC std_ss[rv_gt0_def])
THEN RW_TAC std_ss[]
THEN Q.ABBREV_TAC `D = n_PAND (B::C2::L)` 
THEN KNOW_TAC(``!s. C2 s <= D s ``)
     THEN1( Q.UNABBREV_TAC `D`
            THEN RW_TAC std_ss[]
	    THEN DEP_REWRITE_TAC[lem12]
	    THEN FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT, SNOC_APPEND])
THEN RW_TAC std_ss[]	    
THEN RW_TAC std_ss[P_AND_def, D_AND_def]
THEN KNOW_TAC(``!s.(
        if max (if C1 s <= C2 s then C2 s else PosInf) (D s) <= x s then x s
        else PosInf) =
   (
        max (if C1 s <= C2 s then C2 s else PosInf)
          (if D s <= x s then x s else PosInf)) ``)
      THEN1(RW_TAC std_ss[extreal_max_def] THEN REPEAT (POP_ASSUM MP_TAC) THEN RW_TAC std_ss[]
            THEN FULL_SIMP_TAC std_ss[] THEN REPEAT (POP_ASSUM MP_TAC) THEN RW_TAC std_ss[]
	    THEN FULL_SIMP_TAC std_ss[GSYM extreal_lt_def] THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_le, le_lt, lt_trans, le_trans, lt_infty, le_infty])
THEN RW_TAC std_ss[]);


(******************************************************************************)
(*               Rewrite Rule 21                                              *)
(******************************************************************************)

val rule_21 = store_thm("rule_21",
  `` !X Y L.
            rv_gt0 [X; Y] ==>
            (n_PAND (D_OR X Y::L) = D_OR (n_PAND (X::L)) (n_PAND (Y::L)))``,

GEN_TAC THEN GEN_TAC THEN SNOC_INDUCT_TAC
THEN1(RW_TAC list_ss [rule_3_PAND, rv_gt0_def]
      THEN RW_TAC list_ss[n_PAND_def]
      THEN KNOW_TAC(``!s. 0<= D_OR X Y s ``)
           THEN1(RW_TAC std_ss[D_OR_def, extreal_min_def])
      THEN RW_TAC std_ss[P_AND_ALWAYS])
THEN RW_TAC std_ss[rv_gt0_def]      
THEN FULL_SIMP_TAC std_ss[]
THEN RW_TAC std_ss[SNOC_APPEND]
THEN RW_TAC list_ss[n_PAND_def]
THEN RW_TAC std_ss[P_AND_ALWAYS]
THEN KNOW_TAC(``!s. 0<= D_OR X Y s ``)
     THEN1(RW_TAC std_ss[D_OR_def, extreal_min_def])
THEN RW_TAC std_ss[P_AND_ALWAYS]
THEN FULL_SIMP_TAC list_ss[n_PAND_def, rv_gt0_def]
THEN FULL_SIMP_TAC std_ss[P_AND_ALWAYS]
THEN ONCE_REWRITE_TAC[FOLDL_APPEND]
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC list_ss[]
THEN RW_TAC std_ss[P_AND_lem3]);


(******************************************************************************)
(*               Rewrite Rule 22                                              *)
(******************************************************************************)


val rule_22 = store_thm("rule_22",
  `` !B a b L.
            rv_gt0 (B::a::b::L) ==>
            (n_PAND (B::D_OR (P_AND a b) (P_AND b a)::L) =
             n_OR
               [n_PAND (B::b::a::L); n_PAND (b::B::a::L);
                n_PAND (B::a::b::L); n_PAND (a::B::b::L)]) ``,

NTAC 3(GEN_TAC)
THEN SNOC_INDUCT_TAC
THEN1( RW_TAC list_ss[n_PAND_def]
       THEN FULL_SIMP_TAC list_ss[rv_gt0_def]
       THEN RW_TAC std_ss[P_AND_ALWAYS]
       THEN RW_TAC list_ss[n_OR_def]
       THEN RW_TAC std_ss[P_AND_def, D_OR_def, NEVER_def]
       THEN KNOW_TAC(``  !s.(
        if
          B s <=
          min (if a s <= b s then b s else PosInf)
            (if b s <= a s then a s else PosInf)
        then
          min (if a s <= b s then b s else PosInf)
            (if b s <= a s then a s else PosInf)
        else PosInf) =
   (
        min
          (if (if B s <= b s then b s else PosInf) <= a s then a s
           else PosInf)
          (min
             (if (if b s <= B s then B s else PosInf) <= a s then a s
              else PosInf)
             (min
                (if (if B s <= a s then a s else PosInf) <= b s then b s
                 else PosInf)
                (min
                   (if (if a s <= B s then B s else PosInf) <= b s then b s
                    else PosInf) PosInf)))) ``)
             THEN1(RW_TAC std_ss[extreal_min_def] THEN REPEAT (POP_ASSUM MP_TAC) THEN RW_TAC std_ss[] 
                   THEN FULL_SIMP_TAC std_ss[] THEN REPEAT (POP_ASSUM MP_TAC) THEN RW_TAC std_ss[] 
          	   THEN FULL_SIMP_TAC std_ss[] THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_le, le_lt, lt_infty, le_infty, le_total, lt_total, le_trans, lt_trans])
       THEN RW_TAC std_ss[])
THEN RW_TAC list_ss[SNOC_APPEND]
THEN KNOW_TAC(`` n_PAND (B::D_OR (P_AND a b) (P_AND b a)::(L ++ [x])) =
                 P_AND (n_PAND (B::D_OR (P_AND a b) (P_AND b a)::L)) x``)
     THEN1(`(B::D_OR (P_AND a b) (P_AND b a)::(L ++ [x])) = (B::D_OR (P_AND a b) (P_AND b a)::L) ++ [x]` by RW_TAC list_ss[]
           THEN ONCE_ASM_REWRITE_TAC[]
	   THEN DEP_REWRITE_TAC[lem8]
	   THEN FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT]
	   THEN RW_TAC std_ss[P_AND_def, D_OR_def]
	   THEN METIS_TAC[extreal_min_def, le_infty])
THEN RW_TAC std_ss[]
THEN FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT]
THEN KNOW_TAC(`` n_PAND (B::b::a::(L ++ [x])) = P_AND (n_PAND (B::b::a::L)) x``)
     THEN1(`(B::b::a::(L ++ [x:'a->extreal])) = (B::b::a::L) ++ [x]` by RW_TAC list_ss[]
           THEN ONCE_ASM_REWRITE_TAC[]
	   THEN DEP_REWRITE_TAC[lem8]
	   THEN FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT, SNOC_APPEND])
THEN RW_TAC std_ss[]	   
THEN KNOW_TAC(`` n_PAND (b::B::a::(L ++ [x])) = P_AND (n_PAND (b::B::a::L)) x``)
     THEN1(`(b::B::a::(L ++ [x:'a->extreal])) = (b::B::a::L) ++ [x]` by RW_TAC list_ss[]
           THEN ONCE_ASM_REWRITE_TAC[]
	   THEN DEP_REWRITE_TAC[lem8]
	   THEN FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT, SNOC_APPEND])
THEN RW_TAC std_ss[]	   
THEN KNOW_TAC(`` n_PAND (B::a::b::(L ++ [x])) = P_AND (n_PAND (B::a::b::L)) x``)
     THEN1(`(B::a::b::(L ++ [x:'a->extreal])) = (B::a::b::L) ++ [x]` by RW_TAC list_ss[]
           THEN ONCE_ASM_REWRITE_TAC[]
	   THEN DEP_REWRITE_TAC[lem8]
	   THEN FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT, SNOC_APPEND])
THEN RW_TAC std_ss[]	   
THEN KNOW_TAC(`` n_PAND (a::B::b::(L ++ [x])) = P_AND (n_PAND (a::B::b::L)) x``)
     THEN1(`(a::B::b::(L ++ [x:'a->extreal])) = (a::B::b::L) ++ [x]` by RW_TAC list_ss[]
           THEN ONCE_ASM_REWRITE_TAC[]
	   THEN DEP_REWRITE_TAC[lem8]
	   THEN FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT, SNOC_APPEND])
THEN RW_TAC std_ss[]	   
THEN RW_TAC list_ss[n_OR_def] 
THEN RW_TAC std_ss[P_AND_def, D_OR_def, NEVER_def]
THEN KNOW_TAC(`` !s.(        if
          min (n_PAND (B::b::a::L) s)
            (min (n_PAND (b::B::a::L) s)
               (min (n_PAND (B::a::b::L) s)
                  (min (n_PAND (a::B::b::L) s) PosInf))) <= x s
        then
          x s
        else PosInf) =
   (
        min (if n_PAND (B::b::a::L) s <= x s then x s else PosInf)
          (min (if n_PAND (b::B::a::L) s <= x s then x s else PosInf)
             (min (if n_PAND (B::a::b::L) s <= x s then x s else PosInf)
                (min (if n_PAND (a::B::b::L) s <= x s then x s else PosInf)
                   PosInf))))``)

      THEN1(RW_TAC std_ss[extreal_min_def, extreal_max_def] THEN REPEAT (POP_ASSUM MP_TAC) THEN RW_TAC std_ss[] THEN FULL_SIMP_TAC std_ss[] THEN REPEAT (POP_ASSUM MP_TAC) THEN RW_TAC std_ss[] THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_le, le_lt, le_trans, lt_trans, lt_infty, le_infty])
THEN RW_TAC std_ss[]);      


(******************************************************************************)
(*               Rewrite Rule 23                                              *)
(******************************************************************************)

val rule_23 = store_thm("rule_23",
  `` !L1.
            L1 <> [] /\ (!x. MEM x L1 ==> !s. 0 < x s) ==>
            !L2. n_PAND (L1 ++ [ALWAYS] ++ L2) = NEVER``,

LIST_INDUCT_TAC
THEN  RW_TAC list_ss[n_PAND_def]
THEN KNOW_TAC(``P_AND ALWAYS h = h ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `h`)
           THEN RW_TAC std_ss[]
	   THEN RW_TAC std_ss[P_AND_def, ALWAYS_def]
	   THEN KNOW_TAC(`` !s.( if 0 <= h s then h s else PosInf) = h s``)
	        THEN1(RW_TAC std_ss[]
		      THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_le, le_lt])
	   THEN RW_TAC std_ss[ETA_THM])
THEN RW_TAC std_ss[]	   
THEN RW_TAC list_ss[FOLDL_APPEND]
THEN `!s. 0< h s` by RW_TAC std_ss[]
THEN `!s. 0< FOLDL (\a b. P_AND a b) h L1 s` by RW_TAC std_ss[P_AND_FOLDL_GT01]
THEN KNOW_TAC(``!a. (!s. 0< a s)==> (P_AND a ALWAYS = NEVER)  ``)
     THEN1(RW_TAC std_ss[P_AND_def, ALWAYS_def, NEVER_def]
          THEN KNOW_TAC(`` !s.( if a s <= 0 then 0 else PosInf) = (PosInf)``)
	       THEN1(RW_TAC std_ss[]
	            THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_le, le_lt])
          THEN RW_TAC std_ss[])
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[P_AND_FOLDL_NEVER]);


(******************************************************************************)
(*                                                                            *)
(*                    Example                                                 *)
(*                                                                            *)
(******************************************************************************)
val example = store_thm("example",
  ``!c d f. P_AND (D_AND c (D_OR c d))(D_AND d f) = P_AND c (D_AND d f)``, 

RW_TAC std_ss[rule_8]);

val _ = export_theory();
