
(******************************************************************************)
(*                          Pr(X < Y /\ Y <= t)                               *)
(*                          Pr(X < Y /\ X <= t)                               *)
(*                        Using Lebesgue Integral                             *)
(*                                  by                                        *)
(*                          Yassmeen Elderhalli                               *)
(*                      y_elderh@encs.concordia.ca                            *)
(******************************************************************************)


(*set_trace "Unicode" 0;*)
(*
loadPath := "/home/yassmeen/Downloads/ProbTheories_HOL-k12" :: !loadPath;

app load ["HolKernel", "Parse", "boolLib", "bossLib", "numLib", "unwindLib", 
"tautLib", "Arith", "prim_recTheory", "combinTheory", "quotientTheory", 
"arithmeticTheory", "realTheory", "hrealTheory", "realaxTheory", "realLib",  
"jrhUtils", "pairTheory", "seqTheory", "limTheory", "transcTheory", "listTheory", 
"mesonLib", "boolTheory", "topologyTheory", "pred_setTheory", "util_probTheory", 
"optionTheory", "numTheory", "sumTheory", "InductiveDefinition", "ind_typeTheory",
"pred_setLib", "iterate_hvgTheory", "card_hvgTheory", "product_hvgTheory", 
"topology_hvgTheory", "derivative_hvgTheory", "integration_hvgTheory",
"real_sigmaTheory", "extreal_hvgTheory", "measure_hvgTheory", "lebesgue_hvgTheory",
"probability_hvgTheory", "lebesgue_measure_hvgTheory", "normal_rv_hvgTheory",
"netsTheory","dep_rewrite", "limTheory"];
*)
open HolKernel Parse boolLib bossLib numLib unwindLib tautLib Arith prim_recTheory 
combinTheory quotientTheory arithmeticTheory hrealTheory realaxTheory realTheory 
realLib jrhUtils pairTheory seqTheory limTheory transcTheory listTheory mesonLib 
boolTheory topologyTheory pred_setTheory util_probTheory optionTheory numTheory 
sumTheory InductiveDefinition ind_typeTheory pred_setLib iterate_hvgTheory 
card_hvgTheory product_hvgTheory topology_hvgTheory derivative_hvgTheory
integration_hvgTheory real_sigmaTheory extreal_hvgTheory measure_hvgTheory
lebesgue_hvgTheory probability_hvgTheory lebesgue_measure_hvgTheory
normal_rv_hvgTheory netsTheory dep_rewrite limTheory;

val _ = new_theory "integration_before_after";
infixr 0 ++ << || THENC ORELSEC ORELSER ##;
infix 1 >>;
val op ++ = op THEN;
val op << = op THENL;
val op >> = op THEN1;
val op || = op ORELSE;
val REVERSE = Tactical.REVERSE;
fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Simplify = RW_TAC arith_ss;
val Suff = PARSE_TAC SUFF_TAC;
val Know = PARSE_TAC KNOW_TAC;
fun wrap a = [a];
val Rewr = DISCH_THEN (REWRITE_TAC o wrap);
val Rewr' = DISCH_THEN (ONCE_REWRITE_TAC o wrap);
val Cond =
  DISCH_THEN
  (fn mp_th =>
   let
     val cond = fst (dest_imp (concl mp_th))
   in
     KNOW_TAC cond << [ALL_TAC, DISCH_THEN (MP_TAC o MP mp_th)]
   end);

val POP_ORW = POP_ASSUM (fn thm => ONCE_REWRITE_TAC [thm]);
val FUN_EQ_TAC = CONV_TAC (CHANGED_CONV (ONCE_DEPTH_CONV FUN_EQ_CONV));
fun K_TAC _ = ALL_TAC;
fun MESON ths tm = prove(tm,MESON_TAC ths);
fun METIS ths tm = prove(tm,METIS_TAC ths);
val DISC_RW_KILL = DISCH_TAC THEN ONCE_ASM_REWRITE_TAC [] THEN 
                   POP_ASSUM K_TAC;
			   
val IN_REST = store_thm ("IN_REST",
 ``!x:'a. !s. x IN (REST s) <=> x IN s /\ ~(x = CHOICE s)``,
  REWRITE_TAC[REST_DEF, IN_DELETE]);
fun SET_TAC L = 
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN
    SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION, IN_INTER, IN_DIFF, 
      IN_INSERT, IN_DELETE, IN_REST, IN_BIGINTER, IN_BIGUNION, IN_IMAGE, 
      GSPECIFICATION, IN_DEF, EXISTS_PROD] THEN METIS_TAC [];
fun ASSERT_TAC tm = SUBGOAL_THEN tm STRIP_ASSUME_TAC;
fun SET_RULE tm = prove(tm,SET_TAC []);
fun ASM_SET_TAC L = REPEAT (POP_ASSUM MP_TAC) THEN SET_TAC L;
val ASM_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN ARITH_TAC;
val ASM_REAL_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN REAL_ARITH_TAC;

val REAL_LE_NEG1_1 = store_thm("REAL_LE_NEG1_1",
  `` (-1:real)<=1``,
METIS_TAC [REAL_LE_01, REAL_LE_NEGL]);

val REAL_LE_NEG1_0 = store_thm("REAL_LE_NEG1_0",
  ``  (-1:real) <=0``,
METIS_TAC [REAL_LE_01, REAL_LE_NEGR, REAL_NEG_NEG,REAL_LE_NEG1_1 ]);

val REAL_LT_NEG1_0 = store_thm("REAL_LT_NEG1_0",
  ``  (-1:real) < 0``,
METIS_TAC [REAL_LT_01, REAL_NEG_NEG,REAL_NEG_GT0 ]);


val REAL_LT_NEG1_1 = store_thm("REAL_LT_NEG1_1",
  ``  (-1:real)<1``,
METIS_TAC [REAL_LT_NEG1_0, REAL_LT_TRANS, REAL_LT_01]);


val REAL_MAX_COMM = store_thm("REAL_MAX_COMM",
  ``  ! (A:real) B . max A B = max B A``,
METIS_TAC [REAL_LE_REFL, REAL_LE_LT, REAL_LE_ANTISYM, REAL_LET_ANTISYM, REAL_LET_TOTAL, REAL_LET_TRANS,  max_def]);

val REAL_MIN_COMM = store_thm("REAL_MIN_COMM",
  `` ! (A:real) B . min A B = min B A``,
METIS_TAC [REAL_LE_REFL, REAL_LE_LT, REAL_LE_ANTISYM, REAL_LET_ANTISYM, REAL_LET_TOTAL, REAL_LET_TRANS,  min_def]);



fun DFT_rewrs L =  REPEAT( METIS_TAC L);


val rewrs = [REAL_LE_REFL, REAL_LE_LT, REAL_LE_ANTISYM, REAL_LET_ANTISYM, REAL_LET_TOTAL, REAL_LET_TRANS, real_of_num,REAL_LT_NEG1_1,REAL_LT_NEG1_0,REAL_LE_NEG1_0,REAL_LE_NEG1_1, REAL_LT_TOTAL, max_def, min_def, REAL_LT_TRANS, REAL_LE_TRANS, REAL_MIN_COMM, REAL_MAX_COMM];

val DFT_rewrs_ss  =DFT_rewrs rewrs;

val extreal_real_lt = store_thm("extreal_real_lt",
  ``  !x y. x <> PosInf /\ x <> NegInf /\ y <> PosInf /\ y <> NegInf ==> ((real y<real x) = (y <x))``,

RW_TAC std_ss[] THEN
RW_TAC std_ss [real_def] THEN
SELECT_ELIM_TAC THEN
RW_TAC std_ss[] THEN1(
Q.EXISTS_TAC(`real y`) THEN
METIS_TAC [normal_real]) THEN
SELECT_ELIM_TAC THEN
RW_TAC std_ss[] THEN1(
Q.EXISTS_TAC(`real x`) THEN
METIS_TAC [normal_real] ) THEN
METIS_TAC [extreal_lt_def, extreal_lt_def,real_lt, extreal_le_def]);


val extreal_le_eq = store_thm("extreal_le_eq",
  ``  !x y. Normal x <= Normal y =  x <=y``,
  METIS_TAC [extreal_lt_def,extreal_le_def,real_lt]);


val pos_fn_integral_distr'_x = store_thm("pos_fn_integral_distr'_x",
  ``   !t f M M'.
     measure_space M /\ measure_space M' /\
     t IN
     measurable (m_space M,measurable_sets M)
       (m_space M',measurable_sets M') /\
     (\(x:extreal).x) IN
     measurable (m_space (distr M M' t),measurable_sets (distr M M' t))
       Borel /\ (!x. 0 <= x)  ==>
     (pos_fn_integral (distr M M' t) (\x. max 0 x) =
      pos_fn_integral M (\x. max 0 (t x)))``,

RW_TAC std_ss[]

THEN MP_TAC(Q.ISPECL[`t:'a->extreal`,`(\a:extreal. a)`,`M: 
        ('a -> bool) #
        (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,`(M' :
          (extreal -> bool) #
          ((extreal -> bool) -> bool) # ((extreal -> bool) -> extreal))`] pos_fn_integral_distr')
THEN RW_TAC std_ss[]);


val pos_fn_integral_distr'_x2 = store_thm("pos_fn_integral_distr'_x2",
  ``  !t f M M'.
     prob_space M /\ measure_space M' /\
     t IN
     measurable (p_space M, events M)
       (m_space M',measurable_sets M') /\
     (\(x:extreal).x) IN
     measurable (m_space (distr M M' t),measurable_sets (distr M M' t))
       Borel /\ (!x. 0 <= x) ==>
     (pos_fn_integral (distr M M' t) (\x. max 0 x) =
      pos_fn_integral M (\x. max 0 (t x)))``,
RW_TAC std_ss[]

THEN MP_TAC(Q.ISPECL[`t:'a->extreal`,`f:'b`,`M: 
        ('a -> bool) #
        (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,`(M' :
          (extreal -> bool) #
          ((extreal -> bool) -> bool) # ((extreal -> bool) -> extreal))`] pos_fn_integral_distr'_x)

THEN RW_TAC std_ss[]

THEN FULL_SIMP_TAC std_ss [prob_space_def, p_space_def, events_def]);


val pos_fn_integral_distr'x_random_variable = store_thm(
  "pos_fn_integral_distr'x_random_variable",
  ``!t f M .
     prob_space M /\   t IN
     measurable (p_space M, events M)
       (m_space lborel,measurable_sets lborel) /\
     f IN
     measurable (m_space (distr M lborel t),measurable_sets (distr M lborel t))
       Borel /\ (!x. 0 <= f x) ==>
     (pos_fn_integral (distr M lborel t) (\x. max 0 (f x)) =
      pos_fn_integral M (\x. max 0 (f (t x))))``,
RW_TAC std_ss[]

THEN MP_TAC(Q.ISPECL[`t:'a->real`,`f:real->extreal`,`M:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,`(M':(real -> bool) #
   ((real -> bool) -> bool) # ((real -> bool) -> extreal))`] pos_fn_integral_distr')
THEN RW_TAC std_ss[]
THEN FULL_SIMP_TAC std_ss [measure_space_lborel, p_space_def, prob_space_def, events_def]
THEN METIS_TAC [measure_space_lborel, events_def, pos_fn_integral_distr']);



val prob_event = store_thm("prob_event",
  `` !X  p A .
     random_variable X p (m_space lborel,measurable_sets lborel) /\ A IN measurable_sets lborel==>
(prob p (PREIMAGE X A INTER p_space p) = integral (distr p lborel X) (indicator_fn A))``,
RW_TAC std_ss[]
THEN KNOW_TAC (``prob p (PREIMAGE (X:'a->real) (A:real->bool) INTER p_space p) = distribution p X A``) THEN1( RW_TAC std_ss[distribution_def])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN MP_TAC(Q.ISPECL[` (X:'a->real)`,`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `t:(real -> bool) #
   ((real -> bool) -> bool)`, `A:real->bool`] distribution_lebesgue_thm2 )
THEN RW_TAC std_ss[]
THEN KNOW_TAC (``(distr p lborel (X:'a->real)) = (space(m_space lborel,measurable_sets lborel) ,subsets (m_space lborel,measurable_sets lborel),distribution p X)``)
     	      THEN1( RW_TAC std_ss [lborel, distr]
	      	     THEN1( RW_TAC std_ss [space_def])
		     THEN1(RW_TAC std_ss [subsets_def])
THEN RW_TAC std_ss [distribution_def ,prob_def, p_space_def])
THEN RW_TAC std_ss[]
THEN KNOW_TAC (`` A IN subsets   (m_space lborel,measurable_sets lborel)``) THEN1(
                      RW_TAC std_ss [subsets_def])
THEN RW_TAC std_ss[]
THEN METIS_TAC [distribution_lebesgue_thm2]);



val prob_event_gen = store_thm("prob_event_gen",
  ``!X M p A.
          random_variable X p (m_space M,measurable_sets M) /\
          A IN measurable_sets M /\ measure_space M ==>
          (prob p (PREIMAGE X A INTER p_space p) =
           integral (distr p M X) (indicator_fn A))``,
RW_TAC std_ss[] 
THEN KNOW_TAC (``prob p (PREIMAGE (X:'a->'b) (A:'b->bool) INTER p_space p) = distribution p X A``)
THEN1( RW_TAC std_ss[distribution_def])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN MP_TAC(Q.ISPECL[` (X:'a->'b)`,`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `t:('b -> bool) #
   (('b -> bool) -> bool)`, `A:'b->bool`] distribution_lebesgue_thm2 )
THEN RW_TAC std_ss[]
THEN KNOW_TAC (``(distr p M (X:'a->'b)) = (space(m_space (M:('b -> bool) #
         (('b -> bool) -> bool) # (('b -> bool) -> extreal)),measurable_sets M) ,subsets (m_space M,measurable_sets M),distribution p X)``) THEN1(RW_TAC std_ss [space_def,distr]
	                                       THEN RW_TAC std_ss [subsets_def]
					       THEN RW_TAC std_ss [distribution_def ,prob_def, p_space_def])
THEN RW_TAC std_ss[]

THEN KNOW_TAC (`` (A:'b->bool) IN subsets   (m_space (M:('b -> bool) #
         (('b -> bool) -> bool) # (('b -> bool) -> extreal)),measurable_sets M)``)
THEN1( RW_TAC std_ss [subsets_def])
THEN RW_TAC std_ss[]
THEN METIS_TAC [distribution_lebesgue_thm2]);


val distribution_lebesgue_thm2_function_2 = store_thm(
  "distribution_lebesgue_thm2_function_2",
  ``!X p M' A.
          random_variable X p
            (m_space (pair_measure M' M'),
             measurable_sets (pair_measure M' M')) /\
          A IN measurable_sets (pair_measure M' M') ==>
          (distribution p X A =
           integral (distr p (pair_measure M' M') X) (indicator_fn A)) ``,

RW_TAC std_ss[]
THEN MP_TAC(Q.ISPECL[`(X :'a -> 'b#'b)`,
      `(p :
        ('a -> bool) #
        (('a -> bool) -> bool) # (('a -> bool) -> extreal))`,
      `(s :('b#'b -> bool) # (('b#'b -> bool) -> bool))`, `(A :'b reln)`] distribution_lebesgue_thm2 )
THEN RW_TAC std_ss[]
THEN KNOW_TAC (``A IN subsets (m_space (pair_measure (M':('b -> bool) #
          (('b -> bool) -> bool) # (('b -> bool) -> extreal)) M'), measurable_sets (pair_measure M' M'))``)
THEN1( METIS_TAC[measurable_sets_def, subsets_def, pair_measure, measure_of])
THEN RW_TAC std_ss[]

THEN RW_TAC std_ss[distr, GSYM prob_def, GSYM distribution_def, GSYM p_space_def]
THEN RW_TAC std_ss [p_space_def]
THEN METIS_TAC [distribution_lebesgue_thm2, space_def, subsets_def]);


val distribution_lebesgue_thm2_2_rv = store_thm(
  "distribution_lebesgue_thm2_2_rv",
  `` !X Y p M' A.
          measure_space M' /\ sigma_finite_measure M' /\
          random_variable X p (m_space M',measurable_sets M') /\
          random_variable Y p (m_space M',measurable_sets M') /\
          A IN measurable_sets (pair_measure M' M') ==>
          (distribution p (\x. (X x,Y x)) A =
           integral (distr p (pair_measure M' M') (\x. (X x,Y x)))
             (indicator_fn A))``,
RW_TAC std_ss[]
THEN KNOW_TAC (``measure_space (pair_measure (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) M')``)
THEN1(METIS_TAC [measure_space_pair_measure'])
THEN RW_TAC std_ss[]
THEN KNOW_TAC (``(\x. (X x, Y x )) IN measurable (p_space p, events p)(m_space (pair_measure M' M'),measurable_sets (pair_measure M' M'))``)
THEN1( FULL_SIMP_TAC std_ss [random_variable_def]
       THEN METIS_TAC [measurable_Pair, p_space_def, random_variable_def, events_def, measurable_sets_def, m_space_def, space_def, subsets_def, prob_space_def])
THEN RW_TAC std_ss[]
THEN METIS_TAC[distribution_lebesgue_thm2_function_2, random_variable_def]);


val prob_event_2rv = store_thm("prob_event_2rv",
  `` !X Y p M' A.
          measure_space M' /\ sigma_finite_measure M' /\
          random_variable X p (m_space M',measurable_sets M') /\
          random_variable Y p (m_space M',measurable_sets M') /\
          A IN measurable_sets (pair_measure M' M') ==>
          (prob p (PREIMAGE (\x. (X x,Y x)) A INTER p_space p) =
           integral (distr p (pair_measure M' M') (\x. (X x,Y x)))
             (indicator_fn A))``,
METIS_TAC [distribution_lebesgue_thm2_2_rv,distribution_def]); 



val distributed_def = Define `distributed p  M X f = (X IN
          measurable (m_space p,measurable_sets p)
            (m_space M,measurable_sets M) /\
          f IN measurable (m_space M,measurable_sets M) Borel /\
          AE M {x | 0 <= f x} /\ (distr p M X = density M f))`;



val prob_event_2indep_rv = store_thm("prob_event_2indep_rv",
  `` !X Y p M' A.
          measure_space M' /\ sigma_finite_measure M' /\ prob_space p /\
          indep_var p M' X M' Y /\ A IN measurable_sets (pair_measure M' M') ==>
          (prob p (PREIMAGE (\x. (X x,Y x)) A INTER p_space p) =
           integral (distr p (pair_measure M' M') (\x. (X x,Y x)))
             (indicator_fn A))``,
RW_TAC std_ss[]
THEN METIS_TAC [indep_var_distribution_imp, prob_event_2rv]);


val prob_event_2indep_rv_1 = store_thm("prob_event_2indep_rv_1",
  ``  !X Y p M' A.
          measure_space M' /\ sigma_finite_measure M' /\ prob_space p /\
          indep_var p M' X M' Y /\
          A IN measurable_sets (pair_measure M' M') /\
          sigma_finite_measure (distr p M' X) /\
          sigma_finite_measure (distr p M' Y) ==>
          (prob p (PREIMAGE (\x. (X x,Y x)) A INTER p_space p) =
           integral (pair_measure (distr p M' X) (distr p M' Y))
             (indicator_fn A))``,

RW_TAC std_ss[]
THEN KNOW_TAC (``random_variable X p (m_space M', measurable_sets M') /\ random_variable Y p (m_space M', measurable_sets M')``)
    THEN1( METIS_TAC [indep_var_distribution_imp])
THEN RW_TAC std_ss[]
THEN KNOW_TAC (``measure_space (pair_measure (distr (p :
          ('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)) (M': ('b -> bool) #
          (('b -> bool) -> bool) # (('b -> bool) -> extreal)) X)(distr p M' Y))``)
	  THEN1(METIS_TAC [measure_space_pair_measure', prob_space_def, measure_space_distr, indep_var, random_variable_def, p_space_def, events_def])
THEN RW_TAC std_ss[]
THEN KNOW_TAC (`` measure_of (pair_measure (distr p M' X)(distr p M' Y))=measure_of (distr (p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)) (pair_measure (M': ('b -> bool) #
          (('b -> bool) -> bool) # (('b -> bool) -> extreal)) M') (\x.(X x, Y x)))``) THEN1( METIS_TAC [indep_var_distribution_imp])
THEN DISCH_TAC
THEN RW_TAC std_ss [indicator_fn_pos_le, integral_pos_fn]
THEN RW_TAC std_ss[GSYM  pos_fn_integral_measure_of]
THEN KNOW_TAC (``(\x. (X x, Y x )) IN measurable (p_space p, events p)(m_space (pair_measure M' M'),measurable_sets (pair_measure M' M'))``) THEN1(
FULL_SIMP_TAC std_ss [random_variable_def]
THEN METIS_TAC [measurable_Pair, p_space_def, random_variable_def, events_def, measurable_sets_def, m_space_def, space_def, subsets_def, prob_space_def])
THEN DISCH_TAC
THEN KNOW_TAC (``  measure_space (distr (p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)) (pair_measure (M':('b -> bool) #
          (('b -> bool) -> bool) # (('b -> bool) -> extreal)) M') (\x. (X x,Y x))) ``)
	 THEN1(METIS_TAC [measurable_Pair, p_space_def, random_variable_def, events_def, measurable_sets_def, m_space_def, space_def, subsets_def, prob_space_def, measure_space_distr, measure_space_pair_measure'])
THEN DISCH_TAC
THEN RW_TAC std_ss [pos_fn_integral_measure_of]
THEN RW_TAC std_ss [indicator_fn_pos_le, GSYM integral_pos_fn]
THEN METIS_TAC [prob_event_2indep_rv]);


val EXTREAL_SUM_IMAGE_FUN_MUL = store_thm("EXTREAL_SUM_IMAGE_FUN_MUL",
  ``!s. FINITE s ==>
	!f (Y:'a->real). (!x. x IN s ==> f x <> NegInf) \/ (!x. x IN s ==> f x <> PosInf) ==>((!y. EXTREAL_SUM_IMAGE (\x. (Normal (Y y ))* f x) s = ( (Normal (Y y )) * (EXTREAL_SUM_IMAGE f s))))``,

Suff `!f (Y:'a->real) s. FINITE s ==>
	(\s. (!x. x IN s ==> f x <> NegInf) \/ (!x. x IN s ==> f x <> PosInf) ==> ((!(y:'a). EXTREAL_SUM_IMAGE (\x. (Normal ((Y:'a->real) y)) * f x) s =(( Normal (Y y)) * (EXTREAL_SUM_IMAGE f s))))) s`
THEN1( METIS_TAC [ETA_AX])
THEN  STRIP_TAC
THEN STRIP_TAC
THEN  MATCH_MP_TAC FINITE_INDUCT
THEN RW_TAC real_ss [EXTREAL_SUM_IMAGE_EMPTY,mul_rzero]
      THEN1(Cases_on `0 <= (Y y)` 
            THEN1(  `!x. x IN e INSERT s ==> (\x. (Normal(Y y)) * f x) x <> NegInf` by METIS_TAC [mul_not_infty,IN_INSERT]
                   THEN FULL_SIMP_TAC real_ss [EXTREAL_SUM_IMAGE_PROPERTY,DELETE_NON_ELEMENT]
                   THEN METIS_TAC [add_ldistrib_normal,EXTREAL_SUM_IMAGE_NOT_INFTY,IN_INSERT])
	    THEN  `!x. x IN e INSERT s ==> (\x. (Normal (Y y)) * f x) x <> PosInf` by METIS_TAC [mul_not_infty,real_lt,REAL_LT_IMP_LE]
THEN FULL_SIMP_TAC real_ss [EXTREAL_SUM_IMAGE_PROPERTY,DELETE_NON_ELEMENT]
THEN  METIS_TAC [add_ldistrib_normal,EXTREAL_SUM_IMAGE_NOT_INFTY,IN_INSERT])

THEN Cases_on `0 <= (Y y)`
     THEN1(`!x. x IN e INSERT s ==> (\x. (Normal (Y y)) * f x) x <> PosInf` by METIS_TAC [mul_not_infty]
           THEN FULL_SIMP_TAC real_ss [EXTREAL_SUM_IMAGE_PROPERTY,DELETE_NON_ELEMENT]
           THEN METIS_TAC [add_ldistrib_normal,EXTREAL_SUM_IMAGE_NOT_INFTY,IN_INSERT])
           THEN  `!x. x IN e INSERT s ==> (\x. (Normal (Y y)) * f x) x <> NegInf` by METIS_TAC [mul_not_infty,real_lt,REAL_LT_IMP_LE]
THEN FULL_SIMP_TAC real_ss [EXTREAL_SUM_IMAGE_PROPERTY,DELETE_NON_ELEMENT]
THEN  METIS_TAC [add_ldistrib_normal,EXTREAL_SUM_IMAGE_NOT_INFTY,IN_INSERT]);



val pos_simple_fn_integral_fun_mul = store_thm("pos_simple_fn_integral_fun_mul",
  `` !m f s a x (Y:'a->real) y. measure_space m /\ pos_simple_fn m f s a x /\ (!y. 0 <= Y y) ==>
	    (pos_simple_fn m (\x. Normal( Y y)* f x) s a (\i. (Y y) * x i) /\
	    (pos_simple_fn_integral m s a (\i. (Y y) * x i) = Normal (Y y) * pos_simple_fn_integral m s a x))``,
RW_TAC std_ss [pos_simple_fn_integral_def, pos_simple_fn_def,REAL_LE_MUL,GSYM extreal_mul_def]
THEN1( METIS_TAC [le_mul,extreal_le_def,extreal_of_num_def])
THEN1(`(\i. (Normal (Y y)) * Normal (x i) * indicator_fn (a i) x') = 
       (\i. (Normal( Y y)) * (\i. Normal (x i) * indicator_fn (a i) x') i)`
         by METIS_TAC [mul_assoc]
      THEN POP_ORW
      THEN (MATCH_MP_TAC o UNDISCH o Q.ISPEC `s:num->bool` o GSYM) EXTREAL_SUM_IMAGE_FUN_MUL
      THEN DISJ1_TAC
      THEN RW_TAC std_ss [indicator_fn_def,mul_rone,mul_rzero]
      THEN RW_TAC std_ss [extreal_of_num_def,extreal_not_infty])
THEN `(\i. (Normal(Y y) ) * Normal (x i) * measure m (a i)) = 
         (\i. (Normal (Y y)) * (\i. Normal (x i) * measure m (a i)) i)` by METIS_TAC [mul_assoc]
THEN POP_ORW
THEN (MATCH_MP_TAC o UNDISCH o Q.ISPEC `s:num->bool`) EXTREAL_SUM_IMAGE_FUN_MUL
THEN DISJ1_TAC
THEN RW_TAC std_ss []
THEN METIS_TAC [mul_not_infty,positive_not_infty,MEASURE_SPACE_POSITIVE]);


val psfis_fun_mul = store_thm("psfis_fun_mul",
  `` !m f a (Y:'a->real) y. measure_space m /\ a IN psfis m f /\ (!y. 0 <=Y y)  ==>
	(Normal (Y y)) * a IN psfis m (\x. (Normal (Y y)) * f x)``,
RW_TAC std_ss [psfis_def, IN_IMAGE, psfs_def, GSPECIFICATION]
THEN Cases_on `x'`
THEN Cases_on `r`
THEN  FULL_SIMP_TAC std_ss [PAIR_EQ]
THEN  Q.EXISTS_TAC `(q,q',(\i. (Y y) * r' i))`
THEN  RW_TAC std_ss []
    THEN1( METIS_TAC [pos_simple_fn_integral_fun_mul])
THEN Q.EXISTS_TAC `(q,q',(\i. (Y y) * r' i))`
THEN RW_TAC std_ss []
THEN METIS_TAC [pos_simple_fn_integral_cmul]);


val pos_fn_integral_fun_mul = store_thm("pos_fn_integral_fun_mul",
  `` !M Y f.
          measure_space M /\ (!x. x IN m_space M ==> 0 <= f x) /\
          (!y. 0 <= Y y) ==>
          ((\y. pos_fn_integral M (\x. Normal (Y y) * f x)) =
           (\y. Normal (Y y) * pos_fn_integral M (\x. f x)))``, 

RW_TAC std_ss[]
THEN KNOW_TAC (``(!y. pos_fn_integral (M:
          ('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)) (\x. Normal ((Y:'b->real) y) * f x ) = Normal (Y y) * pos_fn_integral M (\x. f x))``)
            THEN1  (  RW_TAC std_ss[]
	           THEN Cases_on `Y y = (0:real)`
                        THEN1(RW_TAC std_ss [GSYM extreal_of_num_def,mul_lzero,pos_fn_integral_zero])
			  THEN `(0:real) < (Y:'b->real) y` by FULL_SIMP_TAC std_ss [REAL_LT_LE]
                          THEN RW_TAC std_ss [pos_fn_integral_def,sup_eq]
			       THEN1( Q_TAC SUFF_TAC `y' / Normal (Y y )<= sup {r | ?g. r IN psfis M g /\ !x. g x <= f x}`
			       	     THEN1(  METIS_TAC [le_ldiv,mul_comm])
				     THEN  RW_TAC std_ss [le_sup]
				     THEN POP_ASSUM MATCH_MP_TAC
				     THEN ONCE_REWRITE_TAC [GSYM SPECIFICATION]
				     THEN POP_ASSUM (MP_TAC o ONCE_REWRITE_RULE [GSYM SPECIFICATION])
 				     THEN RW_TAC std_ss [GSPECIFICATION]
				     THEN Q.EXISTS_TAC `(\x. g x / Normal( Y y))`
				     THEN  REVERSE (RW_TAC std_ss [])
				     	  THEN1( METIS_TAC [mul_comm,le_ldiv])
					  THEN RW_TAC std_ss [extreal_div_def]
					  THEN ONCE_REWRITE_TAC [mul_comm]
					  THEN RW_TAC std_ss [extreal_inv_def]
					  THEN KNOW_TAC (``!y. 0<=inv ((Y:'b->real) y)``)
					       THEN1(METIS_TAC [REAL_LE_INV])
					  THEN DISCH_TAC
					  THEN MP_TAC(Q.ISPECL[`(M :
          ('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal))`,`(g :'a -> extreal)`,`(y' :extreal)`,`D:'a->real`] psfis_fun_mul )
	       	  	   	   	   THEN KNOW_TAC (``inv ((Y:'b->real)y) = (inv o Y) y``)
					   		 THEN1( METIS_TAC[o_THM])
					   THEN DISCH_TAC
					   THEN ASM_REWRITE_TAC[]
					   THEN KNOW_TAC (``0<=((inv o (Y :'b -> real)) (y :'b))``)
					   	THEN1(METIS_TAC [REAL_LE_INV, o_THM])
						THEN DISCH_TAC
						THEN METIS_TAC [o_DEF, psfis_fun_mul])
			THEN  SUFF_TAC(``sup {r | ?g. r IN psfis M g /\ !x. g x <= f x} <= y' / (Normal (Y y))``)
			      THEN1(METIS_TAC [le_rdiv,extreal_not_infty,mul_comm])

			THEN RW_TAC std_ss [sup_le]
   			THEN POP_ASSUM (MP_TAC o ONCE_REWRITE_RULE [GSYM SPECIFICATION])
			THEN RW_TAC std_ss [GSPECIFICATION]
			THEN Suff`(y'' * (Normal (Y y))) <= y'`
			      	   THEN1(METIS_TAC [le_rdiv,extreal_not_infty])
	   		THEN Q.PAT_X_ASSUM  `!z. {r | ?g. r IN psfis M g /\ !x. g x <= (Normal (Y y)) * f x} z ==> z <= y'` MATCH_MP_TAC
			THEN ONCE_REWRITE_TAC [GSYM SPECIFICATION]
			THEN RW_TAC std_ss [GSPECIFICATION]
			THEN Q.EXISTS_TAC `(\x. (Normal (Y y ))* g x)`
			THEN RW_TAC std_ss []
			     THEN1( METIS_TAC [psfis_fun_mul,mul_comm,extreal_not_infty])
			THEN  METIS_TAC [le_lmul_imp,extreal_of_num_def,extreal_lt_eq,lt_le])
THEN METIS_TAC []);


val CDF_def = Define ` CDF p X (t:real)= distribution p X {y |y<=t}`;

val prob_event_le = store_thm("prob_event_le",
  ``!X p t:real M.
          random_variable X p (m_space M,measurable_sets M) /\
          measure_space M /\ {y | y <= t} IN measurable_sets M ==>
          (prob p (PREIMAGE X {y | y <= t} INTER p_space p) =
           integral (distr p M X) (indicator_fn {y | y <= t}))``,
RW_TAC std_ss[prob_event_gen]);

val CDF_integral_indicator = store_thm("CDF_integral_indicator",
  `` !X p t:real M.
          random_variable X p (m_space M,measurable_sets M) /\
          measure_space M /\ {y | y <= t} IN measurable_sets M ==>
          (CDF p X t = integral (distr p M X) (indicator_fn {y | y <= t}))``,
METIS_TAC [CDF_def, distribution_def, prob_event_le]);

val integral_pos_fn_indicator = store_thm("integral_pos_fn_indicator",
  `` ! m A. measure_space m  ==>
     (integral m (indicator_fn A) = pos_fn_integral m (indicator_fn A))``,
METIS_TAC [integral_pos_fn, indicator_fn_pos_le]);



val integral_pos_fn_distr = store_thm("integral_pos_fn_distr",
  ``   !M p X A.
          measure_space M /\
          random_variable X p (m_space M,measurable_sets M) /\
          A IN measurable_sets M ==>
          (pos_fn_integral (distr p M X) (indicator_fn A) =
           integral (distr p M X) (indicator_fn A))``,

RW_TAC std_ss [integral_def]
THEN Suff `((\x. if 0 < (indicator_fn A )x then (indicator_fn A) x else 0) = indicator_fn A) /\ ((\x. if (indicator_fn A)x < 0 then -(indicator_fn A) x else 0) = (\x. 0))`
  THEN1(
    KNOW_TAC(``measure_space (distr (p :
       ('b -> bool) #
       (('b -> bool) -> bool) # (('b -> bool) -> extreal))
     (M :
       ('a -> bool) #
       (('a -> bool) -> bool) # (('a -> bool) -> extreal))
     (X :'b -> 'a))``)
      THEN1( METIS_TAC [random_variable_def, prob_space_def, measure_space_distr, p_space_def, events_def])
  THEN DISCH_TAC
  THEN RW_TAC std_ss [pos_fn_integral_zero,sub_rzero])

THEN RW_TAC std_ss [FUN_EQ_THM,lt_le]
     THEN1( RW_TAC std_ss[]
            THEN FULL_SIMP_TAC std_ss[indicator_fn_def]
	     THEN RW_TAC std_ss[]
	     THEN FULL_SIMP_TAC std_ss[extreal_le_def]
	     THEN METIS_TAC [le_01])
     THEN RW_TAC std_ss[]
     THEN FULL_SIMP_TAC std_ss[indicator_fn_def]
     THEN RW_TAC std_ss[]
     THEN FULL_SIMP_TAC std_ss[extreal_le_def]
     THEN FULL_SIMP_TAC std_ss [extreal_lt_def]
     THEN METIS_TAC [le_01, extreal_le_def, lt_le, extreal_lt_def]);


val distribution_lebesgue_thm2_distr = store_thm( "distribution_lebesgue_thm2_distr",
  ``!X p M A.
          measure_space M /\
          random_variable X p (m_space M,measurable_sets M) /\
          A IN measurable_sets M ==>
          (distribution p X A = integral (distr p M X) (indicator_fn A))``,

RW_TAC std_ss[]
THEN KNOW_TAC (``measure_space (distr (p :('a -> bool) # (('a -> bool) -> bool) # (('a -> bool) -> extreal)) M
  (X :'a -> 'b)  )``)
     THEN1(METIS_TAC [random_variable_def, prob_space_def, measure_space_distr, p_space_def, events_def])
THEN DISCH_TAC
THEN KNOW_TAC (``(A:'b->bool) IN subsets (m_space M, measurable_sets M)``)
     THEN1( METIS_TAC [subsets_def, measurable_sets_def])
THEN DISCH_TAC
THEN KNOW_TAC (``(distr (p:
             ('a -> bool) #
             (('a -> bool) -> bool) # (('a -> bool) -> extreal))
     (M :
       ('b -> bool) #
       (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (X: 'a->'b)) = (space (m_space M, measurable_sets M), subsets (m_space M , measurable_sets M), distribution p X)``)
    THEN1(RW_TAC std_ss [distr, m_space_def, measurable_sets_def, subsets_def, space_def]
          THEN RW_TAC std_ss [prob_def, distribution_def]
          THEN RW_TAC std_ss [p_space_def])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC []
THEN METIS_TAC [distribution_lebesgue_thm2, integral_pos_fn_indicator, subsets_def, measurable_sets_def, distr, space_def, m_space_def ]);


val SIGMA_ALGEBRA_FN_Q = store_thm
  ("SIGMA_ALGEBRA_FN_Q",
   ``!a.
       sigma_algebra a =
       subset_class (space a) (subsets a) /\
       {} IN subsets a /\ (!s. s IN subsets a ==> (space a DIFF s) IN subsets a) /\
       (!f : extreal -> 'a -> bool.
          f IN (Q_set -> subsets a) ==> BIGUNION (IMAGE f Q_set) IN subsets a)``,
   RW_TAC std_ss [SIGMA_ALGEBRA, IN_FUNSET,  SUBSET_DEF]
   THEN EQ_TAC
   THEN1 (RW_TAC std_ss []
       THEN UNDISCH_TAC(`` !c.
             countable c /\ (!x. x IN c ==> x IN subsets a) ==>
             BIGUNION c IN subsets a``)
        THEN DISCH_TAC
        THEN POP_ASSUM (MP_TAC o Q.SPEC ` IMAGE f Q_set`)
        THEN RW_TAC std_ss[]
        THEN KNOW_TAC(``countable (IMAGE (f:extreal->'a->bool) Q_set)``)
             THEN1(RW_TAC std_ss [Q_COUNTABLE,image_countable])
        THEN DISCH_TAC
        THEN FULL_SIMP_TAC std_ss[]
        THEN KNOW_TAC(`` (!x. x IN IMAGE (f:extreal->'a->bool) Q_set ==> x IN subsets a)``)
        THEN1(RW_TAC std_ss[IN_IMAGE] 
             THEN PROVE_TAC [])
        THEN DISCH_TAC
	THEN FULL_SIMP_TAC std_ss [])
  THEN RW_TAC std_ss [COUNTABLE_ENUM_Q]
       THEN1(RW_TAC std_ss [BIGUNION_EMPTY])
  THEN  Q.PAT_ASSUM `!f. (!x. P x f) ==> Q f` MATCH_MP_TAC
   THEN POP_ASSUM MP_TAC
   THEN RW_TAC std_ss [IN_IMAGE, IN_UNIV]
   THEN PROVE_TAC []);



val MEASURE_SPACE_BIGUNION_Q = store_thm ("MEASURE_SPACE_BIGUNION_Q",
     ``!m s.
          measure_space m /\ (!n. n IN Q_set ==> s n IN measurable_sets m) ==>
          BIGUNION (IMAGE s Q_set) IN measurable_sets m``, 
  RW_TAC std_ss []
  ++ (MP_TAC o REWRITE_RULE [subsets_def,space_def,IN_UNIV,IN_FUNSET] o Q.SPEC `(m_space m,measurable_sets m)`) SIGMA_ALGEBRA_FN_Q
  ++ METIS_TAC [measure_space_def]);


val after_set_BIGUNION_Q = store_thm("after_set_BIGUNION_Q",
  ``!t.  BIGUNION
  ({{u| u:real <  real q   } CROSS
  	  {w|  real q  < w:real /\ 0<= w/\ w <= t} | q IN Q_set}) =
  {(u,a) | u < a /\ 0<=a /\ a <=t}``,

SRW_TAC [] [GSPECIFICATION, EXTENSION]
THEN EQ_TAC
    THEN1( SRW_TAC [] [GSPECIFICATION, EXTENSION]
           THEN RW_TAC std_ss [LAMBDA_PAIR]
           THEN METIS_TAC[REAL_LT_LE, REAL_LE_LT, REAL_LT_TRANS, REAL_LE_TRANS, LAMBDA_PAIR])
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]	    
THEN KNOW_TAC (``FST x < SND x /\ SND x <=t:real /\ 0<= SND x ``)
     THEN1(FULL_SIMP_TAC std_ss[ LAMBDA_PAIR])
THEN DISCH_TAC
THEN KNOW_TAC (``Normal (FST x) < Normal (SND x)``)
     THEN1(METIS_TAC [extreal_lt_eq])
THEN DISCH_TAC

THEN KNOW_TAC(``?q. q IN Q_set/\ Normal (FST x) < q /\  q < Normal (SND x)``)
     THEN1(METIS_TAC [Q_DENSE_IN_R])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``FST (x:real#real) = real (Normal(FST x))``)
     THEN1(RW_TAC std_ss [GSYM real_normal])
THEN DISCH_TAC 
THEN KNOW_TAC(``SND (x:real#real) = real(Normal (SND x))``)
     THEN1(METIS_TAC[real_normal])
THEN DISCH_TAC 
THEN KNOW_TAC(``?r. q = Normal r``) 
     THEN1(METIS_TAC[Q_not_infty])
THEN RW_TAC std_ss[]

THEN Q.EXISTS_TAC(`{y| FST y < real (Normal r) /\ real(Normal r) < SND y /\ 0<= SND y/\ SND y <=t}`)
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]
     THEN1(METIS_TAC[extreal_real_lt , extreal_not_infty])
     THEN1(METIS_TAC[extreal_real_lt , extreal_not_infty])
THEN Q.EXISTS_TAC(`Normal r`)     
THEN SRW_TAC[] [GSPECIFICATION, EXTENSION]);



val before_set_BIGUNION_Q = store_thm("before_set_BIGUNION_Q",
  ``!t.  BIGUNION
  ({{u| u:real <  real q  /\ 0<= u /\ u <=t  } CROSS
  	  {w|  real q  < w:real } | q IN Q_set}) =
  {(u,a) | u < a /\ 0 <=u /\ u <=t}``,

SRW_TAC [] [GSPECIFICATION, EXTENSION]
THEN EQ_TAC
    THEN1( SRW_TAC [] [GSPECIFICATION, EXTENSION]
           THEN RW_TAC std_ss [LAMBDA_PAIR]
           THEN METIS_TAC[REAL_LT_LE, REAL_LE_LT, REAL_LT_TRANS, REAL_LE_TRANS, LAMBDA_PAIR])
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]	    
THEN KNOW_TAC (``FST x < SND x /\ FST x <=t:real /\ 0<= FST x  ``)
     THEN1(FULL_SIMP_TAC std_ss[ LAMBDA_PAIR])
THEN DISCH_TAC
THEN KNOW_TAC (``Normal (FST x) < Normal (SND x)``)
     THEN1(METIS_TAC [extreal_lt_eq])
THEN DISCH_TAC

THEN KNOW_TAC(``?q. q IN Q_set/\ Normal (FST x) < q /\  q < Normal (SND x)``)
     THEN1(METIS_TAC [Q_DENSE_IN_R])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``FST (x:real#real) = real (Normal(FST x))``)
     THEN1(RW_TAC std_ss [GSYM real_normal])
THEN DISCH_TAC 
THEN KNOW_TAC(``SND (x:real#real) = real(Normal (SND x))``)
     THEN1(METIS_TAC[real_normal])
THEN DISCH_TAC 
THEN KNOW_TAC(``?r. q = Normal r``) 
     THEN1(METIS_TAC[Q_not_infty])
THEN RW_TAC std_ss[]

THEN Q.EXISTS_TAC(`{y| FST y < real (Normal r) /\ 0 <= FST y /\ FST y <= t/\  real(Normal r) < SND y}`)
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]
     THEN1(METIS_TAC[extreal_real_lt , extreal_not_infty])
     THEN1(METIS_TAC[extreal_real_lt , extreal_not_infty])
THEN Q.EXISTS_TAC(`Normal r`)     
THEN SRW_TAC[] [GSPECIFICATION, EXTENSION]
THEN EQ_TAC
THEN RW_TAC std_ss[]);




val after_set_BIGUNION_IN_MESURABLE_SETS = store_thm(
  "after_set_BIGUNION_IN_MESURABLE_SETS",
  ``    !t q.
            {u | u < real q} CROSS {w | real q < w /\ 0 <= w /\ w <= t} IN
            measurable_sets (pair_measure lborel lborel)``,


RW_TAC std_ss [pair_measure, measure_of, lborel,m_space_def, measurable_sets_def ]
   THEN1 (KNOW_TAC(``{u| u:real <  real q   } CROSS
  	              {w|  real q  < w:real /\ 0<= w/\ w <= t} IN {a CROSS b | a IN subsets borel /\ b IN subsets borel}``)

             THEN1 (KNOW_TAC(``{u | u < real q} IN subsets borel``) 
                   THEN1(METIS_TAC[OPEN_INTERVAL_LEFT, borel_open])
                   THEN DISCH_TAC
                   THEN KNOW_TAC(``{w|  real q  < w:real /\ 0<= w/\ w <= t} IN subsets borel``)
                        THEN1 (KNOW_TAC(``{w|  real q  < w:real /\ 0<= w/\ w <= t} = {w|real q < w} INTER
	                        {w|0<=w /\ w<=t}``)
                              THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
                              THEN DISCH_TAC
		              THEN ONCE_ASM_REWRITE_TAC[]
		              THEN KNOW_TAC(``{w | real q < w} IN subsets borel /\
		         		 {w | 0 <= w /\ w <= t} IN subsets borel==>
					 ({w | real q < w} INTER
		                         {w | 0 <= w /\ w <= t} IN subsets borel)``)
			          THEN1(METIS_TAC[sigma_algebra_borel, algebra_def, sigma_algebra_def, ALGEBRA_ALT_INTER])
			          THEN DISCH_TAC
			          THEN KNOW_TAC(``{w | real q < w} IN subsets borel ``)
		                       THEN1(METIS_TAC[OPEN_INTERVAL_RIGHT, borel_open])
		    	          THEN DISCH_TAC
			          THEN KNOW_TAC(``{w | 0 <= w /\ w <= t} IN subsets borel``)
			               THEN1 (KNOW_TAC(``{w | 0 <= w:real /\ w <= t} = {w | 0 <= w} INTER
			 	                    {w| w <= t:real}``)
			   	                THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
				       THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
				        THEN METIS_TAC[borel_closed, CLOSED_INTERVAL_RIGHT, CLOSED_INTERVAL_LEFT,sigma_algebra_borel, algebra_def, sigma_algebra_def, ALGEBRA_ALT_INTER])
			        THEN DISCH_TAC
			        THEN FULL_SIMP_TAC std_ss[])
	           THEN DISCH_TAC 	  
	           THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]		  
                   THEN Q.EXISTS_TAC(`({u | u < real q} , {w | real q < w /\ 0 <= w /\ w <= t})`)
	           THEN SRW_TAC [] [GSPECIFICATION, EXTENSION])
            THEN DISCH_TAC
	    THEN METIS_TAC [sigma_sets_basic])

THEN KNOW_TAC(``univ(:real) CROSS univ(:real) = univ(:real#real)``)
    THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
THEN DISCH_TAC THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(`` {a CROSS b | a IN subsets borel /\ b IN subsets borel} SUBSET POW univ(:real#real)``)
     THEN1( RW_TAC std_ss [GSYM UNIV_FUN_TO_BOOL, SUBSET_UNIV])
THEN FULL_SIMP_TAC std_ss[] );

val before_set_BIGUNION_IN_MESURABLE_SETS = store_thm("before_set_BIGUNION_IN_MESURABLE_SETS",
  ``  !t q.
            {u | u < real q /\ 0 <= u /\ u <= t} CROSS {w | real q < w} IN
            measurable_sets (pair_measure lborel lborel)``,


RW_TAC std_ss [pair_measure, measure_of, lborel,m_space_def, measurable_sets_def ]
   THEN1 (KNOW_TAC(``{u | u < real q /\ 0 <= u /\ u <= t} CROSS {w | real q < w} IN {a CROSS b | a IN subsets borel /\ b IN subsets borel}``)

             THEN1 (KNOW_TAC(``{w |real q <w} IN subsets borel``) 
                   THEN1(METIS_TAC[OPEN_INTERVAL_RIGHT, borel_open])
                   THEN DISCH_TAC
                   THEN KNOW_TAC(``{u | u < real q /\ 0 <= u /\ u <= t} IN subsets borel``)
                        THEN1 (KNOW_TAC(``{u | u < real q /\ 0 <= u /\ u <= t} = {u | u < real q } INTER {u| 0 <= u /\ u <= t}``)
                              THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
                              THEN DISCH_TAC
		              THEN ONCE_ASM_REWRITE_TAC[]
		              THEN KNOW_TAC(``{u |  u < real q } IN subsets borel /\
		         		 {u | 0 <= u /\ u <= t} IN subsets borel==>
					 ({u | u< real q} INTER
		                         {u | 0 <= u /\ u <= t} IN subsets borel)``)
			          THEN1(METIS_TAC[sigma_algebra_borel, algebra_def, sigma_algebra_def, ALGEBRA_ALT_INTER])
			          THEN DISCH_TAC
			          THEN KNOW_TAC(``{u | u < real q } IN subsets borel ``)
		                       THEN1(METIS_TAC[OPEN_INTERVAL_LEFT, borel_open])
		    	          THEN DISCH_TAC
			          THEN KNOW_TAC(``{u | 0 <= u /\ u:real<= t} IN subsets borel``)
			               THEN1 (KNOW_TAC(``{u | 0 <= u:real /\ u <= t} = {u | 0 <= u} INTER
			 	                    {u| u <= t:real}``)
			   	                THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
				       THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
				        THEN METIS_TAC[borel_closed, CLOSED_INTERVAL_RIGHT, CLOSED_INTERVAL_LEFT,sigma_algebra_borel, algebra_def, sigma_algebra_def, ALGEBRA_ALT_INTER])
			        THEN DISCH_TAC
			        THEN FULL_SIMP_TAC std_ss[])
	           THEN DISCH_TAC 	  
	           THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]		  
                   THEN Q.EXISTS_TAC(`({u | u < real q /\ 0 <= u /\ u <= t}, {w | real q < w})`)
	           THEN SRW_TAC [] [GSPECIFICATION, EXTENSION])
            THEN DISCH_TAC
	    THEN METIS_TAC [sigma_sets_basic])

THEN KNOW_TAC(``univ(:real) CROSS univ(:real) = univ(:real#real)``)
    THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
THEN DISCH_TAC THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(`` {a CROSS b | a IN subsets borel /\ b IN subsets borel} SUBSET POW univ(:real#real)``)
     THEN1( RW_TAC std_ss [GSYM UNIV_FUN_TO_BOOL, SUBSET_UNIV])
THEN FULL_SIMP_TAC std_ss[] );         



val after_set_IN_MEASURABLE_SETS_PAIR_lborel = store_thm("after_set_IN_MEASURABLE_SETS_PAIR_lborel",
  ``  !t. {(u,a) | u < a /\ 0 <= a /\ a <= t} IN
          measurable_sets (pair_measure lborel lborel) ``,
RW_TAC std_ss [GSYM after_set_BIGUNION_Q]
THEN KNOW_TAC (``!q. q IN Q_set ==> ( {u | u < real q} CROSS {w | real q < w /\ 0 <= w /\ w <= t})   IN measurable_sets (pair_measure lborel lborel)``)
     THEN1(METIS_TAC[after_set_BIGUNION_IN_MESURABLE_SETS])
THEN DISCH_TAC
THEN KNOW_TAC(``BIGUNION
  {{u | u < real q} CROSS {w | real q < w /\ 0 <= w /\ w <= t} |
   q IN Q_set} = BIGUNION
  (IMAGE (\q. {u | u < real q} CROSS {w | real q < w /\ 0 <= w /\ w <= t})
   Q_set)``)
     THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION, IMAGE_DEF])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``measure_space (pair_measure lborel lborel)``)
     THEN1(METIS_TAC[ measure_space_pair_measure', measure_space_lborel, sigma_finite_measure_lborel])
THEN DISCH_TAC
THEN DEP_REWRITE_TAC[MEASURE_SPACE_BIGUNION_Q]
THEN RW_TAC std_ss[] );


 val before_set_IN_MEASURABLE_SETS_PAIR_lborel = store_thm(
  "before_set_IN_MEASURABLE_SETS_PAIR_lborel",
  ``  !t.  {(u,a) | u < a /\ 0 <=u /\ u <=t} IN measurable_sets (pair_measure lborel lborel) ``,
RW_TAC std_ss [GSYM before_set_BIGUNION_Q]
THEN KNOW_TAC (``!q. q IN Q_set ==> ({u | u < real q /\ 0 <= u /\ u <= t} CROSS {w | real q < w }) IN measurable_sets (pair_measure lborel lborel)``)
     THEN1(METIS_TAC[before_set_BIGUNION_IN_MESURABLE_SETS])
THEN DISCH_TAC
THEN KNOW_TAC(``BIGUNION
  {{u | u < real q /\ 0 <=u /\ u <=t} CROSS {w | real q < w} |
   q IN Q_set} = BIGUNION
  (IMAGE (\q.{u | u < real q /\ 0 <=u /\ u <=t} CROSS {w | real q < w})
   Q_set)``)
     THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION, IMAGE_DEF])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``measure_space (pair_measure lborel lborel)``)
     THEN1(METIS_TAC[ measure_space_pair_measure', measure_space_lborel, sigma_finite_measure_lborel])
THEN DISCH_TAC
THEN DEP_REWRITE_TAC[MEASURE_SPACE_BIGUNION_Q]
THEN RW_TAC std_ss[] );



val distribution_lebesgue_thm2_pos_fn = store_thm(
  "distribution_lebesgue_thm2_pos_fn",
  ``  ! X p M A. measure_space M/\ random_variable X p (m_space M, measurable_sets M) /\ A IN measurable_sets M ==>
(distribution p X A = pos_fn_integral (distr p M X) (indicator_fn A))``,
METIS_TAC [distribution_lebesgue_thm2_distr, integral_pos_fn_indicator, integral_pos_fn_distr]);


val prob_event_2indep_rv_PREIMAGE_A = store_thm(
  "prob_event_2indep_rv_PREIMAGE_A",
  ``!X Y p M' A B.
     measure_space M' /\ sigma_finite_measure M' /\ prob_space p /\
     indep_var p M' X M' Y /\
     A  IN measurable_sets (pair_measure M' M') /\sigma_finite_measure (distr p M' X) /\
     sigma_finite_measure (distr p M' Y)

      ==>
     (prob p (PREIMAGE (\x. (X x,Y x)) A  INTER p_space p) =
      pos_fn_integral (pair_measure (distr p M' X) (distr p M' Y))
        (indicator_fn A))``,

RW_TAC std_ss[]
THEN KNOW_TAC (``prob
  (p :('a -> bool) # (('a -> bool) -> bool) # (('a -> bool) -> extreal))
  (PREIMAGE (\(x :'a). ((X :'a -> 'b) x,(Y :'a -> 'b) x))
     (A :'b#'b -> bool) INTER p_space p) = distribution p (\x. (X x , Y x)) A``) THEN1(
         METIS_TAC [distribution_def])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC (``(\x. (X x, Y x )) IN measurable (p_space p, events p)(m_space (pair_measure (distr p M' X) (distr p M' Y)),measurable_sets (pair_measure (distr p M' X) (distr p M' Y)))``)
THEN1( FULL_SIMP_TAC std_ss [random_variable_def]
       THEN RW_TAC std_ss [p_space_def, events_def]
       THEN KNOW_TAC(``random_variable X p (m_space M', measurable_sets M') /\random_variable Y p (m_space M', measurable_sets M') ``)
       	    THEN1(METIS_TAC [indep_var_rv])
       THEN DISCH_TAC
       THEN FULL_SIMP_TAC std_ss [random_variable_def]
       THEN FULL_SIMP_TAC std_ss [prob_space_def]
       THEN KNOW_TAC (``measure_space ((distr p
           (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (X:'a->'b))) /\ measure_space ((distr p
           (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (Y:'a->'b)))``) THEN1(
	     	  METIS_TAC [measure_space_distr, p_space_def, events_def])
	THEN DISCH_TAC
	THEN KNOW_TAC(``X IN
      measurable (p_space p,events p) (m_space (distr p
           (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (X:'a->'b)),measurable_sets (distr p
           (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (X:'a->'b))) /\Y IN
      measurable (p_space p,events p) (m_space (distr p
           (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (Y:'a->'b)),measurable_sets (distr p
           (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (Y:'a->'b)))  ``)
	     THEN1( REWRITE_TAC [distr]
	            THEN REWRITE_TAC [measurable_sets_def, m_space_def]
		    THEN METIS_TAC[])
             THEN DISCH_TAC
	     THEN METIS_TAC [measurable_Pair, p_space_def, events_def])
THEN DISCH_TAC
THEN KNOW_TAC(``random_variable X p (m_space M', measurable_sets M') /\random_variable Y p (m_space M', measurable_sets M') ``)
     THEN1( METIS_TAC [indep_var_rv])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss [random_variable_def]
THEN FULL_SIMP_TAC std_ss [prob_space_def]
THEN KNOW_TAC (``measure_space ((distr p
           (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (X:'a->'b))) /\ measure_space ((distr p
           (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (Y:'a->'b)))``) THEN1(
          METIS_TAC [measure_space_distr, p_space_def, events_def])
THEN DISCH_TAC
THEN KNOW_TAC(``X IN
      measurable (p_space p,events p) (m_space (distr p
           (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (X:'a->'b)),measurable_sets (distr p
           (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (X:'a->'b))) /\Y IN
      measurable (p_space p,events p) (m_space (distr p
           (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (Y:'a->'b)),measurable_sets (distr p
           (M' :
             ('b -> bool) #
             (('b -> bool) -> bool) # (('b -> bool) -> extreal)) (Y:'a->'b)))  ``)
	     THEN1( REWRITE_TAC [distr]
	            THEN REWRITE_TAC [measurable_sets_def, m_space_def]
		    THEN METIS_TAC[])
THEN DISCH_TAC
THEN KNOW_TAC(``distribution
  (p :('a -> bool) # (('a -> bool) -> bool) # (('a -> bool) -> extreal))
  (\ (x :'a). ((X :'a -> 'b) x,(Y :'a -> 'b) x))
  (A :'b #'b -> bool) =
pos_fn_integral (distr p (pair_measure M' M' ) (\x. X x , Y x   ))(indicator_fn A)
  
``)THEN1(
       KNOW_TAC (``(\x. (X x, Y x )) IN measurable (p_space p, events p)(m_space (pair_measure M' M') ,measurable_sets (pair_measure M' M'))``)
       THEN1(
           FULL_SIMP_TAC std_ss [distr, measurable_sets_def, m_space_def, pair_measure, measure_of])
      THEN DISCH_TAC
      THEN METIS_TAC [measurable_Pair, p_space_def, random_variable_def, events_def, measurable_sets_def, m_space_def, space_def, subsets_def, prob_space_def, pair_measure, measure_space_distr, indep_var, indep_vars, indep_var_rv, indep_var_distribution_imp, measure_of, distribution_lebesgue_thm2_pos_fn, measure_space_pair_measure'])
THEN DISCH_TAC
THEN KNOW_TAC(`` random_variable X p (m_space M', measurable_sets M') /\ random_variable Y p (m_space M', measurable_sets M') ``) THEN1( METIS_TAC [random_variable_def, m_space_def, prob_space_def, prob_def])
THEN DISCH_TAC
THEN KNOW_TAC(``measure_of(pair_measure (distr (p:
           ('a -> bool) #
           (('a -> bool) -> bool) # (('a -> bool) -> extreal)) M' X) (distr p M' Y)) =measure_of( distr p (pair_measure M' M' )(\x. (X x , Y x)) ) ``) THEN1(METIS_TAC [indep_var_distribution_imp,measure_of, random_variable_def])
THEN DISCH_TAC
THEN RW_TAC std_ss [GSYM pos_fn_integral_measure_of, measure_space_pair_measure']
THEN KNOW_TAC (``(\x. (X x, Y x )) IN measurable (p_space p, events p)(m_space (pair_measure M' M') ,measurable_sets (pair_measure M' M'))``) THEN1(
         FULL_SIMP_TAC std_ss [distr, measurable_sets_def, m_space_def, pair_measure, measure_of])
THEN DISCH_TAC
THEN METIS_TAC [pos_fn_integral_measure_of, measure_space_distr, prob_space_def, prob_def, events_def, p_space_def, measure_space_pair_measure']);



val lemma1 = store_thm("lemma1",
  ``!M Y B f.
     measure_space M /\ (!x. x IN m_space M ==> 0 <= f x) 
     ==>
     ((\y. pos_fn_integral M (\x. Normal (real ((indicator_fn B )y)) * f x)) =
      (\y. Normal (real ((indicator_fn B) y)) * pos_fn_integral M (\x. f x)))``,
RW_TAC std_ss []
THEN DEP_REWRITE_TAC [pos_fn_integral_fun_mul]
THEN RW_TAC std_ss[]
THEN KNOW_TAC (``(0:extreal) <= indicator_fn B y``)
     THEN1( METIS_TAC [indicator_fn_pos_le])
THEN DISCH_TAC
THEN RW_TAC std_ss [indicator_fn_def, real_def]
     THEN1( METIS_TAC [REAL_LE_REFL])
     THEN1(METIS_TAC [REAL_LE_REFL])
     THEN1( SELECT_ELIM_TAC
     	    THEN RW_TAC std_ss[]
	        THEN1(EXISTS_TAC (``(1:real)``)
	    THEN KNOW_TAC (``1<PosInf``)
	         THEN1( METIS_TAC [extreal_of_num_def, lt_infty])
	    THEN DISCH_TAC
	    THEN METIS_TAC [extreal_of_num_def, lt_le, lt_infty])
	    THEN KNOW_TAC (``Normal 0 <= Normal x``)
                 THEN1( METIS_TAC [extreal_of_num_def, le_trans, lt_le, le_01, extreal_le_def])
THEN METIS_TAC [extreal_of_num_def, le_trans, lt_le, le_01, extreal_le_def] )
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]

THEN1( EXISTS_TAC (``(0:real)``)
     	    THEN METIS_TAC [extreal_of_num_def, le_trans, lt_le, le_01, extreal_le_def, le_refl])
THEN METIS_TAC [extreal_of_num_def, le_trans, lt_le, le_01, extreal_le_def, le_refl]);


val indicator_fn_not_eq_infty = store_thm("indicator_fn_not_eq_infty",
  `` !s x . ((indicator_fn s)x  <> PosInf ) /\ ((indicator_fn s )x<> NegInf)``,
RW_TAC std_ss [indicator_fn_def]
THEN METIS_TAC [extreal_of_num_def, le_trans, lt_le, le_01, extreal_le_def, le_refl]);

val lemma2 = store_thm("lemma2",
  ``!M Y B f.
     measure_space M /\ (!x. x IN m_space M ==> 0 <= f x) 
     ==>
     ((\y. pos_fn_integral M (\x. Normal (real ((indicator_fn B )y)) * f x)) =
      (\y.  ((indicator_fn B) y) * pos_fn_integral M (\x. f x)))``,

RW_TAC std_ss[]
THEN KNOW_TAC (``!y. indicator_fn (B:'c->bool) y = Normal (real (indicator_fn B y))``)
     THEN1 (METIS_TAC [normal_real, indicator_fn_not_eq_infty])
THEN DISCH_TAC
THEN DEP_REWRITE_TAC [lemma1]
THEN RW_TAC std_ss[]
THEN METIS_TAC [lemma1]);


val lemma3 = store_thm("lemma3",
  `` !M B f.
     measure_space M /\ (!x. x IN m_space M ==> 0 <= f x) 
     ==>
     ((\y. pos_fn_integral M (\x.((indicator_fn B )y) * f x)) =
      (\y.  ((indicator_fn B) y) * pos_fn_integral M (\x. f x)))``,
RW_TAC std_ss[]
THEN KNOW_TAC (``!y. indicator_fn (B:'b->bool) y = Normal (real (indicator_fn B y))``)
     THEN1(METIS_TAC [normal_real, indicator_fn_not_eq_infty])
THEN DISCH_TAC
THEN METIS_TAC [lemma1]);

val CDF_pos_fn_integral_indicator = store_thm("CDF_pos_fn_integral_indicator",
  `` !X p t M.
     random_variable X p (m_space M,measurable_sets M) /\
     measure_space M /\ {y | y <= t} IN measurable_sets M ==>
     (CDF p X t = pos_fn_integral (distr p M X) (\x. indicator_fn {y | y <= t} x))``,
METIS_TAC [CDF_def, prob_event_le, distribution_def, integral_pos_fn_distr]);


val CDF_pos_fn_integral_indicator1 = store_thm("CDF_pos_fn_integral_indicator1",
  `` !X p t M.
     random_variable X p (m_space M,measurable_sets M) /\
     measure_space M /\ (!t. {y | y <= t} IN measurable_sets M) ==>
    ( CDF p X t = pos_fn_integral (distr p M X) (\x. indicator_fn {y | y <= t} x))``,
RW_TAC std_ss[]
THEN KNOW_TAC(``!t. CDF p X t = pos_fn_integral (distr p M X) (\x. indicator_fn {y | y <= t} x)``)
     THEN1(METIS_TAC [CDF_def, prob_event_le, distribution_def, integral_pos_fn_distr, CDF_pos_fn_integral_indicator])
THEN RW_TAC std_ss[]);

val event_after = store_thm("event_after",
  ``! X Y (t:real).  {w| X(w) < Y(w) /\ Y(w) <t} = PREIMAGE (\ x.(X x,Y x)) {(u ,a )| u<a /\ a < t}``,
RW_TAC std_ss[PREIMAGE_def]
THEN `(X x,Y x) IN {(u,a) | u < a /\ a < t} = (X x,Y x) IN {(u,a) | (\ a1 a2. a1 < a2 /\ a2 < t) u a}` by RW_TAC std_ss[]
THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]);


val  event_after1 = store_thm("event_after1",
  `` ! X Y (t:real).  {w| X(w) < Y(w) /\ Y(w) <=t} = PREIMAGE (\ x.(X x,Y x)) {(u ,a )| u<a /\ a <= t}``,
RW_TAC std_ss[PREIMAGE_def]
THEN `(X x,Y x) IN {(u,a) | u < a /\ a <= t} = (X x,Y x) IN {(u,a) | (\ a1 a2. a1 < a2 /\ a2 <=t) u a}` by RW_TAC std_ss[]
THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]);


val indicator_mul_pos_le = store_thm("indicator_mul_pos_le",
  ``! A B x y . 0<=indicator_fn A x * indicator_fn B y ``,

RW_TAC std_ss [indicator_fn_def]
THEN METIS_TAC [extreal_of_num_def, extreal_le_def,mul_lone, le_trans, lt_le, le_01, mul_rzero, le_refl, mul_comm ]);


val pos_fn_integral_density = store_thm("pos_fn_integral_density",
  `` !f g M.
     measure_space M /\
     f IN measurable (m_space M,measurable_sets M) Borel /\
     AE M {x | 0 <= f x} /\
     g IN measurable (m_space M,measurable_sets M) Borel /\
     (!x. 0 <= g x) ==>
     (pos_fn_integral
       (density M f) (\x. max 0 (g x)) =
      pos_fn_integral M (\x. max 0 (f x * g x)))``,
RW_TAC std_ss [density, pos_fn_integral_density']);


val pos_fn_integral_density_1 = store_thm("pos_fn_integral_density_1",
  ``  !f g M.
     measure_space M /\
     f IN measurable (m_space M,measurable_sets M) Borel /\(!x. 0<=f x) /\ 
     AE M {x | 0 <= f x} /\
     g IN measurable (m_space M,measurable_sets M) Borel /\
     (!x. 0 <= g x) ==>
     (pos_fn_integral
       (density M f) (\x.  (g x)) =
      pos_fn_integral M (\x.(f x * g x)))``,
RW_TAC std_ss[]
THEN KNOW_TAC(``pos_fn_integral (density M (f:'a->extreal)) (\x. (g:'a->extreal) x) = pos_fn_integral (density M f) (\x. max 0 (g x))``) THEN1(RW_TAC std_ss [extreal_max_def])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC (``  pos_fn_integral M (\x. (f:'a->extreal) x * (g:'a->extreal) x) = pos_fn_integral M (\x. max 0 (f x * g x)) ``) THEN1(
            KNOW_TAC(``!x. 0<= ((f:'a->extreal) x * (g:'a-> extreal) x)``)
	    THEN1(METIS_TAC [le_mul])
	    THEN RW_TAC std_ss [extreal_max_def])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss [pos_fn_integral_density]);



(*-----------------------------------------------------------*)
(* CDF proposerties                                          *)
(*-----------------------------------------------------------*)
val  CDF_pos = store_thm("CDF_pos",
  `` !p X t M. random_variable X p (m_space M, measurable_sets M) /\ {y|y<=(t:real)} IN measurable_sets M==> ( 0<= CDF p X t )``,
RW_TAC std_ss [CDF_def, distribution_def, random_variable_def]
THEN KNOW_TAC(``PREIMAGE (X:'a->real) {y | y<= (t:real)} INTER p_space p IN events p``)
     THEN1(
          FULL_SIMP_TAC std_ss [measurable_def]
	  THEN FULL_SIMP_TAC std_ss [subsets_def, space_def]
	  THEN FULL_SIMP_TAC std_ss [EXTENSION, GSPECIFICATION])
THEN DISCH_TAC
THEN METIS_TAC [PROB_POSITIVE]);



val prob_neq_infty = store_thm("prob_neq_infty",
  `` ! p s . prob_space p /\ s IN events p ==>( prob p s <> PosInf /\ prob p s <> NegInf)``,
METIS_TAC [PROB_POSITIVE, PROB_LE_1, extreal_of_num_def, lt_trans, le_trans, extreal_le_def, le_infty]);


val extreal_real_le = store_thm("extreal_real_le",
  ``  !x y. x <> PosInf /\ x <> NegInf /\ y <> PosInf /\ y <> NegInf ==> ((real y<=real x) = (y <=x))``,

RW_TAC std_ss[]
THEN RW_TAC std_ss [real_def]
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
     THEN1(EXISTS_TAC(``real y``)
           THEN METIS_TAC [normal_real])
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
      THEN1(EXISTS_TAC(``real x``)
            THEN METIS_TAC [normal_real])
THEN METIS_TAC [extreal_lt_def, extreal_le_def,  real_lt]);



val extreal_real_sub_eq = store_thm("extreal_real_sub_eq",
  ``  ! (x:extreal) y (z:extreal)  .x <> PosInf /\ x <> NegInf /\ y <> PosInf /\ y <> NegInf /\ z <> PosInf /\ z <> NegInf ==> ( (real z = real x - real y) = (z = x - y))``,
RW_TAC std_ss[]
THEN RW_TAC std_ss [real_def]
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
     THEN1(EXISTS_TAC (``real z``)
           THEN METIS_TAC [normal_real])
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
     THEN1(EXISTS_TAC (``real x``)
           THEN METIS_TAC [normal_real])
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
     THEN1(EXISTS_TAC (``real y``)
           THEN METIS_TAC [normal_real])
THEN RW_TAC std_ss[]
THEN EQ_TAC
     THEN1(RW_TAC std_ss[]
           THEN METIS_TAC [extreal_sub_def])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``(Normal x'' - Normal x )= Normal (x''-x)``)
     THEN1(
       METIS_TAC [extreal_sub_def])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]
THEN METIS_TAC [extreal_11]);

val extreal_real_eq = store_thm("extreal_real_eq",
  `` ! x y .  x <> PosInf /\ x <> NegInf /\ y <> PosInf /\ y <> NegInf==> ((real x = real y) = (x = y))``,

RW_TAC std_ss [real_def]
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
     THEN1(
           EXISTS_TAC(``real x``)
	   THEN METIS_TAC [normal_real])
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
THEN EXISTS_TAC(``real y``)
THEN METIS_TAC [normal_real]);


val eq_sub_ladd = store_thm("eq_sub_ladd",
  ``   ! x y z. z<> NegInf /\ z <> PosInf ==>((x = y-z) = (x+z = y) )``,

REPEAT Cases
THEN RW_TAC std_ss[extreal_add_def, extreal_sub_def, REAL_EQ_SUB_LADD]);


(* ------------------------------------------------------------------------- *)
(*                PROB_AT_POINT1                                             *)
(* ------------------------------------------------------------------------- *)

val PROB_AT_POINT1 = store_thm("PROB_AT_POINT1",
  `` !p (X:'a->real) (x:real) n.  prob_space p  /\ PREIMAGE X {y | x - 1 / &SUC n < y /\ y <= x} INTER p_space p IN events p /\ PREIMAGE X {y | y = x} INTER p_space p IN events p
==> ((prob p (PREIMAGE X {y | y = x} INTER p_space p)) <= (distribution p X {y |  x - (1 / &SUC n) < y /\ y <=  x}))``,
RW_TAC std_ss[]
THEN RW_TAC std_ss[distribution_def]
THEN MATCH_MP_TAC PROB_INCREASING
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss [SUBSET_DEF,IN_PREIMAGE,IN_INTER]
THEN FULL_SIMP_TAC std_ss [GSPECIFICATION]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[ REAL_LT_SUB_RADD]
THEN ONCE_REWRITE_TAC [REAL_ADD_COMM]
THEN RW_TAC std_ss[REAL_LT_ADDL]
THEN RW_TAC real_ss[GSYM REAL_INV_1OVER,REAL_LE_INV_EQ ]
THEN RW_TAC std_ss[REAL_LE_REFL]);


(* ------------------------------------------------------------------------- *)
(*                                                                           *)
(* ------------------------------------------------------------------------- *)


val CDF_INTERVAL = store_thm("CDF_INTERVAL",
  `` !p (X:'a->real) (a:real) b. a <= b  /\  prob_space p /\ PREIMAGE X {y|y<=a} INTER p_space p IN events p   /\PREIMAGE X {y | a < y /\ y <= b} INTER p_space p IN events p
==> (distribution p X {y | ( a < y) /\ (y <=  b)} =
			CDF p X b - CDF p X a)``,

REPEAT STRIP_TAC
THEN RW_TAC std_ss [CDF_def]
THEN RW_TAC std_ss [distribution_def]
THEN KNOW_TAC (``{y | y <=  (b:real)} = {y | y <=  a} UNION {y | a < y /\ y <=  b}``)
     THEN1(RW_TAC std_ss [UNION_DEF]
           THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]
           THEN DFT_rewrs_ss)
THEN DISCH_TAC
THEN ASM_REWRITE_TAC []
THEN RW_TAC std_ss [eq_sub_ladd, prob_neq_infty]
THEN RW_TAC std_ss [EQ_SYM_EQ]
THEN MATCH_MP_TAC PROB_ADDITIVE
THEN KNOW_TAC (``{y |  a < y /\ y <= (b:real)} = {y | y <=  b} DIFF {y | y <=  a}``)
     THEN1(RW_TAC std_ss [DIFF_DEF]
           THEN RW_TAC std_ss [UNION_DEF]
	   THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]
	   THEN DFT_rewrs_ss)
THEN RW_TAC std_ss []
     THEN1(RW_TAC std_ss [DISJOINT_DEF, INTER_DEF,IN_PREIMAGE,IN_INTER,IN_POW,INTER_SUBSET,SUBSET_DEF,GSPECIFICATION ]
	   
           THEN RW_TAC std_ss [real_lt]
           THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]
           THEN METIS_TAC [REAL_LT_TOTAL, real_lt, DISJ_ASSOC, DISJ_COMM])
THEN RW_TAC std_ss[ PREIMAGE_UNION]
THEN RW_TAC std_ss [PREIMAGE_def, UNION_DEF]
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]
THEN EQ_TAC
     THEN1(RW_TAC std_ss[]
           THEN DFT_rewrs_ss)
THEN DFT_rewrs_ss);

val ABS_BOUND_LT = store_thm("ABS_BOUNF_LT",
  `` !x k:real. abs x < k = -k < x /\ x < k``,
REAL_ARITH_TAC);

val real_of_0 = store_thm("real_of_0",
  `` real 0 = 0``,
RW_TAC std_ss [real_def]
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
     THEN1 (EXISTS_TAC (``real 0``)
            THEN METIS_TAC [normal_real])
THEN METIS_TAC [extreal_eq_zero]);

(* ------------------------------------------------------------------------- *)
(*                                                                           *)
(* ------------------------------------------------------------------------- *)



val CONT_PROB_ZERO_POINT = store_thm("CONT_PROB_ZERO_POINT",
  ``!p (X:'a->real) (x:real).
        prob_space p /\
       (!n.
          PREIMAGE X {y | x - 1 / &SUC n < y /\ y <= x} INTER
          p_space p IN events p /\
          PREIMAGE X {y | y <= x} INTER p_space p IN events p /\
          PREIMAGE X {y | y <= x - 1 / &SUC n} INTER p_space p IN
          events p) /\
       PREIMAGE X {y | y = x} INTER p_space p IN events p /\
       (!z. (\x. real (CDF p X x)) contl z) ==>
       real (prob p (PREIMAGE X {y | y = x} INTER p_space p)) <= 0``,

RW_TAC std_ss[]
THEN MATCH_MP_TAC SEQ_LE
THEN EXISTS_TAC (``(\ (n:num) . (real(prob p (PREIMAGE (X:'a->real) {y | y =  (x)} INTER p_space p))))``)
THEN RW_TAC std_ss [SEQ_CONST]
THEN EXISTS_TAC (``(\n:num. (real(CDF p (X:'a->real) (( x) ))) - (real( CDF p (X:'a->real) ((x - 1 / &SUC n) ))))``)
THEN RW_TAC real_ss[]
     THEN1(RW_TAC std_ss[CDF_def,distribution_def]
           THEN POP_ASSUM (MP_TAC o Q.SPEC `x`)
	   THEN FULL_SIMP_TAC std_ss [CDF_def, contl,distribution_def]
	   THEN FULL_SIMP_TAC std_ss [LIM,SEQ]
	   THEN RW_TAC real_ss[]
	   THEN FULL_SIMP_TAC std_ss []
	   THEN POP_ASSUM MP_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `e`)
	   THEN RW_TAC std_ss []
	   THEN FULL_SIMP_TAC std_ss []
	   THEN EXISTS_TAC (``(clg (1/d)) ``)
	   THEN RW_TAC std_ss []
	   THEN POP_ASSUM MP_TAC
	   THEN POP_ASSUM MP_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `-(1 / &SUC n)`)
	   THEN RW_TAC std_ss []
	   THEN FULL_SIMP_TAC std_ss [REAL_SUB_RZERO]
	   THEN KNOW_TAC(``( 0 < abs (-(1 / &SUC n:real)) /\ abs (-(1 / &SUC n:real)) < d:real )``)
	   	THEN1(RW_TAC std_ss[ABS_NEG]
		       THEN1(RW_TAC std_ss [abs]
		             THEN1(RW_TAC real_ss[GSYM REAL_INV_1OVER])
		       THEN RW_TAC std_ss[GSYM REAL_NEG_NEG ]
		       THEN KNOW_TAC(``(0 = -0:real )``)
		            THEN1(RW_TAC real_ss[])
		       THEN DISCH_TAC
		       THEN ONCE_ASM_REWRITE_TAC[]
		       THEN RW_TAC real_ss[REAL_LT_NEG]
		       THEN FULL_SIMP_TAC std_ss [REAL_NOT_LE])
		THEN RW_TAC std_ss [ABS_BOUND_LT]
		     THEN1(MATCH_MP_TAC REAL_LET_TRANS
		     	   THEN EXISTS_TAC (``(-(1 / &SUC n:real)) ``)
			   THEN RW_TAC real_ss[]
			   	THEN1(RW_TAC real_ss[REAL_LE_LDIV_EQ]
				      THEN ONCE_REWRITE_TAC[REAL_MUL_COMM]
				      THEN RW_TAC real_ss[GSYM REAL_LE_LDIV_EQ]
				      THEN MATCH_MP_TAC REAL_LE_TRANS
				      THEN EXISTS_TAC (`` (&(clg(1/(d:real))):real) ``)
				      THEN rw_tac std_ss [LE_NUM_CEILING]
				      THEN FULL_SIMP_TAC std_ss [GREATER_EQ]
				      THEN METIS_TAC [LESS_EQ_SUC_REFL, LESS_EQ_TRANS, REAL_LE] )
		           THEN MATCH_MP_TAC REAL_LT_TRANS
		           THEN EXISTS_TAC (`` 0:real ``)
		           THEN KNOW_TAC(``(0 = -0:real )``)
		               THEN1(RW_TAC real_ss[])
		           THEN DISCH_TAC
		           THEN ONCE_ASM_REWRITE_TAC[]
		           THEN RW_TAC real_ss[REAL_LT_NEG]
		               THEN1(RW_TAC real_ss[GSYM REAL_INV_1OVER,REAL_LT_INV_EQ ])
                           THEN RW_TAC real_ss[GSYM REAL_INV_1OVER,REAL_LT_INV_EQ ])

                     THEN RW_TAC real_ss[REAL_LT_LDIV_EQ]
	             THEN ONCE_REWRITE_TAC[REAL_MUL_COMM]
	             THEN RW_TAC real_ss[GSYM REAL_LT_LDIV_EQ]
	             THEN MATCH_MP_TAC REAL_LET_TRANS
	             THEN EXISTS_TAC (`` (&(clg(1/(d:real))):real) ``)
	             THEN rw_tac std_ss[LE_NUM_CEILING]
		     THEN FULL_SIMP_TAC std_ss [GREATER_EQ]
		     THEN RW_TAC std_ss [REAL_LT]
		     THEN METIS_TAC [LESS_SUC_REFL, LESS_EQ_TRANS,LESS_EQ_LESS_TRANS])

	       THEN RW_TAC real_ss[]
	       THEN ONCE_REWRITE_TAC[GSYM REAL_NEG_SUB]
	       THEN RW_TAC real_ss[ABS_NEG]
	       THEN FULL_SIMP_TAC std_ss [real_sub])
THEN EXISTS_TAC (`` 1:num ``)
THEN RW_TAC real_ss[]
THEN KNOW_TAC(`` real(CDF p (X:'a->real) ((x ))) -real( CDF p (X:'a->real) ((x -  1 / &SUC n ))) = real(distribution p (X:'a->real) {y |  ( (x -  1 / &SUC n ) <  y) /\ (y <=  (x ))})``)
     THEN1(MATCH_MP_TAC EQ_SYM
           THEN RW_TAC std_ss [distribution_def, CDF_def]
	   THEN RW_TAC std_ss [extreal_real_sub_eq, prob_neq_infty]
	   THEN KNOW_TAC (``prob p (PREIMAGE (X:'a->real) {y | x  - 1 / &SUC n < y /\ y <= x} INTER p_space p) =distribution p X {y | x  -1 / &SUC n < y /\ y <= x} ``)
	   	THEN1(RW_TAC std_ss [distribution_def])
           THEN DISCH_TAC
           THEN ONCE_ASM_REWRITE_TAC[]
	   THEN KNOW_TAC (``prob p (PREIMAGE (X:'a->real) {y | y <= x} INTER p_space p)  = CDF p X x ``)
	   	THEN1(RW_TAC std_ss [CDF_def, distribution_def])
	  THEN DISCH_TAC
	  THEN ONCE_ASM_REWRITE_TAC[]
	  THEN KNOW_TAC (``prob p (PREIMAGE (X:'a->real) {y | y <= x   -1 / &SUC n} INTER p_space p) = CDF p X  (x  -1 / &SUC n)``)
	       THEN1(RW_TAC std_ss [CDF_def, distribution_def])
	  THEN DISCH_TAC
     	  THEN ONCE_ASM_REWRITE_TAC[]
	  THEN MATCH_MP_TAC CDF_INTERVAL
	  THEN RW_TAC std_ss[]
	  THEN RW_TAC std_ss [GSYM real_sub]
	  THEN RW_TAC std_ss [REAL_LE_SUB_RADD]
	  THEN RW_TAC std_ss [REAL_LE_ADDR]
	  THEN RW_TAC real_ss[GSYM REAL_INV_1OVER,REAL_LE_INV_EQ ])
THEN RW_TAC real_ss[]
THEN KNOW_TAC(`` (prob p (PREIMAGE (X:'a->real) {y | y = x} INTER p_space p)) <=
 (distribution p X {y | x - 1 / &SUC n < y /\ y <= x})``)   
     THEN1( RW_TAC std_ss [PROB_AT_POINT1])
THEN DISCH_TAC
THEN RW_TAC std_ss[ distribution_def, prob_neq_infty,PROB_AT_POINT1, extreal_real_le]);



val CONT_PROB_POINT_EQ_0 = store_thm("CONT_PROB_POINT_EQ_0",
  `` !p (X:'a->real) (x:real).
     prob_space p /\ 
     (!n.
        PREIMAGE X {y | x - 1 / &SUC n < y /\ y <= x} INTER p_space p IN
        events p /\
        PREIMAGE X {y | y <= x} INTER p_space p IN events p /\
        PREIMAGE X {y | y <= x - 1 / &SUC n} INTER p_space p IN
        events p) /\
     PREIMAGE X {y | y = x} INTER p_space p IN events p /\
     (!z.  (\x. real (CDF p X x)) contl z) ==>
     (real (prob p (PREIMAGE X {y | y = x} INTER p_space p)) = 0)``,


RW_TAC std_ss[]
THEN KNOW_TAC(``0<= real(prob p (PREIMAGE (X:'a->real) {y | y = x} INTER p_space p ))``)
     THEN1(RW_TAC std_ss [GSYM real_of_0]
           THEN KNOW_TAC(`` 0<=prob p (PREIMAGE (X:'a->real) {y | y = x} INTER p_space p ) ``)
	        THEN1(METIS_TAC [PROB_POSITIVE])
	    THEN DISCH_TAC
	    THEN KNOW_TAC(``prob p (PREIMAGE (X:'a->real) {y | y = x} INTER p_space p) <> PosInf``)
                 THEN1(METIS_TAC [prob_neq_infty])
	    THEN  DISCH_TAC
	    THEN KNOW_TAC(``prob p (PREIMAGE (X:'a->real) {y | y = x} INTER p_space p) <> NegInf``)
	          THEN1(METIS_TAC [prob_neq_infty])
            THEN DISCH_TAC

	    THEN METIS_TAC [extreal_real_le, extreal_of_num_def, extreal_lt_def, extreal_le_def, real_of_0])
THEN DISCH_TAC
THEN METIS_TAC [REAL_LE_ANTISYM, CONT_PROB_ZERO_POINT]);


val CONT_PROB_POINT_0 = store_thm("CONT_PROB_POINT_0",
  `` !p (X:'a->real) (x:real).
     prob_space p /\ 
     (!n.
        PREIMAGE X {y | x - 1 / &SUC n < y /\ y <= x} INTER p_space p IN
        events p /\
        PREIMAGE X {y | y <= x} INTER p_space p IN events p /\
        PREIMAGE X {y | y <= x - 1 / &SUC n} INTER p_space p IN
        events p) /\
     PREIMAGE X {y | y = x} INTER p_space p IN events p /\
     (!z.(\x. real (CDF p X x)) contl z) ==>
      (prob p (PREIMAGE X {y | y = x} INTER p_space p) = 0)``,
RW_TAC std_ss[]
THEN METIS_TAC [CONT_PROB_POINT_EQ_0, extreal_real_eq, extreal_of_num_def, extreal_lt_def, extreal_le_def, real_of_0, prob_neq_infty]);



val PROB_le_eq = store_thm("PROB_le_eq",
  ``  !p (X:'a->real) (x:real).
     prob_space p /\      (!n.
        PREIMAGE X {y | x - 1 / &SUC n < y /\ y <= x} INTER p_space p IN
        events p /\
        PREIMAGE X {y | y <= x} INTER p_space p IN events p /\
	 PREIMAGE X {y | y < x} INTER p_space p IN events p /\
        PREIMAGE X {y | y <= x - 1 / &SUC n} INTER p_space p IN
        events p) /\
     PREIMAGE X {y | y = x} INTER p_space p IN events p /\
     (!z.  (\x. real (CDF p X x)) contl z) ==>
      (prob p (PREIMAGE X {y | y <= x} INTER p_space p) =(prob p (PREIMAGE X {y | y < x} INTER p_space p) ))``,

RW_TAC std_ss[]
THEN KNOW_TAC(`` (PREIMAGE (X:'a->real) {y | y <= x} INTER p_space p) = PREIMAGE X {y | y < x} INTER p_space p  UNION PREIMAGE X {y | y = x} INTER p_space p``)
     THEN1( RW_TAC std_ss [PREIMAGE_def, UNION_DEF]
            THEN SRW_TAC [][EXTENSION, GSPECIFICATION]
	    THEN EQ_TAC
	         THEN1(RW_TAC std_ss[]
		       THEN METIS_TAC [REAL_LE_LT])
	    THEN RW_TAC std_ss[]
	    THEN DFT_rewrs_ss)
	    
THEN DISCH_TAC
THEN KNOW_TAC(`` DISJOINT (PREIMAGE (X:'a->real) {y | y < x} INTER p_space p)(PREIMAGE X {y | y = x} INTER p_space p)  ``)
     THEN1( RW_TAC std_ss [DISJOINT_DEF, PREIMAGE_def, UNION_DEF]
            THEN SRW_TAC [][EXTENSION, GSPECIFICATION]
	    THEN DFT_rewrs_ss)
THEN DISCH_TAC
THEN KNOW_TAC(``prob p (PREIMAGE (X:'a->real) {y | y <= x} INTER p_space p) = prob p (PREIMAGE X {y | y < x} INTER p_space p) +prob p (PREIMAGE X {y | y = x} INTER p_space p)``)
     THEN1(RW_TAC std_ss [PROB_ADDITIVE])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC []
THEN RW_TAC std_ss [CONT_PROB_POINT_0]
THEN RW_TAC std_ss[ add_rzero]);


val CDF_def2 = store_thm("CDF_def2",
  ``  !p X x.
     prob_space p /\
     (!n.
        PREIMAGE X {y | x - 1 / &SUC n < y /\ y <= x} INTER p_space p IN
        events p /\
        PREIMAGE X {y | y <= x} INTER p_space p IN events p /\
        PREIMAGE X {y | y < x} INTER p_space p IN events p /\
        PREIMAGE X {y | y <= x - 1 / &SUC n} INTER p_space p IN
        events p) /\
     PREIMAGE X {y | y = x} INTER p_space p IN events p /\
     (!z.  (\x. real (CDF p X x)) contl z) ==>
     (CDF p X x =
      prob p (PREIMAGE X {y | y < x} INTER p_space p))``,
RW_TAC std_ss[]
THEN RW_TAC std_ss [CDF_def, distribution_def]
THEN RW_TAC std_ss [PROB_le_eq]);

val LE_UNION_GT = store_thm("LE_UNION_GT",
  ``
     !p X t.
       prob_space p ==>
       (PREIMAGE X univ(:real) INTER p_space p =
        PREIMAGE X {y | y <= t} INTER p_space p UNION
        PREIMAGE X {y | y > t} INTER p_space p)
``,
RW_TAC std_ss []
THEN RW_TAC std_ss [PREIMAGE_def]
THEN SRW_TAC [] [EXTENSION, GSPECIFICATION]
THEN EQ_TAC
     THEN1(RW_TAC std_ss[]
           THEN METIS_TAC [REAL_LT_TOTAL, REAL_LE_LT, real_gt])
THEN RW_TAC std_ss[]);


val set_le_gt_disjoint = store_thm("set_le_gt_disjoint",
  ``  ! (t:real). DISJOINT {y|y>t} {y|y<=t}``,
RW_TAC std_ss [DISJOINT_DEF]
THEN SRW_TAC [] [EXTENSION, GSPECIFICATION]
THEN RW_TAC std_ss [real_gt]
THEN RW_TAC std_ss [real_lt]);


val prob_gt_1_le = store_thm("prob_gt_1_le",
  ``  !p X t:real.
       prob_space p /\
       PREIMAGE X {y | y <= t} INTER p_space p IN events p /\
       PREIMAGE X {y | y > t} INTER p_space p IN events p ==>
       (prob p (PREIMAGE X {y | y > t} INTER p_space p) =
        1 - prob p (PREIMAGE X {y | y <= t} INTER p_space p))
 ``,

RW_TAC std_ss []
THEN KNOW_TAC(``univ(:real) = {y|y>t} UNION {y|y<=t}``)
     THEN1(SRW_TAC [] [EXTENSION, GSPECIFICATION]
           THEN METIS_TAC [REAL_LT_TOTAL, REAL_LE_LT, real_gt])
THEN DISCH_TAC

THEN KNOW_TAC(`` DISJOINT {y|y>t} {y|y<=t}``)
     THEN1( RW_TAC std_ss [set_le_gt_disjoint])
THEN DISCH_TAC
THEN KNOW_TAC (``prob p (PREIMAGE X univ(:real) INTER p_space p) = prob p (PREIMAGE X {y|y>t} INTER p_space p) + prob p (PREIMAGE X {y|y<=t} INTER p_space p)``)
     THEN1( ASM_REWRITE_TAC[]
           THEN RW_TAC std_ss [PREIMAGE_UNION]
	   THEN KNOW_TAC (`` ((PREIMAGE X {y | y > t} UNION PREIMAGE X {y | y <= t}) INTER
   p_space p) = ((PREIMAGE X {y | y > t} INTER p_space p) UNION PREIMAGE X {y | y <= t} INTER
   p_space p) ``)
		THEN1(RW_TAC std_ss [PREIMAGE_def, UNION_DEF]
	              THEN SRW_TAC [] [EXTENSION, GSPECIFICATION]
		      THEN EQ_TAC
		           THEN1(RW_TAC std_ss [])
		      THEN RW_TAC std_ss []
		      THEN METIS_TAC [REAL_LT_TOTAL, REAL_LE_LT, real_gt])
	    THEN DISCH_TAC
	    THEN ASM_REWRITE_TAC[]
	    THEN KNOW_TAC (``DISJOINT (PREIMAGE X {y | y > t} INTER p_space p) (PREIMAGE X {y | y <= t} INTER p_space p)``)
	    	 THEN1(RW_TAC std_ss [DISJOINT_DEF, PREIMAGE_def]
		       THEN SRW_TAC [] [EXTENSION, GSPECIFICATION]
		       THEN RW_TAC std_ss [real_gt, real_lt]
		       THEN RW_TAC std_ss [GSYM DISJ_ASSOC]
		       THEN METIS_TAC [DISJ_COMM])
	     THEN DISCH_TAC
	     THEN METIS_TAC [PROB_ADDITIVE, PREIMAGE_DISJOINT, PREIMAGE_UNION])
THEN DISCH_TAC
THEN KNOW_TAC (`` 1 = prob p (PREIMAGE X univ(:real) INTER p_space p) ``)
     THEN1(REWRITE_TAC [PREIMAGE_UNIV]
            THEN REWRITE_TAC [INTER_UNIV]
	    THEN METIS_TAC [PROB_UNIV])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``prob p (PREIMAGE X {y | y > t} INTER p_space p) +
prob p (PREIMAGE X {y | y <= t} INTER p_space p) -
prob p (PREIMAGE X {y | y <= t} INTER p_space p) = prob p (PREIMAGE X {y | y > t} INTER p_space p) -
prob p (PREIMAGE X {y | y <= t} INTER p_space p) +
prob p (PREIMAGE X {y | y <= t} INTER p_space p)``)
     THEN1(METIS_TAC [REAL_SUB_REFL, extreal_sub_def, extreal_of_num_def, prob_neq_infty, extreal_sub_add,sub_add, add_comm, add_sub2])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN METIS_TAC [sub_add, prob_neq_infty]);


val prob_gt_CDF = store_thm("prob_gt_CDF",
  ``  !p X t.
       prob_space p /\
       PREIMAGE X {y | y <= t} INTER p_space p IN events p /\
       PREIMAGE X {y | y > t} INTER p_space p IN events p ==>
       (prob p (PREIMAGE X {y | y > t} INTER p_space p) = 1 - CDF p X t)
 ``,

RW_TAC std_ss [CDF_def, distribution_def, prob_gt_1_le]);



val prob_gt_pos_fn_integral = store_thm("prob_gt_pos_fn_integral",
  ``  !p X t M.
       random_variable X p (m_space M,measurable_sets M) /\
       measure_space M /\ (!t. {y | y > t} IN measurable_sets M) ==>
       (prob p (PREIMAGE X {y | y > t} INTER p_space p) =
        pos_fn_integral (distr p M X) (\x. indicator_fn {y | y > t} x))
 ``,
RW_TAC std_ss[]
THEN KNOW_TAC(`` prob p (PREIMAGE (X:'a->real) {y | y > t} INTER p_space p) = distribution p X {y|y>t}``)
     THEN1(RW_TAC std_ss [distribution_def])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN METIS_TAC [ distribution_lebesgue_thm2_pos_fn, ETA_AX]);

val pos_fn_integral_gt_CDF = store_thm("pos_fn_integral_gt_CDF",
  `` !M p X t.
       random_variable X p (m_space M,measurable_sets M) /\
       PREIMAGE X {y | y <= t} INTER p_space p IN events p /\
       PREIMAGE X {y | y > t} INTER p_space p IN events p /\
       measure_space M /\ (!t. {y | y > t} IN measurable_sets M) ==>
       (pos_fn_integral (distr p M X) (\x. indicator_fn {y | y > t} x) =
        1 - CDF p X t)``,
RW_TAC std_ss []
THEN METIS_TAC [prob_gt_pos_fn_integral, random_variable_def, prob_gt_CDF]);

val CDF_pos_fn_integral_indicator1 = store_thm("CDF_pos_fn_integral_indicator1",
  ``  !X p t M.
       random_variable X p (m_space M,measurable_sets M) /\
       measure_space M /\ (!t. {y | y <= t} IN measurable_sets M) ==>
       (CDF p X t =
        pos_fn_integral (distr p M X) (\x. indicator_fn {y | y <= t} x))
 ``,

RW_TAC std_ss[]
THEN KNOW_TAC(``!t. CDF p X t = pos_fn_integral (distr p M X) (\x. indicator_fn {y | y <= t} x)``)
     THEN1(METIS_TAC [CDF_def, prob_event_le, distribution_def, integral_pos_fn_distr, CDF_pos_fn_integral_indicator])
THEN RW_TAC std_ss[]);



val event_BEFORE = store_thm("event_BEFORE",
  ``  ! X Y (t:real).
         {w|X(w)<=t /\ 0<=X(w) /\ X(w) <Y(w)} =
         PREIMAGE (\x.(X x , Y x )) {(u,a)| u<=t /\ 0<=u/\ u<a}``,

RW_TAC std_ss[PREIMAGE_def]
THEN `(X x,Y x) IN {(u,a) | u <=t /\ 0<=u/\ u<a} = (X x,Y x) IN {(u,a) | (\ a1 a2. a1 <=t /\ 0<=a1/\ a1 <a2) u a}` by RW_TAC std_ss[]
THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]);



val indicator_of_indicator_before = store_thm("indicator_of_indicator_before",
  `` !x y t:real.
       indicator_fn {(u,w) | u <= t /\ 0 <= u /\ u < w} (x,y) =
       indicator_fn {u | 0 <= u /\ u <= t} x *
       indicator_fn {w | x < w} y ``,


RW_TAC std_ss [indicator_fn_def]
THEN1( METIS_TAC [mul_lone])
THEN1(`(x,y) IN {(u,w) | u <=t /\0<=u/\ u < w} = ((x,y) IN {(w,u) | (\a b. a <=t /\ 0<=a/\a <b) w u} )` by RW_TAC std_ss[]
       THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]
       THEN FULL_SIMP_TAC std_ss [GSPECIFICATION, EXTENSION])

THEN1(`(x,y) IN {(u,w) | u <=t /\0<=u/\ u < w} = ((x,y) IN {(w,u) | (\a b. a <=t /\ 0<=a/\a <b) w u} )` by RW_TAC std_ss[]
       THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]
       THEN FULL_SIMP_TAC std_ss [GSPECIFICATION, EXTENSION]
       THEN DFT_rewrs_ss   )

THEN1(`(x,y) IN {(u,w) | u <=t /\0<=u/\ u < w} = ((x,y) IN {(w,u) | (\a b. a <=t /\ 0<=a/\a <b) w u} )` by RW_TAC std_ss[]
       THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]
       THEN FULL_SIMP_TAC std_ss [GSPECIFICATION, EXTENSION])

THEN1(`(x,y) IN {(u,w) | u <=t /\0<=u/\ u < w} = ((x,y) IN {(w,u) | (\a b. a <=t /\ 0<=a/\a <b) w u} )` by RW_TAC std_ss[]
       THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]
       THEN FULL_SIMP_TAC std_ss [GSPECIFICATION, EXTENSION])

THEN METIS_TAC [mul_rzero, mul_comm]);


val lemma_indicator_mul_before = store_thm("lemma_indicator_mul_before",
  ``  !(X:'a->real) (Y:'a->real) p M t.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (\(x,y).
          indicator_fn {u | 0 <= u /\ u <= t} x *
          indicator_fn {w | x < w} y) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel ==>
       (pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
          (\(x,y).
             indicator_fn {(w,u) | 0 <= w /\ w <= t /\ w < u} (x,y)) =
        pos_fn_integral (distr p M X)
          (\x.
             pos_fn_integral (distr p M Y)
               (\y.
                  indicator_fn {u | 0 <= u /\ u <= t} x *
                  indicator_fn {w | x < w} y))) ``,

RW_TAC std_ss[]
THEN KNOW_TAC (``measure_space (distr p M (X:'a->real))``)
     THEN1(METIS_TAC [indep_var_rv, random_variable_def, prob_space_def, p_space_def, events_def, measure_space_distr])
THEN DISCH_TAC
THEN KNOW_TAC (``measure_space (distr p M (Y:'a->real))``)
     THEN1(METIS_TAC [indep_var_rv, random_variable_def, prob_space_def, p_space_def, events_def, measure_space_distr])
THEN DISCH_TAC
THEN KNOW_TAC(`` !x y. indicator_fn {(w,u) | 0 <= w /\ w <=t:real /\ w <u} (x,y)  = indicator_fn {w | 0 <= w /\ w <= t} x * indicator_fn {u | x < u} y ``)
     THEN1(KNOW_TAC(``!u t w.  (0 <= w /\ w <=t /\ w<u )=  (w<=t /\ 0<=w /\ w<u:real)``)
           THEN1(METIS_TAC[CONJ_COMM, CONJ_ASSOC])
     THEN DISCH_TAC
     THEN ASM_REWRITE_TAC[]
     THEN METIS_TAC [indicator_of_indicator_before, CONJ_COMM, CONJ_ASSOC, mul_comm])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN DEP_REWRITE_TAC [GSYM pos_fn_integral_fst]
THEN RW_TAC std_ss[]
THEN KNOW_TAC (`` (x:real#real) = (FST x, SND x)``)
    THEN1 (RW_TAC std_ss [PAIR])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[indicator_mul_pos_le]);


val lemma2_indicator_mul_before = store_thm("lemma2_indicator_mul_before",
  ``   !(X:'a->real) (Y:'a->real) p M t.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (\(x,y).
          indicator_fn {w | 0 <= w /\ w <= t} x *
          indicator_fn {u | x < u} y) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel ==>
       (pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
          (\(x,y).
             indicator_fn {(w,u) | 0 <= w /\ w <= t /\ w < u} (x,y)) =
        pos_fn_integral (distr p M X)
          (\x.
             indicator_fn {w | 0 <= w /\ w <= t} x *
             pos_fn_integral (distr p M Y)
               (\y. indicator_fn {u | x < u} y)))``,

RW_TAC std_ss[lemma_indicator_mul_before]
THEN KNOW_TAC (``measure_space (distr p M (X:'a->real))``)
     THEN1(METIS_TAC [indep_var_rv, random_variable_def, prob_space_def, p_space_def, events_def, measure_space_distr])
THEN DISCH_TAC
THEN KNOW_TAC (``measure_space (distr p M (Y:'a->real))``)
     THEN1(METIS_TAC [indep_var_rv, random_variable_def, prob_space_def, p_space_def, events_def, measure_space_distr])
THEN DISCH_TAC
THEN KNOW_TAC (``(!x. (!y. y IN m_space (distr p M (Y:'a->real))==>  0<= indicator_fn {u|(x:real)< u} y))``)
     THEN1(METIS_TAC [indicator_fn_pos_le])
THEN DISCH_TAC
THEN KNOW_TAC(``(\x.
     pos_fn_integral (distr p M (Y:'a->real))
       (\y.
          indicator_fn {w | 0<=w/\w <= t} x * indicator_fn {u | (x:real) < u} y)) =(\x.
     indicator_fn {w | 0<=w/\w <= t} x *
     pos_fn_integral (distr p M Y) (\y. indicator_fn {u | x < u} y)) ``)
     THEN1(METIS_TAC [lemma3, mul_comm])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[]);



val sigma_finite_measure_distr = store_thm ("sigma_finite_measure_distr",
 ``!p X. prob_space p /\ random_variable X p (m_space lborel, measurable_sets lborel) ==>(sigma_finite_measure (distr p lborel X))``,

 RW_TAC std_ss [sigma_finite_measure] THEN RW_TAC std_ss [distr, measurable_sets_def, m_space_def]
THEN RW_TAC std_ss [GSYM distr] THEN Q.EXISTS_TAC `{line n | n IN UNIV}` THEN
  REPEAT CONJ_TAC THENL
  [SIMP_TAC std_ss [GSYM IMAGE_DEF] THEN
   MATCH_MP_TAC pred_setTheory.image_countable THEN
   SIMP_TAC std_ss [COUNTABLE_NUM],
   SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, lborel, measurable_sets_def] THEN
   REPEAT STRIP_TAC THEN RW_TAC std_ss [borel_line],
   SIMP_TAC std_ss [EXTENSION, lborel, m_space_def, IN_UNIV] THEN
   SIMP_TAC std_ss [IN_BIGUNION, GSPECIFICATION] THEN GEN_TAC THEN
   ASSUME_TAC mem_big_line THEN POP_ASSUM (MP_TAC o Q.SPEC `x`) THEN
   SET_TAC [], RW_TAC std_ss [distr, measure_def] THEN RW_TAC std_ss [GSYM prob_def, GSYM p_space_def] THEN KNOW_TAC (``{line n | n IN univ(:num)} SUBSET measurable_sets lborel
``) THEN1   (SIMP_TAC std_ss [SUBSET_DEF, GSPECIFICATION, lborel, measurable_sets_def] THEN
   REPEAT STRIP_TAC THEN RW_TAC std_ss [borel_line]) THEN DISCH_TAC THEN KNOW_TAC(``a IN measurable_sets lborel``) THEN1 (METIS_TAC [SUBSET_DEF]) THEN DISCH_TAC THEN METIS_TAC [random_variable_def, IN_MEASURABLE, measurable_sets_def, m_space_def, subsets_def, space_def, PROB_FINITE]]); 




val sigma_algebra_pair_distr_lborel = store_thm(
  "sigma_algebra_pair_distr_lborel",
  ``  !X Y p.
       sigma_algebra
         (m_space (pair_measure (distr p lborel X) (distr p lborel Y)),
          measurable_sets
            (pair_measure (distr p lborel X) (distr p lborel Y))) ``,

RW_TAC std_ss [pair_measure, measure_of, m_space_def, measurable_sets_def, distr]
       THEN1(RW_TAC std_ss [m_space_def, lborel, space_def, measurable_sets_def, subsets_def]
             THEN KNOW_TAC(``univ(:real) CROSS univ(:real) = univ(:real#real)``)
                  THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
	     THEN DISCH_TAC
             THEN ASM_REWRITE_TAC[]
	     THEN KNOW_TAC(`` {a CROSS b | a IN subsets borel /\ b IN subsets borel} SUBSET POW univ(:real#real)``)
     	     	  THEN1(RW_TAC std_ss [GSYM UNIV_FUN_TO_BOOL]
                         THEN RW_TAC std_ss [SUBSET_UNIV])
             THEN DISCH_TAC
	     THEN METIS_TAC [sigma_algebra_sigma_sets])
THEN RW_TAC std_ss [m_space_def, lborel, space_def, measurable_sets_def, subsets_def]
THEN METIS_TAC [sigma_algebra_trivial]);



val sigma_algebra_pair_lborel = store_thm("sigma_algebra_pair_lborel",
  ``   sigma_algebra
       (m_space (pair_measure lborel lborel),
        measurable_sets (pair_measure lborel lborel))``,
	
RW_TAC std_ss [pair_measure, measure_of]
      THEN1( RW_TAC std_ss [m_space_def, lborel, space_def, measurable_sets_def, subsets_def]
      THEN KNOW_TAC(``univ(:real) CROSS univ(:real) = univ(:real#real)``)
            THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
      THEN DISCH_TAC
      THEN ASM_REWRITE_TAC[]
      THEN KNOW_TAC(`` {a CROSS b | a IN subsets borel /\ b IN subsets borel} SUBSET POW univ(:real#real)``)
           THEN1(RW_TAC std_ss [GSYM UNIV_FUN_TO_BOOL]
                 THEN RW_TAC std_ss [SUBSET_UNIV])
      THEN DISCH_TAC
      THEN METIS_TAC [sigma_algebra_sigma_sets])
THEN RW_TAC std_ss [m_space_def, lborel, space_def, measurable_sets_def, subsets_def]
THEN KNOW_TAC(``univ(:real) CROSS univ(:real) = univ(:real#real)``)
     THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN RW_TAC std_ss [sigma_algebra_trivial]);



val lemma3_indicator_mul_before = store_thm("lemma3_indicator_mul_before",
  ``   !(X:'a->real) (Y:'a->real) p t.
        prob_space p /\  indep_var p  lborel X lborel Y ==>
       (pos_fn_integral (pair_measure (distr p lborel X) (distr p lborel Y))
          (\ (x,y).
             indicator_fn {(w,u) | 0 <= w /\ w <= t /\ w < u} (x,y)) =
        pos_fn_integral (distr p lborel X)
          (\x.
             indicator_fn {w | 0 <= w /\ w <= t} x *
             pos_fn_integral (distr p lborel Y)
               (\y. indicator_fn {u | x < u} y)))``,

RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[lemma2_indicator_mul_before]
THEN KNOW_TAC(``  {(w,u) | 0 <= w /\ w <= t:real /\ w < u} IN
     measurable_sets (pair_measure lborel lborel)``)
     THEN1(KNOW_TAC(``!t:real w u.  0 <= w /\ w <= t /\ w < u=
                                w < u /\ 0 <= w /\ w <= t  ``)
          THEN1(METIS_TAC[CONJ_ASSOC, CONJ_COMM])
     THEN DISCH_TAC THEN ASM_REWRITE_TAC[]
     THEN METIS_TAC [before_set_IN_MEASURABLE_SETS_PAIR_lborel])
THEN KNOW_TAC(``random_variable X p (m_space lborel,measurable_sets lborel) /\
                 random_variable Y p (m_space lborel,measurable_sets lborel) ``)
     THEN1(METIS_TAC[indep_var_rv])
THEN DISCH_TAC     
THEN RW_TAC std_ss[sigma_algebra_pair_distr_lborel,measure_space_lborel,sigma_finite_measure_distr,indep_var_rv, sigma_finite_measure_lborel] 

THEN KNOW_TAC(``(\ (x,y).
         indicator_fn {w | 0<=w/\w <= t} x * indicator_fn {u | x < u} y) =
	 (\ (x:real,y). indicator_fn {(w,u) | 0<=w/\w <= t:real /\ w<u} (x,y))``)
	 THEN1(KNOW_TAC(``!w u t.  (0<=w/\w <= t:real /\ w<u )= (w<=t/\0<=w/\w<u)``)
	       THEN1(METIS_TAC [CONJ_COMM, CONJ_ASSOC])
	 THEN DISCH_TAC
         THEN ASM_REWRITE_TAC[]
         THEN DEP_REWRITE_TAC[indicator_of_indicator_before])
THEN DISCH_TAC THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(`` (\ (x:real,y). indicator_fn {(w,u) | 0<=w/\w <= t:real /\ w<u} (x,y)) =
                                 indicator_fn {(x,y) | 0<=x/\x <= t:real /\ x<y} ``)
     THEN1(METIS_TAC [LAMBDA_PROD, ETA_AX] )
THEN DISCH_TAC THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(``{(x,y) | 0<=x/\x <= t:real /\ x < y} IN subsets
            (m_space (pair_measure lborel lborel),
	        measurable_sets (pair_measure lborel lborel)) ``)
     THEN1(METIS_TAC [measure_space_pair_measure, measure_of, subsets_def, space_def, m_space_def, measurable_sets_def])
THEN DISCH_TAC
THEN KNOW_TAC(``(indicator_fn {(x,y) | 0<=x/\x <= t:real /\ x < y} ) =
                (\z. 1 * (indicator_fn {(x,y) |0<=x/\ x<= t:real /\ x < y} z)) ``)
     THEN1 (METIS_TAC [mul_lone,LAMBDA_PROD, ETA_AX] )
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``(\z. 1 * (indicator_fn {(x,y) | 0<=x/\x <= t:real /\ x < y} z)) =
                 (\z. Normal 1 * (indicator_fn {(x,y) | 0<=x/\x <= t:real /\ x < y} z))``)
     THEN1(METIS_TAC [extreal_of_num_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``{(x,y) |0<=x/\ x <= t:real /\ x < y} IN subsets
                  (m_space (pair_measure (distr p lborel X) (distr p lborel Y)),
          measurable_sets
            (pair_measure (distr p lborel X) (distr p lborel Y)))``)
    THEN1(FULL_SIMP_TAC  std_ss [distr, pair_measure, m_space_def, measurable_sets_def, measure_of])
THEN DISCH_TAC
THEN METIS_TAC[IN_MEASURABLE_BOREL_CMUL_INDICATOR, extreal_of_num_def, REAL_LE_01,sigma_algebra_pair_distr_lborel]);



val CDF_before_integration = store_thm("CDF_before_integration",
  ``  !X Y p M t.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (\(x,y).
          indicator_fn {w | 0 <= w /\ w <= t} x *
          indicator_fn {u | x < u} y) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel /\ (!x. {w | w > x} IN measurable_sets M) /\
       (!x. PREIMAGE Y {y | y <= x} INTER p_space p IN events p) /\
       (!x. PREIMAGE Y {y | y > x} INTER p_space p IN events p) ==>
       (pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
          (\(x,y).
             indicator_fn {(w,u) | 0 <= w /\ w <= t /\ w < u} (x,y)) =
        pos_fn_integral (distr p M X)
          (\x. indicator_fn {w | 0 <= w /\ w <= t} x * (1 - CDF p Y x)))
 ``,
RW_TAC std_ss []
THEN KNOW_TAC(``random_variable (Y:'a->real) p (m_space M,measurable_sets M)  ``)
     THEN1(METIS_TAC [indep_var_rv])
THEN DISCH_TAC
THEN RW_TAC std_ss [lemma2_indicator_mul_before]
THEN KNOW_TAC(`` !x. pos_fn_integral (distr p M (Y:'a->real)) (\y. indicator_fn {u | x < u} y)=1-CDF p Y x``)
     THEN1(RW_TAC std_ss[ GSYM real_gt]
     	   THEN METIS_TAC [pos_fn_integral_gt_CDF])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC []);


val  CDF_before_integration_2 = store_thm("CDF_before_integration_2",
  `` !X Y p M fx t.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (\(x,y).
          indicator_fn {w | 0 <= w /\ w <= t} x *
          indicator_fn {u | x < u} y) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel /\ (!x. {w | w > x} IN measurable_sets M) /\
       distributed p M X fx /\
       (!x. PREIMAGE Y {y | y <= x} INTER p_space p IN events p) /\
       (!x. PREIMAGE Y {y | y > x} INTER p_space p IN events p) ==>
       (pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
          (\(x,y).
             indicator_fn {(w,u) | 0 <= w /\ w <= t /\ w < u} (x,y)) =
        pos_fn_integral (density M fx)
          (\x. indicator_fn {w | 0 <= w /\ w <= t} x * (1 - CDF p Y x)))

  ``,
RW_TAC std_ss [distributed_def, CDF_before_integration]);


val before_event_integration = store_thm("before_event_integration",
  ``  !X Y p M t:real.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (\(x,y).
          indicator_fn {w | 0 <= w /\ w <= t} x *
          indicator_fn {u | x < u} y) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel /\ (!x. {w | w > x} IN measurable_sets M) /\
       (!x. PREIMAGE Y {y | y <= x} INTER p_space p IN events p) /\
       (!x. PREIMAGE Y {y | y > x} INTER p_space p IN events p) /\
       (!r.
          {(w,u) | 0 <= w /\ w <= r /\ w < u} IN
          measurable_sets (pair_measure M M)) ==>
       (prob p
          (PREIMAGE (\x. (X x,Y x))
             {(w,u) | 0 <= w /\ w <= t /\ w < u} INTER p_space p) =
        pos_fn_integral (distr p M X)
          (\x. indicator_fn {w | 0 <= w /\ w <= t} x * (1 - CDF p Y x))) ``,

RW_TAC std_ss[]
THEN KNOW_TAC (``prob p
  (PREIMAGE (\x. ((X:'a->real) x,(Y:'a->real) x)) {(w,u) | 0<=w/\w <=t /\ w <u} INTER
   p_space p) = pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
        (indicator_fn {(w,u) | 0<=w/\w <=t /\ w < u})``)
     THEN1(METIS_TAC [prob_event_2indep_rv_PREIMAGE_A])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(``(indicator_fn {(w,u) | 0<=w/\w <= (t:real) /\ w <u}) = ( (\ (x,y). indicator_fn {(w,u) | 0<=w/\w <=t /\ w <u} (x,y)))``)
     THEN1(METIS_TAC [ETA_AX, LAMBDA_PROD])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN DEP_REWRITE_TAC [CDF_before_integration]
THEN RW_TAC std_ss[]);


val CDF_before_PDF_integration = store_thm("CDF_before_PDF_integration",
  ``  !X Y p M fx t:real.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (\(x,y).
          indicator_fn {w | 0 <= w /\ w <= t} x *
          indicator_fn {u | x < u} y) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel /\ (!x. {w | w > x} IN measurable_sets M) /\
       distributed p M X fx /\
       (!x. PREIMAGE Y {y | y <= x} INTER p_space p IN events p) /\
       (!x. PREIMAGE Y {y | y > x} INTER p_space p IN events p) /\
       (\x. indicator_fn {w | 0 <= w /\ w <= t} x * (1 - CDF p Y x)) IN
       measurable (m_space M,measurable_sets M) Borel /\
       (!x. 0 <= 1 - CDF p Y x) /\ (!x. 0 <= fx x) ==>
       (pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
          (\(x,y).
             indicator_fn {(w,u) | 0 <= w /\ w <= t /\ w < u} (x,y)) =
        pos_fn_integral M
          (\x.
             fx x *
             (indicator_fn {w | 0 <= w /\ w <= t} x * (1 - CDF p Y x)))) ``,
RW_TAC std_ss [CDF_before_integration_2]
THEN KNOW_TAC(``pos_fn_integral (pair_measure (distr p M (X:'a->real)) (distr p M (Y:'a->real)))
  (\(x,y). indicator_fn {(w,u) | 0<=w/\w <= t /\ w < u} (x,y))=pos_fn_integral (density M fx)
  (\x. indicator_fn {w | 0<=w /\w <= t} x *
     (1-CDF p Y x))``)
     THEN1(METIS_TAC [CDF_before_integration_2, distributed_def])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN FULL_SIMP_TAC std_ss [distributed_def]
THEN DEP_REWRITE_TAC [pos_fn_integral_density_1]
THEN RW_TAC std_ss[]
THEN METIS_TAC [le_mul, indicator_fn_pos_le]);


val  CDF_before_PDF_integration_general = store_thm(
  "CDF_before_PDF_integration_general",
  ``  !X Y p M fx t:real.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (\(x,y).
          indicator_fn {w | 0 <= w /\ w <= t} x *
          indicator_fn {u | x < u} y) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel /\ (!x. {w | w > x} IN measurable_sets M) /\
       distributed p M X fx /\
       (!x. PREIMAGE Y {y | y <= x} INTER p_space p IN events p) /\
       (!x. PREIMAGE Y {y | y > x} INTER p_space p IN events p) /\
       (\x. indicator_fn {w | 0 <= w /\ w <= t} x * (1 - CDF p Y x)) IN
       measurable (m_space M,measurable_sets M) Borel /\
       (!x. 0 <= 1 - CDF p Y x) /\ (!x. 0 <= fx x) /\
       {(w,u) | 0 <= w /\ w <= t /\ w < u} IN
       measurable_sets (pair_measure M M) ==>
       (prob p
          (PREIMAGE (\x. (X x,Y x))
             {(w,u) | 0 <= w /\ w <= t /\ w < u} INTER p_space p) =
        pos_fn_integral M
          (\x.
             fx x *
             (indicator_fn {w | 0 <= w /\ w <= t} x * (1 - CDF p Y x)))) ``,

RW_TAC std_ss[]
THEN KNOW_TAC (``prob p
  (PREIMAGE (\x. ((X:'a->real) x,(Y:'a->real) x)) {(w,u) | 0<=w/\w <=t /\ w<u} INTER
   p_space p) = pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
        (indicator_fn {(w,u) | 0<=w/\w <=t /\ w <u})``)
     THEN1(METIS_TAC [prob_event_2indep_rv_PREIMAGE_A])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(``(indicator_fn {(w,u) |0<=w/\ w <=(t:real) /\ w <u}) = ( (\ (x,y). indicator_fn {(w,u) | 0<=w/\w <=t /\ w <u} (x,y)))``)
     THEN1(METIS_TAC [ETA_AX, LAMBDA_PROD])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN METIS_TAC [before_event_integration, CDF_before_PDF_integration]);



val  indicator_of_indicator_after = store_thm("indicator_of_indicator_after",
  `` 
     !x y t:real.
       indicator_fn {(w,u) | w < u /\ 0 <= u /\ u <= t} (x,y) =
       indicator_fn {u | 0 <= u /\ u <= t} y *
       indicator_fn {w | w < y} x ``,

RW_TAC std_ss [indicator_fn_def]
THEN1 (METIS_TAC [mul_lone])
THEN1(`(x,y) IN {(w,u) | w < u /\ 0<=u/\ u <= t} = ((x,y) IN {(w,u) | (\a b. a < b /\0<=b/\ b <= t) w u} )` by RW_TAC std_ss[]
      THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]
      THEN FULL_SIMP_TAC std_ss [GSPECIFICATION, EXTENSION])
      
THEN1(`(x,y) IN {(w,u) | w < u /\ 0<=u/\ u <= t} = ((x,y) IN {(w,u) | (\a b. a < b /\0<=b/\ b <= t) w u} )` by RW_TAC std_ss[]
      THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]
      THEN FULL_SIMP_TAC std_ss [GSPECIFICATION, EXTENSION]
      THEN DFT_rewrs_ss)

THEN1(`(x,y) IN {(w,u) | w < u /\ 0<=u/\ u <= t} = ((x,y) IN {(w,u) | (\a b. a < b /\0<=b/\ b <= t) w u} )` by RW_TAC std_ss[]
      THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]
      THEN FULL_SIMP_TAC std_ss [GSPECIFICATION, EXTENSION])

THEN1(`(x,y) IN {(w,u) | w < u /\ 0<=u/\ u <= t} = ((x,y) IN {(w,u) | (\a b. a < b /\0<=b/\ b <= t) w u} )` by RW_TAC std_ss[]
      THEN FULL_SIMP_TAC std_ss [IN_ELIM_PAIR_THM]
      THEN FULL_SIMP_TAC std_ss [GSPECIFICATION, EXTENSION])

THEN METIS_TAC [mul_rzero, mul_comm]);


val lemma_indicator_mul_after = store_thm("lemma_indicator_mul_after",
  ``    !X Y p M t:real.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (\(x,y).
          indicator_fn {u | 0 <= u /\ u <= t} y *
          indicator_fn {w | w < y} x) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel ==>
       (pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
          (\(x,y).
             indicator_fn {(w,u) | w < u /\ 0 <= u /\ u <= t} (x,y)) =
        pos_fn_integral (distr p M Y)
          (\y.
             pos_fn_integral (distr p M X)
               (\x.
                  indicator_fn {u | 0 <= u /\ u <= t} y *
                  indicator_fn {w | w < y} x))) ``,


RW_TAC std_ss[]
THEN KNOW_TAC (``measure_space (distr p M (X:'a->real))``)
     THEN1(METIS_TAC [indep_var_rv, random_variable_def, prob_space_def, p_space_def, events_def, measure_space_distr])
THEN DISCH_TAC
THEN KNOW_TAC (``measure_space (distr p M (Y:'a->real))``)
     THEN1(METIS_TAC [indep_var_rv, random_variable_def, prob_space_def, p_space_def, events_def, measure_space_distr])
THEN DISCH_TAC
THEN RW_TAC std_ss [indicator_of_indicator_after]
THEN DEP_REWRITE_TAC [GSYM pos_fn_integral_snd]
THEN RW_TAC std_ss[]
THEN KNOW_TAC (`` (x:real#real) = (FST x, SND x)``)
     THEN1(RW_TAC std_ss [PAIR])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[indicator_mul_pos_le]);


val lemma2_indicator_mul_after = store_thm("lemma2_indicator_mul_after",
  ``  !X Y p M t:real.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (\(x,y).
          indicator_fn {u | 0 <= u /\ u <= t} y *
          indicator_fn {w | w < y} x) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel ==>
       (pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
          (\(x,y).
             indicator_fn {(w,u) | w < u /\ 0 <= u /\ u <= t} (x,y)) =
        pos_fn_integral (distr p M Y)
          (\y.
             indicator_fn {u | 0 <= u /\ u <= t} y *
             pos_fn_integral (distr p M X)
               (\x. indicator_fn {w | w < y} x))) ``,

RW_TAC std_ss[lemma_indicator_mul_after]
THEN KNOW_TAC (``measure_space (distr p M (X:'a->real))``)
     THEN1(METIS_TAC [indep_var_rv, random_variable_def, prob_space_def, p_space_def, events_def, measure_space_distr])
THEN DISCH_TAC
THEN KNOW_TAC (``measure_space (distr p M (Y:'a->real))``)
     THEN1(METIS_TAC [indep_var_rv, random_variable_def, prob_space_def, p_space_def, events_def, measure_space_distr])
THEN DISCH_TAC
THEN KNOW_TAC (``(!y. (!x. x IN m_space (distr p M (X:'a->real))==>  0<= indicator_fn {w|w<(y:real)} x))``)
     THEN1(METIS_TAC [indicator_fn_pos_le])
THEN DISCH_TAC
THEN KNOW_TAC(``(\y.
     pos_fn_integral (distr p M (X:'a->real))
       (\x.
          indicator_fn {u | 0<=u/\u <= t} y * indicator_fn {w | w < y} x)) =(\y.
     indicator_fn {u | 0<=u/\u <= t} y *
     pos_fn_integral (distr p M X) (\x. indicator_fn {w | w < y} x)) ``)
     THEN1(METIS_TAC [lemma3])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[]);


val lemma3_indicator_mul_after = store_thm("lemma3_indicator_mul_after",
  ``  !X Y p  t:real.
        prob_space p /\
       indep_var p lborel X lborel Y  ==>
       (pos_fn_integral (pair_measure (distr p lborel X) (distr p lborel Y))
          (\(x,y).
             indicator_fn {(w,u) | w < u /\ 0 <= u /\ u <= t} (x,y)) =
        pos_fn_integral (distr p lborel Y)
          (\y.
             indicator_fn {u | 0 <= u /\ u <= t} y *
             pos_fn_integral (distr p lborel X)
               (\x. indicator_fn {w | w < y} x))) ``,

RW_TAC std_ss[]
THEN `(!t. {(w,u) | w < u /\ 0 <= u /\ u <= t} IN
                      measurable_sets (pair_measure lborel lborel))` by RW_TAC std_ss [after_set_IN_MEASURABLE_SETS_PAIR_lborel]
THEN DEP_REWRITE_TAC[lemma2_indicator_mul_after]
THEN KNOW_TAC(``random_variable X p (m_space lborel,measurable_sets lborel) /\
                 random_variable Y p (m_space lborel,measurable_sets lborel) ``)
     THEN1(METIS_TAC[indep_var_rv])
THEN DISCH_TAC     
THEN RW_TAC std_ss[sigma_algebra_pair_distr_lborel,measure_space_lborel,sigma_finite_measure_distr,indep_var_rv, sigma_finite_measure_lborel]
THEN  KNOW_TAC(`` (\(x,y).
         indicator_fn {u |0<=u/\ u <= t} y * indicator_fn {w | w < y} x) =(\ (x:real,y). indicator_fn {(w,u) | w < u /\ 0<=u/\u <= t:real} (x,y)) ``)
     THEN1(RW_TAC std_ss [indicator_of_indicator_after])
THEN DISCH_TAC THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(``(\ (x:real,y). indicator_fn {(w,u) | w < u /\0<=u/\ u <= t:real} (x,y)) = indicator_fn  {(x,y) | x < y /\0<=y/\ y <= t:real} ``)
     THEN1 (RW_TAC std_ss[]
            THEN METIS_TAC [LAMBDA_PROD, ETA_AX])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(``{(x,y) | x < y /\ 0<=y/\y <= t:real} IN subsets (m_space (pair_measure lborel lborel), measurable_sets (pair_measure lborel lborel)) ``)
           THEN1(METIS_TAC [measure_space_pair_measure, measure_of, subsets_def, space_def, m_space_def, measurable_sets_def])
THEN DISCH_TAC
THEN KNOW_TAC(``(indicator_fn {(x,y) | x < y /\ 0<=y/\y <= t:real} ) = (\z. 1 * (indicator_fn {(x,y) | x < y /\ 0<=y/\y <= t:real} z)) ``)
          THEN1(METIS_TAC [mul_lone,LAMBDA_PROD, ETA_AX])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``(\z. 1 * (indicator_fn {(x,y) | x < y /\0<=y/\ y <= t:real} z)) =(\z. Normal 1 * (indicator_fn {(x,y) | x < y /\ 0<=y/\y <= t:real} z))``)
     THEN1(METIS_TAC [extreal_of_num_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``{(x,y) | x < y /\ 0<=y/\y <= t:real} IN subsets (m_space (pair_measure (distr p lborel X) (distr p lborel Y)),
          measurable_sets
            (pair_measure (distr p lborel X) (distr p lborel Y)))``)
    THEN1( FULL_SIMP_TAC std_ss [distr, pair_measure, m_space_def, measurable_sets_def, measure_of])
THEN DISCH_TAC
THEN METIS_TAC[IN_MEASURABLE_BOREL_CMUL_INDICATOR, extreal_of_num_def, REAL_LE_01,sigma_algebra_pair_distr_lborel]);


val CDF_after_integration = store_thm("CDF_after_integration",
  ``  !X Y p M t:real.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (\(x,y).
          indicator_fn {u | 0 <= u /\ u <= t} y *
          indicator_fn {w | w < y} x) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel /\ (!y. {w | w < y} IN measurable_sets M) /\
       (!n x.
          PREIMAGE X {y | x - 1 / &SUC n < y /\ y <= x} INTER
          p_space p IN events p /\
          PREIMAGE X {y | y <= x} INTER p_space p IN events p /\
          PREIMAGE X {y | y < x} INTER p_space p IN events p /\
          PREIMAGE X {y | y <= x - 1 / &SUC n} INTER p_space p IN
          events p) /\
       (!x. PREIMAGE X {y | y = x} INTER p_space p IN events p) /\
       (!z. (\x. real (CDF p X x)) contl z) ==>
       (pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
          (\(x,y).
             indicator_fn {(w,u) | w < u /\ 0 <= u /\ u <= t} (x,y)) =
        pos_fn_integral (distr p M Y)
          (\y. indicator_fn {u | 0 <= u /\ u <= t} y * CDF p X y)) ``,

RW_TAC std_ss []
THEN KNOW_TAC(``random_variable (X:'a->real) p (m_space M,measurable_sets M)  ``)
     THEN1(METIS_TAC [indep_var_rv])
THEN DISCH_TAC
THEN RW_TAC std_ss [lemma2_indicator_mul_after]
THEN KNOW_TAC(`` !y. pos_fn_integral (distr p M (X:'a->real)) (\x. indicator_fn {w | w < y} x)=CDF p X y``)
     THEN1(RW_TAC std_ss[]
     THEN DEP_REWRITE_TAC [CDF_def2]
     THEN RW_TAC std_ss[]
     THEN KNOW_TAC(``prob p (PREIMAGE X {y' | y' < y:real} INTER p_space p) = distribution p X {y'|y'<y}``)
          THEN1 (METIS_TAC [distribution_def])
     THEN DISCH_TAC
     THEN ASM_REWRITE_TAC[]
     THEN DEP_REWRITE_TAC [distribution_lebesgue_thm2_pos_fn]
     THEN RW_TAC std_ss[]
     THEN METIS_TAC[ ETA_THM])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC []);

val CDF_after_integration_2 = store_thm("CDF_after_integration_2",
  `` !X Y p M fy t.
     measure_space M /\ sigma_finite_measure M /\ prob_space p /\
     indep_var p M X M Y /\
     sigma_finite_measure (distr p M X) /\
     sigma_finite_measure (distr p M Y) /\
(\ (x,y). indicator_fn {u |0<=u/\ u <= (t:real)} y * indicator_fn {w | w < y} x) IN
 measurable
   (m_space (pair_measure (distr p M X) (distr p M Y)),
    measurable_sets (pair_measure (distr p M X) (distr p M Y)))
   Borel/\ (!y. {w | w < y} IN measurable_sets M) /\ (distributed p M Y fy) /\ (!n x.
        PREIMAGE X {y | x - 1 / &SUC n < y /\ y <= x} INTER p_space p IN
        events p /\
        PREIMAGE X {y | y <= x} INTER p_space p IN events p /\
        PREIMAGE X {y | y < x} INTER p_space p IN events p /\
        PREIMAGE X {y | y <= x - 1 / &SUC n} INTER p_space p IN
        events p) /\
     (!x. PREIMAGE X {y | y = x} INTER p_space p IN events p) /\
     (!z. (\x. real (CDF p X x)) contl z)  ==>
     ( pos_fn_integral (pair_measure (distr p M X) (distr p M Y) ) (\ (x,y). indicator_fn {(w,u)| w<u /\ 0<=u/\u<=t}(x,y)) =  pos_fn_integral (density M fy)
  (\y. indicator_fn {u | 0<=u/\u <= t} y *
     CDF p X y) )``,
RW_TAC std_ss [distributed_def, CDF_after_integration]);


val after_event_integration = store_thm("after_event_integration",
  ``   !X Y p M t:real.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (!t.
          {(w,u) | w < u /\ 0 <= u /\ u <= t} IN
          measurable_sets (pair_measure M M)) /\
       (\(x,y).
          indicator_fn {u | 0 <= u /\ u <= t} y *
          indicator_fn {w | w < y} x) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel /\ (!y. {w | w < y} IN measurable_sets M) /\
       (!n x.
          PREIMAGE X {y | x - 1 / &SUC n < y /\ y <= x} INTER
          p_space p IN events p /\
          PREIMAGE X {y | y <= x} INTER p_space p IN events p /\
          PREIMAGE X {y | y < x} INTER p_space p IN events p /\
          PREIMAGE X {y | y <= x - 1 / &SUC n} INTER p_space p IN
          events p) /\
       (!x. PREIMAGE X {y | y = x} INTER p_space p IN events p) /\
       (!z. (\x. real (CDF p X x)) contl z) ==>
       (prob p
          (PREIMAGE (\x. (X x,Y x))
             {(w,u) | w < u /\ 0 <= u /\ u <= t} INTER p_space p) =
        pos_fn_integral (distr p M Y)
          (\y. indicator_fn {u | 0 <= u /\ u <= t} y * CDF p X y))``,
RW_TAC std_ss[]
THEN KNOW_TAC (``prob p
  (PREIMAGE (\x. ((X:'a->real) x,(Y:'a->real) x)) {(w,u) | w < u /\ 0<=u/\ u <= t} INTER
   p_space p) = pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
        (indicator_fn {(w,u) | w< u /\0<=u/\ u <= t})``)
     THEN1(METIS_TAC [prob_event_2indep_rv_PREIMAGE_A])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(``(indicator_fn {(w,u) | w < u /\ 0<=u/\u <= (t:real)}) = ( (\ (x,y). indicator_fn {(w,u) | w < u /\0<=u/\ u <= t} (x,y)))``)
     THEN1 ( METIS_TAC [ETA_AX, LAMBDA_PROD])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN DEP_REWRITE_TAC [CDF_after_integration]
THEN RW_TAC std_ss[]);


val CDF_after_PDF_integration = store_thm("CDF_after_PDF_integration",
  ``    !X Y p M fy t:real.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (\(x,y).
          indicator_fn {u | 0 <= u /\ u <= t} y *
          indicator_fn {w | w < y} x) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel /\ (!y. {w | w < y} IN measurable_sets M) /\
       distributed p M Y fy /\
       (\y. indicator_fn {u | 0 <= u /\ u <= t} y * CDF p X y) IN
       measurable (m_space M,measurable_sets M) Borel /\
       (!y. 0 <= CDF p X y) /\ (!y. 0 <= fy y) /\
       (!n x.
          PREIMAGE X {y | x - 1 / &SUC n < y /\ y <= x} INTER
          p_space p IN events p /\
          PREIMAGE X {y | y <= x} INTER p_space p IN events p /\
          PREIMAGE X {y | y < x} INTER p_space p IN events p /\
          PREIMAGE X {y | y <= x - 1 / &SUC n} INTER p_space p IN
          events p) /\
       (!x. PREIMAGE X {y | y = x} INTER p_space p IN events p) /\
       (!z. (\x. real (CDF p X x)) contl z) ==>
       (pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
          (\(x,y).
             indicator_fn {(w,u) | w < u /\ 0 <= u /\ u <= t} (x,y)) =
        pos_fn_integral M
          (\y.
             fy y *
             (indicator_fn {u | 0 <= u /\ u <= t} y * CDF p X y)))``,


RW_TAC std_ss [CDF_after_integration_2]
THEN KNOW_TAC(``pos_fn_integral (pair_measure (distr p M (X:'a->real)) (distr p M (Y:'a->real)))
  (\(x,y). indicator_fn {(w,u) | w < u /\ 0<=u/\u <= t} (x,y))=pos_fn_integral (density M fy)
  (\y. indicator_fn {u | 0<=u/\u <= t} y *
     CDF p X y)``)
     THEN1(METIS_TAC [CDF_after_integration_2, distributed_def])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN FULL_SIMP_TAC std_ss [distributed_def]
THEN DEP_REWRITE_TAC [pos_fn_integral_density_1]
THEN RW_TAC std_ss[]
THEN METIS_TAC [le_mul, indicator_fn_pos_le]);


val CDF_after_PDF_integration_general = store_thm(
  "CDF_after_PDF_integration_general",
  ``   !X Y p M fy t.
       measure_space M /\ sigma_finite_measure M /\ prob_space p /\
       indep_var p M X M Y /\ sigma_finite_measure (distr p M X) /\
       sigma_finite_measure (distr p M Y) /\
       (!t.
          {(w,u) | w < u /\ 0 <= u /\ u <= t} IN
          measurable_sets (pair_measure M M)) /\
       (\(x,y).
          indicator_fn {u | 0 <= u /\ u <= t} y *
          indicator_fn {w | w < y} x) IN
       measurable
         (m_space (pair_measure (distr p M X) (distr p M Y)),
          measurable_sets (pair_measure (distr p M X) (distr p M Y)))
         Borel /\ (!y. {w | w < y} IN measurable_sets M) /\
       distributed p M Y fy /\
       (\y. indicator_fn {u | 0 <= u /\ u <= t} y * CDF p X y) IN
       measurable (m_space M,measurable_sets M) Borel /\
       (!y. 0 <= CDF p X y) /\ (!y. 0 <= fy y) /\
       (!n x.
          PREIMAGE X {y | x - 1 / &SUC n < y /\ y <= x} INTER
          p_space p IN events p /\
          PREIMAGE X {y | y <= x} INTER p_space p IN events p /\
          PREIMAGE X {y | y < x} INTER p_space p IN events p /\
          PREIMAGE X {y | y <= x - 1 / &SUC n} INTER p_space p IN
          events p) /\
       (!x. PREIMAGE X {y | y = x} INTER p_space p IN events p) /\
       (!z. (\x. real (CDF p X x)) contl z) ==>
       (prob p
          (PREIMAGE (\x. (X x,Y x))
             {(w,u) | w < u /\ 0 <= u /\ u <= t} INTER p_space p) =
        pos_fn_integral M
          (\y.
             fy y *
             (indicator_fn {u | 0 <= u /\ u <= t} y * CDF p X y))) ``,

RW_TAC std_ss[]
THEN KNOW_TAC (``prob p
  (PREIMAGE (\x. ((X:'a->real) x,(Y:'a->real) x)) {(w,u) | w < u /\ 0<=u/\u <= t} INTER
   p_space p) = pos_fn_integral (pair_measure (distr p M X) (distr p M Y))
        (indicator_fn {(w,u) | w < u /\ 0<=u/\u <= t})``)
     THEN1(METIS_TAC [prob_event_2indep_rv_PREIMAGE_A])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(``(indicator_fn {(w,u) | w < u /\ 0<=u/\u <= (t:real)}) = ( (\ (x,y). indicator_fn {(w,u) | w < u /\ 0<=u/\u <= t} (x,y)))``)
     THEN1(METIS_TAC [ETA_AX, LAMBDA_PROD])
THEN DISCH_TAC
THEN ONCE_ASM_REWRITE_TAC[]
THEN METIS_TAC [after_event_integration, CDF_after_PDF_integration]);


val cont_CDF_def = Define `cont_CDF p X =  (!z. (\x. real (CDF p X x)) contl z)`;
val measurable_CDF_def = Define `measurable_CDF p X = ((\x. CDF p X x) IN measurable borel Borel)`; 

val prob_after = store_thm("prob_after",
  ``  !X Y p fy t.
       prob_space p /\ indep_var p lborel X lborel Y /\
       distributed p lborel Y fy /\ (!y. 0 <= fy y) /\ cont_CDF p X /\
       measurable_CDF p X ==>
       (prob p
          (PREIMAGE (\x. (X x,Y x))
             {(w,u) | w < u /\ 0 <= u /\ u <= t} INTER p_space p) =
        pos_fn_integral lborel
          (\y.
             fy y *
             (indicator_fn {u | 0 <= u /\ u <= t} y * CDF p X y)))  ``,

RW_TAC std_ss[cont_CDF_def, measurable_CDF_def]
THEN `(!t.
          {(w,u) | w < u /\ 0 <= u /\ u <= t} IN
          measurable_sets (pair_measure lborel lborel))` by METIS_TAC[after_set_IN_MEASURABLE_SETS_PAIR_lborel]
THEN MP_TAC(Q.ISPECL[` (X:'a->real)`,`Y:'a->real`, `p:('a -> bool) #
          (('a -> bool) -> bool) # (('a-> bool) -> extreal)`, `lborel`, `fy: real->extreal`,`t:real`] CDF_after_PDF_integration_general )
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``measure_space lborel``)
    THEN1( METIS_TAC [measure_space_lborel])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC (``sigma_finite_measure lborel``)
     THEN1(METIS_TAC [sigma_finite_measure_lborel])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``random_variable X p (m_space lborel, measurable_sets lborel)``)
     THEN1(METIS_TAC [indep_var_rv])
THEN DISCH_TAC
THEN KNOW_TAC(``random_variable Y p (m_space lborel, measurable_sets lborel)``)
     THEN1(METIS_TAC [indep_var_rv])
THEN DISCH_TAC
THEN KNOW_TAC(``sigma_finite_measure (distr p lborel X)``)
     THEN1(METIS_TAC [sigma_finite_measure_distr])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``sigma_finite_measure (distr p lborel Y)``)
     THEN1 (METIS_TAC [sigma_finite_measure_distr])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(`` (!x. PREIMAGE X {y | y = x:real} INTER p_space p IN events p)``)
     THEN1(KNOW_TAC(``!x.{y|y=x:real} IN subsets borel``)
     	   THEN1(KNOW_TAC(``!x.{y|y=x:real} = {x:real}``)
                 THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
	   THEN DISCH_TAC
	   THEN METIS_TAC[borel_closed, CLOSED_SING])
     THEN DISCH_TAC
     THEN KNOW_TAC(``!x.{y|y=x:real} IN measurable_sets lborel``)
          THEN1(RW_TAC std_ss[]
	        THEN METIS_TAC [measure_of, lborel, subsets_def, measurable_sets_def])
     THEN DISCH_TAC
     THEN METIS_TAC [random_variable_def, lborel, measure_of, subsets_def, m_space_def, measurable_sets_def, space_def, IN_MEASURABLE, events_def, p_space_def])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(`` (!y. 0 <= CDF p X y)``)
     THEN1(RW_TAC std_ss [CDF_def, distribution_def]
           THEN KNOW_TAC(`` (PREIMAGE X {y' | y' <= y:real} INTER p_space p) IN events p``)
	   	THEN1(KNOW_TAC(``{y'|y'<=y:real} IN subsets borel``)
		      THEN1(METIS_TAC [borel_closed, CLOSED_INTERVAL_LEFT])
		THEN DISCH_TAC
		THEN METIS_TAC [random_variable_def, lborel, measure_of, subsets_def, m_space_def, measurable_sets_def, space_def, IN_MEASURABLE, events_def, p_space_def])
	   THEN DISCH_TAC
	   THEN METIS_TAC [PROB_POSITIVE])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``(!y. {w | w < y:real} IN measurable_sets lborel)``)
     THEN1( KNOW_TAC(``!y. {w | w < y:real} IN subsets borel``)
             THEN1(METIS_TAC [borel_open, OPEN_INTERVAL_LEFT])
     THEN DISCH_TAC
     THEN METIS_TAC [measure_of, lborel, subsets_def, measurable_sets_def])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``(!n x.
         PREIMAGE X {y:real | x - 1 / &SUC n < y /\ y <= x} INTER
         p_space p IN events p /\
         PREIMAGE X {y:real | y <= x} INTER p_space p IN events p /\
         PREIMAGE X {y:real | y < x} INTER p_space p IN events p /\
         PREIMAGE X {y:real | y <= x - 1 / &SUC n} INTER p_space p IN
         events p)``)
     THEN1(RW_TAC std_ss[]
           THEN1(KNOW_TAC(``{y:real | x - 1 / &SUC n < y /\ y <= x} IN subsets borel``)
	   	THEN1(KNOW_TAC(``{y:real | x - 1 / &SUC n < y /\ y <= x} = {y:real | x - 1 / &SUC n<y} INTER {y|  y <= x}``)
		      THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION, INTER_DEF])
		THEN DISCH_TAC
		THEN ASM_REWRITE_TAC[]
		THEN KNOW_TAC(``{y:real | x - 1 / &SUC n<y} IN subsets borel /\  {y|  y:real <= x} IN subsets borel``)
		     THEN1(RW_TAC std_ss[]
		           THEN1 (METIS_TAC [OPEN_INTERVAL_RIGHT, borel_open])
                     THEN METIS_TAC [CLOSED_INTERVAL_LEFT, borel_closed])
	   THEN DISCH_TAC
           THEN METIS_TAC [sigma_algebra_def,ALGEBRA_INTER,sigma_algebra_borel])
	   THEN DISCH_TAC
	   THEN METIS_TAC [random_variable_def, lborel, measure_of, subsets_def, m_space_def, measurable_sets_def, space_def, IN_MEASURABLE, events_def, p_space_def])
	   THEN1(KNOW_TAC(``{y | y <= x:real} IN subsets borel``)
	         THEN1(METIS_TAC [CLOSED_INTERVAL_LEFT, borel_closed])
	   THEN DISCH_TAC
	   THEN METIS_TAC [random_variable_def, lborel, measure_of, subsets_def, m_space_def, measurable_sets_def, space_def, IN_MEASURABLE, events_def, p_space_def])
	   THEN1(KNOW_TAC(``{y | y < x:real} IN subsets borel``)
	         THEN1(METIS_TAC [OPEN_INTERVAL_LEFT, borel_open])
           THEN DISCH_TAC
	   THEN METIS_TAC [random_variable_def, lborel, measure_of, subsets_def, m_space_def, measurable_sets_def, space_def, IN_MEASURABLE, events_def, p_space_def])
THEN KNOW_TAC(``{y | y:real <= x - 1 / &SUC n} IN subsets borel``)
     THEN1(METIS_TAC [CLOSED_INTERVAL_LEFT, borel_closed])
THEN DISCH_TAC
THEN METIS_TAC [random_variable_def, lborel, measure_of, subsets_def, m_space_def, measurable_sets_def, space_def, IN_MEASURABLE, events_def, p_space_def])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]

THEN KNOW_TAC(``sigma_algebra (m_space (pair_measure (distr p lborel X) (distr p lborel Y)),
         measurable_sets
           (pair_measure (distr p lborel X) (distr p lborel Y)))``)
    THEN1(METIS_TAC [sigma_algebra_pair_distr_lborel])
THEN DISCH_TAC
THEN KNOW_TAC(`` (\(x,y).
         indicator_fn {u |0<=u/\ u <= t} y * indicator_fn {w | w < y} x) =(\ (x:real,y). indicator_fn {(w,u) | w < u /\ 0<=u/\u <= t:real} (x,y)) ``)
     THEN1(RW_TAC std_ss [indicator_of_indicator_after])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``(\ (x:real,y). indicator_fn {(w,u) | w < u /\0<=u/\ u <= t:real} (x,y)) = indicator_fn  {(x,y) | x < y /\0<=y/\ y <= t:real} ``)
     THEN1 (RW_TAC std_ss[]
            THEN METIS_TAC [LAMBDA_PROD, ETA_AX])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN FULL_SIMP_TAC std_ss []
THEN KNOW_TAC(``indicator_fn {(x,y) | x < y /\ 0<=y/\y <= t:real} IN
           measurable
             (m_space
                (pair_measure (distr p lborel X) (distr p lborel Y)),
              measurable_sets
                (pair_measure (distr p lborel X) (distr p lborel Y)))
             Borel``)
     THEN1(KNOW_TAC(``{(x,y) | x < y /\ 0<=y/\y <= t:real} IN subsets (m_space (pair_measure lborel lborel), measurable_sets (pair_measure lborel lborel)) ``)
           THEN1(METIS_TAC [measure_space_pair_measure, measure_of, subsets_def, space_def, m_space_def, measurable_sets_def])
           THEN DISCH_TAC
     THEN KNOW_TAC(``(indicator_fn {(x,y) | x < y /\ 0<=y/\y <= t:real} ) = (\z. 1 * (indicator_fn {(x,y) | x < y /\ 0<=y/\y <= t:real} z)) ``)
          THEN1(METIS_TAC [mul_lone,LAMBDA_PROD, ETA_AX])
     THEN DISCH_TAC
     THEN ONCE_ASM_REWRITE_TAC[]
     THEN KNOW_TAC(``(\z. 1 * (indicator_fn {(x,y) | x < y /\0<=y/\ y <= t:real} z)) =(\z. Normal 1 * (indicator_fn {(x,y) | x < y /\ 0<=y/\y <= t:real} z))``)
          THEN1(METIS_TAC [extreal_of_num_def])
     THEN DISCH_TAC
     THEN ONCE_ASM_REWRITE_TAC[]
     THEN KNOW_TAC(``{(x,y) | x < y /\ 0<=y/\y <= t:real} IN subsets (m_space (pair_measure (distr p lborel X) (distr p lborel Y)),
          measurable_sets
            (pair_measure (distr p lborel X) (distr p lborel Y)))
``)
          THEN1( FULL_SIMP_TAC  std_ss [distr, pair_measure, m_space_def, measurable_sets_def, measure_of])
      THEN DISCH_TAC
      THEN METIS_TAC[IN_MEASURABLE_BOREL_CMUL_INDICATOR, extreal_of_num_def, REAL_LE_01])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``(\y. indicator_fn {u | 0<=u/\u <= t} y * CDF p X y) IN
      measurable (m_space lborel,measurable_sets lborel) Borel``)
      THEN1(MP_TAC(Q.ISPECL[`borel`, `\y:real. CDF p X y `,`{u|0<=u/\u<=t:real}`] IN_MEASURABLE_BOREL_MUL_INDICATOR )
            THEN RW_TAC std_ss [sigma_algebra_borel]
	    THEN KNOW_TAC (``{u|0<=u/\u<=t} IN subsets borel``)
	         THEN1(KNOW_TAC(``{u|0<=u/\u<=t:real} = {u|0<=u} INTER {u|u<=t:real}``)
		       THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
		 THEN DISCH_TAC
		 THEN ASM_REWRITE_TAC[]
		 THEN METIS_TAC [borel_closed, CLOSED_INTERVAL_LEFT, CLOSED_INTERVAL_RIGHT,CLOSED_INTER, GSPECIFICATION, EXTENSION])
	   THEN DISCH_TAC
	   THEN FULL_SIMP_TAC std_ss[]
	   THEN KNOW_TAC(`` (m_space lborel,measurable_sets lborel)= borel``)
	        THEN1(METIS_TAC [m_space_def, space_def, subsets_def, measurable_sets_def, borel,lborel, sigma_def])
	   THEN DISCH_TAC
	   THEN FULL_SIMP_TAC std_ss[]
	   THEN RW_TAC std_ss [mul_comm])
THEN DISCH_TAC
THEN FULL_SIMP_TAC std_ss[]);


val mul_extreal_not_infty = store_thm("mul_extreal_not_infty",
  ``  ! x y. x <> PosInf /\ x <> NegInf /\ y <> PosInf /\ y <> NegInf ==>
x * y <> PosInf /\ x * y <> NegInf
 ``,
REPEAT Cases THEN
RW_TAC std_ss[] THEN
METIS_TAC [extreal_mul_def, mul_comm, extreal_distinct]);

val minus_x_not_infty = store_thm("minus_x_not_infty",
  ``   !x. x<> PosInf/\ x<> NegInf==> (-x<>NegInf /\ -x<> PosInf) ``,

REWRITE_TAC [GSYM sub_lzero]
THEN METIS_TAC[sub_not_infty, extreal_of_num_def, lt_infty, le_infty, lt_le, le_lt]);

val prob_before = store_thm ("prob_before",
  `` !X Y p fx t.

 prob_space p /\
     normal_rv_hvg$indep_var p lborel X lborel Y  /\
     distributed p lborel X fx /\
      (!x. 0 <= fx x) /\ measurable_CDF p Y ==>
      ((prob p
        (PREIMAGE (\x. (X x,Y x)) {(w,u) | 0<=w/\w <=t /\ w <u} INTER
         p_space p)) =
      pos_fn_integral lborel
        (\x.  (fx x * (indicator_fn {w |0<=w/\ w <= t} x * (1-CDF p Y x))))) ``,

RW_TAC std_ss[measurable_CDF_def]
THEN KNOW_TAC(``{(w,u) | 0<=w/\w <=t /\ w<u} IN measurable_sets (pair_measure lborel lborel)``)
     THEN1(`!w u t:real. 0<=w/\w <=t /\ w<u =
                         w<u/\ 0 <=w/\ w<=t` by METIS_TAC[CONJ_ASSOC, CONJ_COMM]
	   THEN ASM_REWRITE_TAC[]
	   THEN METIS_TAC[before_set_IN_MEASURABLE_SETS_PAIR_lborel])
THEN DISCH_TAC	   
THEN MP_TAC(Q.ISPECL[` (X:'a->real)`,`Y:'a->real`, `p:('a -> bool) #
          (('a -> bool) -> bool) # (('a-> bool) -> extreal)`, `lborel`, `fx: real->extreal`,`t:real`] CDF_before_PDF_integration_general )
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``measure_space lborel``)
     THEN1(METIS_TAC [measure_space_lborel])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC (``sigma_finite_measure lborel``)
     THEN1(METIS_TAC [sigma_finite_measure_lborel])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``random_variable X p (m_space lborel, measurable_sets lborel)``) 
     THEN1( METIS_TAC [indep_var_rv])
THEN DISCH_TAC
THEN KNOW_TAC(``random_variable Y p (m_space lborel, measurable_sets lborel)``)
     THEN1(METIS_TAC [indep_var_rv])
THEN DISCH_TAC
THEN KNOW_TAC(``sigma_finite_measure (distr p lborel X)``)
     THEN1(METIS_TAC [sigma_finite_measure_distr])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``sigma_finite_measure (distr p lborel Y)``)
      THEN1( METIS_TAC [sigma_finite_measure_distr])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN WEAKEN_TAC (equal (Term `sigma_finite_measure (distr p lborel Y)`))
THEN WEAKEN_TAC (equal (Term `sigma_finite_measure (distr p lborel X)`))
THEN WEAKEN_TAC (equal (Term `sigma_finite_measure  lborel`))
THEN KNOW_TAC(`` (!x. {w | w > x} IN measurable_sets lborel)``)
     THEN1(RW_TAC std_ss [real_gt]
           THEN RW_TAC std_ss [lborel]
	   THEN METIS_TAC [OPEN_INTERVAL_RIGHT, borel_open, lborel, measurable_sets_def, subsets_def, m_space_def, sigma_def])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``(!x. PREIMAGE (Y:'a->real) {y | y <= x} INTER p_space p IN events p)``)
     THEN1(KNOW_TAC(`` !x. {y | y <= x}  IN subsets borel``)
           THEN1(METIS_TAC [borel_closed, CLOSED_INTERVAL_LEFT])
	   THEN DISCH_TAC
	   THEN METIS_TAC [random_variable_def, p_space_def, m_space_def, subsets_def, measurable_sets_def, IN_MEASURABLE, lborel, sigma_def, events_def, space_def])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(`` (!x. PREIMAGE (Y:'a->real) {y | y > x} INTER p_space p IN events p)``)
THEN1(METIS_TAC [real_gt, lborel, OPEN_INTERVAL_RIGHT, borel_open, measurable_sets_def, subsets_def, m_space_def, sigma_def, random_variable_def, p_space_def, m_space_def,  IN_MEASURABLE,  events_def, space_def, sigma_algebra_borel])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``!x. 0 <= 1 - CDF p Y x``)
     THEN1(KNOW_TAC(``!x. CDF p Y x <=1``)
          THEN1(RW_TAC std_ss [CDF_def, distribution_def]
	        THEN METIS_TAC[PROB_LE_1] )
	  THEN DISCH_TAC
	  THEN KNOW_TAC(``!x. CDF p Y x <> PosInf /\ CDF p Y x <> NegInf``)
	       THEN1(METIS_TAC[CDF_def, distribution_def, PROB_FINITE])
	  THEN DISCH_TAC
	  THEN RW_TAC std_ss [le_sub_eq]
	  THEN RW_TAC std_ss [add_lzero])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``(\ (x,y).
         indicator_fn {w | 0<=w/\w <= t} x * indicator_fn {u | x < u} y) =
	 (\ (x:real,y). indicator_fn {(w,u) | 0<=w/\w <= t:real /\ w<u} (x,y))``)
	 THEN1(KNOW_TAC(``!w u t.  (0<=w/\w <= t:real /\ w<u )= (w<=t/\0<=w/\w<u)``)
	       THEN1(METIS_TAC [CONJ_COMM, CONJ_ASSOC])
	 THEN DISCH_TAC
         THEN ASM_REWRITE_TAC[]
         THEN DEP_REWRITE_TAC[indicator_of_indicator_before])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(`` (\ (x:real,y). indicator_fn {(w,u) | 0<=w/\w <= t:real /\ w<u} (x,y)) =
                                 indicator_fn {(x,y) | 0<=x/\x <= t:real /\ x<y} ``)
     THEN1(METIS_TAC [LAMBDA_PROD, ETA_AX] )
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``indicator_fn {(x,y) | 0<=x/\x <= t:real /\ x < y} IN
              measurable
             (m_space
                (pair_measure (distr p lborel X) (distr p lborel Y)),
              measurable_sets
                (pair_measure (distr p lborel X) (distr p lborel Y)))
             Borel``)
THEN1(KNOW_TAC(``{(x,y) | 0<=x/\x <= t:real /\ x < y} IN subsets
            (m_space (pair_measure lborel lborel),
	        measurable_sets (pair_measure lborel lborel)) ``)
     THEN1(METIS_TAC [measure_space_pair_measure, measure_of, subsets_def, space_def, m_space_def, measurable_sets_def])
THEN DISCH_TAC
THEN KNOW_TAC(``(indicator_fn {(x,y) | 0<=x/\x <= t:real /\ x < y} ) =
                (\z. 1 * (indicator_fn {(x,y) |0<=x/\ x<= t:real /\ x < y} z)) ``)
     THEN1 (METIS_TAC [mul_lone,LAMBDA_PROD, ETA_AX] )
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``(\z. 1 * (indicator_fn {(x,y) | 0<=x/\x <= t:real /\ x < y} z)) =
                 (\z. Normal 1 * (indicator_fn {(x,y) | 0<=x/\x <= t:real /\ x < y} z))``)
     THEN1(METIS_TAC [extreal_of_num_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``{(x,y) |0<=x/\ x <= t:real /\ x < y} IN subsets
                  (m_space (pair_measure (distr p lborel X) (distr p lborel Y)),
          measurable_sets
            (pair_measure (distr p lborel X) (distr p lborel Y)))``)
    THEN1(FULL_SIMP_TAC  std_ss [distr, pair_measure, m_space_def, measurable_sets_def, measure_of])
THEN DISCH_TAC
THEN METIS_TAC[IN_MEASURABLE_BOREL_CMUL_INDICATOR, extreal_of_num_def, REAL_LE_01,sigma_algebra_pair_distr_lborel])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN WEAKEN_TAC (equal(Term`
indicator_fn {(x,y) | 0<=x/\x <= t /\ x < y} IN
       measurable
         (m_space (pair_measure (distr p lborel X) (distr p lborel Y)),
          measurable_sets
            (pair_measure (distr p lborel X) (distr p lborel Y))) Borel`))
THEN WEAKEN_TAC (equal(Term` (\ (x,y). indicator_fn {(w,u) | 0<=w/\w <= t:real /\ w < u} (x,y)) =
       indicator_fn {(x,y) | 0<=x/\x <= t /\ x < y}`))
THEN WEAKEN_TAC (equal(Term` (\x y.
          indicator_fn {w | 0<=w/\w <= t:real} x * indicator_fn {u | x < u} y) =
      (\x y. indicator_fn {(w,u) | 0<=w/\w <= t /\ w < u} (x,y))`))

THEN MP_TAC(Q.ISPECL[`borel`, `\x:real.(1- CDF p Y x) `,`{w|0<=w/\w<=t:real}`] IN_MEASURABLE_BOREL_MUL_INDICATOR )
THEN RW_TAC std_ss [sigma_algebra_borel]
THEN KNOW_TAC(``{w|0<=w/\w<=t} IN subsets borel``)
     THEN1( KNOW_TAC (``{w|0<=w/\w<=t} = {w|0<=w} INTER {w|w<=t:real}``)
           THEN1(SRW_TAC [] [GSPECIFICATION, EXTENSION])
     THEN DISCH_TAC THEN ASM_REWRITE_TAC[] 
     THEN METIS_TAC [borel_closed, CLOSED_INTER, CLOSED_INTERVAL_RIGHT,CLOSED_INTERVAL_LEFT])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN KNOW_TAC(``(\y. 1 - CDF p Y y) IN measurable borel Borel``)
     THEN1 (KNOW_TAC(``!y. CDF p Y y <> PosInf /\ CDF p Y y <> NegInf``)
            THEN1(METIS_TAC[CDF_def, distribution_def, PROB_FINITE])
     THEN DISCH_TAC
     THEN KNOW_TAC(``(\y. 1 - CDF p Y y) = (\y. 1 + - CDF p Y y)``)
     THEN1 (METIS_TAC [extreal_sub_add, extreal_of_num_def, extreal_lt_def, lt_infty])
     THEN DISCH_TAC THEN ASM_REWRITE_TAC[]
     THEN ONCE_REWRITE_TAC [neg_minus1]
     THEN MP_TAC(Q.ISPECL[`borel`, `\x:real.1 `, `\x. -1* CDF p Y x`,`(\x. 1 + -1* CDF p Y x)` ]
         IN_MEASURABLE_BOREL_ADD )
     THEN RW_TAC std_ss[]
     THEN FULL_SIMP_TAC std_ss [sigma_algebra_borel]
     THEN MP_TAC(Q.ISPECL[`borel`, `1:extreal `, `\x:real.1` ] IN_MEASURABLE_BOREL_CONST)
     THEN RW_TAC std_ss [sigma_algebra_borel]
     THEN FULL_SIMP_TAC std_ss []
     THEN MP_TAC(Q.ISPECL[`borel`, `\x:real.-1 `, `\x. CDF p Y x`,`(\x. -1* CDF p Y x)` ] IN_MEASURABLE_BOREL_MUL )
     THEN RW_TAC std_ss [sigma_algebra_borel]
     THEN MP_TAC(Q.ISPECL[`borel`, `-1:extreal `, `\x:real.-1` ] IN_MEASURABLE_BOREL_CONST )
     THEN RW_TAC std_ss [sigma_algebra_borel]
     THEN FULL_SIMP_TAC std_ss []
     THEN KNOW_TAC(``(!x. x:real IN space borel ==> -1 <> NegInf /\ -1 <> PosInf)``)
          THEN1(METIS_TAC [sub_lzero, sub_not_infty, extreal_of_num_def, lt_infty, le_infty, lt_le, le_lt ])
     THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
     THEN KNOW_TAC(``!x. x IN space borel``)
          THEN1(METIS_TAC [space_borel, IN_UNIV])
     THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
     THEN KNOW_TAC(``(!x.
          x IN space borel ==>
          -1 <> NegInf /\ -1 <> PosInf /\ CDF p X x <> NegInf /\
          CDF p X x <> PosInf)``)
	  THEN1( KNOW_TAC(``!x. (PREIMAGE (X:'a->real) {y | y <= x} )INTER p_space p IN events p``)
                THEN1(METIS_TAC [random_variable_def, p_space_def, m_space_def, subsets_def, measurable_sets_def, IN_MEASURABLE, lborel, sigma_def, events_def, space_def, borel_closed, CLOSED_INTERVAL_LEFT, sigma_algebra_borel])
	        THEN DISCH_TAC
	        THEN RW_TAC std_ss []
	        THEN METIS_TAC[CDF_def, distribution_def, PROB_FINITE])
	 THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``!x. 1<> NegInf``)
	      THEN1(METIS_TAC [sub_lzero, sub_not_infty, extreal_of_num_def, lt_infty, le_infty, lt_le, le_lt ])
	 THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``!x. -1 * CDF p Y x <> NegInf``)
	      THEN1(KNOW_TAC(``!x. -1 <> PosInf /\ -1 <> NegInf``)
	            THEN1(METIS_TAC [sub_lzero, sub_not_infty, extreal_of_num_def,extreal_le_def, lt_infty, le_infty, lt_le, le_lt , extreal_mul_def, minus_x_not_infty, CDF_def, distribution_def, PROB_FINITE, PROB_POSITIVE, mul_not_infty, mul_lneg])
	      THEN DISCH_TAC
	      THEN METIS_TAC [mul_extreal_not_infty])
	 THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
THEN FULL_SIMP_TAC std_ss [mul_comm]
THEN KNOW_TAC(``borel = (m_space lborel,measurable_sets lborel)``)
     THEN1(METIS_TAC[borel, lborel, measurable_sets_def, subsets_def, sigma_def, space_def, m_space_def])
THEN RW_TAC std_ss[]
THEN FULL_SIMP_TAC std_ss[]
); 

val _ = export_theory();



