
(******************************************************************************)
(*                       n-ary gates definitions                              *)
(*                       DFT Rewrite Rules Lemmas                             *)
(*                          Yassmeen Elderhalli                               *)
(*                      y_elderh@encs.concordia.ca                            *)
(******************************************************************************)

(*loadPath := "/home/yassmeen/Downloads/Reqiured-Theories" :: !loadPath;
loadPath := "/home/yassmeen/Downloads/DFT-Theories" :: !loadPath;
*)
(*set_trace "Unicode" 0;*)

(*app load ["HolKernel", "Parse", "boolLib", "bossLib", "numLib", "unwindLib", 
"tautLib", "Arith", "prim_recTheory", "combinTheory", "quotientTheory", 
"arithmeticTheory", "realTheory", "hrealTheory", "realaxTheory", "realLib",  
"jrhUtils", "pairTheory", "seqTheory", "limTheory", "transcTheory", "listTheory", 
"sortingTheory", "rich_listTheory",  "mesonLib", "boolTheory", "topologyTheory", "pred_setTheory", "util_probTheory", "optionTheory", "numTheory", "sumTheory", "InductiveDefinition", "ind_typeTheory","pred_setLib", "iterate_hvgTheory", "card_hvgTheory", "product_hvgTheory", 
"topology_hvgTheory", "derivative_hvgTheory", "integration_hvgTheory",
"real_sigmaTheory", "extreal_hvgTheory", "measure_hvgTheory", "lebesgue_hvgTheory",
"probability_hvgTheory", "lebesgue_measure_hvgTheory", "normal_rv_hvgTheory", "netsTheory",
"PIE_EXTREALTheory", "integration_before_afterTheory", "dep_rewrite", "DFT_Gates_def_PROBTheory"];
*)
open HolKernel Parse boolLib bossLib numLib unwindLib tautLib Arith prim_recTheory 
combinTheory quotientTheory arithmeticTheory hrealTheory realaxTheory realTheory 
realLib jrhUtils pairTheory seqTheory limTheory transcTheory listTheory sortingTheory rich_listTheory mesonLib boolTheory topologyTheory pred_setTheory util_probTheory optionTheory numTheory 
sumTheory InductiveDefinition ind_typeTheory pred_setLib iterate_hvgTheory 
card_hvgTheory product_hvgTheory topology_hvgTheory derivative_hvgTheory
integration_hvgTheory real_sigmaTheory extreal_hvgTheory measure_hvgTheory
lebesgue_hvgTheory probability_hvgTheory lebesgue_measure_hvgTheory
normal_rv_hvgTheory netsTheory PIE_EXTREALTheory integration_before_afterTheory dep_rewrite DFT_Gates_def_PROBTheory;

val _ = new_theory "rewrite_Rules_Lemmas";

infixr 0 ++ << || ORELSEC ## --> THENC;
infix 1 >> |->;
fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
 
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Suff = PARSE_TAC SUFF_TAC;
val POP_ORW = POP_ASSUM (fn thm => ONCE_REWRITE_TAC [thm]);
val !! = REPEAT;
val op++ = op THEN;
val op<< = op THENL;
val op|| = op ORELSE;
val op>> = op THEN1;
val std_ss' = simpLib.++ (std_ss, boolSimps.ETA_ss);

(*---------------------------*)
fun SET_TAC L =
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION,
    IN_INTER, IN_DIFF, IN_INSERT, IN_DELETE, IN_BIGINTER, IN_BIGUNION,
    IN_IMAGE, GSPECIFICATION, IN_DEF] THEN METIS_TAC [];

fun SET_RULE tm = prove(tm,SET_TAC []);


val set_rewrs
= [INTER_EMPTY, INTER_UNIV, UNION_EMPTY, UNION_UNIV, DISJOINT_UNION,
DISJOINT_INSERT, DISJOINT_EMPTY, GSYM DISJOINT_EMPTY_REFL,
DISJOINT_BIGUNION, INTER_SUBSET, INTER_IDEMPOT, UNION_IDEMPOT,
SUBSET_UNION];

val UNIONL_def = Define `(UNIONL [] = {})
/\ (UNIONL (s::ss) = (s:'a ->bool) UNION UNIONL ss)`;


val IN_UNIONL = store_thm
("IN_UNIONL",
``!l (v:'a ). v IN UNIONL l = (?s. MEM s l /\ v IN s)``,
Induct >> RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY]
++ RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY, IN_UNION]
++ PROVE_TAC []);


val elt_rewrs
= [SUBSET_DEF, IN_COMPL, IN_DIFF, IN_UNIV, NOT_IN_EMPTY, IN_UNION,
IN_INTER, IN_IMAGE, IN_FUNSET, IN_DFUNSET, GSPECIFICATION,
DISJOINT_DEF, IN_BIGUNION, IN_BIGINTER, IN_COUNT, IN_o,
IN_UNIONL, IN_DELETE, IN_PREIMAGE, IN_SING, IN_INSERT];


fun rewr_ss ths =
simpLib.++
(std_ss,
simpLib.SSFRAG
{ac = [],
name = NONE,
convs = [],
dprocs = [],
filter = NONE,
rewrs = set_rewrs @ elt_rewrs,
congs = []});
val pset_set_ss = rewr_ss set_rewrs;
val pset_elt_ss = rewr_ss elt_rewrs;
val pset_ss = rewr_ss (set_rewrs @ elt_rewrs);


fun PSET_TAC ths =
REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_set_ss ths
++ REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_elt_ss ths;

fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Simplify = RW_TAC arith_ss;
val Suff = PARSE_TAC SUFF_TAC;
val Know = PARSE_TAC KNOW_TAC;
fun wrap a = [a];
val Rewr = DISCH_THEN (REWRITE_TAC o wrap);
val Rewr' = DISCH_THEN (ONCE_REWRITE_TAC o wrap);
val Cond =
  DISCH_THEN
  (fn mp_th =>
   let
     val cond = fst (dest_imp (concl mp_th))
   in
     KNOW_TAC cond << [ALL_TAC, DISCH_THEN (MP_TAC o MP mp_th)]
   end);
val FUN_EQ_TAC = CONV_TAC (CHANGED_CONV (ONCE_DEPTH_CONV FUN_EQ_CONV));
fun K_TAC _ = ALL_TAC;
fun MESON ths tm = prove(tm,MESON_TAC ths);
fun METIS ths tm = prove(tm,METIS_TAC ths);
val DISC_RW_KILL = DISCH_TAC THEN ONCE_ASM_REWRITE_TAC [] THEN 
                   POP_ASSUM K_TAC;
			   
val IN_REST = store_thm ("IN_REST",
 ``!x:'a. !s. x IN (REST s) <=> x IN s /\ ~(x = CHOICE s)``,
  REWRITE_TAC[REST_DEF, IN_DELETE]);
fun SET_TAC L = 
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN
    SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION, IN_INTER, IN_DIFF, 
      IN_INSERT, IN_DELETE, IN_REST, IN_BIGINTER, IN_BIGUNION, IN_IMAGE, 
      GSPECIFICATION, IN_DEF, EXISTS_PROD] THEN METIS_TAC [];
fun ASSERT_TAC tm = SUBGOAL_THEN tm STRIP_ASSUME_TAC;
fun SET_RULE tm = prove(tm,SET_TAC []);
fun ASM_SET_TAC L = REPEAT (POP_ASSUM MP_TAC) THEN SET_TAC L;
val ASM_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN ARITH_TAC;
val ASM_REAL_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN REAL_ARITH_TAC;

val LIST_INDUCT_TAC = INDUCT_THEN list_INDUCT ASSUME_TAC;

val SNOC_INDUCT_TAC = Prim_rec.INDUCT_THEN listTheory.SNOC_INDUCT ASSUME_TAC;


(* -------------------------------------------------------------------------- *)
(*          Extended definitions                                              *)
(* -------------------------------------------------------------------------- *)

val rv_gt0_def = Define `(rv_gt0 [] = T) /\ (rv_gt0 (h::t) = (!s. 0<= h s) /\ rv_gt0 t)`;

val n_AND_def = Define `n_AND L = FOLDR (\a b. D_AND a b) ALWAYS L`;

val n_OR_def = Define `n_OR L = FOLDR (\a b. D_OR a b) NEVER L `;

val n_PAND_def = Define `n_PAND L = FOLDL (\a b. P_AND a b) ALWAYS L`;

val k_out_def = Define `k_out k L= {s|s SUBSET (set L) /\ (CARD s = k)}`;

val k_out_n_gate_def = Define `
    k_out_n_gate (k:num) L =
    n_OR (MAP (\a. n_AND (SET_TO_LIST (a))) (SET_TO_LIST (k_out (k:num) L)))`;

(*----------------------------------------------------------------------------*)

val n_AND_comm = store_thm("n_AND_comm",
  `` !L1 L2. PERM L1 L2 ==> (n_AND L1 = n_AND L2) ``,

HO_MATCH_MP_TAC PERM_IND THEN
SRW_TAC [][] THEN RW_TAC std_ss[n_AND_def, FOLDR]
THEN FULL_SIMP_TAC std_ss[n_AND_def]
THEN RW_TAC std_ss[GSYM D_AND_ASSOC, D_AND_COMM]);

val n_OR_comm = store_thm("n_OR_comm",
  `` !L1 L2. PERM L1 L2 ==> (n_OR L1 = n_OR L2) ``,
HO_MATCH_MP_TAC PERM_IND THEN
SRW_TAC [][] THEN RW_TAC std_ss[n_OR_def, FOLDR]
THEN FULL_SIMP_TAC std_ss[n_OR_def]
THEN RW_TAC std_ss[GSYM D_OR_ASSOC, D_OR_COMM]);


val n_OR_APPEND = store_thm("n_OR_APPEND",
  `` !L1 L2. n_OR (L1 ++ L2) = D_OR(n_OR L1) (n_OR L2) ``,
Induct
THEN1( Induct
       THEN1(RW_TAC list_ss[n_OR_def]
             THEN RW_TAC std_ss[D_OR_NEVER])
       THEN RW_TAC list_ss[n_OR_def, FOLDR]
       THEN `!x. D_OR NEVER x = x` by METIS_TAC[D_OR_COMM, D_OR_NEVER]
       THEN RW_TAC std_ss[])
THEN RW_TAC std_ss[]
THEN FULL_SIMP_TAC list_ss[n_OR_def, FOLDR]
THEN FULL_SIMP_TAC list_ss[D_OR_NEVER, D_OR_COMM]
THEN RW_TAC list_ss[GSYM n_OR_def]
THEN METIS_TAC[D_OR_ASSOC, D_OR_COMM]);


val P_AND_FOLDL_GT0 = store_thm("P_AND_FOLDL_GT0",
  `` !s L.
        rv_gt0 L ==> (!h. 0 <= h s ==> 0 <=  (FOLDL (λa b. P_AND a b) h L) s) ``,

GEN_TAC THEN Induct
THEN1(RW_TAC list_ss[FOLDL])
THEN RW_TAC std_ss[]
THEN RW_TAC list_ss[FOLDL]
THEN FULL_SIMP_TAC list_ss[rv_gt0_def]
THEN UNDISCH_TAC(`` ∀h. 0 ≤ h s ⇒ 0 ≤ FOLDL (λa b. P_AND a b) h L s``)
THEN DISCH_TAC
THEN POP_ASSUM (MP_TAC o Q.SPEC `P_AND h' h`)
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``0<= P_AND h' h s ``)
     THEN1(RW_TAC std_ss[P_AND_def]
          THEN METIS_TAC[extreal_of_num_def, le_infty])
THEN RW_TAC std_ss[]);	  


val n_AND_GT0 = store_thm("n_AND_GT0",
  `` !L. rv_gt0 L ==> (!s. 0 <= n_AND L s) ``,

Induct
THEN1 (RW_TAC list_ss[rv_gt0_def, n_AND_def, ALWAYS_def, le_refl]
       THEN METIS_TAC[extreal_of_num_def, lt_infty])
THEN RW_TAC list_ss[rv_gt0_def, n_AND_def]
THEN1 (RW_TAC list_ss[GSYM n_AND_def]
       THEN RW_TAC std_ss[D_AND_def]
       THEN RW_TAC std_ss[extreal_max_def])
THEN RW_TAC list_ss[GSYM n_AND_def]       
THEN RW_TAC std_ss[extreal_max_def, D_AND_def]);


val n_AND_APPEND = store_thm("n_AND_APPEND",
  `` !L1 L2.
         rv_gt0 (L1 ++ L2) ==>
	 (n_AND (L1 ++ L2) = D_AND(n_AND L1) (n_AND L2)) ``,
Induct
THEN1( Induct
       THEN1(RW_TAC list_ss[n_AND_def]
             THEN RW_TAC std_ss[D_AND_ID])
       THEN RW_TAC list_ss[]
       THEN RW_TAC list_ss[n_AND_def]
       THEN RW_TAC list_ss[GSYM n_AND_def]
       THEN RW_TAC std_ss[GSYM D_AND_ASSOC]
       THEN FULL_SIMP_TAC list_ss[rv_gt0_def]
       THEN `D_AND ALWAYS h = h` by METIS_TAC[D_AND_ALWAYS, D_AND_COMM]
       THEN RW_TAC list_ss[])
THEN RW_TAC list_ss[]
THEN RW_TAC list_ss[n_AND_def]
THEN RW_TAC list_ss[GSYM n_AND_def]
THEN RW_TAC std_ss[D_AND_ASSOC]
THEN POP_ASSUM MP_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `L2`)
THEN DISCH_TAC
THEN RW_TAC list_ss[rv_gt0_def]);


val PERM_k_out = store_thm("PERM_k_out",
  ``!L1 L2 k. PERM L1 L2 ==> (k_out (k:num) L1 = k_out (k:num) L2)``,

RW_TAC list_ss[k_out_def]
THEN `set L1 = set L2` by
RW_TAC list_ss[PERM_LIST_TO_SET]
THEN RW_TAC list_ss[]);
 
val k_out_CARD = store_thm("k_out_CARD",
  ``!s k L. s IN k_out k L ==> (CARD s = k)  ``,

RW_TAC std_ss[k_out_def]
THEN ASM_SET_TAC[]);


val FINITE_k_out = store_thm("FINITE_k_out",
  `` !L k.  FINITE (k_out k L)``,

Induct
THEN RW_TAC std_ss[k_out_def]
     THEN1(RW_TAC list_ss[LIST_TO_SET_THM]
          THEN DEP_REWRITE_TAC[FINITE_SUBSETS_RESTRICT_NEW,FINITE_EMPTY])
THEN DEP_REWRITE_TAC[FINITE_SUBSETS_RESTRICT_NEW, FINITE_LIST_TO_SET]);


val FINITE_IN_k_out = store_thm("FINITE_IN_k_out",
  ``!s k L. s IN k_out k L ==> FINITE s  ``,

RW_TAC std_ss[]
THEN `!s. s IN k_out k L==> s SUBSET set L` by ASM_SET_TAC[k_out_def]
THEN `s SUBSET (set L)` by RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[FINITE_LIST_TO_SET, FINITE_SUBSET]
THEN Q.EXISTS_TAC`set L`
THEN RW_TAC std_ss[FINITE_LIST_TO_SET]);


val LENGTH_k_out_MEM = store_thm("LENGTH_k_out_MEM",
  ``!x k L. (MEM x (SET_TO_LIST(k_out k L))) ==> (CARD x = k)``,

RW_TAC std_ss[]
THEN KNOW_TAC(``x IN k_out k L``)
     THEN1(`FINITE (k_out k L)` by RW_TAC std_ss[FINITE_k_out]
           THEN METIS_TAC[MEM_SET_TO_LIST])
THEN RW_TAC std_ss[]	   
THEN METIS_TAC[k_out_CARD]);


val n_AND_SING_set = store_thm("n_AND_SING_set",
  `` !s.  rv_gt0 (SET_TO_LIST s)/\ (CARD s = 1) /\ FINITE s ==>
          (?x. x IN s /\ (n_AND (SET_TO_LIST s) = x)) ``,

RW_TAC std_ss[]
THEN `SING s` by RW_TAC std_ss[SING_IFF_CARD1]
THEN FULL_SIMP_TAC std_ss[SING_DEF]
THEN RW_TAC list_ss[SET_TO_LIST_THM]
THEN RW_TAC list_ss[n_AND_def]
THEN FULL_SIMP_TAC list_ss[rv_gt0_def]
THEN RW_TAC std_ss[D_AND_ALWAYS]);


val k_out_n_empty = store_thm("k_out_n_empty",
  `` !k. k <> 0 ==> (k_out k [] = {}) ``,

RW_TAC std_ss[k_out_def]
THEN RW_TAC list_ss[LIST_TO_SET_THM, SUBSET_EMPTY]
THEN KNOW_TAC(``!s. ( s = {}) /\ (CARD s = k) = (s = {}) /\ (CARD {} = k) ``)
     THEN1 (RW_TAC std_ss[]
            THEN EQ_TAC
	    THEN1 (RW_TAC std_ss[] THEN FULL_SIMP_TAC std_ss[CARD_DEF])
	    THEN FULL_SIMP_TAC std_ss[CARD_DEF])
THEN DISCH_TAC
THEN KNOW_TAC(``{s|(s = {}) /\ (CARD s = k)} = {s|(s ={}) /\ (CARD {} = k)} ``)
     THEN1 ASM_SET_TAC[]
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]    
THEN RW_TAC std_ss[CARD_DEF]
THEN RW_TAC std_ss[GSPEC_F]);


val SING_1_out_n = store_thm("SING_1_out_n",
  `` !L s. s IN k_out 1 L ==> (?x. s = {x})``,

RW_TAC std_ss[]
THEN `FINITE s` by ASM_SET_TAC[FINITE_IN_k_out]
THEN `CARD s = 1` by METIS_TAC[k_out_CARD]
THEN `SING s` by RW_TAC std_ss[SING_IFF_CARD1]
THEN FULL_SIMP_TAC std_ss[SING_DEF]
THEN ASM_SET_TAC[]);


val MEM_k_out_IN_L = store_thm("MEM_k_out_IN_L",
  `` !x L. MEM x (SET_TO_LIST (k_out 1 L)) ==> x IN (k_out 1 L)``,

GEN_TAC THEN Induct
THEN RW_TAC list_ss[k_out_n_empty]
THEN `FINITE (k_out 1 (h::L))` by ASM_SET_TAC[FINITE_k_out]
THEN METIS_TAC[MEM_SET_TO_LIST]);


val MEM_k_out_CHOICE = store_thm("MEM_k_out_CHOICE",
  ``  !x L. MEM x (SET_TO_LIST (k_out 1 L)) ==> MEM (CHOICE x) L ``,

GEN_TAC THEN Induct
THEN RW_TAC list_ss[k_out_n_empty]
THEN RW_TAC std_ss[]
THEN `x IN (k_out 1 (h::L))` by METIS_TAC[MEM_k_out_IN_L]
THEN `FINITE x` by METIS_TAC[FINITE_IN_k_out]
THEN `CARD x = 1` by METIS_TAC[k_out_CARD]
THEN `?a. x = {a}` by METIS_TAC[SING_1_out_n]
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[CHOICE_SING]
THEN FULL_SIMP_TAC list_ss[k_out_def]
THEN KNOW_TAC(``{a} SUBSET (h INSERT set L) ``)
     THEN1 (UNDISCH_TAC(``{a} IN {s | s SUBSET h INSERT set L /\ (CARD s = 1)} ``)
            THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
	    THEN `s = {a}` by ASM_SET_TAC[]
	    THEN ASM_SET_TAC[])
THEN ASM_SET_TAC[]);	    


val MEM_CHOICE_k_out = store_thm("MEM_CHOICE_k_out",
  ``!x L. SING x /\ MEM (CHOICE x) L ==> MEM x (SET_TO_LIST (k_out 1 L))  ``,

GEN_TAC THEN Induct
THEN1 RW_TAC list_ss[k_out_n_empty]
THEN RW_TAC std_ss[]
THEN `FINITE (k_out 1 (h::L))` by ASM_SET_TAC[FINITE_k_out]
THEN RW_TAC list_ss[MEM_SET_TO_LIST]
THEN RW_TAC list_ss[k_out_def]
THEN FULL_SIMP_TAC list_ss[]
     THEN1(SRW_TAC[][GSPECIFICATION, EXTENSION]
           THEN Q.EXISTS_TAC`x`
	   THEN RW_TAC std_ss[]
	       THEN1 (FULL_SIMP_TAC list_ss[SING_DEF]
	              THEN ASM_SET_TAC[CHOICE_SING])
           THEN METIS_TAC[SING_IFF_CARD1])
THEN FULL_SIMP_TAC list_ss[]	   
THEN `x IN k_out 1 L`  by METIS_TAC[MEM_k_out_IN_L]
THEN FULL_SIMP_TAC std_ss[k_out_def]
THEN ASM_SET_TAC[]);


val MEM_SING_elem_k_out = store_thm("MEM_SING_elem_k_out",
  ``!a L. MEM a L ==> MEM {a} (SET_TO_LIST (k_out 1 L)) ``,
RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[MEM_CHOICE_k_out]
THEN RW_TAC std_ss[SING, CHOICE_SING]);


val MEM_SING_k_out_equal = store_thm("MEM_SING_k_out_equal",
  ``!a L. MEM a L = MEM {a}(SET_TO_LIST (k_out 1 L))  ``,
RW_TAC std_ss[]
THEN EQ_TAC
     THEN1(RW_TAC std_ss[MEM_SING_elem_k_out])
THEN METIS_TAC[MEM_k_out_CHOICE, CHOICE_SING]);

val MAP_MEM = store_thm("MAP_MEM",
  ``!x f L. MEM x L ==> MEM (f x) (MAP f L)``,

GEN_TAC THEN GEN_TAC THEN Induct
THEN RW_TAC list_ss[]
THEN FULL_SIMP_TAC list_ss[]);


val MAP_MEM_equal_set = store_thm("MAP_MEM",
  ``!x f L. MEM x L = MEM {x} (MAP (\a. {a}) L)``,

RW_TAC std_ss[]
THEN EQ_TAC
THEN1 (RW_TAC list_ss[MAP_MEM]
      THEN `{x} = (\a. {a}) x` by RW_TAC std_ss[]
      THEN ONCE_ASM_REWRITE_TAC[]
      THEN MP_TAC(Q.ISPECL[`x:'a`,`(\a. {a:'a})`, `L:'a list`]MAP_MEM)
      THEN METIS_TAC[]) 
THEN RW_TAC list_ss[MEM_MAP]
THEN ASM_SET_TAC[]);


val NOT_MAP_MEM = store_thm("NOT_MAP_MEM",
  ``!x f L. ALL_DISTINCT L /\ ~MEM x L ==> ~MEM {x} (MAP (\a. {a}) L)``,

GEN_TAC THEN GEN_TAC THEN Induct
THEN RW_TAC list_ss[]
THEN SRW_TAC[][]);


val ALL_DISTINCT_MAP_set = store_thm("ALL_DISTINCT_MAP_set",
  ``!L. ALL_DISTINCT L ==> ALL_DISTINCT (MAP (\a. {a}) L)``,
Induct
THEN RW_TAC list_ss[]
THEN RW_TAC list_ss[NOT_MAP_MEM]);

val MEM_x_SING = store_thm("MEM_x_SING",
  ``!x L. MEM x (MAP (\a. {a}) L) ==> (?a. x = {a})``,
RW_TAC list_ss[MEM_MAP]
THEN ASM_SET_TAC[]);


val MEM_k_out_1_SING = store_thm("MEM_k_out_1_SING",
  ``!x L. MEM x (SET_TO_LIST (k_out 1 L)) ==> (?a. x = {a})``,

RW_TAC std_ss[]
THEN `x IN k_out 1 L` by  RW_TAC std_ss[MEM_k_out_IN_L]
THEN `FINITE (x:'a->bool)` by METIS_TAC[FINITE_IN_k_out]
THEN `CARD x = 1` by METIS_TAC[k_out_CARD]
THEN `SING x` by METIS_TAC[SING_IFF_CARD1]
THEN FULL_SIMP_TAC std_ss[SING_DEF]
THEN ASM_SET_TAC[]);


val MEM_k_out_MEM_L = store_thm("MEM_k_out_MEM_L",
``!x L. MEM x (SET_TO_LIST (k_out 1 (L))) = MEM x (MAP (\a. {a}) L )``,

RW_TAC std_ss[]
THEN EQ_TAC
THEN RW_TAC std_ss[]
     THEN1(`?a. x = {a}` by METIS_TAC[MEM_k_out_1_SING]
            THEN ONCE_ASM_REWRITE_TAC[]
	    THEN RW_TAC std_ss[GSYM MAP_MEM_equal_set]
	    THEN METIS_TAC[MEM_SING_k_out_equal])
THEN `?a. x = {a}` by METIS_TAC[MEM_x_SING]
THEN ONCE_ASM_REWRITE_TAC[]
THEN FULL_SIMP_TAC list_ss[]
THEN `MEM a L` by METIS_TAC[GSYM MAP_MEM_equal_set]
THEN METIS_TAC[MEM_SING_k_out_equal]);


val PERM_k_out_set_L = store_thm("PERM_k_out_set_L",
  ``!L. ALL_DISTINCT L ==> PERM (SET_TO_LIST (k_out 1 L)) (MAP (\a. {a})L)``,

RW_TAC list_ss[k_out_n_empty, PERM_NIL]
THEN KNOW_TAC(``ALL_DISTINCT (MAP(\a. {a})L) ``)
    THEN1 RW_TAC list_ss[ALL_DISTINCT_MAP_set]
THEN DISCH_TAC
THEN KNOW_TAC(`` ALL_DISTINCT (SET_TO_LIST (k_out 1 (L)))``)
     THEN1 (`FINITE (k_out 1 (L))` by RW_TAC std_ss[FINITE_k_out]
            THEN RW_TAC std_ss[ALL_DISTINCT_SET_TO_LIST])
THEN DISCH_TAC
THEN KNOW_TAC(``!x. MEM x (SET_TO_LIST (k_out 1 (L))) = MEM x (MAP (\a. {a}) L) ``)
     THEN1(RW_TAC std_ss[MEM_k_out_MEM_L])
THEN RW_TAC std_ss[]     
THEN METIS_TAC[PERM_ALL_DISTINCT]);

val n_AND_SING = store_thm("n_AND_SING",
  `` !L. rv_gt0 L /\ (LENGTH L = 1) ==> (n_AND L =  HD L ) ``,

Induct
THEN RW_TAC list_ss[n_AND_def]
THEN FULL_SIMP_TAC list_ss[rv_gt0_def]
THEN RW_TAC std_ss[D_AND_ALWAYS]);

val PERM_MAP_AND_L = store_thm("PERM_MAP_AND_L",
  ``!L. rv_gt0 L ==> PERM (MAP (\a. n_AND (SET_TO_LIST a)) (MAP (\a. {a}) L)) L``, 

Induct
THEN RW_TAC list_ss[PERM_NIL]
THEN RW_TAC list_ss[n_AND_def]
THEN RW_TAC list_ss[GSYM n_AND_def]
THEN FULL_SIMP_TAC list_ss[rv_gt0_def]
THEN RW_TAC std_ss[D_AND_ALWAYS]
THEN RW_TAC list_ss[PERM_MONO]);


val k_out_n_greater = store_thm("k_out_n_greater",
  ``!k L. (LENGTH L < k) ==> (k_out k L = {})  ``,

RW_TAC list_ss[k_out_def]
THEN KNOW_TAC(``!s. s SUBSET set (L:'a list) = (s SUBSET (set L)) /\ (CARD s <= LENGTH L) ``)
    THEN1( RW_TAC std_ss[]
          THEN EQ_TAC THEN RW_TAC std_ss[]
    	  THEN `CARD (set L) <= LENGTH (L:'a list) ` by RW_TAC list_ss[CARD_LIST_TO_SET]
    	  THEN `FINITE (set (L:'a list))` by RW_TAC list_ss[FINITE_LIST_TO_SET]
    	  THEN `CARD s <= CARD (set (L:'a list))` by METIS_TAC[CARD_SUBSET]
    	  THEN METIS_TAC[LESS_EQ_TRANS])
THEN DISCH_TAC	  
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[GSYM CONJ_ASSOC]
THEN KNOW_TAC(``!s. CARD s <= LENGTH (L:'a list) /\ (CARD s = k)    = (k <= LENGTH L)  ``)
     THEN1(RW_TAC std_ss[]
           THEN EQ_TAC
	   THEN RW_TAC std_ss[]
	        THEN1 RW_TAC std_ss[]
	        THEN1 FULL_SIMP_TAC std_ss[GSYM NOT_LESS]
	   THEN FULL_SIMP_TAC std_ss[GSYM NOT_LESS])
THEN DISCH_TAC
THEN KNOW_TAC(``{s | s SUBSET set (L:'a list) /\ CARD s <= LENGTH L /\ (CARD s = k)} =
                {s | s SUBSET set L /\ k <= LENGTH L}``)
    THEN1(SRW_TAC[][GSPECIFICATION, EXTENSION]
          THEN EQ_TAC 
	      THEN1 (RW_TAC std_ss[]
                    THEN ASM_SET_TAC[])
         THEN RW_TAC std_ss[]
         THEN Q.EXISTS_TAC`s`
	 THEN RW_TAC std_ss[]
	      THEN1(FULL_SIMP_TAC std_ss[GSYM NOT_LESS])
         THEN FULL_SIMP_TAC std_ss[GSYM NOT_LESS])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN SRW_TAC [][GSPECIFICATION, EXTENSION]
THEN METIS_TAC[NOT_LESS]);


val rv_gt0_PERM1 = store_thm("rv_gt0_PERM1",
  ``!L1 L2. PERM L1 L2 ==> rv_gt0 L1 ==> rv_gt0 L2  ``,

HO_MATCH_MP_TAC PERM_IND THEN
SRW_TAC [][] 
THEN FULL_SIMP_TAC list_ss[rv_gt0_def]);

val rv_gt0_PERM = store_thm("rv_gt0_PERM",
  ``!L1 L2. PERM L1 L2 /\ rv_gt0 L1 ==> rv_gt0 L2  ``,
RW_TAC std_ss[rv_gt0_PERM1]
THEN METIS_TAC[rv_gt0_PERM1]);

val rv_gt0_SPLIT = store_thm("rv_gt0_SPLIT",
  ``!L1 L2. rv_gt0 (L1 ++ L2) =  rv_gt0 L1 /\  rv_gt0 L2``,

Induct
   THEN1( Induct
          THEN1 RW_TAC list_ss[ rv_gt0_def]
	  THEN RW_TAC list_ss[ rv_gt0_def])
THEN RW_TAC list_ss[ rv_gt0_def]	  
THEN POP_ASSUM (MP_TAC o Q.SPEC ` L2`)
THEN RW_TAC std_ss[]
THEN EQ_TAC THEN RW_TAC list_ss[]);

val P_AND_ID = store_thm("P_AND_ID",
  ``!x. P_AND x x  = x  ``,
RW_TAC std_ss[P_AND_def]
THEN RW_TAC std_ss[le_refl]
THEN RW_TAC std_ss[ETA_THM]);

val P_AND_ALWAYS = store_thm("P_AND_ALWAYS",
  ``!X. (!s. 0<= X s) ==> (P_AND ALWAYS X = X)  ``,
RW_TAC std_ss[P_AND_def]
THEN RW_TAC std_ss[ALWAYS_def, ETA_THM]);


val k_out_of_n_gate_OR = store_thm("k_out_of_n_gate_OR",
  ``!L. ALL_DISTINCT L /\ rv_gt0 L==>( k_out_n_gate 1 L = n_OR L)``,

RW_TAC std_ss[k_out_n_gate_def]
THEN KNOW_TAC(``PERM  (MAP (\a. n_AND (SET_TO_LIST a)) (SET_TO_LIST (k_out 1 L)))
                      (MAP (\a. n_AND (SET_TO_LIST a)) (MAP (\a. {a}) L))``)
     THEN1(`PERM (SET_TO_LIST (k_out 1 L)) (MAP (\a. {a})L)` by RW_TAC std_ss[PERM_k_out_set_L]		THEN METIS_TAC[PERM_MAP])
THEN DISCH_TAC     
THEN `n_OR (MAP (\a. n_AND (SET_TO_LIST a)) (SET_TO_LIST (k_out 1 L))) =
      n_OR (MAP (\a. n_AND (SET_TO_LIST a)) (MAP (\a. {a}) L))` by RW_TAC std_ss[n_OR_comm]
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``PERM (MAP (\a. n_AND (SET_TO_LIST a)) (MAP (\a. {a}) L)) L ``)
     THEN1(RW_TAC std_ss[PERM_MAP_AND_L])
THEN DISCH_TAC     
THEN RW_TAC std_ss[n_OR_comm]);


val n_PAND_GT0 = store_thm("n_PAND_GT0",
  `` !L. rv_gt0 L==> (!s. 0<= n_PAND L s) ``,

RW_TAC list_ss[n_PAND_def]
THEN RW_TAC list_ss[ALWAYS_def]
THEN DEP_REWRITE_TAC[P_AND_FOLDL_GT0]
THEN RW_TAC std_ss[le_refl]);


val LIST_APPEND_middle = store_thm("LIST_APPEND_middle",
  ``!h L L1. L++[h]++L1 = L++(h::L1)``,

GEN_TAC THEN Induct THEN1( Induct THEN RW_TAC list_ss[])
THEN RW_TAC list_ss[]);


val n_PAND_left_flattening1 = store_thm("n_PAND_left_flattening1",
  ``!L2. rv_gt0 L2==> (!L1. rv_gt0 L1==> (n_PAND ((n_PAND L2)::L1) = n_PAND (L2++L1))) ``,

Induct
THEN1( RW_TAC list_ss[rv_gt0_def]
       THEN RW_TAC list_ss[n_PAND_def]
       THEN RW_TAC list_ss[P_AND_ID])
THEN RW_TAC list_ss[]
THEN FULL_SIMP_TAC list_ss[rv_gt0_def]
THEN RW_TAC list_ss[n_PAND_def]
THEN RW_TAC list_ss[P_AND_ALWAYS, P_AND_FOLDL_GT0]
THEN RW_TAC list_ss[FOLDL_APPEND]);


val D_RIGHT_AND_OVER_OR = store_thm("D_RIGHT_AND_OVER_OR",
  ``!X Y Z. D_AND (D_OR X Y) Z = D_OR (D_AND Z X)(D_AND Z Y)  ``,
RW_TAC std_ss[D_AND_COMM, D_AND_OVER_OR]);


val n_OR_GT0 = store_thm("n_OR_GT0",
  ``!L1. rv_gt0 L1==> (!s. 0<= n_OR L1 s)  ``,

Induct
   THEN1(RW_TAC list_ss[n_OR_def]
        THEN RW_TAC list_ss[NEVER_def]
	THEN METIS_TAC[extreal_of_num_def, le_infty])
THEN RW_TAC list_ss[rv_gt0_def]	
THEN RW_TAC std_ss[n_OR_def]
THEN RW_TAC list_ss[FOLDR]
THEN RW_TAC list_ss[GSYM n_OR_def]
THEN FULL_SIMP_TAC std_ss[]
THEN RW_TAC std_ss[D_OR_def, extreal_min_def]);


val P_AND_NEVER = store_thm("P_AND_NEVER",
  `` !X. P_AND NEVER X = NEVER ``,

RW_TAC std_ss[NEVER_def, P_AND_def, le_infty]);


val P_AND_FOLDL_NEVER = store_thm("P_AND_FOLDL_NEVER",
  `` !L. FOLDL (\a b. P_AND a b) NEVER L = NEVER  ``,
Induct
THEN1 RW_TAC list_ss[]
THEN RW_TAC list_ss[]
THEN RW_TAC std_ss[P_AND_NEVER]);


val lem8 = store_thm("lem8",
  `` !x L. rv_gt0 L ==> (n_PAND (L++[x]) = P_AND (n_PAND L) x) ``,

GEN_TAC THEN Induct
THEN1 RW_TAC list_ss[n_PAND_def]
THEN RW_TAC list_ss[n_PAND_def]
THEN FULL_SIMP_TAC list_ss[rv_gt0_def]
THEN RW_TAC std_ss[P_AND_ALWAYS]
THEN RW_TAC list_ss[FOLDL_APPEND]);


val lem9 = store_thm("lem9",
  `` !y s L. (!h. y s <= h s ==> (y s <= FOLDL (\a b. P_AND a b) h L s))``,

GEN_TAC THEN  GEN_TAC THEN Induct
THEN1(RW_TAC list_ss[FOLDL])
THEN RW_TAC std_ss[]
THEN RW_TAC list_ss[FOLDL]
THEN FULL_SIMP_TAC list_ss[]
THEN UNDISCH_TAC(`` !h. y s <= h s ==> y s <= FOLDL (\a b. P_AND a b) h L s``)
THEN DISCH_TAC
THEN POP_ASSUM (MP_TAC o Q.SPEC `P_AND h' h`)
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``y s<= P_AND h' h s ``)
     THEN1(RW_TAC std_ss[P_AND_def]
          THEN1 METIS_TAC[lt_le, le_lt, lt_trans, le_trans]
	  THEN METIS_TAC[lt_infty, le_infty])
THEN RW_TAC std_ss[]);	  

val lem10 = store_thm("lem10",
  `` !x y s. y s <= P_AND x y s ``,
RW_TAC std_ss[P_AND_def]
THEN1 RW_TAC std_ss[le_refl]
THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_le, le_lt, lt_infty, le_infty]); 

val lem11 = store_thm("lem11",
  `` !x y s. x s <= P_AND x y s ``,
RW_TAC std_ss[P_AND_def]
THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_le, le_lt, lt_infty, le_infty]); 


val lem12 = store_thm("lem12",
  `` !x y s L . rv_gt0 (x::y::L)==> y s<= n_PAND (x::y::L) s ``,
NTAC 3(GEN_TAC) THEN  SNOC_INDUCT_TAC
THEN1( RW_TAC list_ss[n_PAND_def]
THEN RW_TAC std_ss[P_AND_def, ALWAYS_def]
THEN RW_TAC std_ss[le_refl]
THEN FULL_SIMP_TAC std_ss[rv_gt0_def]
THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_le, le_lt, lt_infty, le_infty])
THEN RW_TAC list_ss[SNOC_APPEND] 
THEN KNOW_TAC(``n_PAND (x::y::(L ++ [x'])) = P_AND (n_PAND (x::y::L))x' ``)
     THEN1(`(x::y::(L ++ [x']))= (x::y::L) ++ [x']` by RW_TAC list_ss[GSYM APPEND_ASSOC]
          THEN ONCE_ASM_REWRITE_TAC[]
	  THEN DEP_REWRITE_TAC[lem8]
	  THEN FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]	  
THEN `n_PAND (x::y::L) s<= P_AND (n_PAND (x::y::L)) x' s` by RW_TAC std_ss[lem11]
THEN FULL_SIMP_TAC list_ss[rv_gt0_def, rv_gt0_SPLIT]
THEN METIS_TAC[extreal_le_def, le_trans]);


val P_AND_lem3 = store_thm("P_AND_lem3",
  `` !X Y Z. P_AND (D_OR X Y) Z = D_OR (P_AND X Z)(P_AND Y Z) ``,

RW_TAC std_ss[P_AND_def, D_OR_def]
THEN KNOW_TAC(`` !s.  ( if min (X s) (Y s) <= Z s then Z s else PosInf) =
   (
        min (if X s <= Z s then Z s else PosInf)
          (if Y s <= Z s then Z s else PosInf)) ``)
      THEN1(RW_TAC std_ss[extreal_min_def] THEN REPEAT(POP_ASSUM MP_TAC )THEN RW_TAC std_ss[] THEN METIS_TAC[extreal_le_def, extreal_lt_def, lt_le, le_lt, le_trans, lt_trans, lt_total, le_total, le_refl, lt_infty, le_infty])
THEN RW_TAC std_ss[]  );    


val P_AND_FOLDL_GT01 = store_thm("P_AND_FOLDL_GT01",
  ``   !s L.
            (!x. MEM x L ==> !s. 0 < x s) ==>
            !h. 0 < h s ==> 0 < FOLDL (\a b. P_AND a b) h L s ``,
GEN_TAC THEN Induct
THEN1(RW_TAC list_ss[FOLDL])
THEN RW_TAC std_ss[]
THEN RW_TAC list_ss[FOLDL]
THEN FULL_SIMP_TAC list_ss[]
THEN UNDISCH_TAC(`` ∀h. 0 < h s ⇒ 0 < FOLDL (λa b. P_AND a b) h L s``)
THEN DISCH_TAC
THEN POP_ASSUM (MP_TAC o Q.SPEC `P_AND h' h`)
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``0< P_AND h' h s ``)
     THEN1(RW_TAC std_ss[P_AND_def]
          THEN METIS_TAC[extreal_of_num_def, lt_infty])
THEN RW_TAC std_ss[]);	  


val P_AND_lem14 = store_thm("P_AND_lem14",
  `` !L.L <> [] /\ (!x. MEM x L ==> (!s. 0< x s))==> (n_PAND (L++[ALWAYS]) = NEVER) ``,
Induct
THEN RW_TAC list_ss[]
THEN Cases_on`L=[]`
THEN1 (RW_TAC list_ss[]
       THEN RW_TAC list_ss[n_PAND_def]
       THEN RW_TAC std_ss[P_AND_def, ALWAYS_def, NEVER_def]
       THEN POP_ASSUM(MP_TAC o Q.SPEC `h`)
       THEN RW_TAC std_ss[]
       THEN KNOW_TAC(`` !s.( if (if 0 <= h s then h s else PosInf) <= 0 then 0 else PosInf) =
   ( PosInf) ``)

           THEN1(RW_TAC std_ss[]
                 THEN METIS_TAC[extreal_lt_def, extreal_le_def, le_infty, lt_infty])
        THEN RW_TAC std_ss[])	   
THEN `h::(L ++ [ALWAYS]) = [h]++(L++[ALWAYS])` by RW_TAC list_ss[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC list_ss[FOLDL_APPEND, n_PAND_def]
THEN KNOW_TAC(``P_AND ALWAYS h = h ``)
     THEN1(RW_TAC std_ss[P_AND_def, ALWAYS_def]
          THEN UNDISCH_TAC(`` !x. (x = h) \/ MEM x L ==> !s. 0 < x s ``)
	  THEN DISCH_TAC
	  THEN POP_ASSUM (MP_TAC o Q.SPEC `h`)
	  THEN RW_TAC std_ss[]
	  THEN KNOW_TAC (``  !s.( if 0 <= h s then h s else PosInf) = h s``)
	       THEN1(RW_TAC std_ss[]
	            THEN METIS_TAC[le_infty, lt_infty, extreal_lt_def, extreal_le_def, lt_le, le_lt])
          THEN RW_TAC std_ss[ETA_THM])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``!s. 0< h s ``)
     THEN1(UNDISCH_TAC(``  !x. (x = h) \/ MEM x L ==> !s. 0 < x s``)
     	   THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `h`)
	   THEN RW_TAC std_ss[])
THEN DISCH_TAC
THEN `!s. MEM x L ==> !s. 0 < x s` by RW_TAC list_ss[]
THEN `!s. 0< FOLDL (\a b. P_AND a b) h L s` by METIS_TAC[P_AND_FOLDL_GT01]
THEN KNOW_TAC(``!a. (!s. 0< a s)==> (P_AND a ALWAYS = NEVER)  ``)
     THEN1(RW_TAC std_ss[P_AND_def, ALWAYS_def, NEVER_def]
          THEN KNOW_TAC(`` !s.( if a s <= 0 then 0 else PosInf) = (PosInf)``)
	       THEN1(RW_TAC std_ss[]
	            THEN METIS_TAC[extreal_lt_def, extreal_le_def, lt_le, le_lt])
          THEN RW_TAC std_ss[])
THEN RW_TAC std_ss[]);  

val _ = export_theory();
