

(******************************************************************************)
(*                      Probabilistic Analysis of                             *)
(*                              Drive by wire                                 *)
(*                                  by                                        *)
(*                          Yassmeen Elderhalli                               *)
(*                      y_elderh@encs.concordia.ca                            *)
(******************************************************************************)

(*lloadPath := "/home/yassmeen/Downloads/ProbTheories_HOL-k12" :: !loadPath;
(*set_trace "Unicode" 0;*)

app load ["HolKernel", "Parse", "boolLib", "bossLib", "numLib", "unwindLib", 
"tautLib", "Arith", "prim_recTheory", "combinTheory", "quotientTheory", 
"arithmeticTheory", "realTheory", "hrealTheory", "realaxTheory", "realLib",  
"jrhUtils", "pairTheory", "seqTheory", "limTheory", "transcTheory", "listTheory", 
"mesonLib", "boolTheory", "topologyTheory", "pred_setTheory", "util_probTheory", 
"optionTheory", "numTheory", "sumTheory", "InductiveDefinition", "ind_typeTheory",
"pred_setLib", "iterate_hvgTheory", "card_hvgTheory", "product_hvgTheory", 
"topology_hvgTheory", "derivative_hvgTheory", "integration_hvgTheory",
"real_sigmaTheory", "extreal_hvgTheory", "measure_hvgTheory", "lebesgue_hvgTheory",
"probability_hvgTheory", "lebesgue_measure_hvgTheory", "normal_rv_hvgTheory", "netsTheory", "PIE_EXTREALTheory","dep_rewrite", "integration_before_afterTheory", "DFT_Gates_def_PROBTheory", "CASTheory","WCSPTheory", "WCSP_sharedTheory", "AND_FDEPTheory"];
*)
open HolKernel Parse boolLib bossLib numLib unwindLib tautLib Arith prim_recTheory 
combinTheory quotientTheory arithmeticTheory hrealTheory realaxTheory realTheory 
realLib jrhUtils pairTheory seqTheory limTheory transcTheory listTheory mesonLib 
boolTheory topologyTheory pred_setTheory util_probTheory optionTheory numTheory 
sumTheory InductiveDefinition ind_typeTheory pred_setLib iterate_hvgTheory 
card_hvgTheory product_hvgTheory topology_hvgTheory derivative_hvgTheory
integration_hvgTheory real_sigmaTheory extreal_hvgTheory measure_hvgTheory
lebesgue_hvgTheory probability_hvgTheory lebesgue_measure_hvgTheory normal_rv_hvgTheory netsTheory PIE_EXTREALTheory dep_rewrite integration_before_afterTheory DFT_Gates_def_PROBTheory CASTheory WCSPTheory WCSP_sharedTheory AND_FDEPTheory;


val _ = new_theory "DBW_DFT";


infixr 0 ++ << || ORELSEC ## --> THENC;
infix 1 >> |->;
fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
 
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Suff = PARSE_TAC SUFF_TAC;
val POP_ORW = POP_ASSUM (fn thm => ONCE_REWRITE_TAC [thm]);
val !! = REPEAT;
val op++ = op THEN;
val op<< = op THENL;
val op|| = op ORELSE;
val op>> = op THEN1;
val std_ss' = simpLib.++ (std_ss, boolSimps.ETA_ss);

(*---------------------------*)
fun SET_TAC L =
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION,
    IN_INTER, IN_DIFF, IN_INSERT, IN_DELETE, IN_BIGINTER, IN_BIGUNION,
    IN_IMAGE, GSPECIFICATION, IN_DEF] THEN METIS_TAC [];

fun SET_RULE tm = prove(tm,SET_TAC []);


val set_rewrs
= [INTER_EMPTY, INTER_UNIV, UNION_EMPTY, UNION_UNIV, DISJOINT_UNION,
DISJOINT_INSERT, DISJOINT_EMPTY, GSYM DISJOINT_EMPTY_REFL,
DISJOINT_BIGUNION, INTER_SUBSET, INTER_IDEMPOT, UNION_IDEMPOT,
SUBSET_UNION];

val UNIONL_def = Define `(UNIONL [] = {})
/\ (UNIONL (s::ss) = (s:'a ->bool) UNION UNIONL ss)`;


val IN_UNIONL = store_thm
("IN_UNIONL",
``!l (v:'a ). v IN UNIONL l = (?s. MEM s l /\ v IN s)``,
Induct >> RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY]
++ RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY, IN_UNION]
++ PROVE_TAC []);


val elt_rewrs
= [SUBSET_DEF, IN_COMPL, IN_DIFF, IN_UNIV, NOT_IN_EMPTY, IN_UNION,
IN_INTER, IN_IMAGE, IN_FUNSET, IN_DFUNSET, GSPECIFICATION,
DISJOINT_DEF, IN_BIGUNION, IN_BIGINTER, IN_COUNT, IN_o,
IN_UNIONL, IN_DELETE, IN_PREIMAGE, IN_SING, IN_INSERT];


fun rewr_ss ths =
simpLib.++
(std_ss,
simpLib.SSFRAG
{ac = [],
name = NONE,
convs = [],
dprocs = [],
filter = NONE,
rewrs = set_rewrs @ elt_rewrs,
congs = []});
val pset_set_ss = rewr_ss set_rewrs;
val pset_elt_ss = rewr_ss elt_rewrs;
val pset_ss = rewr_ss (set_rewrs @ elt_rewrs);


fun PSET_TAC ths =
REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_set_ss ths
++ REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_elt_ss ths;

fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Simplify = RW_TAC arith_ss;
val Suff = PARSE_TAC SUFF_TAC;
val Know = PARSE_TAC KNOW_TAC;
fun wrap a = [a];
val Rewr = DISCH_THEN (REWRITE_TAC o wrap);
val Rewr' = DISCH_THEN (ONCE_REWRITE_TAC o wrap);
val Cond =
  DISCH_THEN
  (fn mp_th =>
   let
     val cond = fst (dest_imp (concl mp_th))
   in
     KNOW_TAC cond << [ALL_TAC, DISCH_THEN (MP_TAC o MP mp_th)]
   end);
val FUN_EQ_TAC = CONV_TAC (CHANGED_CONV (ONCE_DEPTH_CONV FUN_EQ_CONV));
fun K_TAC _ = ALL_TAC;
fun MESON ths tm = prove(tm,MESON_TAC ths);
fun METIS ths tm = prove(tm,METIS_TAC ths);
val DISC_RW_KILL = DISCH_TAC THEN ONCE_ASM_REWRITE_TAC [] THEN 
                   POP_ASSUM K_TAC;
			   
val IN_REST = store_thm ("IN_REST",
 ``!x:'a. !s. x IN (REST s) <=> x IN s /\ ~(x = CHOICE s)``,
  REWRITE_TAC[REST_DEF, IN_DELETE]);
fun SET_TAC L = 
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN
    SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION, IN_INTER, IN_DIFF, 
      IN_INSERT, IN_DELETE, IN_REST, IN_BIGINTER, IN_BIGUNION, IN_IMAGE, 
      GSPECIFICATION, IN_DEF, EXISTS_PROD] THEN METIS_TAC [];
fun ASSERT_TAC tm = SUBGOAL_THEN tm STRIP_ASSUME_TAC;
fun SET_RULE tm = prove(tm,SET_TAC []);
fun ASM_SET_TAC L = REPEAT (POP_ASSUM MP_TAC) THEN SET_TAC L;
val ASM_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN ARITH_TAC;
val ASM_REAL_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN REAL_ARITH_TAC;

fun DFT_rewrs L =  REPEAT( METIS_TAC L);


val rewrs = [REAL_LE_REFL, REAL_LE_LT, REAL_LE_ANTISYM, REAL_LET_ANTISYM, REAL_LET_TOTAL, REAL_LET_TRANS, real_of_num,REAL_LT_NEG1_1,REAL_LT_NEG1_0,REAL_LE_NEG1_0,REAL_LE_NEG1_1, REAL_LT_TOTAL, max_def, min_def, REAL_LT_TRANS, REAL_LE_TRANS, REAL_MIN_COMM, REAL_MAX_COMM];

val DFT_rewrs_ss  =DFT_rewrs rewrs;


val drive_by_wire_top_event = store_thm("drive_by_wire_top_event",
  ``  !BS TS PCCU SCCU_a SCCU_d BCU EF TF.
            (!s.
                 ALL_DISTINCT
                   [BS s; TS s; PCCU s; SCCU_a s; SCCU_d s; BCU s; EF s;
                    TF s]) ==>
            (D_OR (D_OR (D_OR (D_OR TF EF) (WSP PCCU SCCU_a SCCU_d)) BCU)
               (D_OR TS BS) =
             D_OR
               (D_OR
                  (D_OR
                     (D_OR (D_OR (D_OR TF EF) BCU)
                        (D_AND SCCU_a (D_BEFORE PCCU SCCU_a)))
                     (D_AND PCCU (D_BEFORE SCCU_d PCCU))) TS) BS)`` , 

RW_TAC std_ss[WSP_def]
THEN KNOW_TAC(``(D_SIMULT PCCU SCCU_d) = NEVER``)
     THEN1(RW_TAC std_ss[D_SIMULT_def, NEVER_def]
           THEN FULL_SIMP_TAC std_ss[ALL_DISTINCT, MEM])
THEN RW_TAC std_ss[]   
THEN `(D_SIMULT PCCU SCCU_a) = NEVER` by (RW_TAC std_ss[D_SIMULT_def, NEVER_def]
           THEN FULL_SIMP_TAC std_ss[ALL_DISTINCT, MEM])
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[D_OR_ASSOC]
THEN `(D_OR NEVER (D_OR NEVER (D_OR BCU (D_OR TS BS)))) = 
                           (D_OR BCU (D_OR TS BS))` by METIS_TAC [D_OR_NEVER, D_OR_COMM]
THEN ONCE_ASM_REWRITE_TAC[]
THEN  METIS_TAC[D_OR_ASSOC, D_OR_COMM]);


val drive_by_wire_union_list = store_thm("drive_by_wire_union_list",
  ``!BS TS PCCU SCCU_a SCCU_d BCU SCU EF TF p t.
          DFT_event p
            (D_OR (D_OR (D_OR (D_OR TF EF) (WSP PCCU SCCU_a SCCU_d)) BCU)
             (D_OR TS BS)) t =
          union_list
            [DFT_event p TF t;
	     DFT_event p EF t;
             DFT_event p BCU t;
	     DFT_event p (WSP PCCU SCCU_a SCCU_d) t;
             DFT_event p BS t; DFT_event p TS t]``,

RW_TAC std_ss [OR_UNION]
THEN RW_TAC std_ss [union_list_def]
THEN PSET_TAC[]
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION, UNION_COMM, UNION_ASSOC]
THEN EQ_TAC THEN RW_TAC std_ss[] THEN RW_TAC std_ss[]);


val DFT_event_IN_events_p = store_thm("DFT_event_IN_events_p",
  `` !X p t.  random_variable (\x. real (X x)) p borel  /\ (!s. 0<= X s /\ X s <> PosInf) /\ 0<=t ==>
        DFT_event p X t IN events p``,
RW_TAC std_ss[DFT_event_def, distribution_def]
THEN `{s | X s <= Normal t} = PREIMAGE  X {s | s <= Normal t}` by SRW_TAC [] [GSPECIFICATION, EXTENSION, PREIMAGE_def]
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL]
THEN REWRITE_TAC [events_def]
THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``)
      THEN1(RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN REWRITE_TAC [p_space_def, m_space_def]
THEN KNOW_TAC(``prob_space p``) THEN1(FULL_SIMP_TAC std_ss [random_variable_def])
THEN DISCH_TAC
THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def,  m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def]);



val prob_drive_by_wire_PIE = store_thm("prob_drive_by_wire_PIE",
  ``      
        !BS TS  PCCU SCCU_a SCCU_d BCU  EF TF p t.
            (!s. ALL_DISTINCT [BS s; TS s;  PCCU s; SCCU_a s; SCCU_d s; BCU s;  EF s; TF s]) /\ All_distinct_events p
              [TF; EF; BCU;
                WSP PCCU SCCU_a SCCU_d; BS; TS] t /\ 0 <= t /\
	    rv_gt0_ninfinity [BS; TS;  PCCU; SCCU_a; SCCU_d; BCU ; EF; TF] /\   
            random_variable (\x. real (TF x)) p borel /\
            random_variable (\x. real (EF x)) p borel /\
            random_variable (\x. real (BCU x)) p borel /\
            random_variable (\x. real (SCCU_d x)) p borel /\
            random_variable (\x. real (SCCU_a x)) p borel /\
            random_variable (\x. real (PCCU x)) p borel /\
            random_variable (\x. real (TS x)) p borel /\
            random_variable (\x. real (BS x)) p borel ==>
            (prob p
               (DFT_event p
                  (D_OR (D_OR (D_OR (D_OR TF EF) (WSP PCCU SCCU_a SCCU_d)) BCU)
               (D_OR TS BS)) t) =

   prob p (DFT_event p TF t) + prob p (DFT_event p EF t) +
   prob p (DFT_event p BCU t) +
   prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) +
   prob p (DFT_event p BS t) + prob p (DFT_event p TS t) -
   prob p (DFT_event p TF t INTER DFT_event p EF t) -
   prob p (DFT_event p TF t INTER DFT_event p BCU t) -
   prob p (DFT_event p TF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t) -
   prob p (DFT_event p TF t INTER DFT_event p BS t) -
   prob p (DFT_event p TF t INTER DFT_event p TS t) -
   prob p (DFT_event p EF t INTER DFT_event p BCU t) -
   prob p (DFT_event p EF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t) -
   prob p (DFT_event p EF t INTER DFT_event p BS t) -
   prob p (DFT_event p EF t INTER DFT_event p TS t) -
   prob p (DFT_event p BCU t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t) -
   prob p (DFT_event p BCU t INTER DFT_event p BS t) -
   prob p (DFT_event p BCU t INTER DFT_event p TS t) -
   prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t) -
   prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p TS t) -
   prob p (DFT_event p BS t INTER DFT_event p TS t) +
   prob p (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t) +
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t) +
   prob p (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BS t) +
   prob p (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p TS t) +
   prob p
     (DFT_event p TF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t) +
   prob p (DFT_event p TF t INTER DFT_event p BCU t INTER DFT_event p BS t) +
   prob p (DFT_event p TF t INTER DFT_event p BCU t INTER DFT_event p TS t) +
   prob p
     (DFT_event p TF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      DFT_event p BS t) +
   prob p
     (DFT_event p TF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      DFT_event p TS t) +
   prob p (DFT_event p TF t INTER DFT_event p BS t INTER DFT_event p TS t) +
   prob p
     (DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t) +
   prob p (DFT_event p EF t INTER DFT_event p BCU t INTER DFT_event p BS t) +
   prob p (DFT_event p EF t INTER DFT_event p BCU t INTER DFT_event p TS t) +
   prob p
     (DFT_event p EF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      DFT_event p BS t) +
   prob p
     (DFT_event p EF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      DFT_event p TS t) +
   prob p (DFT_event p EF t INTER DFT_event p BS t INTER DFT_event p TS t) +
   prob p
     (DFT_event p BCU t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      DFT_event p BS t) +
   prob p
     (DFT_event p BCU t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      DFT_event p TS t) +
   prob p (DFT_event p BCU t INTER DFT_event p BS t INTER DFT_event p TS t) +
   prob p
     (DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t INTER
      DFT_event p TS t) -
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t) -
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p BS t) -
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p TS t) -
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t) -
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p TS t) -
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BS t INTER
      DFT_event p TS t) -
   prob p
     (DFT_event p TF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t) -
   prob p
     (DFT_event p TF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p TS t) -
   prob p
     (DFT_event p TF t INTER DFT_event p BCU t INTER DFT_event p BS t INTER
      DFT_event p TS t) -
   prob p
     (DFT_event p TF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      DFT_event p BS t INTER DFT_event p TS t) -
   prob p
     (DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t) -
   prob p
     (DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p TS t) -
   prob p
     (DFT_event p EF t INTER DFT_event p BCU t INTER DFT_event p BS t INTER
      DFT_event p TS t) -
   prob p
     (DFT_event p EF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      DFT_event p BS t INTER DFT_event p TS t) -
   prob p
     (DFT_event p BCU t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      DFT_event p BS t INTER DFT_event p TS t) +
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t) +
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p TS t) +
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p BS t INTER DFT_event p TS t) +
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t INTER
      DFT_event p TS t) +
   prob p
     (DFT_event p TF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t INTER
      DFT_event p TS t) +
   prob p
     (DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t INTER
      DFT_event p TS t) -
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t INTER
      DFT_event p TS t)) ``,
		      
RW_TAC std_ss[drive_by_wire_union_list, All_distinct_events_def, MAP, rv_gt0_ninfinity_def]	
THEN `borel = (m_space lborel, measurable_sets lborel)` by METIS_TAC[m_space_def, measurable_sets_def, borel, lborel, PAIR, space_def, subsets_def, sigma_def]
THEN FULL_SIMP_TAC std_ss[]
THEN `{s | s<= t} IN measurable_sets lborel` by METIS_TAC [borel_closed, CLOSED_INTERVAL_RIGHT, CLOSED_INTERVAL_LEFT, measurable_sets_def, subsets_def]
THEN ` DFT_event p BS t IN events p` by RW_TAC std_ss[DFT_event_IN_events_p]
THEN  ` DFT_event p TS t IN events p` by RW_TAC std_ss[DFT_event_IN_events_p]
   
THEN  `DFT_event p PCCU t IN events p` by RW_TAC std_ss [DFT_event_IN_events_p]
THEN  `DFT_event p SCCU_a t IN events p` by RW_TAC std_ss [DFT_event_IN_events_p]
THEN  `DFT_event p SCCU_d t IN events p` by RW_TAC std_ss [DFT_event_IN_events_p]
THEN  `DFT_event p BCU t IN events p`by RW_TAC std_ss [DFT_event_IN_events_p]
THEN  `DFT_event p EF t IN events p` by RW_TAC std_ss [DFT_event_IN_events_p]
THEN  `DFT_event p TF t IN events p` by RW_TAC std_ss [DFT_event_IN_events_p]
THEN `prob_space p` by FULL_SIMP_TAC std_ss[random_variable_def]
THEN  KNOW_TAC(``DFT_event p (WSP PCCU SCCU_a SCCU_d) t IN events p ``)
      THEN1(KNOW_TAC(``WSP PCCU SCCU_a SCCU_d = D_OR (D_AND (SCCU_a)(D_BEFORE PCCU SCCU_a))(D_AND (PCCU)(D_BEFORE SCCU_d PCCU)) ``)   
           THEN1(FULL_SIMP_TAC std_ss[D_AND_def, NEVER_def]
	         THEN RW_TAC std_ss[D_OR_def, D_AND_def,D_BEFORE_def, WSP_def, D_SIMULT_def]
		 THEN KNOW_TAC(`` !s. (
      min
          (min
             (min
                (max (SCCU_a s)
                   (if PCCU s < SCCU_a s then PCCU s else PosInf))
                (max (PCCU s)
                   (if SCCU_d s < PCCU s then SCCU_d s else PosInf)))
             (if PCCU s = SCCU_a s then SCCU_a s else PosInf))
          (if PCCU s = SCCU_d s then SCCU_d s else PosInf)) =
   (
        min (max (SCCU_a s) (if PCCU s < SCCU_a s then PCCU s else PosInf))
          (max (PCCU s) (if SCCU_d s < PCCU s then SCCU_d s else PosInf)))``)
	         THEN1( RW_TAC std_ss[extreal_max_def, extreal_min_def] THEN REPEAT (POP_ASSUM MP_TAC) THEN RW_TAC std_ss[] THEN FULL_SIMP_TAC std_ss[ALL_DISTINCT, MEM] THEN METIS_TAC[lt_infty, le_infty, lt_le, le_lt, lt_trans, le_trans, extreal_lt_def, extreal_le_def, ALL_DISTINCT, MEM])
		 THEN RW_TAC std_ss[])
	 THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]	 
         THEN RW_TAC std_ss[OR_UNION]
	 THEN KNOW_TAC(`` DFT_event p (D_AND SCCU_a (D_BEFORE PCCU SCCU_a)) t IN events p ``)
	      THEN1(RW_TAC std_ss[DFT_event_AFTER_PREIMAGE_GT0, rv_gt0_ninfinity_def]
	            THEN `{(u,w) | u < w /\ 0 <= w /\ w <= t} IN measurable_sets (pair_measure lborel lborel)` by RW_TAC std_ss[after_set_IN_MEASURABLE_SETS_PAIR_lborel]
                  THEN `(\x. (real (PCCU x),real (SCCU_a x))) IN measurable (m_space p, measurable_sets p) (m_space (pair_measure lborel lborel), measurable_sets (pair_measure lborel lborel))`
		       by METIS_TAC[random_variable_def, p_space_def, events_def, m_space_def, measurable_sets_def, measurable_Pair, prob_space_def,  measure_space_lborel, borel, lborel, subsets_def, space_def, sigma_def]
		  THEN METIS_TAC[IN_MEASURABLE, random_variable_def, space_def, m_space_def, subsets_def, measurable_sets_def, events_def, p_space_def])
        THEN DISCH_TAC
	THEN KNOW_TAC(`` DFT_event p (D_AND PCCU (D_BEFORE SCCU_d PCCU)) t IN events p``)
	 THEN1(RW_TAC std_ss[DFT_event_AFTER_PREIMAGE_GT0, rv_gt0_ninfinity_def]
	          THEN `{(u,w) | u < w /\ 0 <= w /\ w <= t} IN measurable_sets (pair_measure lborel lborel)` by RW_TAC std_ss[after_set_IN_MEASURABLE_SETS_PAIR_lborel]
                  THEN `(\x. (real (SCCU_d x),real (PCCU x))) IN measurable (m_space p, measurable_sets p) (m_space (pair_measure lborel lborel), measurable_sets (pair_measure lborel lborel))`
		       by METIS_TAC[random_variable_def, p_space_def, events_def, m_space_def, measurable_sets_def, measurable_Pair, prob_space_def,  measure_space_lborel, borel, lborel, subsets_def, space_def, sigma_def]
		  THEN METIS_TAC[IN_MEASURABLE, random_variable_def, space_def, m_space_def, subsets_def, measurable_sets_def, events_def, p_space_def])
        THEN DISCH_TAC
	THEN METIS_TAC [EVENTS_UNION])
THEN DISCH_TAC

THEN DEP_REWRITE_TAC[PROB_PIE_63]
THEN RW_TAC std_ss[]);


val WSP_PREIMAGE = store_thm("WSP_PREIMAGE",
  ``  !Y X_a X_d p t.
            {s |
            Y s < X_a s /\ X_a s <= Normal t /\ 0 <= Y s /\ Y s <= Normal t} INTER
            p_space p UNION
            {s | X_d s < Y s /\ Y s <= Normal t} INTER p_space p =
            PREIMAGE (\x. (Y x,X_a x,X_d x))
              {(y,xa,xd) |
              y < xa /\ xa <= Normal t /\ 0 <= y /\ y <= Normal t \/
              xd < y /\ y <= Normal t} INTER p_space p``,  

SRW_TAC [] [GSPECIFICATION, EXTENSION, PREIMAGE_def]
THEN EQ_TAC
     THEN1(RW_TAC std_ss[]
           THEN1(Q.EXISTS_TAC `(Y x, X_a x, X_d x)`
	         THEN RW_TAC std_ss[PAIR, LAMBDA_PROD])
	   THEN1(RW_TAC std_ss[])	 
	   THEN1( Q.EXISTS_TAC `(Y x, X_a x, X_d x)`	 
	   	THEN RW_TAC std_ss[PAIR, LAMBDA_PROD])
	  THEN RW_TAC std_ss[])	
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``(\ (y,xa,xd).
         ((y,xa,xd),
          y < xa /\ xa <= Normal t /\ 0 <= y /\ y <= Normal t \/
          xd < y /\ y <= Normal t)) x' =
	 ((x'),
          FST x' < FST(SND x') /\ (FST (SND x')) <= Normal t /\ 0 <= FST x' /\ FST x' <= Normal t \/
          (SND (SND x')) < FST x' /\ FST x' <= Normal t)``)

	 THEN1(`x':extreal#extreal#extreal = (FST x', FST(SND(x')), SND(SND x'))` by RW_TAC std_ss[PAIR]
              THEN ONCE_ASM_REWRITE_TAC[]THEN RW_TAC std_ss[PAIR, LAMBDA_PROD])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]
     THEN1(FULL_SIMP_TAC std_ss[PAIR]

      THEN `FST (SND x') = X_a x` by RW_TAC std_ss[PAIR, LAMBDA_PROD]
      THEN `FST x' = Y x` by RW_TAC std_ss[PAIR]
      THEN  DISJ1_TAC   THEN FULL_SIMP_TAC std_ss[] )
THEN `SND (SND x') = X_d x` by RW_TAC std_ss[PAIR, LAMBDA_PROD]
THEN `FST x' = Y x` by RW_TAC std_ss[PAIR]
THEN  DISJ2_TAC   THEN FULL_SIMP_TAC std_ss[]);


val PREIMAGE_EXTREAL_REAL_3RV_WSP = store_thm("PREIMAGE_EXTREAL_REAL_3RV_WSP",
   `` !Y X_a X_d p t.(!s. X_a s <> PosInf /\ 0 <= X_a s /\ 0 <= X_d s /\X_d s <> PosInf /\ Y s <> PosInf /\ 0 <= Y s) /\ 0<= t==>
        ((PREIMAGE (\x. (Y x,X_a x,X_d x))
        {(y',xa',xd') |
        y' < xa' /\ xa' <= Normal t /\ 0 <= y' /\ y' <= Normal t \/
        xd' < y' /\ y' <= Normal t} INTER p_space p) =

        (PREIMAGE (\x. (real (Y x), real (X_a x),real (X_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <=  t \/
        xd < y /\ y <=  t} INTER p_space p))``,

RW_TAC std_ss [PREIMAGE_def]
THEN KNOW_TAC(`` !x. (Y x,X_a x,X_d x) IN
   {(y',xa',xd') |
   y' < xa' /\ xa' <= Normal t /\ 0 <= y' /\ y' <= Normal t \/
   xd' < y' /\ y' <= Normal t} =
                       Y x < X_a x /\ X_a x <= Normal t /\ 0 <= Y x /\ Y x <= Normal t \/
   X_d x < Y x /\ Y x <= Normal t``)
THEN1(RW_TAC std_ss [IN_ELIM_PAIR_THM_2, PAIR])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN KNOW_TAC(`` !x. (real (Y x),real (X_a x),real (X_d x)) IN
                {(y,xa,xd) | y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} =
   
                       real (Y x) < real (X_a x) /\ real (X_a x) <= t /\ 0 <= real (Y x) /\ real (Y x) <= t \/ real (X_d x) < real (Y x) /\ real (Y x )<=  t``)
THEN1(RW_TAC std_ss [IN_ELIM_PAIR_THM_2])
THEN DISCH_TAC
THEN ASM_REWRITE_TAC[]
THEN SRW_TAC [] [GSPECIFICATION, EXTENSION]
THEN EQ_TAC
    THEN1 (KNOW_TAC (``X_a x <> NegInf ``)
      	    THEN1 (METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
      	    THEN DISCH_TAC
      	    THEN KNOW_TAC (``Y x <> NegInf ``)
      	    THEN1 (METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
      	    THEN DISCH_TAC
      	    THEN  KNOW_TAC (``X_d x <> NegInf ``)
      	    THEN1 (METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
      	    THEN DISCH_TAC
      	   THEN RW_TAC std_ss[real_def]
           THEN1(  SELECT_ELIM_TAC
                   THEN RW_TAC std_ss []
                        THEN1 (Q.EXISTS_TAC `real (Y x)`
      	    	        THEN METIS_TAC [normal_real])
 	           THEN  SELECT_ELIM_TAC
	           THEN  RW_TAC std_ss[]
	                THEN1 (Q.EXISTS_TAC `real (X_a x)`
      	    	        THEN METIS_TAC [normal_real])
	   THEN SELECT_ELIM_TAC		
	   THEN RW_TAC std_ss[]
	       THEN1 (Q.EXISTS_TAC `real (X_d x)`
      	    	        THEN METIS_TAC [normal_real])
	   
	   THEN METIS_TAC [extreal_le_eq,extreal_lt_eq, extreal_of_num_def])
       THEN KNOW_TAC (``X_a x <> NegInf ``)
      	    THEN1 (METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
       THEN DISCH_TAC
       THEN KNOW_TAC (``Y x <> NegInf ``)
           THEN1 (METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
       THEN DISCH_TAC
       THEN  KNOW_TAC (``X_d x <> NegInf ``)
      	    THEN1 (METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
       THEN DISCH_TAC
       THEN RW_TAC std_ss[real_def]
       THEN SELECT_ELIM_TAC
       THEN RW_TAC std_ss []
           THEN1 (Q.EXISTS_TAC `real (Y x)`
                 THEN METIS_TAC [normal_real])
       THEN SELECT_ELIM_TAC
       THEN RW_TAC std_ss []
           THEN1 (Q.EXISTS_TAC `real (X_a x)`
                 THEN METIS_TAC [normal_real])
       THEN SELECT_ELIM_TAC
       THEN RW_TAC std_ss []
           THEN1 (Q.EXISTS_TAC `real (X_d x)`
                 THEN METIS_TAC [normal_real])
		 		 		 
      THEN METIS_TAC [extreal_le_eq,extreal_lt_eq, extreal_of_num_def])
THEN KNOW_TAC (``X_a x <> NegInf ``)
      	    THEN1 (METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
 THEN DISCH_TAC
THEN KNOW_TAC (``Y x <> NegInf ``)
      	    THEN1 (METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
THEN DISCH_TAC
THEN  KNOW_TAC (``X_d x <> NegInf ``)
      	    THEN1 (METIS_TAC [extreal_real_le, lt_infty,extreal_of_num_def,extreal_le_def, extreal_lt_def, lt_le, le_lt, le_infty ])
THEN DISCH_TAC
THEN RW_TAC std_ss[]
     THEN1( UNDISCH_TAC(``real (Y x) <= t``)
           THEN REWRITE_TAC [real_def]
	   THEN SELECT_ELIM_TAC
	   THEN RW_TAC std_ss[]
	       THEN1 (Q.EXISTS_TAC`real (Y x)`
      	            THEN METIS_TAC[normal_real])
           THEN UNDISCH_TAC(``real (X_a x) <= t``)
	   THEN REWRITE_TAC [real_def]
	   THEN SELECT_ELIM_TAC
	   THEN RW_TAC std_ss[]
	        THEN1 (Q.EXISTS_TAC`real (X_a x)`
      		       THEN METIS_TAC[normal_real])
	    THEN DISJ1_TAC
            THEN METIS_TAC [extreal_le_eq, extreal_lt_eq, extreal_real_lt, extreal_real_le])
THEN UNDISCH_TAC(``real (Y x) <= t``)
THEN REWRITE_TAC [real_def]
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
    THEN1 (Q.EXISTS_TAC`real (Y x)`
           THEN METIS_TAC[normal_real])

THEN METIS_TAC [extreal_le_eq, extreal_lt_eq, extreal_real_lt, extreal_real_le]);

val normal_real_mul = store_thm("normal_real_mul",
  `` !x y. x <> PosInf /\ x <> NegInf /\ y <> PosInf /\ y<> NegInf==>
           (Normal (real x * real y ) = Normal (real x) * Normal (real y))``,
REPEAT Cases
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss [real_def]
THEN METIS_TAC[extreal_mul_def]);



val indep_vars_7_def = Define `  indep_vars_7 p M A0 A1 A2 A3 A4 A5 A6=
     indep_vars p (\i. M)
       (\i.
          if i = 0 then A0
          else if i = 1 then A1
          else if i = 2 then A2
          else if i = 3 then A3
          else if i = 4 then A4
          else if i = 5 then A5
          else  A6) {0; 1; 2; 3; 4; 5; 6}`;

val indep_vars_sets_drive_def = Define `
 indep_vars_sets_drive [A0; A1; A2; A3; A4; A5; A6; A7] p t =
     indep_vars_7 p lborel (\s. real (A0 s)) (\s. real (A1 s))
       (\s. real (A2 s)) (\s. real (A4 s)) (\s. real (A5 s))
       (\s. real (A6 s)) (\s. real (A7 s)) /\
     indep_sets p
       (\i.
          {if i = 0 then
             PREIMAGE (\s. real (A0 s)) {u | u <= t} INTER p_space p
           else if i = 1 then
             PREIMAGE (\s. real (A1 s)) {u | u <= t} INTER p_space p
           else if i = 2 then
             PREIMAGE (\s. (real (A2 s) , real (A3 s), real (A4 s)))
	         {(y,xa,xd)| y < xa /\ xa <=  t /\ 0<= y /\ y <=  t \/ xd < y /\ y <= t}INTER p_space p
	   else if i = 3 then
	    PREIMAGE (\s. real (A5 s)){u | u<=t} INTER p_space p
	   else if i = 4 then
             PREIMAGE (\s. real (A6 s)) {u | u <= t} INTER p_space p
           else
	      PREIMAGE (\s. real (A7 s)) {u | u <= t} INTER p_space p})
       {0; 1; 2; 3; 4; 5}`;


val dbw_event_req_def = Define `dbw_event_req BS TS PCCU SCCU_a SCCU_d BCU EF TF p t f_pccu f_cond f_sccu_pccu = (!s.
               ALL_DISTINCT
                 [BS s; TS s;  PCCU s; SCCU_a s; SCCU_d s;
                  BCU s; EF s; TF s]) /\
          All_distinct_events p
            [ TF; EF; BCU;
             WSP PCCU SCCU_a SCCU_d;  BS; TS] t /\
                    rv_gt0_ninfinity
            [BS; TS;  PCCU; SCCU_a; SCCU_d; BCU; EF; TF]  /\
	    DISJOINT_WSP PCCU SCCU_a SCCU_d t /\
	    random_variable (\x. real (SCCU_a x)) p borel /\
	    (!y.
             cond_density lborel lborel p (\s. real (SCCU_a s))
               (\s. real (PCCU s)) y f_sccu_pccu f_pccu f_cond) /\
        den_gt0_ninfinity f_sccu_pccu f_pccu f_cond /\
        indep_var p lborel (\s. real (SCCU_d s)) lborel (\s. real (PCCU s)) /\
        cont_CDF p (\s. real (SCCU_d s)) /\
        measurable_CDF p (\s. real (SCCU_d s)) /\
       
  	  indep_vars_sets_drive [BS; TS; PCCU; SCCU_a; SCCU_d; BCU; EF; TF] p t `;

val prob_drive_by_wire_initial2 = store_thm ("prob_drive_by_wire_initial2",
  ``!BS TS PCCU SCCU_a SCCU_d BCU EF TF p t f_pccu f_cond f_sccu_pccu .
        0<=t /\ dbw_event_req BS TS PCCU SCCU_a SCCU_d BCU EF TF p t f_pccu f_cond f_sccu_pccu
           ==>
	    (prob p
          (DFT_event p
             (D_OR (D_OR (D_OR (D_OR TF EF) (WSP PCCU SCCU_a SCCU_d)) BCU)
                (D_OR TS BS)) t) =  CDF p (\s. real (TF s)) t + CDF p (\s. real (EF s)) t +
   CDF p (\s. real (BCU s)) t +
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) + CDF p (\s. real (BS s)) t +
   CDF p (\s. real (TS s)) t -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t -
   CDF p (\s. real (TF s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (BS s)) t -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (TS s)) t -
   CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t -
   CDF p (\s. real (EF s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) -
   CDF p (\s. real (EF s)) t * CDF p (\s. real (BS s)) t -
   CDF p (\s. real (EF s)) t * CDF p (\s. real (TS s)) t -
   CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) -
   CDF p (\s. real (BCU s)) t * CDF p (\s. real (BS s)) t -
   CDF p (\s. real (BCU s)) t * CDF p (\s. real (TS s)) t -
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t -
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (TS s)) t -
   CDF p (\s. real (BS s)) t * CDF p (\s. real (TS s)) t +
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   CDF p (\s. real (BCU s)) t +
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) +
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   CDF p (\s. real (BS s)) t +
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   CDF p (\s. real (TS s)) t +
   CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) +
   CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
   CDF p (\s. real (BS s)) t +
   CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
   CDF p (\s. real (TS s)) t +
   CDF p (\s. real (TF s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t +
   CDF p (\s. real (TF s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (TS s)) t +
   CDF p (\s. real (TF s)) t * CDF p (\s. real (BS s)) t *
   CDF p (\s. real (TS s)) t +
   CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) +
   CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
   CDF p (\s. real (BS s)) t +
   CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
   CDF p (\s. real (TS s)) t +
   CDF p (\s. real (EF s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t +
   CDF p (\s. real (EF s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (TS s)) t +
   CDF p (\s. real (EF s)) t * CDF p (\s. real (BS s)) t *
   CDF p (\s. real (TS s)) t +
   CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t +
   CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (TS s)) t +
   CDF p (\s. real (BCU s)) t * CDF p (\s. real (BS s)) t *
   CDF p (\s. real (TS s)) t +
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t *
   CDF p (\s. real (TS s)) t -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   CDF p (\s. real (BCU s)) t * CDF p (\s. real (BS s)) t -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   CDF p (\s. real (BCU s)) t * CDF p (\s. real (TS s)) t -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (TS s)) t -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   CDF p (\s. real (BS s)) t * CDF p (\s. real (TS s)) t -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (TS s)) t -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
   CDF p (\s. real (BS s)) t * CDF p (\s. real (TS s)) t -
   CDF p (\s. real (TF s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t *
   CDF p (\s. real (TS s)) t -
   CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t -
   CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (TS s)) t -
   CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
   CDF p (\s. real (BS s)) t * CDF p (\s. real (TS s)) t -
   CDF p (\s. real (EF s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t *
   CDF p (\s. real (TS s)) t -
   CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t *
   CDF p (\s. real (TS s)) t +
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t) +
   prob p
     (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
      DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p TS t) +
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   CDF p (\s. real (BCU s)) t * CDF p (\s. real (BS s)) t *
   CDF p (\s. real (TS s)) t +
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t *
   CDF p (\s. real (TS s)) t +
   CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t *
   CDF p (\s. real (TS s)) t +
   CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t *
   CDF p (\s. real (TS s)) t -
   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
   CDF p (\s. real (BCU s)) t *
   (pos_fn_integral lborel
      (\pccu.
           indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
           f_pccu pccu *
           pos_fn_integral lborel
             (\sccu_a.
                  indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t}
                    sccu_a * f_cond pccu sccu_a)) +
    pos_fn_integral lborel
      (\pccu.
           f_pccu pccu *
           (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
            CDF p (\s. real (SCCU_d s)) pccu))) * CDF p (\s. real (BS s)) t *
   CDF p (\s. real (TS s)) t )``,


RW_TAC std_ss[dbw_event_req_def]
THEN KNOW_TAC(``borel = (m_space lborel, measurable_sets lborel)  ``) THEN1(RW_TAC std_ss[borel, lborel, m_space_def, space_def, measurable_sets_def, subsets_def, sigma_def, PAIR])
THEN DISCH_TAC
THEN `random_variable (\x. real (TF x)) p borel`
     by (FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def, indep_vars]
           THEN UNDISCH_TAC (``!i:num.
             i IN {0; 1; 2; 3; 4; 5; 6} ==>
             random_variable
               (if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))) p
               (m_space lborel,measurable_sets lborel) ``)
	   THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `6:num`)  THEN PSET_TAC[])
THEN `random_variable (\x. real (EF x)) p borel`
     by (FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def, indep_vars]
           THEN UNDISCH_TAC (``!i:num.
             i IN {0; 1; 2; 3; 4; 5; 6} ==>
             random_variable
               (if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))) p
               (m_space lborel,measurable_sets lborel) ``)
	   THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5:num`)  THEN PSET_TAC[])
THEN `random_variable (\x. real (BCU x)) p borel`
     by (FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def, indep_vars]
           THEN UNDISCH_TAC (``!i:num.
             i IN {0; 1; 2; 3; 4; 5; 6} ==>
             random_variable
               (if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))) p
               (m_space lborel,measurable_sets lborel) ``)
	   THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `4:num`)  THEN PSET_TAC[])

THEN `random_variable (\x. real (SCCU_d x)) p borel`
     by (FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def, indep_vars]
           THEN UNDISCH_TAC (``!i:num.
             i IN {0; 1; 2; 3; 4; 5; 6} ==>
             random_variable
               (if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))) p
               (m_space lborel,measurable_sets lborel) ``)
	   THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num`)  THEN PSET_TAC[])
	   
THEN `random_variable (\x. real (PCCU x)) p borel`
     by (FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def, indep_vars]
           THEN UNDISCH_TAC (``!i:num.
             i IN {0; 1; 2; 3; 4; 5; 6} ==>
             random_variable
               (if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))) p
               (m_space lborel,measurable_sets lborel) ``)
	   THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num`)  THEN PSET_TAC[])
	   
THEN `random_variable (\x. real (TS x)) p borel`
     by (FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def, indep_vars]
           THEN UNDISCH_TAC (``!i:num.
             i IN {0; 1; 2; 3; 4; 5; 6} ==>
             random_variable
               (if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))) p
               (m_space lborel,measurable_sets lborel) ``)
	   THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num`)  THEN PSET_TAC[])
	   
THEN `random_variable (\x. real (BS x)) p borel`
     by (FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def, indep_vars]
           THEN UNDISCH_TAC (``!i:num.
             i IN {0; 1; 2; 3; 4; 5; 6} ==>
             random_variable
               (if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))) p
               (m_space lborel,measurable_sets lborel) ``)
	   THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num`)  THEN PSET_TAC[])
THEN `PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p IN events p` by
      (REWRITE_TAC [events_def]
               THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	       	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
		THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
		THEN REWRITE_TAC [p_space_def, m_space_def]
		THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def, EVENTS_INTER, EVENTS_SPACE, m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def])
THEN `PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p IN events p` by
      (REWRITE_TAC [events_def]
               THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	       	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
		THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
		THEN REWRITE_TAC [p_space_def, m_space_def]
		THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def, EVENTS_INTER, EVENTS_SPACE, m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def])
THEN `PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p IN events p` by
      (REWRITE_TAC [events_def]
               THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	       	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
		THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
		THEN REWRITE_TAC [p_space_def, m_space_def]
		THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def, EVENTS_INTER, EVENTS_SPACE, m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def])
THEN `PREIMAGE (\s. real (SCCU_d s)) {u | u <= t} INTER p_space p IN events p` by
      (REWRITE_TAC [events_def]
               THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	       	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
		THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
		THEN REWRITE_TAC [p_space_def, m_space_def]
		THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def, EVENTS_INTER, EVENTS_SPACE, m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def])
THEN  `PREIMAGE (\s. real (SCCU_a s)) {u | u <= t} INTER p_space p IN events p` by
      (REWRITE_TAC [events_def]
               THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	       	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
		THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
		THEN REWRITE_TAC [p_space_def, m_space_def]
		THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def, EVENTS_INTER, EVENTS_SPACE, m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def])
THEN `PREIMAGE (\s. real (PCCU s)) {u | u <= t} INTER p_space p IN events p` by
      (REWRITE_TAC [events_def]
               THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	       	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
		THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
		THEN REWRITE_TAC [p_space_def, m_space_def]
		THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def, EVENTS_INTER, EVENTS_SPACE, m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def])
THEN `PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p IN events p` by
      (REWRITE_TAC [events_def]
               THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	       	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
		THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
		THEN REWRITE_TAC [p_space_def, m_space_def]
		THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def, EVENTS_INTER, EVENTS_SPACE, m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def])
THEN `PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p IN events p` by
      (REWRITE_TAC [events_def]
               THEN KNOW_TAC(``measurable_sets p = subsets (p_space p, measurable_sets p)``) THEN1(
	       	    		RW_TAC std_ss [p_space_def, measurable_sets_def, subsets_def])
		THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
		THEN REWRITE_TAC [p_space_def, m_space_def]
		THEN METIS_TAC [random_variable_def, IN_MEASURABLE, events_def, subsets_def, p_space_def, measurable_sets_def, EVENTS_INTER, EVENTS_SPACE, m_space_def, space_def, events_def, lborel_le,lborel, borel, sigma_def])
THEN `prob_space p` by FULL_SIMP_TAC std_ss[random_variable_def]
THEN KNOW_TAC(`` PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
     {(y,xa,xd) | y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
   p_space p IN events p``)
      THEN1(FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
            THEN RW_TAC std_ss[GSYM PREIMAGE_EXTREAL_REAL_3RV_WSP]
             THEN `(!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s])` by FULL_SIMP_TAC std_ss[ALL_DISTINCT, MEM]
	     THEN REWRITE_TAC[ GSYM WSP_PREIMAGE]
	   
	     THEN `{s |
   PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0 <= PCCU s /\
   PCCU s <= Normal t} INTER p_space p UNION
   {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p = DFT_event p (WSP PCCU SCCU_a SCCU_d) t ` by METIS_TAC[GSYM WSP_DFT_event, rv_gt0_ninfinity_def]
             THEN ONCE_ASM_REWRITE_TAC[]
	     THEN KNOW_TAC(``WSP PCCU SCCU_a SCCU_d = D_OR (D_AND (SCCU_a)(D_BEFORE PCCU SCCU_a))(D_AND (PCCU)(D_BEFORE SCCU_d PCCU)) ``)   
           THEN1(FULL_SIMP_TAC std_ss[D_AND_def, NEVER_def]
	         THEN RW_TAC std_ss[D_OR_def, D_AND_def,D_BEFORE_def, WSP_def, D_SIMULT_def]
		 THEN KNOW_TAC(`` !s. (
      min
          (min
             (min
                (max (SCCU_a s)
                   (if PCCU s < SCCU_a s then PCCU s else PosInf))
                (max (PCCU s)
                   (if SCCU_d s < PCCU s then SCCU_d s else PosInf)))
             (if PCCU s = SCCU_a s then SCCU_a s else PosInf))
          (if PCCU s = SCCU_d s then SCCU_d s else PosInf)) =
   (
        min (max (SCCU_a s) (if PCCU s < SCCU_a s then PCCU s else PosInf))
          (max (PCCU s) (if SCCU_d s < PCCU s then SCCU_d s else PosInf)))``)
	         THEN1( RW_TAC std_ss[extreal_max_def, extreal_min_def] THEN REPEAT (POP_ASSUM MP_TAC) THEN RW_TAC std_ss[] THEN FULL_SIMP_TAC std_ss[ALL_DISTINCT, MEM] THEN METIS_TAC[lt_infty, le_infty, lt_le, le_lt, lt_trans, le_trans, extreal_lt_def, extreal_le_def, ALL_DISTINCT, MEM])
		 THEN RW_TAC std_ss[])
	 THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]	 
         THEN RW_TAC std_ss[OR_UNION]
	 THEN KNOW_TAC(`` DFT_event p (D_AND SCCU_a (D_BEFORE PCCU SCCU_a)) t IN events p ``)
	      THEN1(FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
	            THEN RW_TAC std_ss[DFT_event_AFTER_PREIMAGE_GT0, rv_gt0_ninfinity_def]
	            THEN `{(u,w) | u < w /\ 0 <= w /\ w <= t} IN measurable_sets (pair_measure lborel lborel)` by RW_TAC std_ss[after_set_IN_MEASURABLE_SETS_PAIR_lborel]
                  THEN `(\x. (real (PCCU x),real (SCCU_a x))) IN measurable (m_space p, measurable_sets p) (m_space (pair_measure lborel lborel), measurable_sets (pair_measure lborel lborel))`
		       by METIS_TAC[random_variable_def, p_space_def, events_def, m_space_def, measurable_sets_def, measurable_Pair, prob_space_def,  measure_space_lborel, borel, lborel, subsets_def, space_def, sigma_def]
		  THEN METIS_TAC[IN_MEASURABLE, random_variable_def, space_def, m_space_def, subsets_def, measurable_sets_def, events_def, p_space_def])
        THEN DISCH_TAC
	THEN KNOW_TAC(`` DFT_event p (D_AND PCCU (D_BEFORE SCCU_d PCCU)) t IN events p``)
	 THEN1(FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
	       THEN RW_TAC std_ss[DFT_event_AFTER_PREIMAGE_GT0, rv_gt0_ninfinity_def]
	       THEN `{(u,w) | u < w /\ 0 <= w /\ w <= t} IN measurable_sets (pair_measure lborel lborel)` by RW_TAC std_ss[after_set_IN_MEASURABLE_SETS_PAIR_lborel]
               THEN `(\x. (real (SCCU_d x),real (PCCU x))) IN measurable (m_space p, measurable_sets p) (m_space (pair_measure lborel lborel), measurable_sets (pair_measure lborel lborel))`
		       by METIS_TAC[random_variable_def, p_space_def, events_def, m_space_def, measurable_sets_def, measurable_Pair, prob_space_def,  measure_space_lborel, borel, lborel, subsets_def, space_def, sigma_def]
	       THEN METIS_TAC[IN_MEASURABLE, random_variable_def, space_def, m_space_def, subsets_def, measurable_sets_def, events_def, p_space_def])
        THEN DISCH_TAC
	THEN DEP_REWRITE_TAC [EVENTS_UNION]
	THEN RW_TAC std_ss[])
	
THEN DISCH_TAC

THEN DEP_REWRITE_TAC [prob_drive_by_wire_PIE]
THEN RW_TAC std_ss[]
THEN ` prob p (DFT_event p TF t) = CDF p (\s. real (TF s)) t` by (FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def] THEN RW_TAC std_ss[GSYM CDF_prob_DFT_event])
THEN ` prob p (DFT_event p EF t) = CDF p (\s. real (EF s)) t` by (FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def] THEN RW_TAC std_ss[GSYM CDF_prob_DFT_event])
THEN ` prob p (DFT_event p BCU t) = CDF p (\s. real (BCU s)) t` by (FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def] THEN RW_TAC std_ss[GSYM CDF_prob_DFT_event])

THEN ` prob p (DFT_event p BS t) = CDF p (\s. real (BS s)) t` by (FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def] THEN RW_TAC std_ss[GSYM CDF_prob_DFT_event])

THEN ` prob p (DFT_event p TS t) = CDF p (\s. real (TS s)) t` by (FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def] THEN RW_TAC std_ss[GSYM CDF_prob_DFT_event])
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``{u|u<=t:real} IN measurable_sets lborel``)
     THEN1( RW_TAC std_ss [lborel_le])
THEN DISCH_TAC  
THEN KNOW_TAC(``{u|u<=t:real} IN subsets borel``)
     THEN1( METIS_TAC [measurable_sets_def, lborel, borel , subsets_def, sigma_def])
THEN DISCH_TAC

THEN KNOW_TAC(``prob p (DFT_event p TF t INTER DFT_event p EF t) =
                 CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t``)
     THEN1( RW_TAC std_ss [GSYM AND_INTER]
            THEN DEP_REWRITE_TAC[PROB_AND]
	    THEN FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def]
	    THEN MP_TAC(Q.ISPECL [`(\i:num.
                if i = 0 then (\s. real ((BS:'a->extreal) s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s)))`, `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `lborel`, `6:num`, `5:num`, `{0;1;2;3;4;5;6:num}`] indep_vars_var)
		THEN ` (6 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 5 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 6:num <> 5)` by ASM_SET_TAC[]
		THEN RW_TAC std_ss[]
		THEN METIS_TAC[rv_gt0_ninfinity_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]		
THEN  WEAKEN_TAC is_eq 

THEN KNOW_TAC(`` prob p (DFT_event p TF t INTER DFT_event p BCU t) =
     		 CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t``)
     THEN1( RW_TAC std_ss [GSYM AND_INTER]
            THEN DEP_REWRITE_TAC[PROB_AND]
	    THEN FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def]
	    THEN MP_TAC(Q.ISPECL [`(\i:num.
                if i = 0 then (\s. real ((BS:'a->extreal) s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s)))`, `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `lborel`, `6:num`, `4:num`, `{0;1;2;3;4;5;6:num}`] indep_vars_var)
		THEN ` (6 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 4 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 6:num <> 4)` by ASM_SET_TAC[]
		THEN RW_TAC std_ss[]
		THEN METIS_TAC[rv_gt0_ninfinity_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]		
THEN  WEAKEN_TAC is_eq 

THEN KNOW_TAC(`` prob p (DFT_event p TF t INTER DFT_event p BS t)=
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (BS s)) t``)
     THEN1( RW_TAC std_ss [GSYM AND_INTER]
            THEN DEP_REWRITE_TAC[PROB_AND]
	    THEN FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def]
	    THEN MP_TAC(Q.ISPECL [`(\i:num.
                if i = 0 then (\s. real ((BS:'a->extreal) s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s)))`, `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `lborel`, `6:num`, `0:num`, `{0;1;2;3;4;5;6:num}`] indep_vars_var)
		THEN ` (6 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 0 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 6:num <> 0)` by ASM_SET_TAC[]
		THEN RW_TAC std_ss[]
		THEN METIS_TAC[rv_gt0_ninfinity_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]		
THEN WEAKEN_TAC is_eq 



THEN KNOW_TAC(`` prob p (DFT_event p TF t INTER DFT_event p TS t)=
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (TS s)) t``)
     THEN1( RW_TAC std_ss [GSYM AND_INTER]
            THEN DEP_REWRITE_TAC[PROB_AND]
	    THEN FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def]
	    THEN MP_TAC(Q.ISPECL [`(\i:num.
                if i = 0 then (\s. real ((BS:'a->extreal) s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s)))`, `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `lborel`, `6:num`, `1:num`, `{0;1;2;3;4;5;6:num}`] indep_vars_var)
		THEN ` (6 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 1 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 6:num <> 1)` by ASM_SET_TAC[]
		THEN RW_TAC std_ss[]
		THEN METIS_TAC[rv_gt0_ninfinity_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]		
THEN WEAKEN_TAC is_eq 


THEN KNOW_TAC(`` prob p (DFT_event p EF t INTER DFT_event p BCU t)=
 		 CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t``)
     THEN1( RW_TAC std_ss [GSYM AND_INTER]
            THEN DEP_REWRITE_TAC[PROB_AND]
	    THEN FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def]
	    THEN MP_TAC(Q.ISPECL [`(\i:num.
                if i = 0 then (\s. real ((BS:'a->extreal) s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s)))`, `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `lborel`, `5:num`, `4:num`, `{0;1;2;3;4;5;6:num}`] indep_vars_var)
		THEN ` (5 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 4 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 5:num <> 4)` by ASM_SET_TAC[]
		THEN RW_TAC std_ss[]
		THEN METIS_TAC[rv_gt0_ninfinity_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]		
THEN WEAKEN_TAC is_eq 

THEN KNOW_TAC(`` prob p (DFT_event p EF t INTER DFT_event p BS t)=
 		 CDF p (\s. real (EF s)) t * CDF p (\s. real (BS s)) t``)
     THEN1( RW_TAC std_ss [GSYM AND_INTER]
            THEN DEP_REWRITE_TAC[PROB_AND]
	    THEN FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def]
	    THEN MP_TAC(Q.ISPECL [`(\i:num.
                if i = 0 then (\s. real ((BS:'a->extreal) s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s)))`, `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `lborel`, `5:num`, `0:num`, `{0;1;2;3;4;5;6:num}`] indep_vars_var)
		THEN ` (5 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 0 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 5:num <> 0)` by ASM_SET_TAC[]
		THEN RW_TAC std_ss[]
		THEN METIS_TAC[rv_gt0_ninfinity_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]		
THEN WEAKEN_TAC is_eq 

THEN  KNOW_TAC(`` prob p (DFT_event p EF t INTER DFT_event p TS t)=
 		 CDF p (\s. real (EF s)) t * CDF p (\s. real (TS s)) t``)
     THEN1( RW_TAC std_ss [GSYM AND_INTER]
            THEN DEP_REWRITE_TAC[PROB_AND]
	    THEN FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def]
	    THEN MP_TAC(Q.ISPECL [`(\i:num.
                if i = 0 then (\s. real ((BS:'a->extreal) s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s)))`, `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `lborel`, `5:num`, `1:num`, `{0;1;2;3;4;5;6:num}`] indep_vars_var)
		THEN ` (5 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 1 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 5:num <> 1)` by ASM_SET_TAC[]
		THEN RW_TAC std_ss[]
		THEN METIS_TAC[rv_gt0_ninfinity_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]		
THEN WEAKEN_TAC is_eq 
			

THEN KNOW_TAC(`` prob p (DFT_event p BCU t INTER DFT_event p BS t)=
 		 CDF p (\s. real (BCU s)) t * CDF p (\s. real (BS s)) t``)
     THEN1( RW_TAC std_ss [GSYM AND_INTER]
            THEN DEP_REWRITE_TAC[PROB_AND]
	    THEN FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def]
	    THEN MP_TAC(Q.ISPECL [`(\i:num.
                if i = 0 then (\s. real ((BS:'a->extreal) s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s)))`, `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `lborel`, `4:num`, `0:num`, `{0;1;2;3;4;5;6:num}`] indep_vars_var)
		THEN ` (4 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 0 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 4:num <> 0)` by ASM_SET_TAC[]
		THEN RW_TAC std_ss[]
		THEN METIS_TAC[rv_gt0_ninfinity_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]		
THEN WEAKEN_TAC is_eq 

THEN KNOW_TAC(`` prob p (DFT_event p BCU t INTER DFT_event p TS t)=
 		 CDF p (\s. real (BCU s)) t * CDF p (\s. real (TS s)) t``)
     THEN1( RW_TAC std_ss [GSYM AND_INTER]
            THEN DEP_REWRITE_TAC[PROB_AND]
	    THEN FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def]
	    THEN MP_TAC(Q.ISPECL [`(\i:num.
                if i = 0 then (\s. real ((BS:'a->extreal) s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s)))`, `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `lborel`, `4:num`, `1:num`, `{0;1;2;3;4;5;6:num}`] indep_vars_var)
		THEN ` (4 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 1 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 4:num <> 1)` by ASM_SET_TAC[]
		THEN RW_TAC std_ss[]
		THEN METIS_TAC[rv_gt0_ninfinity_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]		
THEN WEAKEN_TAC is_eq 

THEN KNOW_TAC(`` prob p (DFT_event p BS t INTER DFT_event p TS t)=
 		 CDF p (\s. real (BS s)) t * CDF p (\s. real (TS s)) t``)
     THEN1( RW_TAC std_ss [GSYM AND_INTER]
            THEN DEP_REWRITE_TAC[PROB_AND]
	    THEN FULL_SIMP_TAC std_ss[indep_vars_sets_drive_def, indep_vars_7_def]
	    THEN MP_TAC(Q.ISPECL [`(\i:num.
                if i = 0 then (\s. real ((BS:'a->extreal) s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s)))`, `p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `lborel`, `0:num`, `1:num`, `{0;1;2;3;4;5;6:num}`] indep_vars_var)
		THEN ` (0 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 1 IN {0; 1; 2; 3; 4; 5; 6:num} /\ 0:num <> 1)` by ASM_SET_TAC[]
		THEN RW_TAC std_ss[]
		THEN METIS_TAC[rv_gt0_ninfinity_def])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]		
THEN WEAKEN_TAC is_eq 
THEN `!X. {s| X s <= Normal t} = PREIMAGE X {s | s <= Normal t}` by SRW_TAC [] [GSPECIFICATION, EXTENSION, PREIMAGE_def]
THEN FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def, indep_vars_sets_drive_def, indep_vars_7_def]
THEN `prob_space p` by FULL_SIMP_TAC std_ss[random_variable_def]
THEN KNOW_TAC(`` prob p (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t)=
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
		 CDF p (\s. real (BCU s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `6:num`,`5:num`,`4:num`  ]  prob_prod_any_3_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [6:num;5;4]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{6; 5; 4} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq


THEN KNOW_TAC(``prob p (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BS t) =
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
		 CDF p (\s. real (BS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `6:num`,`5:num`,`0:num`  ]  prob_prod_any_3_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [6:num;5;0]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{6; 5; 0} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN  KNOW_TAC(``prob p (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p TS t) =
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
		 CDF p (\s. real (TS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `6:num`,`5:num`,`1:num`  ]  prob_prod_any_3_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [6:num;5;1]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{6; 5; 1} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN  KNOW_TAC(``prob p (DFT_event p TF t INTER DFT_event p BCU t INTER DFT_event p BS t) =
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
		 CDF p (\s. real (BS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `6:num`,`4:num`,`0:num`  ]  prob_prod_any_3_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [6:num;4;0]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{6; 4; 0} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN KNOW_TAC(``prob p (DFT_event p TF t INTER DFT_event p BCU t INTER DFT_event p TS t) =
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
		 CDF p (\s. real (TS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `6:num`,`4:num`,`1:num`  ]  prob_prod_any_3_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [6:num;4;1]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{6; 4; 1} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN  KNOW_TAC(``prob p (DFT_event p TF t INTER DFT_event p BS t INTER DFT_event p TS t) =
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (BS s)) t *
		 CDF p (\s. real (TS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `6:num`,`0:num`,`1:num`  ]  prob_prod_any_3_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [6:num;0;1]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{6; 0; 1} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN  KNOW_TAC(``prob p (DFT_event p EF t INTER DFT_event p BCU t INTER DFT_event p BS t) =
 		 CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
		 CDF p (\s. real (BS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `5:num`,`4:num`,`0:num`  ]  prob_prod_any_3_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [5:num;4;0]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{5; 4; 0} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN  KNOW_TAC(``prob p (DFT_event p EF t INTER DFT_event p BCU t INTER DFT_event p TS t) =
 		 CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
		 CDF p (\s. real (TS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `5:num`,`4:num`,`1:num`  ]  prob_prod_any_3_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [5:num;4;1]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{5; 4; 1} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN KNOW_TAC(``prob p (DFT_event p EF t INTER DFT_event p BS t INTER DFT_event p TS t) =
 		 CDF p (\s. real (EF s)) t * CDF p (\s. real (BS s)) t *
		 CDF p (\s. real (TS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `5:num`,`0:num`,`1:num`  ]  prob_prod_any_3_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [5:num;0;1]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{5; 0; 1} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN KNOW_TAC(`` prob p (DFT_event p BCU t INTER DFT_event p BS t INTER DFT_event p TS t) =
 		 CDF p (\s. real (BCU s)) t * CDF p (\s. real (BS s)) t *
		 CDF p (\s. real (TS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `4:num`,`0:num`,`1:num`  ]  prob_prod_any_3_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [4:num;0;1]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{4; 0; 1} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq
THEN  KNOW_TAC(`` prob p
                  (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
                   DFT_event p BS t)  =
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
		 CDF p (\s. real (BCU s)) t * CDF p (\s. real (BS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `6:num`,`5:num`,`4:num`, `0:num`  ]  prob_prod_any_4_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [6:num;5;4;0]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{6;5;4;0} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq
THEN KNOW_TAC(`` prob p
                  (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
		   DFT_event p TS t)  =
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
		 CDF p (\s. real (BCU s)) t * CDF p (\s. real (TS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `6:num`,`5:num`,`4:num`, `1:num`  ]  prob_prod_any_4_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [6:num;5;4;1]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{6;5;4;1} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq
THEN KNOW_TAC(`` prob p
                  (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BS t INTER
      		  DFT_event p TS t)  =
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
		 CDF p (\s. real (BS s)) t * CDF p (\s. real (TS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `6:num`,`5:num`,`0:num`, `1:num`  ]  prob_prod_any_4_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [6:num;5;0;1]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{6;5;0;1} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq
THEN  KNOW_TAC(`` prob p
                  (DFT_event p TF t INTER DFT_event p BCU t INTER DFT_event p BS t INTER
      		   DFT_event p TS t)  =
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
		 CDF p (\s. real (BS s)) t * CDF p (\s. real (TS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `6:num`,`4:num`,`0:num`, `1:num`  ]  prob_prod_any_4_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [6:num;4;0;1]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{6;4;0;1} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN KNOW_TAC(`` prob p
                  (DFT_event p EF t INTER DFT_event p BCU t INTER DFT_event p BS t INTER
      		   DFT_event p TS t)  =
 		 CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
		 CDF p (\s. real (BS s)) t * CDF p (\s. real (TS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `5:num`,`4:num`,`0:num`, `1:num`  ]  prob_prod_any_4_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [5:num;4;0;1]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{5;4;0;1} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN KNOW_TAC(`` prob p
                  (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
      		  DFT_event p BS t INTER DFT_event p TS t)  =
 		 CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
		 CDF p (\s. real (BCU s)) t * CDF p (\s. real (BS s)) t *
		 CDF p (\s. real (TS s)) t``)
		 
       THEN1(RW_TAC std_ss[DFT_event_def]
             THEN RW_TAC std_ss [PREIMAGE_EXTREAL_REAL]
	     THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`, `(\i. lborel):num->((real->bool)#((real->bool)->bool)#((real->bool)->extreal))`, ` (\i.
                if i = 0 then (\s. real (BS s))
                else if i = 1 then (\s. real (TS s))
                else if i = 2 then (\s. real (PCCU s))
                else if i = 3 then (\s. real (SCCU_d s))
                else if i = 4 then (\s. real (BCU s))
                else if i = 5 then (\s. real (EF s))
                else (\s. real (TF s))):num->'a->real`,`{0;1;2;3;4;5;6}:num->bool`, `(\i. {u|u<=t:real}):num->real->bool `, `6:num`,`5:num`,`4:num`, `0:num`,`1:num`]  prob_prod_any_5_of_10)
		THEN RW_TAC std_ss[]
		THEN `ALL_DISTINCT [6:num;5;4;0;1]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
		THEN `{6;5;4;0;1} SUBSET {0; 1; 2; 3; 4; 5; 6:num}`by ASM_SET_TAC[]
		THEN FULL_SIMP_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[]
		THEN METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])

THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN KNOW_TAC(`` prob p (DFT_event p TF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t) =
                 CDF p (\s. real (TF s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t)``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num.  if i = 5 then  PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p
            else
              PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p):num->'a->bool`, `5:num`,`2:num`]  prob_prod_any_2_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5; 2} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {5; 2} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(`` (!i:num.
              i IN {5; 2:num} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 

THEN KNOW_TAC(``  prob p (DFT_event p EF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t)  =
                 CDF p (\s. real (EF s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t)``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num.  if i = 4 then  PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
            else
              PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p):num->'a->bool`, `4:num`,`2:num`]  prob_prod_any_2_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{4; 2} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {4; 2} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(`` (!i:num.
              i IN {4; 2:num} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN  KNOW_TAC(``  prob p (DFT_event p BCU t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t)  =
                 CDF p (\s. real (BCU s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t)``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num.  if i = 3 then  PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
            else
              PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p):num->'a->bool`, `3:num`,`2:num`]  prob_prod_any_2_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{3; 2} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {3; 2} ==>
              (if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(`` (!i:num.
              i IN {3; 2:num} ==>
              (if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN  KNOW_TAC(``  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t)  =
                   prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (BS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num.  if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p 
            else PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `2:num`,`0:num`]  prob_prod_any_2_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{2;0} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {2; 0} ==>
              (if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(`` (!i:num.
              i IN {2; 0} ==>
              (if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN  KNOW_TAC(``  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p TS t)  =
                   prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num.  if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p 
            else PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `2:num`,`1:num`]  prob_prod_any_2_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{2;1} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {2; 1} ==>
              (if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(`` (!i:num.
              i IN {2; 1} ==>
              (if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN  KNOW_TAC(``  prob p
                 (DFT_event p TF t INTER DFT_event p EF t INTER
                  DFT_event p (WSP PCCU SCCU_a SCCU_d) t)  =
                   CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
		   prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t)``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p else
		 if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
		 else PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p):num->'a->bool`, `5:num`,`4:num`,`2:num`]  prob_prod_any_3_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;4;2} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {5; 4; 2} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;4;2:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {5; 4; 2} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN  KNOW_TAC(``  prob p
                  (DFT_event p TF t INTER DFT_event p BCU t INTER
                   DFT_event p (WSP PCCU SCCU_a SCCU_d) t) =
                   CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
		   prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t)``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p else
		 if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p):num->'a->bool`, `5:num`,`3:num`,`2:num`]  prob_prod_any_3_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;3;2} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {5; 3; 2} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;3;2:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {5; 3; 2} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN  KNOW_TAC(`` prob p
                  (DFT_event p TF t INTER
           	   DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t) =
                   CDF p (\s. real (TF s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) *
		   CDF p (\s. real (BS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p else
		 if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	else PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `5:num`,`2:num`,`0:num`]  prob_prod_any_3_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;2;0} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``  (!i:num.
              i IN {5; 2; 0} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;2;0:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {5; 2; 0} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN   KNOW_TAC(`` prob p
                  (DFT_event p TF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      		  DFT_event p TS t) =
                   CDF p (\s. real (TF s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) *
		   CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p else
		 if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	else PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `5:num`,`2:num`,`1:num`]  prob_prod_any_3_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;2;1} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``  (!i:num.
              i IN {5; 2; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;2;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {5; 2; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN  KNOW_TAC(`` prob p
                  (DFT_event p EF t INTER DFT_event p BCU t INTER
      		  DFT_event p (WSP PCCU SCCU_a SCCU_d) t) =
                   CDF p (\s. real (EF s)) t *  CDF p (\s. real (BCU s)) t *
		   prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) ``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p else
		 if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p):num->'a->bool`, `4:num`,`3:num`,`2:num`]  prob_prod_any_3_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{4;3;2} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``   (!i:num.
              i IN {4; 3; 2} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [4;3;2:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {4; 3; 2} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN KNOW_TAC(`` prob p
     		 (DFT_event p EF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      		  DFT_event p BS t) =
                   CDF p (\s. real (EF s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) *
		   CDF p (\s. real (BS s)) t ``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p else
		 if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `4:num`,`2:num`,`0:num`]  prob_prod_any_3_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{4;2;0} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``   (!i:num.
              i IN {4; 2; 0} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [4;2;0:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {4; 2; 0} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN KNOW_TAC(`` prob p
     		 (DFT_event p EF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      		  DFT_event p TS t) =
                   CDF p (\s. real (EF s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) *
		   CDF p (\s. real (TS s)) t ``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p else
		 if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `4:num`,`2:num`,`1:num`]  prob_prod_any_3_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{4;2;1} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``   (!i:num.
              i IN {4; 2; 1} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [4;2;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {4; 2; 1} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN KNOW_TAC(`` prob p
     		 (DFT_event p BCU t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      		  DFT_event p BS t) =
                   CDF p (\s. real (BCU s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) *
		   CDF p (\s. real (BS s)) t ``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p else
		 if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `3:num`,`2:num`,`0:num`]  prob_prod_any_3_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{3;2;0} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``   (!i:num.
              i IN {3; 2; 0} ==>
              (if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [3;2;0:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {3; 2; 0} ==>
              (if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN KNOW_TAC(`` prob p
     		 (DFT_event p BCU t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      		 DFT_event p TS t) =
                   CDF p (\s. real (BCU s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) *
		   CDF p (\s. real (TS s)) t ``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p else
		 if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `3:num`,`2:num`,`1:num`]  prob_prod_any_3_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{3;2;1} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``   (!i:num.
              i IN {3; 2; 1} ==>
              (if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [3;2;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {3; 2; 1} ==>
              (if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN KNOW_TAC(`` prob p
     		 (DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t INTER
      		  DFT_event p TS t) =
                  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (BS s)) t *
		   CDF p (\s. real (TS s)) t ``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else if i = 0 then PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p
		 else PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `2:num`,`0:num`,`1:num`]  prob_prod_any_3_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{2;0;1} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``   (!i:num.
              i IN {2; 0; 1} ==>
              (if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [2;0;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {2; 0; 1} ==>
              (if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN KNOW_TAC(`` prob p
     		 (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
      		  DFT_event p (WSP PCCU SCCU_a SCCU_d) t) =
                  CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
		  CDF p (\s. real (BCU s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t)``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p
		 else if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
		 else if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p):num->'a->bool`, `5:num`,`4:num`,`3:num`, `2:num`]  prob_prod_any_4_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;4;3;2:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``   (!i:num.
              i IN {5; 4; 3; 2} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;4;3;2:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {5; 4; 3; 2} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p) IN events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN KNOW_TAC(`` prob p
     		 (DFT_event p TF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      		  DFT_event p BS t INTER DFT_event p TS t) =
                  CDF p (\s. real (TF s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) *
		  CDF p (\s. real (BS s)) t * CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else if i = 0 then PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p
		 else  PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `5:num`,`2:num`,`0:num`, `1:num`]  prob_prod_any_4_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;2;0;1:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``  (!i:num.
              i IN {5; 2; 0; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;2;0;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {5; 2; 0; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN  KNOW_TAC(`` prob p
     		 (DFT_event p EF t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      		 DFT_event p BS t INTER DFT_event p TS t) =
                  CDF p (\s. real (EF s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) *
		  CDF p (\s. real (BS s)) t * CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else if i = 0 then PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p
		 else  PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `4:num`,`2:num`,`0:num`, `1:num`]  prob_prod_any_4_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{4;2;0;1:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``  (!i:num.
              i IN {4; 2; 0; 1} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [4;2;0;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {4; 2; 0; 1} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN KNOW_TAC(`` prob p
     		 (DFT_event p BCU t INTER DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER
      		  DFT_event p BS t INTER DFT_event p TS t) =
                  CDF p (\s. real (BCU s)) t * prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) *
		  CDF p (\s. real (BS s)) t * CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else if i = 0 then PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p
		 else  PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `3:num`,`2:num`,`0:num`, `1:num`]  prob_prod_any_4_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{3;2;0;1:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``  (!i:num.
              i IN {3; 2; 0; 1} ==>
              (if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [3;2;0;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {3; 2; 0; 1} ==>
              (if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN KNOW_TAC(`` prob p
     		 (DFT_event p TF t INTER DFT_event p EF t INTER
      		  DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t) =
                  CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
		  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (BS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p
		 else if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else  PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `5:num`,`4:num`,`2:num`, `0:num`]  prob_prod_any_4_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;4;2;0:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``  (!i:num.
              i IN {5; 4; 2; 0} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;4;2;0:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {5; 4; 2; 0} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN  KNOW_TAC(`` prob p
     		 (DFT_event p TF t INTER DFT_event p EF t INTER
      		  DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p TS t) =
                  CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
		  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p
		 else if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else  PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `5:num`,`4:num`,`2:num`, `1:num`]  prob_prod_any_4_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;4;2;1:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``  (!i:num.
              i IN {5; 4; 2; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;4;2;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {5; 4; 2; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq 
THEN  KNOW_TAC(`` prob p
     		 (DFT_event p TF t INTER DFT_event p BCU t INTER
      		  DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t) =
                  CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
		  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (BS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p
		 else if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else  PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `5:num`,`3:num`,`2:num`, `0:num`]  prob_prod_any_4_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;3;2;0:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``  (!i:num.
              i IN {5; 3; 2; 0} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;3;2;0:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {5; 3; 2; 0} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq


THEN KNOW_TAC(`` prob p
     		 (DFT_event p TF t INTER DFT_event p BCU t INTER
      		 DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p TS t) =
                  CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
		  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p
		 else if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else  PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `5:num`,`3:num`,`2:num`, `1:num`]  prob_prod_any_4_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;3;2;1:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``  (!i:num.
              i IN {5; 3; 2; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;3;2;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {5; 3; 2; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN KNOW_TAC(`` prob p
     		 (DFT_event p EF t INTER DFT_event p BCU t INTER
      		 DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t) =
                  CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
		  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (BS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
		 else if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else  PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `4:num`,`3:num`,`2:num`, `0:num`]  prob_prod_any_4_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{4;3;2;0:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``  (!i:num.
              i IN {4; 3; 2; 0} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [4;3;2;0:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {4; 3; 2; 0} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq
THEN KNOW_TAC(`` prob p
     		 (DFT_event p EF t INTER DFT_event p BCU t INTER
      		 DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p TS t) =
                  CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
		  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
		 else if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else  PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `4:num`,`3:num`,`2:num`, `1:num`]  prob_prod_any_4_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{4;3;2;1:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``  (!i:num.
              i IN {4; 3; 2; 1} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [4;3;2;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(``  (!i:num.
              i IN {4; 3; 2; 0} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq
THEN KNOW_TAC(`` prob p
     		 (DFT_event p TF t INTER DFT_event p EF t INTER
      		  DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t INTER
      		  DFT_event p TS t) =
                  CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t *
		  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (BS s)) t *
		  CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p
		 else if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else if i = 0 then PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p
		 else  PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `5:num`,`4:num`,`2:num`, `0:num`,`1:num`]  prob_prod_any_5_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;4;2;0;1:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {5; 4; 2; 0; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;4;2;0;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(`` (!i:num.
              i IN {5; 4; 2; 0; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq
THEN KNOW_TAC(`` prob p
     		 (DFT_event p TF t INTER DFT_event p BCU t INTER
      		 DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t INTER
      		 DFT_event p TS t) =
                  CDF p (\s. real (TF s)) t * CDF p (\s. real (BCU s)) t *
		  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (BS s)) t *
		  CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p
		 else if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else if i = 0 then PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p
		 else  PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `5:num`,`3:num`,`2:num`, `0:num`,`1:num`]  prob_prod_any_5_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;3;2;0;1:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {5; 3; 2; 0; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;3;2;0;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(`` (!i:num.
              i IN {5; 3; 2; 0; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq
THEN  KNOW_TAC(`` prob p
     		 (DFT_event p EF t INTER DFT_event p BCU t INTER
      		 DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t INTER
      		 DFT_event p TS t) =
                  CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
		  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (BS s)) t *
		  CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
		 else if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else if i = 0 then PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p
		 else  PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `4:num`,`3:num`,`2:num`, `0:num`,`1:num`]  prob_prod_any_5_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{4;3;2;0;1:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {4; 3; 2; 0; 1} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [4;3;2;0;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(`` (!i:num.
              i IN {4; 3; 2; 0; 1} ==>
              (if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq
THEN  KNOW_TAC(`` prob p
     		 (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
       		 DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t) =
                 CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t*
		 prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (BS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p
		 else if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
		 else if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else  PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `5:num`,`4:num`,`3:num`, `2:num`,`0:num`]  prob_prod_any_5_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;4;3;2;0:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {5; 4; 3; 2; 0} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;4;3;2;0:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(`` (!i:num.
              i IN {5; 4; 3; 2; 0} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN KNOW_TAC(`` prob p
     		 (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
       		  DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p TS t) =
                 CDF p (\s. real (TF s)) t * CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t*
		 prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
    	   THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p
		 else if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
		 else if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else  PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `5:num`,`4:num`,`3:num`, `2:num`,`1:num`]  prob_prod_any_5_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;4;3;2;1:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {5; 4; 3; 2; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;4;3;2;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(`` (!i:num.
              i IN {5; 4; 3; 2; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq

THEN KNOW_TAC(`` prob p
     		 (DFT_event p TF t INTER DFT_event p EF t INTER DFT_event p BCU t INTER
      		 DFT_event p (WSP PCCU SCCU_a SCCU_d) t INTER DFT_event p BS t INTER
      		 DFT_event p TS t) =
		 CDF p (\s. real (TF s)) t * 
                  CDF p (\s. real (EF s)) t * CDF p (\s. real (BCU s)) t *
		  prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) * CDF p (\s. real (BS s)) t *
		  CDF p (\s. real (TS s)) t``)

    THEN1(`!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]` by METIS_TAC [ALL_DISTINCT, MEM]
           THEN `DFT_event p TF t = PREIMAGE TF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	  
           THEN `DFT_event p EF t = PREIMAGE EF {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BCU t = PREIMAGE BCU {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p TS t = PREIMAGE TS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   THEN `DFT_event p BS t = PREIMAGE BS {u | u <= Normal t} INTER p_space p` by RW_TAC std_ss[DFT_PREIMAGE]
	   
	   THEN `DFT_event p (WSP PCCU SCCU_a SCCU_d) t =
	   ({s | PCCU s < SCCU_a s /\ SCCU_a s <= Normal t /\ 0<= PCCU s /\ PCCU s <= Normal t} INTER
       p_space p UNION
       {s | SCCU_d s < PCCU s /\ PCCU s <= Normal t} INTER p_space p)` by RW_TAC std_ss[WSP_DFT_event]	      					
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN WEAKEN_TAC is_eq
	   THEN RW_TAC std_ss [WSP_PREIMAGE] 
           THEN RW_TAC std_ss[PREIMAGE_EXTREAL_REAL,PREIMAGE_EXTREAL_REAL_3RV_WSP]
	   THEN MP_TAC(Q.ISPECL [`p:('a -> bool) #
          (('a -> bool) -> bool) # (('a -> bool) -> extreal)`,  ` (\i:num.
                {if i = 0 then
                   PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
                 else if i = 1 then
                   PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
                 else if i = 2 then
                   PREIMAGE
                     (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                     {(y,xa,xd) |
                     y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/
                     xd < y /\ y <= t} INTER p_space p
                 else if i = 3 then
                   PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
                 else if i = 4 then
                   PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
                 else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})`, `{0:num; 1; 2; 3; 4; 5}`,`(\i:num. if i = 5 then PREIMAGE (\s. real (TF s)) {u | u <=  t} INTER p_space p
		 else if i = 4 then PREIMAGE (\s. real (EF s)) {u | u <=  t} INTER p_space p
		 else if i = 3 then PREIMAGE (\s. real (BCU s)) {u | u <=  t} INTER p_space p
		 else if i = 2 then PREIMAGE (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
        {(y,xa,xd) |
        y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER p_space p
	         else if i = 0 then PREIMAGE (\s. real (BS s)) {u | u <=  t} INTER p_space p
		 else  PREIMAGE (\s. real (TS s)) {u | u <=  t} INTER p_space p):num->'a->bool`, `5:num`,`4:num`,`3:num`,`2:num`, `0:num`,`1:num`]  prob_prod_any_6_of_10_set)
	
          THEN RW_TAC std_ss[]
          THEN `{5;4;3;2;0;1:num} SUBSET {0; 1; 2; 3; 4; 5:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(`` (!i:num.
              i IN {5; 4; 3; 2; 0; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              {if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else if i = 1 then
                 PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\s. (real (PCCU s),real (SCCU_a s),real (SCCU_d s)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p})``)
               THEN1( RW_TAC real_ss[ALL_DISTINCT, MEM ] 
 	            THEN PSET_TAC[GSPECIFICATION, EXTENSION,MEM, ALL_DISTINCT]
		    THEN RW_TAC real_ss[])
         THEN DISCH_TAC
	 THEN `ALL_DISTINCT [5;4;3;2;0;1:num]` by RW_TAC std_ss[ALL_DISTINCT, MEM]
	 THEN FULL_SIMP_TAC std_ss[]
	 THEN KNOW_TAC(`` (!i:num.
              i IN {5; 4; 3; 2; 0; 1} ==>
              (if i = 5 then
                 PREIMAGE (\s. real (TF s)) {u | u <= t} INTER p_space p
               else if i = 4 then
                 PREIMAGE (\s. real (EF s)) {u | u <= t} INTER p_space p
               else if i = 3 then
                 PREIMAGE (\s. real (BCU s)) {u | u <= t} INTER p_space p
               else if i = 2 then
                 PREIMAGE
                   (\x. (real (PCCU x),real (SCCU_a x),real (SCCU_d x)))
                   {(y,xa,xd) |
                   y < xa /\ xa <= t /\ 0 <= y /\ y <= t \/ xd < y /\ y <= t} INTER
                 p_space p
               else if i = 0 then
                 PREIMAGE (\s. real (BS s)) {u | u <= t} INTER p_space p
               else PREIMAGE (\s. real (TS s)) {u | u <= t} INTER p_space p) IN
              events p)``)
	       THEN1(RW_TAC std_ss [])
         THEN DISCH_TAC
         THEN FULL_SIMP_TAC std_ss[]
	 THEN  RW_TAC std_ss[]
	 THEN  METIS_TAC[GSYM DFT_PREIMAGE, CDF_prob_DFT_event, PREIMAGE_EXTREAL_REAL])


THEN DISCH_TAC THEN ASM_REWRITE_TAC[] THEN WEAKEN_TAC is_eq


THEN KNOW_TAC(`` prob p (DFT_event p (WSP PCCU SCCU_a SCCU_d) t) =
     pos_fn_integral lborel
            (\pccu.
               indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu * f_pccu pccu *
               pos_fn_integral lborel
                 (\sccu_a. indicator_fn {sccu_a' | pccu < sccu_a' /\ sccu_a' <= t} sccu_a * f_cond pccu sccu_a)) +
        pos_fn_integral lborel
          (\pccu.
               f_pccu pccu *
               (indicator_fn {pccu' | 0 <= pccu' /\ pccu' <= t} pccu *
                CDF p (\s. real (SCCU_d s)) pccu)) ``)

THEN1(MP_TAC(Q.ISPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `PCCU:'a->extreal`, `SCCU_a:'a->extreal`, `SCCU_d:'a->extreal`, `t:real`, `f_pccu:real->extreal`, `f_sccu_pccu:(real#real->extreal)`, `f_cond:real->real->extreal` ]prob_WSP)
      THEN RW_TAC std_ss[]
      THEN `(!s. ALL_DISTINCT [SCCU_a s; SCCU_d s; PCCU s]) /\
         rv_gt0_ninfinity [SCCU_a; SCCU_d; PCCU]` by METIS_TAC[ALL_DISTINCT, MEM, rv_gt0_ninfinity_def]
      THEN FULL_SIMP_TAC std_ss[])
      
THEN DISCH_TAC THEN ASM_REWRITE_TAC[]);



val _ = export_theory();

